/**
 * Created by mintao on 2016/10/14.
 * c++调用js的类接口
 */

var AppComponent = cc.Component.extend({

    ctor : function(){
        this._super();

    },

    /***
     * 选取相册图片之后回调
     * @param filename 图片路径
     * @param cfg tag
     */
    onSystemPhotoEvent: function (event_param, event_id) {
        switch (event_id) {
            case 'headPhoto'://头像
            {
                var filepath = event_param;
                cc.log('--------准备上传--filepath is ', filepath);

                app.curlLoader.startToLoad(appglobal.appCfg.PostUpHeadUrl(0), event_param, 1, "upHeadImg");
            }
                break;
            case 'sysnetwork':
            {
                FYEngine.dispatchCustomEvent(FYCustomEventName.SystemNet, event_param);
            }
                break;



        }
    },

    /***
     *
     * @param event_param
     * @param event_id
     */
    onCurlLoadEvent: function (event_param, event_id) {
        cc.log('eventid======'+event_id);
        switch (event_id) {
            case "upHeadImg":
                cc.log('----------上传头像成功, 头像id:', event_param);
                break;
            case "downloadApk":{
                cc.log("=====js===下载成功======");
                this.oldPres = 0;
                var layer = cc.director.getRunningScene().getChildByName("mustUpdateLayer");
                if(layer){
                    layer.installApk();}


            }
                break;
            case "downLoadPercent":
            {
                event_param = parseInt(event_param);
                if (this.oldPres == event_param) {
                    return;
                }
                else {
                    this.oldPres = event_param;
                    var mustUpdateLayer = cc.director.getRunningScene().getChildByName("mustUpdateLayer");
                    if(mustUpdateLayer){
                        mustUpdateLayer.downLoadPer(event_param)
                    }
                }
            }
                break;
        }
    },

    /***
     * 系统网络事件处理
     * @param event_id
     * @param event_param
     */
    onSystemNetworkEvent: function (event) {
        var name = event.getEventName();
        var param = event.getUserData();
        switch (name) {
            case 'systemnetwork':
            {
                var status = parseInt(param);
                switch (status) {
                    case 0:
                    {
                        if (appglobal.isNetwork) {
                            // FYEngine.AddCommToast('网络连接已断开，请检查网络');

                        }
                        cc.log("11111111网络连接已断开");
                        appglobal.isNetwork = false;
                    }
                        break;
                    case 1:
                    case 2:
                    {
                        if (!appglobal.isNetwork) {
                            // FYEngine.AddCommToast('网络已重新连接');

                        }

                        cc.log("11111111网络已重新连接");
                        appglobal.isNetwork = true;
                    }
                        break;
                }
            }
                break;
        }

    },



});