/**
 * Created by mintao on 16/5/25.
 * 引擎基础定义
 */

// 定义命名空间
var FYEngine = FYEngine || {};

/***
 * web私钥
 * @type {string}
 */
FYEngine.PrivateKey     =   "57EJqwo7wsLL4c79";

/****
 * 宏len
 */
FYEngine.NickNameLen    =   32;
FYEngine.FaceIdLen      =   32;
FYEngine.TokenLen       =   32;
FYEngine.ImeiLen        =   32;
FYEngine.PassWordLen    =   32;
FYEngine.AccountLen     =   64;
FYEngine.SignLen        =   128;
FYEngine.BirthLen       =   32;
FYEngine.VoiceLen       =   32;
FYEngine.InfoDataLen    =   32;

/***
 * 客户端通用颜色定义
 * @type {{r, g, b, a}|cc.Color}
 */
FYEngine.BeanColor = cc.color(249,255,76);
FYEngine.SignColor = cc.color(255,178,251);

/**
 * 图层
 * @type {{}}
 */
var FYZorder = {
    BGLayer     : 0,  //背景层
    GameLayer   : 20, //游戏层 & 战斗、特效
    UILayer     : 50, //UI层 & 按钮、玩家信息
    EftLayer    : 80, //特效层 & 动作、特效
    PopLayer    : 100 //弹出层
};

/***
 * 通用模块tag名字
 */
var FYTagName = {
    BGLayer     : 'bglayer',
    GameLayer   : 'gamelayer',
    UILayer     : 'uilayer',
    EftLayer    : 'eftlayer',
    PopLayer    : 'poplayer',
    NuclearLayers: 'NuclearLayers',
    NuclearLayero: 'NuclearLayero'
};

/****
 * 触摸类型
 * @type {{Began: number, Moved: number, Cancelled: number, Ended: number}}
 */
FYEngine.TouchType = {
    Began       : 0,
    Moved       : 1,
    Cancelled   : 2,
    Ended       : 3,
};

/****
 * 动作类型
 */
FYEngine.ActionType = {
    Scale : 0,
    Fade : 1,
    Dark : 2,
    ScaleDark : 3,
};

/***
 * 关闭app
 */
FYEngine.closeApp = function(){
    FYEngine.Audio.end();
    if(cc.sys.os == 'iOS'){
        cc.sys.closeWindow();
    }else{
        cc.director.end();
    }


};

FYEngine.winSize = cc.size(1136, 640);

