//同步方法
FYEngine.SDKMacros = {};
FYEngine.SDKMacros.NativeMethod = {

    //------------获取用户缓存
    getCacheUser :{
        input :{
            tag : "getCacheUser",
            data: ""
        },
        output:{
                userid:"",
                password:"",
                nickname:"",
                account:"",
        }
    },
    //------------存储用户缓存
    setCacheUser :{
        input :{
            tag : "setCacheUser",
            data:{
                userid:"",
                password:"",
                nickname:"",
                account:"",
            }
        },
        output:{
                userid:"",
                password:"",
                nickname:"",
                account:"",
        }
    },
    //-----------获取网络状态
    getNetworkType:{
        input :{
            tag : "getNetworkType",
            data:""
        },
        output:{
                type:"",//网络类型，0网络不可用 1wifi 2数据 3其它
        }
    }
}

//异步方法
FYEngine.SDKMacros.NativeMethodAysn = {
    capture:{
        //拍照或从相册获取图片
        input :{
            tag : "capture",
            data:{
                mode:""//0拍照，1相册
            }
        },
        output:{
            tag: "capture",
            data:{
                imagePath:""//图片路径
            }
        }
    },
    //----------------支付
    startPay:{
        input:{
            tag:"startPay",
            data:{
                userId:0,
                itemType:0,
                itemPrice:1.0,
                orderNo:"123123123",
                notifyUrl:"1123123.123123.123123/sdrer",
            }
        },
        output:{
            tag:"startPay",
            data: {
                result: 0//0成功1失败
            }
        }
    },
    //----------------安装apk ios并没有实现接口
    installApk:{
        input:{
            tag:"installApk",
            data:{
                apkPath:"包体路径",
            }
        },
        output:{
            tag:"startPay",
            data: {
                result: 0//0成功1失败
            }
        }
    }

}
//sdk主动推送
FYEngine.SDKMacros.NativeResp= {
    networkType:{
        //sdk
        output:{
            tag:"networkType",
            data:{
                type:"",//网络类型，0网络不可用 1wifi 2数据 3其它
            }
        }
    }
}
