/**
 * Created by mintao on 16/5/26.
 */

/***
 * 创建进度条
 * @param progressbg 背景file
 * @param progress 进度file
 * @param changerate
 * @param percent
 * @param midpoint
 * @param pos 位置
 * @param anch
 * @param type
 */
FYEngine.createProgressBar = function(progressbg, progress, changerate, percent, midpoint, pos, anch, type){
    var progress_bg = new cc.Sprite(progress_bg);
    var sp_progress = new cc.Sprite(progress);
    var progressbar = new cc.ProgressTimer(sp_progress);
    if (pos == undefined){
        pos = cc.p(0,0);
    }
    if (percent == undefined){
        percent = 0;
    }
    if (midpoint == undefined){
        midpoint = cc.p(0,0);
    }
    if (changerate == undefined){
        changerate = cc.p(1,0);
    }
    if(anch == undefined){
        anch = cc.p(0, 0);
    }
    if (pos == undefined){
        pos = cc.p(0,0);
    }
    if (type == undefined){
        type = cc.ProgressTimer.TYPE_BAR;
    }
    progressbar.setBarChangeRate(changerate);
    progressbar.setPercentage(percent);
    progressbar.setMidpoint(midpoint);
    progressbar.setAnchorPoint(anch);
    progressbar.setPosition(pos);
    progressbar.setType(type);
    progress_bg.addChild(progressbar,0,0);
    return progress_bg;
};


/***
 * 创建扇形进度条
 */