/**
 * Created by garychen on 16/3/1.
 */

/**
 * @class CoreService
 */

app.CoreService = {

    /*!**
     * @method getInstance
     *!*/
    getInstance: function () {
        return app.CoreService;
    },

     /*!**
     * @method getTestValue
     *!*/
    getTestValue: function () {
        return 0;
    },

    /***
     *
     * @returns {boolean}
     */
    checkIsCollision:function(size,pos,angle,pos1){
        return false;
    },

    checkAllCollision:function(sizearr,posarr,anglearr,pos1arr,fishidarr, bulletidarr){
        return [];
    },

    /*!**
     * @method createClientThread
     *!*/
    createClientThread: function(clientId) {
        return null;
    },

    /*!**
     * @method getClientThread
     *!*/
    getClientThread: function(clientId) {
        return null;
    },

    /*!**
     * @method getTestValue
     *!*/
    setComponent: function (compent) {
        cc.log('--------setComponent : '+compent);
    },

    /*!**
     * @method start
     *
     * start a network thread
     *!*/
    start : function() {
    },

    /*!**
     * @method start
     *
     * stop a network thread
     *!*/
    stop: function() {
    },

    /*!**
     * @method update
     *
     * update for processing message
     *!*/
    update: function (t){
    },

    /*!**
     * @method getUserLoginType
     *
     * user login type before login action
     *
     * ret value:
     *     1 - eUserLoginTypeReg,              注册
     *     2 - eUserLoginTypeLogin,            快速登录
     *     3 - eUserLoginTypeNeedPassword,     密码登录
     *
     *!*/
    getUserLoginType : function(){
        return 0;
    },

    /*!**
     * @method getUserInfo
     *
     * It is readable when called AppGlobal.onGameLogin() and after this call for user login info
     *
     *!*/
    getUserInfo : function() {
      return {
          nickname : '',
          account : '',
          token : '',
          userId : 0,
          imei : '',
      };
    },

    /*!**
     * @method utf82unicdoe
     *
     * utf8 string -> unicode string
     *
     *!*/
    utf82unicdoe : function(utf8array){
        return ''
    },

    unicdoe2utf8 : function(unicdoearray){
        return '';
    },

    /*!**
     * @method getAudioThread
     *
     * audio preload thread
     *
     *!*/
    getAudioThread : function(){
        return null;
    },

    /****
     * 设置角色id
     * @param roleid
     */
    setRoleId : function(roleid){

    },



};

/**
 * @class AudioPreloadThread
 */

app.AudioPreloadThread = {
    /*
    *
    * resList = [ [app.AudioResType, resPathName], [], [], ... ]
    * */
    // 添加资源列表
    addLoadResource : function(resList){
    },
    // 开启加载线程
    start : function(){
    },
    // join加载线程
    end : function(){
    },
};

/**
 * @class SdkService
 */

app.SdkService = {
    /*!**
     * @method getInstance
     *!*/
    getInstance: function () {
        return app.SdkService;
    },



    /*!**
     * @method init
     *!*/
    init : function() {
        return "";
    },

    /*!**
     * @method quickRegister
     *
     * 快速注册
     *!*/
    quickRegister : function() {
    },


    /*!**
     * @method userLogin
     *
     * 账号登录
     *!*/
    userLogin : function(username, password) {
    },

    /*!**
     * @method userLogin
     *
     * 绑定帐号
     *!*/
    userBinding : function(username, password){
    },

    /*!**
     * @method userPasswordModify
     *
     * 修改密码
     *!*/
    userPasswordModify : function(oldpass, newpass){
    },

    /*!**
     * @method checkUserPassword
     *
     * 检查玩家密码
     *!*/
    checkUserPassword : function(password){
        return false;
    },

    /*!**
     * @method quickLogin
     *
     * 快速登录
     *!*/
    quickLogin : function() {
    },

    /*!**
     * @method userLogout
     *
     * 账号退出
     *!*/
    userLogout: function(){
    },
    //修改密码
    modifyPwd : function(pwd){
    },
    //修改账号
    modifyAccount : function(pwd){
    },
    /*!**
     * @method userPurchase
     *
     * 用户支付
     *!*/
    userPurchase : function (itemid, itemType, itemName, itemNum, itemPrice) {
    },
    //新支付
    userPay:function(goodsId, money, sn, point, url,goodsName){

    },

    /*!**
     * @method setSdkConfig
     *
     * 设置SDK配置
     *!*/
    setSdkConfig : function(cfgStr){
    },

    /*!**
     *
     * @param jsonstr
     *!*/
    sendFishJsonMsg : function(jsonstr){

    },

    /*!**
     * @method getVersionString
     *
     * 返回版本号字串
     *!*/
    getVersionString : function(){
        return '';
    },

    /*!**
     * @method getVersionCode
     *
     * 返回整数型版本号
     *!*/
    getVersionCode : function(){
      return 0;
    },

    /*!**
     * @method getChannelId
     *
     * 返回渠道号
     *!*/
    getChannelId : function(){
        return 0;
    },

    /***
     * 启动捕鱼,调用安卓
     * @param userId int
     * @param userName string
     * @param headImg string
     * @param sex int
     * @param token string
     * @param downloadUrl string
     * @param pkgName string
     * @param versionCode int
     * @param desc string
     */
    startFishingGame : function(userId, userName, headImg, sex, token, downloadUrl, pkgName, versionCode, desc){

    },
};

/**
 * @class ClientThread
 */

app.ClientThread = {
    /*!**
     * @method getClientId
     *!*/
    getClientId: function() {
      return 0;
    },

    /*!**
     * @method setClientId
     *!*/
    setClientId: function(clientId) {
    },

    /*!**
     * @method start
     * make a thread running
     *!*/
    start: function() {
    },

    /*!**
     * @method stop
     * stop a thread running
     *!*/
    stop: function() {
    },

    /*!**
     * @method sendDataMsg
     * send a message to server
     *!*/
    sendDataMsg : function(arrayBuffer){
    },

    sendFishJsonMsg : function(jsonstr){

    },

    /*!**
     * @method setAccessInfo
     * set ip,port for connecting server
     *!*/
    setAccessInfo : function(ip,port){
    },

    /*!**
     * @method connect
     * send a connect command to execute in c++ client thread, (should call setAccessInfo BEFORE it).
     *!*/
    connect : function(){
    },

    /****
     * 设置加密方式\公钥信息\私钥信息
     * @param type
     * @constructor
     */
    SetEncrytype : function(type){

    },

    setPubKey : function(userid, keyLen, szkeys){

    },

    setPrvKey : function(userid, keyLen, szkeys){

    },

    /**
     * 手动清除底层的消息队列
     */
    cleanMessage: function () {

    },
};

app.SdkPlugin={
    /*
    *  获取单例
    * */
    getInstance:function(){

    },
    /*
    * 获取原生设备信息  渠道号,版本号,位置等等
    * */
    getNativeInfo:function(){
        return '1111111111';
    },
    getTestValue:function(){
        return 0;
    },
    /*
    * 同步调用方法
    * */
    callNativeMethod:function(tag,jsonData){
        return jsonData;
    },
    /*
    * http  get请求
    * */
    httpReqNativeGet:function(tag,jsonData){

    },
    /*
    * http  post请求
    * */
    httpReqNativePost:function(tag,jsonData){

    },
    /*
    * 异步调用方法
    * */
    callNativeMethodAysc:function(tag,jsonData){

    },

}

app.coreservice = app.CoreService.getInstance();
app.sdkservice = app.SdkService.getInstance();
app.sdkPlugin = app.SdkPlugin.getInstance();
