var SccomRes = {
    Head: "#bg_head.png",
    Backbtn: {
        Up: 'dialog_20.png',
        Down: 'dialog_19.png',
    },
    RewardRes: {
        Rewardname: '#reward_name.png',
        Lotterysmall: 'lottery_small.png',
        Broadbg: 'frame1.png',
        Tip: '#tip.png',
        Record: '#reward_record.png',
        ClassNormal: 'dialog_24.png',
        ClassSelect: 'dialog_25.png',
        Dialog: 'dialog_21.png',
        ClassTittle: '#dialog_23.png',
        Gou: 'dialog_22.png',

    },
    SmallWinRes: {
        Outerbg: 'smallwines7.png',
        Innerbg: 'smallwines3.png',
        Innerbg2: 'smallwines19.png',
        Smallbg: 'smallwines1.png',
        Titlebg: '#smallwines0.png',
        Confirmbtn: '#smallwines22.png',
        Confirmtitle: '#smallwines4.png',
        Confirmtitle2: '#smallwines9.png',
        Cancelbtn: '#smallwines21.png',
        Canceltitle: '#smallwines20.png',
        TitleWrite: '#smallwines2.png',
        Passwordchange: '#smallwines18.png',
        Completeinfor: '#smallwines5.png',
     
        Helper: '#smallwines10.png',
        Helperbtnname: '#smallwines17.png',
        settingPassNow: "#setting_now_pass.png",
        exchangebtn: '#smallwines23.png',
        exchangetittle: '#smallwines24.png',
        lay3other: 'smallwines25.png',
        
        recordtittle: '#smallwines29.png',
    
       
        changeName: "#crystal48.png",
        timeout: "#gameui35.png",
        changeSign:"#crystal02.png"


    },
    MallRes: {
        Outerbg: 'bg_frame1.png',
        Innerbg: 'bg_frame2.png',
        Head: '#bg_head.png',
        Mallname: '#mall_name.png',

        Boxbg: 'frame_bg.png',
        Boxbtn: 'button.png',
        Goldbig: 'gold_big.png',

        Goldsmall: 'gold_small.png',
        Goldlittle: 'goldlittle.png',
        Number: 'res/hall/mall_number.png',
        Yuan: 'yuan.png',
        loadingbg: '#loadingquanrevise.png',
        loadingfish: '#loadingfish.png',
    
        iknowbtn: '#iknow.png',
        gohigher: '#gohigher.png',

    },
    Backbtn: {
        Up: 'dialog_20.png',
        Down: 'dialog_19.png',
    },
    MapAlts: 'res/hall/lobby_number.png',
};
var SccomLayerName = {
    broad: 'broad',
    loading: 'loading',
    classify: 'classify'
};
var FishExchangeBroad = FishExchangeBroad || [];
/**
 * 公共模块.商城和兑换使用
 */
var SccomLayer = cc.LayerColor.extend({
    ctor: function () {
        this._super();
        this.init(cc.color(0, 0, 0, 190));
        this.bindTouch();
    },

    bindTouch: function () {
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {

                }

            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },
    addLayerBg: function (imageName, bgSize, bgPosition) {
        var that = this;
        var outBg = that.layerbg = FYEngine.createImageView(imageName, bgPosition, cc.p(0.5, 0.5), bgSize);
        that.addChild(outBg, 0, 1);
        return that.layerbg;
    },

    addInnerBg: function (imageName, bgSize,position) {
        var mposition = position|| cc.p(this.layerbg.width / 2, this.layerbg.height / 2);
        var innerBg = FYEngine.createImageView(imageName, mposition, cc.p(0.5, 0.5), bgSize);
        this.layerbg.addChild(innerBg, 0, 2);
        return innerBg;
    },

    addTitle: function (titleImage) {
        var titleBg = FYEngine.createSprite(SccomRes.Head, cc.p(this.layerbg.width / 2, this.layerbg.height * 1.02));
        this.layerbg.addChild(titleBg, 0, 3);
        var titleName = FYEngine.createSprite(titleImage, cc.p(titleBg.width / 2, titleBg.height / 2));
        titleBg.addChild(titleName, 0, 1);
    },

    addCloseBtn: function (func) {
        var that = this;
        var btnBack = new ccui.Button(SccomRes.Backbtn.Up, SccomRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(that.layerbg.width * 0.97, that.layerbg.height * 1.05);
            this.layerbg.addChild(btnBack, 0, 3);
            if (func) {
                btnBack.addClickEventListener(func);
            } else {
                btnBack.addClickEventListener(function () {
                    FYEngine.popoutLayerAnimate(that.layerbg);
                })
            }
        }
    },

});
var SccomMsgKey = {
    allExchange: "allExchange",
    gameTool : "gameTool",
    mobileFee: "mobileFee",
    shoppingCard: "shoppingCard",
    digital: "digital",
    electrical: "electrical",
    life: "life",
    gold: "gold",
    stock: "stock",
    stockNotConfine: "stockNotConfine",
    stockEmpty: "stockEmpty",
    stockEnough: "stockEnough",
    stockNotEnough: "stockNotEnough",
    nowCoupon: "nowCoupon",
    exchangeEmpty: "exchangeEmpty",
    couponNotEnough: "couponNotEnough",
    networkTimeOut: "networkTimeOut",
    exchangeName: "exchangeName",
    exchangePhoneNo: "exchangePhoneNo",
    checkPhoneNo: "checkPhoneNo",
    exchangeCompleteMsg: "exchangeCompleteMsg",
    noExchangeName: "noExchangeName",
    noExchangePhoneNo: "noExchangePhoneNo",
    failedPhoneNo: "failedPhoneNo",
    failedPhoneNo1: "failedPhoneNo1",

    exchangePostCode: "exchangePostCode",
    exchangeAddress: "exchangeAddress",
    exchangeTip: "exchangeTip",
    noPostCode: "noPostCode",
    failedPostCode: "failedPostCode",
    noAddress: "noAddress",
    exchangeInfo: "exchangeInfo",
    exchangeGold: "exchangeGold",
    exchangeCrystal: "exchangeCrystal",
    exchangeSuccess: "exchangeSuccess",
    rewardSendTime: "rewardSendTime",
    "exchangeFailed314": "exchangeFailed314",
    "exchangeFailed311": "exchangeFailed311",
    "exchangeFailed": "exchangeFailed",
    "exchangeOrderFailed": "exchangeOrderFailed",
    "exchangeOrderNone": "exchangeOrderNone",
    "exchangeTime": "exchangeTime",
    "exchangeStatus": "exchangeStatus",
    "sevenDaySend": "sevenDaySend",
    "sendAlready": "sendAlready",
    "orderComplete": "orderComplete"
};
var ExchangeTemp = {
    productArry: [],
    classifyArry: [FYEngine.LanguageString.getValue(SccomMsgKey.allExchange), FYEngine.LanguageString.getValue(SccomMsgKey.gameTool),FYEngine.LanguageString.getValue(SccomMsgKey.mobileFee), FYEngine.LanguageString.getValue(SccomMsgKey.shoppingCard),
        FYEngine.LanguageString.getValue(SccomMsgKey.digital), FYEngine.LanguageString.getValue(SccomMsgKey.electrical), FYEngine.LanguageString.getValue(SccomMsgKey.life),
        FYEngine.LanguageString.getValue(SccomMsgKey.gold)],
    classifyTag: [0, 99, 2, 1, 4, 5, 6, 3],
    classTag: 0,
    shopOpenTag: 0,//判断是选中了第几个按钮
};

var ExchangeTemp1 = {
    productArry: [],
    classifyArry: [FYEngine.LanguageString.getValue(SccomMsgKey.allExchange), "话费","时尚数码"],
    classifyTag: [0, 99, 2, 1, 4],
    classTag: 0,
    shopOpenTag: 0,//判断是选中了第几个按钮
};

/**
 * 兑奖商城
 */
var RewardLayer = SccomLayer.extend({
    _isClose : false,
    _exchangeArry1 : [],
    _exchangeArry2 : [],

    ctor: function () {
        cc.log("-------------测试");
        this._super();
        this._index = 0;
        this._finishloading = 0;
        this._isClose = false;
        this._exchangeArry1 =[];
        this._exchangeArry2 = [];
        var self = this;
        ExchangeTemp.shopOpenTag = 0;
        ExchangeTemp1.shopOpenTag = 0;
        var size = cc.winSize;
        this.size = size;
        this.initUI();
        if(FishGlobal.LiveLevel!= 0){
            if(FishGlobal.playerscorelevel>=FishGlobal.realProSwitch){
                this.exchangeBroad();
            }
        }

        this.scheduleOnce(this.timeOutCheck, 15);
        this.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function () {
            Http.getMessage(self.getExchangeListUrl(), null, function (cfgStr) {
                var scene = FYEngine.getRunningLayer(0);
                var that = scene.getChildByName(LobbySceneName.ExchangeLayer);
                ExchangeTemp.productArry = [];
                var jsonInfo = eval('(' + cfgStr + ')');
                var errcode = jsonInfo.code;
                if (errcode != 0) {
//                    cc.log('-----获取获取商品列表 失败');
                    return;
                }

                if(that && (that._isClose == false)){
                    that._exchangeArry1 = jsonInfo.data;
                    // FYEngine.logObject(jsonInfo.data,'------兑奖商城列表1');
                    that._finishloading+=1;
                    if (that && (that._isClose == false)){
                        if(that._finishloading>=1){
                            that.unschedule(that.timeOutCheck);
                            var loading = that.layerbg.getChildByName(SccomLayerName.loading);
                            if (loading) {
                                loading.removeFromParent(true);
                            }

                            that.addContent1();
                            // that.addContent2();
                        }
                    }
                }
            });


        })));

        FYEngine.AddCustomLister(this, "refreshList", function (event) {
            var data = event.getUserData();
            self.refreshListView(parseInt(data));
        });

    },

    addContent1 : function(){
        cc.log("FishGlobal.LiveLevel:"+FishGlobal.LiveLevel+
            "FishGlobal.playerscorelevel:"+FishGlobal.playerscorelevel
        +"FishGlobal.realProSwitch:"+FishGlobal.realProSwitch);
       // FYEngine.AddCommToast("FishGlobal.playerscorelevel:"+FishGlobal.playerscorelevel+"appglobal._switch16:"+appglobal._switch16);
        var that = this;
        if(FishGlobal.LiveLevel ==0){
            for (var i = 0; i < that._exchangeArry1.length; ++i) {
                if(that._exchangeArry1[i].type !=3){
                    continue;
                }
                var box = new ProductExchangeBox(i, that._exchangeArry1[i]);
                if (box) {
                    box.setAnchorPoint(cc.p(0.5, 0.5));
                    that.listview1.pushBackCustomItem(box);
                }
            }
        }else if(FishGlobal.LiveLevel ==1 ||FishGlobal.LiveLevel ==2){
            for (var i = 0; i < that._exchangeArry1.length; ++i) {
                ExchangeTemp.productArry.push(that._exchangeArry1[i]);
                if(that._exchangeArry1[i].type ==99){
                    continue;
                }

                if(FishGlobal.playerscorelevel<FishGlobal.realProSwitch ){
                    if(that._exchangeArry1[i].type !=3){
                        continue;
                    }
                }
                if (ExchangeTemp.shopOpenTag == 0) {
                    var box = new ProductExchangeBox(i, that._exchangeArry1[i]);
                    if (box) {
                        box.setAnchorPoint(cc.p(0.5, 0.5));
                        that.listview1.pushBackCustomItem(box);
                    }
                } else {
                    if (ExchangeTemp.classifyTag[ExchangeTemp.shopOpenTag] == that._exchangeArry1[i].type) {
                        var box = new ProductExchangeBox(i, that._exchangeArry1[i]);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            that.listview1.pushBackCustomItem(box);
                        }
                    }
                }
            }
        }else{
            for (var i = 0; i < that._exchangeArry1.length; ++i) {
                ExchangeTemp.productArry.push(that._exchangeArry1[i]);
                if(FishGlobal.playerscorelevel < FishGlobal.realProSwitch){
                    if(that._exchangeArry1[i].type !=3 && that._exchangeArry1[i].type !=99){
                        continue;
                    }
                }
                if (ExchangeTemp.shopOpenTag == 0) {
                    var box = new ProductExchangeBox(i, that._exchangeArry1[i]);
                    if (box) {
                        box.setAnchorPoint(cc.p(0.5, 0.5));
                        that.listview1.pushBackCustomItem(box);
                    }
                } else {
                    if (ExchangeTemp.classifyTag[ExchangeTemp.shopOpenTag] == that._exchangeArry1[i].type) {
                        var box = new ProductExchangeBox(i, that._exchangeArry1[i]);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            that.listview1.pushBackCustomItem(box);
                        }
                    }
                }
            }
        }
    },

    addContent2: function(){
                                    
    },

    timeOutCheck: function () {
        this._isClose = true;
        var scene = FYEngine.getRunningLayer(0);
        var rewardLayer = scene.getChildByName(LobbySceneName.ExchangeLayer);
        if (rewardLayer) {
            FYEngine.popoutLayerAnimate(rewardLayer.layerbg);
        }

        var classify = scene.getChildByName(LobbySceneName.ClassifyLayer);
        if(classify){
            classify.removeFromParent(true);
        }
        var warmTipLayer = new WarmTipLayer(FYEngine.LanguageString.getValue("WarmTipText3"));
        if(warmTipLayer){
            scene.addChild(warmTipLayer, FishZorder.poplayer, LobbySceneName.TimeOutLayer);
        }



    },


    initUI: function () {
        var bg = this.addLayerBg(SccomRes.MallRes.Outerbg, cc.size(990, 570), cc.p(this.width / 2, this.height * 0.4 + 30));
        this.addInnerBg(SccomRes.MallRes.Innerbg, cc.size(920, 392));
        this.addTitle(SccomRes.RewardRes.Rewardname);
        this.addCloseBtn(this.closeCallBack);

        var tip = FYEngine.createSprite(SccomRes.RewardRes.Tip, cc.p(this.layerbg.width/2, 55));
        if(tip){
            bg.addChild(tip, 0, 12);
        }

        if(FishGlobal.LiveLevel !=0 && (FishGlobal.playerscorelevel>=FishGlobal.realProSwitch)){
            var rewardrecord = new FYEngine.SingleButton(SccomRes.RewardRes.Record,"",this.recordCallBack,FYEngine.ButtonAction.Fade);
            if(rewardrecord){
                rewardrecord.setPosition(cc.p(840,55));
                bg.addChild(rewardrecord, 99, 13);
            }
        }

        var _sprite = FYEngine.createSprite(SccomRes.MallRes.loadingbg, cc.p(bg.width / 2, bg.height * 0.5));
        if(_sprite){
            bg.addChild(_sprite, 99, SccomLayerName.loading);
            var rotate = new cc.RotateBy(1.2, 360);
            _sprite.runAction(new cc.RepeatForever(rotate));
        }

        if(FishGlobal.LiveLevel !=0 && (FishGlobal.playerscorelevel>=FishGlobal.realProSwitch)){
            var classifyBtn = new ccui.Button(SccomRes.RewardRes.ClassNormal, SccomRes.RewardRes.ClassSelect, "", ccui.Widget.PLIST_TEXTURE);
            if (classifyBtn) {
                bg.addChild(classifyBtn, 99, SccomLayerName.classify);
                classifyBtn.setPosition(cc.p(100, 503));
                classifyBtn.addClickEventListener(this.classCallBack);
            }

            var content = new cc.LabelTTF(FYEngine.LanguageString.getValue(SccomMsgKey.allExchange), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 20);
            if (content) {
                content.setAnchorPoint(cc.p(0.5, 0.5));
                content.setColor(cc.color(255, 255, 255));
                classifyBtn.addChild(content, 1, 0);
                content.setPosition(cc.p(classifyBtn.width / 2 - 4, classifyBtn.height / 2));
            }
        }

        var listview = FYEngine.createListView(cc.size(880, 364), cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5), cc.p(0.5, 0.5), 5, ccui.ScrollView.DIR_HORIZONTAL);
        if (listview) {
            this.layerbg.addChild(listview, 1, 10);
            this.listview1 = listview;
            listview.setScrollBarPositionFromCornerForHorizontal(cc.p(0, 0));
        }

        var lotterynumbg = new ccui.ImageView(SccomRes.RewardRes.Broadbg, ccui.Widget.PLIST_TEXTURE);
        if(lotterynumbg){
            lotterynumbg.setScale9Enabled(true);
            lotterynumbg.setContentSize(cc.size(215,40));
            lotterynumbg.setPosition(cc.p(170,55));
            bg.addChild(lotterynumbg, 0, 14);
        }

        var lotterypic = new cc.Sprite();
        if(lotterypic){
            lotterypic.setSpriteFrame(SccomRes.RewardRes.Lotterysmall);
            lotterypic.setAnchorPoint(cc.p(0.5,0.5));
            lotterypic.setPosition(cc.p(3,lotterynumbg.height/2+5));
            lotterynumbg.addChild(lotterypic, 0, 15);
        }
        var usercoupon = FYEngine.createAlts("res/num/fishnum10.png",12,appglobal.getPlayer().coupon,'.');
        //cc.log(FishGlobal.playerInfo.coupon+'@@@@@@@@@@@@@@@@@@@@@111');
        usercoupon.setAnchorPoint(cc.p(0,0.5));
        usercoupon.setPosition(cc.p(lotterynumbg.width*0.1+5,lotterynumbg.height/2));
        lotterynumbg.addChild(usercoupon, 0 ,16);
        this.updateWealth();

    },

    clickCallBack : function(sender){

        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.ExchangeLayer);
        cc.log(layer._index+'-----------按钮按下:'+sender.getTag());
        if(layer._index ==sender.getTag()){
            layer._index = sender.getTag();
            return;
        }

        layer.selectList(sender.getTag());

    },



    closeCallBack : function(){
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.ExchangeLayer);
        layer._isClose = true;
        FYEngine.popoutLayerAnimate(layer.layerbg);
    },

    classCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer1 = scene.getChildByName(LobbySceneName.ExchangeLayer);
        var layer = scene.getChildByName(LobbySceneName.ClassifyLayer);
        if (!layer) {
            cc.log("----------layer._index"+layer1._index);
            layer = new ClassifyWin(layer1._index);
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ClassifyLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },


    recordCallBack: function (sender,type) {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.ExchangeRecordLayer);
        if (!layer) {
            layer = new ExchangeRecord();
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ExchangeRecordLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);

        }
    },

    selectList : function(value){
        this._index = value;
        //ExchangeTemp.shopOpenTag = 0;
        //ExchangeTemp1.shopOpenTag = 0;

        if(value ==1){
            this.listview1.setVisible(false);
            this.listview2.setVisible(true);
            this._sedbtn.setVisible(true);
            this._revbtn.setVisible(false);
            var btn = this.layerbg.getChildByName(SccomLayerName.classify);
            if (btn) {
                var btnname = btn.getChildByTag(0);
                if (btnname) {
                    btnname.setString(ExchangeTemp1.classifyArry[ExchangeTemp1.shopOpenTag]);
                }
            }
        }else{
            this.listview1.setVisible(true);
            this.listview2.setVisible(false);
            this._sedbtn.setVisible(false);
            this._revbtn.setVisible(true);
            var btn = this.layerbg.getChildByName(SccomLayerName.classify);
            if (btn) {
                var btnname = btn.getChildByTag(0);
                if (btnname) {
                    btnname.setString(ExchangeTemp.classifyArry[ExchangeTemp.shopOpenTag]);
                }
            }
        }

    },


    updateWealth: function () {
        var self = this;
        var bg = self.getChildByTag(1);
        var lbg = bg.getChildByTag(14);
        var usercoupon = lbg.getChildByTag(16);
        if (usercoupon) {
           usercoupon.setString(appglobal.getPlayer().coupon);
        }
    },

    exchangeBroad: function () {
        var that = this;
        if (that) {
            var handler = CoreServiceProxy.getInstance().getLobbyHandler();
            if(handler){
                var _broadSp = new ExchangeBroadCast(SccomRes.RewardRes.Broadbg, cc.size(670, 39), cc.rect(20, 0, 17, 36),
                    cc.size(650, 39), cc.p(5, 0), 3.5, ccui.Widget.PLIST_TEXTURE, true, handler._lobbyData.getLobbyBroadExchange());
                _broadSp.setVisible(true);
                // _broadSp.setPosition(cc.p(that.layerbg.width / 2 - 110, 55));
                _broadSp.setPosition(cc.p(that.layerbg.width / 2 + 60, 500));
                that.layerbg.addChild(_broadSp, FishZorder.poplayer, SccomLayerName.broad);
            }
        }
    },

    refreshListView: function (tag) {
//        cc.log('------------11111111111111111111');
        if(this.layerbg && this._isClose ==false){
            if(this._index ==0){
                var btn = this.layerbg.getChildByName(SccomLayerName.classify);
                if (btn) {
                    var btnname = btn.getChildByTag(0);
                    if (btnname) {
                        btnname.setString(ExchangeTemp.classifyArry[tag]);
                    }
                }

//            cc.log('------商城刷新------test1104');
                var shoplist = this.listview1;
                if (shoplist) {
                    shoplist.removeAllItems();
                    if((FishGlobal.LiveLevel == 1 ||FishGlobal.LiveLevel == 2) && tag == 1){
                        return;
                    }
                    //shoplist.removeAllChildren(true);
                    for (var j = 0; j < ExchangeTemp.productArry.length; ++j) {
                        if (tag == 0) {
                            for (var j = 0; j < ExchangeTemp.productArry.length; ++j) {
                                if((FishGlobal.LiveLevel == 1 ||FishGlobal.LiveLevel == 2) && ExchangeTemp.productArry[j].type ==99){
                                    continue;
                                }
                                var box = new ProductExchangeBox(j, ExchangeTemp.productArry[j]);
                                if (box) {
                                    box.setAnchorPoint(cc.p(0.5, 0.5));
                                    shoplist.pushBackCustomItem(box);
                                }
                            }
                        } else {
                            if (ExchangeTemp.productArry[j].type == ExchangeTemp.classifyTag[tag]) {
                                var box = new ProductExchangeBox(j, ExchangeTemp.productArry[j]);
                                if (box) {
                                    box.setAnchorPoint(cc.p(0.5, 0.5));
                                    shoplist.pushBackCustomItem(box);
                                }
                            }
                        }
                    }
                }
            }

        }

    },
    getExchangeListUrl: function () {
        var service = formservice("exchangeListRole");
        var time = Date.now();
        var sign = formsign("exchangeListRole", time);
        time = formTime(time);
        var source = formsource(appglobal.getSource());
        var rid = {name: "role", value : appglobal.getPlayer().roleid};
        var checksum = formchecksum(source.value, sign.value, FYEngine.PrivateKey);
        return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, source,rid);
    },

    getExchangeListUrl1: function () {
        var service = formservice("gameItemExchange");
        var time = Date.now();
        var sign = formsign("gameItemExchange", time);
        time = formTime(time);
        var type ={name:"type",value:0};
        var mode = {name:"mode",value:0};
        var source = formsource(appglobal.getSource());
        var checksum = formchecksum( mode.value,sign.value, FYEngine.PrivateKey);
//        FYEngine.logObject(formUrl(appglobal.getFishApiUrl(), "fishService", service, time, mode,sign, type,checksum),"---------wangzhi:");
        return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, mode,type,sign, checksum);
    }


});
var ExchangeBroadCast = FYEngine.RichBroadCast.extend({
    _handler: null,
    _broadArr1: [],
    _index: 0,

    ctor: function (filename, size, rect, masksize, maskpos, move, textureType, isshow, broadArry) {
        this._super(filename, size, rect, masksize, maskpos, move, textureType, isshow);

        this._broadArr1 = broadArry;

        this.scheduleUpdate();

        return true;
    },

    update: function (dt) {
        if (this._broadArr1 != undefined) {
            if (this._broadArr1.length == 0) {
                //cc.log('没有广播');
                return;
            }

            if (this._broadlab == null) {
                //if (!this._isAwlaysShow){
                //this.setVisible(true);
                //}

                var broadInfo = this._broadArr1[this._index];//.shift();
                this.setLabelText(broadInfo.szMsg, cc.color.WHITE, cc.color(254, 245, 6), 24); //
                ++this._index;
                if (this._index >= this._broadArr1.length) {
                    this._index = 0;
                }
                //return;
                //this.runMoveToAction();
            }
            this.OnUpdateOrigion(dt);
        }

    },
    /***
     * 每帧刷新
     * @param dt
     */
    OnUpdateOrigion: function (dt) {
        if (!this._broadlab) {
            return;
        }

        this._broadlab.x -= this._move;
        if (this._broadlab.x < -(this._broadlab._getWidth() - 575)) {
            this._broadlab.removeFromParent();
            this._broadlab = null;
            if (!this._isAwlaysShow) {
                this.setVisible(false);
            }
        }
    },

});
var ExchangeRecord = DialogLayer.extend({
    ctor: function () {
        this._super();
        this._index = 0;
        var bg = this.addLayerBg(cc.size(590, 535));
        //this.addTitleBg(LobbyRes.SmallWinRes.recordtittle, 492);
        var titleBigBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleBigBG, cc.p(bg.width / 2 , bg.height * 0.95), null, cc.size(600, 73), cc.rect(164, 0, 5, 73));
        bg.addChild(titleBigBg, 0, 3);
//        FYEngine.logObject(titleBigBg.getPosition(), '------------2-----');
        var titleSmallBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleSmallBG, cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56), null, cc.size(276, 54), cc.rect(50, 0, 8, 54));
        titleBigBg.addChild(titleSmallBg, 0, 1);

        var titleName = FYEngine.createSprite(SccomRes.SmallWinRes.recordtittle, cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56));
        titleBigBg.addChild(titleName, 0, 2);
        this.addCloseBtn();

        var layer1 = new ccui.Layout();
        if(layer1){
            this._layer1 = layer1;
            layer1.setContentSize(cc.size(530,430));
            this.layerbg.addChild(layer1);
            layer1.setBackGroundColorType(ccui.Layout.BG_COLOR_NONE);
            // layer1.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
            // layer1.setBackGroundColor(cc.color(255,0,0));
            layer1.setPosition(cc.p(30,35));
        }
        this.loadData();
    },

    loadData : function(){
        cc.log("---------------------下载数据");

        Http.getMessage(function () {
                var service = formservice("exchangeOrder");
                var time = Date.now();
                var sign = formsign("exchangeOrder", time);
                time = formTime(time);
                var roleId = formRoleId(appglobal.getPlayer().roleid);
                var checksum = formchecksum(roleId.value, sign.value, FYEngine.PrivateKey);
                return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, roleId);
            }(), null, function (cfgStr) {
                var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.ExchangeRecordLayer);
                var jsonInfo = eval('(' + cfgStr + ')');
                var errcode = jsonInfo.code;
                if (errcode != 0) {
                    cc.log('------------------------------------兑奖记录信息 失败');
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeOrderFailed));
                    return;
                }

                var dataValue = jsonInfo.data;
               FYEngine.logObject(dataValue,"--------------DATAVALUE:");
                if(layer){
                    if (dataValue.length == 0) {
                        var label = new cc.LabelTTF(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeOrderNone), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 26);
                        if (label) {
                            cc.log("--------------创建label");
                            layer._layer1.addChild(label);
                            label.setPosition(cc.p(layer._layer1.width / 2, layer._layer1.height / 2 + 10));
                        }
                        return;
                    }

                    var listview = FYEngine.createListView(cc.size(530,430), cc.p(layer._layer1.width / 2 , layer._layer1.height * 0.5 ), cc.p(0.5, 0.5), 1, ccui.ScrollView.DIR_VERTICAL);
                    if (listview) {
                        layer._layer1.addChild(listview, 1, 10);
                    }


                    for (var i = 0; i < dataValue.length; ++i) {
                        var box = new RecordBox(i, dataValue[i]);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            listview.pushBackCustomItem(box);
                        }
                    }
                }
            }
        );
    },

   
    clickCallBack : function(sender){

        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.ExchangeRecordLayer);
        cc.log(layer._index+'-----------按钮按下:'+sender.getTag());
        if(layer._index ==sender.getTag()){
            layer._index = sender.getTag();
            return;
        }

        layer.selectList(sender.getTag());

    },

    selectList : function(value){
        this._index = value;
        //ExchangeTemp.shopOpenTag = 0;
        //ExchangeTemp1.shopOpenTag = 0;

        if(value ==1){
            //this.listview1.setVisible(false);
            //this.listview2.setVisible(true);
            this._layer1.setVisible(false);
            this._layer2.setVisible(true);
            this._sedbtn.setVisible(true);
            this._revbtn.setVisible(false);
            var btn = this.layerbg.getChildByName(SccomLayerName.classify);
        }else{
            this._layer1.setVisible(true);
            this._layer2.setVisible(false);
            this._sedbtn.setVisible(false);
            this._revbtn.setVisible(true);

        }

    },


});

var ProductExchangListArry = ["1000003.png","1000004.png","1000005.png","1000006.png","1000007.png","1000008.png","1000009.png","1000010.png",
    "1000011.png","1000012.png","1000013.png","1000014.png","1000015.png","1000016.png","1000017.png","1000018.png","1000019.png","1000020.png",
    "1000021.png","1000022.png","1000023.png","1000024.png","1000025.png","1000026.png","1000027.png","1000028.png","1000029.png","1000030.png",
    "1000031.png","1000032.png","1000033.png","1000034.png","1000039.png","11000001.png","11000002.png","11000003.png","2000004.png","3000014.png",
    "3000015.png","3000016.png","3000017.png","3000018.png","3000019.png","3000020.png","3000021.png","3000022.png","3000023.png","3000024.png",
    "3000025.png","3000026.png","3000027.png","3000028.png","3000029.png","3000030.png","3000031.png","3000032.png","3000033.png","3000034.png",
    "3000035.png","3000036.png","3000037.png","3000038.png","3000039.png","4000003.png","4000004.png","4000008.png","4000009.png","4000010.png",
    "4000011.png","4000012.png","4000013.png","4000014.png","4000015.png","4000016.png","4000017.png","4000018.png","4000019.png","4000020.png",
    "4000021.png","4000022.png","4000023.png","4000024.png","4000025.png","4000026.png","4000027.png","4000028.png","4000029.png","4000030.png",
    "5000002.png","5000003.png","5000004.png","9900001.png","9900002.png","9900003.png","4000006.png","4000037.png","1000101.png","1000102.png",
    "9900004.png","9900005.png","9900006.png","3000040.png","3000041.png","3000042.png","3000043.png","4000040.png","4000041.png",
    "4000042.png","4000043.png","4000044.png","4000045.png","4000046.png","4000047.png","4000048.png","4000049.png","4000050.png",
    "4000051.png","4000052.png","4000053.png","fishnewboompic1.png","fishnewboompic10.png","fishnewboompic100.png","3000049.png",
    "3000050.png","4000054.png","4000055.png","4000056.png","3000051.png","3000052.png","3000053.png","3000054.png","3000055.png",
    "4000058.png","4000059.png","4000060.png","4000061.png","4000062.png","4000063.png","4000064.png","4000065.png","4000066.png",
    "4000067.png","4000068.png","3000056.png","4000070.png","4000071.png","4000072.png","4000073.png","4000074.png","4000075.png"];

var ProductExchangeBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _status: 0,
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        this.loadTexture(SccomRes.MallRes.Boxbg, ccui.Widget.PLIST_TEXTURE);
        var labeltop = new cc.LabelTTF();
        if (labeltop) {
            this.addChild(labeltop, 0, 0);
            labeltop.initWithString(this._info.name, FYEngine.LanguageString.getValue(LoginMsgKey.Arial), 24);
            labeltop.setPosition(cc.p(this.width / 2, 340));
        }

        var IsPic = ProductExchangListArry.indexOf(this._info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this._info.picId;
            var pic = new cc.Sprite("#" + picName);
            if(pic){
                pic.setScale(0.8);
                pic.setPosition(cc.p(this.width / 2, this.height * 0.55 + 20));
                this.addChild(pic, 0, 1);
            }
        }else{
            picName = "nopic.png";
            var pic = new cc.Sprite("#" + picName);
            if(pic){
                //pic.setScale(0.8);
                pic.setPosition(cc.p(this.width / 2, this.height * 0.55 + 20));
                this.addChild(pic, 0, 1);
            }
        }
        //var pic = new cc.Sprite("#" + picName);
        //if(pic){
        //    pic.setScale(0.8);
        //    pic.setPosition(cc.p(this.width / 2, this.height * 0.55 + 20));
        //    this.addChild(pic, 0, 1);
        //}

        var stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stock);
        var stock = new cc.LabelTTF();
        if (stock) {
            this.addChild(stock, 0, 'stock');
            if (this._info.initStock >= 2000000000) {
                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockNotConfine);
                stock.setColor(cc.color(14, 95, 14));
            } else if (this._info.initStock == 0 || this._info.stock == 0) {
                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockEmpty);
                stock.setColor(cc.color('#616161'));
            } else if (this._info.stock / this._info.initStock > 0.3) {
                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockEnough);
                stock.setColor(cc.color(14, 95, 14));
            } else if (this._info.stock / this._info.initStock <= 0.3) {
                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockNotEnough);
                stock.setColor(cc.color(255, 0, 0));
            }
            stock.initWithString(stocktemp, FYEngine.LanguageString.getValue(LoginMsgKey.Arial), 18);
            stock.setPosition(cc.p(this.width / 2 + 5, 122));
        }


        var btn = new ccui.ImageView(SccomRes.MallRes.Boxbtn, ccui.Widget.PLIST_TEXTURE);
        if (btn) {
            var tag = this._item;
            btn.setTouchEnabled(true);
            this.addChild(btn, 0, tag);
            btn.setPosition(cc.p(this.width / 2, this.height * 0.16));
            btn.setSwallowTouches(true);
            FYEngine.AddNodeTouchListener(btn, this.boxbtnCallBack, FYEngine.ActionType.Fade);
        }

        var lotteryqty = this._info.coinCount + '';
        var number = FYEngine.createAlts(SccomRes.MallRes.Number, 10, lotteryqty, '0');
        if (number) {
            btn.addChild(number, 0, 1);
            btn.setSwallowTouches(false);
            number.setAnchorPoint(cc.p(0.5, 0.5));
            number.setPosition(cc.p(btn.width / 2 + 10, btn.height / 2 + 7));
        }

        var lottery = new cc.Sprite('#' + SccomRes.RewardRes.Lotterysmall);
        if (lottery) {
            lottery.setAnchorPoint(cc.p(0.5, 0.5));
            lottery.setPosition(cc.p(btn.width * 0.15, btn.height / 2 + 15));
            btn.addChild(lottery, 0, 2);
        }
    },

    boxbtnCallBack: function (sender, type) {
        var box = sender.getParent();
        var scene = FYEngine.getRunningLayer(0);
        var inlayer = scene.getChildByName(LobbySceneName.ProductInfoLayer);
        FishGlobal.ProLimitCount = box._info.limitCount;
        if (!inlayer) {
            var infolayer = new ProductInfoWin(box._item, box._info);
            if (infolayer) {
                scene.addChild(infolayer, FishZorder.poplayer, LobbySceneName.ProductInfoLayer);
                FYEngine.popupLayerAnimate(infolayer.layerbg);
            }
        }
    },

});

//var ProductExchangeBoxDL = ccui.ImageView.extend({
//    _item: 0,
//    _info: {},
//    _status: 0,
//    _count:0,
//    ctor: function (i, info) {
//        this._super();
//        this._count =0;
//        this._item = i;
//        this._info = info;
//        this.loadTexture(SccomRes.MallRes.Boxbg, ccui.Widget.PLIST_TEXTURE);
//
//        var labeltop = new cc.LabelTTF();
//        if (labeltop) {
//            this.addChild(labeltop, 0, 0);
//            labeltop.initWithString(this._info.name, FYEngine.LanguageString.getValue(LoginMsgKey.Arial), 24);
//            labeltop.setPosition(cc.p(this.width / 2, 340));
//        }
//
//        if(this._info.picId ==""){
//            var pic = new cc.Sprite("#nopic.png");
//            pic.setPosition(cc.p(this.width/2, this.height*0.55+20));
//            this.addChild(pic, 0, "selfphoto");
//        }else{
//            var pic = new cc.Sprite();
//            pic.setPosition(cc.p(this.width/2, this.height*0.55+20));
//            this.addChild(pic, 0, "selfphoto");
//            // cc.log("-----picid"+this._info.picId);
//            var frame = cc.spriteFrameCache.getSpriteFrame(this._info.picId);
//            if(!frame){
//                var _sprite = new cc.Sprite("#fhis_bloading.png");
//                if(_sprite){
//                    _sprite.setPosition(cc.p(this.width/2, this.height*0.55+20));
//                    this.addChild(_sprite, 0, 'loading');
//                    var rotate = new cc.RotateBy(1,240);
//                    _sprite.runAction(new cc.RepeatForever(rotate));
//                }
//                this.refreshpic(0);
//                this.schedule(this.refreshpic, 1);
//            }
//            else{
//                // _sprite.removeFromParent(true);
//                pic.setSpriteFrame(frame);
//                pic.setScale(0.8);
//            }
//        }
//
//        // var IsPic = ProductExchangListArry.indexOf(this._info.picId);
//        // var picName = "";
//        // if(IsPic >= 0){
//        //     picName = this._info.picId;
//        //     var pic = new cc.Sprite("#" + picName);
//        //     if(pic){
//        //         pic.setScale(0.8);
//        //         pic.setPosition(cc.p(this.width / 2, this.height * 0.55 + 20));
//        //         this.addChild(pic, 0, 1);
//        //     }
//        // }else{
//        //     picName = "nopic.png";
//        //     var pic = new cc.Sprite("#" + picName);
//        //     if(pic){
//        //         //pic.setScale(0.8);
//        //         pic.setPosition(cc.p(this.width / 2, this.height * 0.55 + 20));
//        //         this.addChild(pic, 0, 1);
//        //     }
//        // }
//
//
//        var stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stock);
//        var stock = new cc.LabelTTF();
//        if (stock) {
//            this.addChild(stock, 0, 'stock');
//            if (this._info.initStock >= 2000000000) {
//                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockNotConfine);
//                stock.setColor(cc.color(14, 95, 14));
//            } else if (this._info.initStock == 0 || this._info.stock == 0) {
//                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockEmpty);
//                stock.setColor(cc.color('#616161'));
//            } else if (this._info.stock / this._info.initStock > 0.3) {
//                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockEnough);
//                stock.setColor(cc.color(14, 95, 14));
//            } else if (this._info.stock / this._info.initStock <= 0.3) {
//                stocktemp = FYEngine.LanguageString.getValue(SccomMsgKey.stockNotEnough);
//                stock.setColor(cc.color(255, 0, 0));
//            }
//            stock.initWithString(stocktemp, FYEngine.LanguageString.getValue(LoginMsgKey.Arial), 18);
//            stock.setPosition(cc.p(this.width / 2 + 5, 122));
//        }
//
//
//        var btn = new ccui.ImageView(SccomRes.MallRes.Boxbtn, ccui.Widget.PLIST_TEXTURE);
//        if (btn) {
//            var tag = this._item;
//            btn.setTouchEnabled(true);
//            this.addChild(btn, 0, tag);
//            btn.setPosition(cc.p(this.width / 2, this.height * 0.16));
//            btn.setSwallowTouches(true);
//            FYEngine.AddNodeTouchListener(btn, this.boxbtnCallBack, FYEngine.ActionType.Fade);
//        }
//
//        var lotteryqty = this._info.coinCount + '';
//        var number = FYEngine.createAlts(SccomRes.MallRes.Number, 10, lotteryqty, '0');
//        if (number) {
//            btn.addChild(number, 0, 1);
//            btn.setSwallowTouches(false);
//            number.setAnchorPoint(cc.p(0.5, 0.5));
//            number.setPosition(cc.p(btn.width / 2 + 10, btn.height / 2 + 7));
//        }
//
//        var lottery = new cc.Sprite('#' + SccomRes.RewardRes.Lotterysmall);
//        if (lottery) {
//            lottery.setAnchorPoint(cc.p(0.5, 0.5));
//            lottery.setPosition(cc.p(btn.width * 0.15, btn.height / 2 + 15));
//            btn.addChild(lottery, 0, 2);
//        }
//    },
//
//    // refreshpic : function(dt){
//    //     var self = this;
//    //     var frame = cc.spriteFrameCache.getSpriteFrame(self._info.picId);
//    //     if(frame){
//    //         cc.log("------------获取到了图片资源");
//    //         self.unschedule(self.refreshpic);
//    //         var loading = self.getChildByName('loading');
//    //         if(loading){
//    //             loading.removeFromParent(true);
//    //         }
//    //         var pic = self.getChildByName("selfphoto");
//    //         if(pic){
//    //             pic.setSpriteFrame(frame);
//    //             pic.setScale(0.8);
//    //         }
//    //     }else{
//    //         var url = appglobal._downphoto+'/' + self._info.picId;
//    //         if(url){
//    //             var dlname = self._info.picId.split(".");
//    //             app.httpManager.loadImgFromUrl(url, ''+dlname[0]);
//    //         }
//    //     }
//    //     self._count++;
//    //     if(self._count>8){
//    //         self.unschedule(self.refreshpic);
//    //         var loading = self.getChildByName('loading');
//    //         if(loading){
//    //             loading.removeFromParent(true);
//    //         }
//    //         var pic = self.getChildByName("selfphoto");
//    //         if(pic){
//    //             pic.setSpriteFrame("nopic.png");
//    //             pic.setScale(0.8);
//    //         }
//    //     }
//    // },
//
//    boxbtnCallBack: function (sender, type) {
//        var box = sender.getParent();
//        var scene = FYEngine.getRunningLayer(0);
//        var inlayer = scene.getChildByName(LobbySceneName.ProductInfoLayer);
//        if (!inlayer) {
//            var infolayer = new ProductInfoWin(box._item, box._info);
//            if (infolayer) {
//                scene.addChild(infolayer, FishZorder.poplayer, LobbySceneName.ProductInfoLayer);
//                FYEngine.popupLayerAnimate(infolayer.layerbg);
//            }
//        }
//    },
//
//});


var ProductInfoWin = DialogLayer.extend({
    item: 0,
    info: {},
    _time: 0,
    ctor: function (i, info) {
        this._super();
        this.item = i;
        this.info = info;
        this.initUI();

    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(924, 541));
        this.addTitleBg(SccomRes.SmallWinRes.exchangetittle, 924);
        this.addCloseBtn();



        var innerbg = new ccui.ImageView(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        if (innerbg) {
            innerbg.setScale9Enabled(true);
            innerbg.setContentSize(cc.size(850, 312));
            innerbg.setPosition(cc.p(bg.width/2, 300));
            bg.addChild(innerbg, 0, 'innerbg');
        }

        var box = new ProductBox(this.item, this.info);
        if (box) {
            bg.addChild(box, 1, 'box');
            box.setPosition(cc.p(179, 295));
        }

        var confirmbtn = new cc.Sprite(FishSceneRes.DialogPng.ConfirmBtn);
        if (confirmbtn) {
            confirmbtn.setPosition(cc.p(670, 75));
            bg.addChild(confirmbtn, 0, 'btn');
            FYEngine.AddNodeTouchListener(confirmbtn, this.confirmCallBack, FYEngine.ActionType.Fade);
        }
        var confirmtitle = new cc.Sprite(SccomRes.SmallWinRes.exchangebtn);
        if (confirmtitle) {
            confirmtitle.setPosition(confirmbtn.width / 2, confirmbtn.height * 0.6);
            confirmbtn.addChild(confirmtitle, 0);
        }

        var label = new ccui.Text("当前拥有", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (label) {
            label.setColor(cc.color("#ffffff"));
            label.setPosition(cc.p(210, 55));
            label.enableOutline(cc.color("023b8a"), 4);
            bg.addChild(label, 0);
        }

        var lotterynumbg = new ccui.ImageView(SccomRes.RewardRes.Broadbg, ccui.Widget.PLIST_TEXTURE);
        if (lotterynumbg) {
            lotterynumbg.setScale9Enabled(true);
            lotterynumbg.setContentSize(cc.size(215, 50));
            lotterynumbg.setPosition(cc.p(415, 55));
            bg.addChild(lotterynumbg, 0, 14);

            var usercoupon = FYEngine.createAlts("res/num/fishnum10.png", 12, appglobal.getPlayer().coupon, '.');
            if(usercoupon){
                usercoupon.setAnchorPoint(cc.p(0, 0.5));
                usercoupon.setPosition(cc.p(lotterynumbg.width * 0.2 - 5, lotterynumbg.height / 2));
                lotterynumbg.addChild(usercoupon, 0, 16);
            }

            var lotterypic = new cc.Sprite();
            if(lotterypic){
                lotterypic.setSpriteFrame(SccomRes.RewardRes.Lotterysmall);
                lotterypic.setAnchorPoint(cc.p(0.5,0.5));
                lotterypic.setPosition(cc.p(5,lotterynumbg.height/2+8));
                lotterynumbg.addChild(lotterypic, 0, 15);
            }
        }

        var label2 = new ccui.Text("兑换所需", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (label2) {
            label2.setColor(cc.color("#ffffff"));
            label2.setPosition(cc.p(210, 110));
            label2.enableOutline(cc.color("023b8a"), 4);
            bg.addChild(label2, 0);
        }

        var lotterynumbg2 = new ccui.ImageView(SccomRes.RewardRes.Broadbg, ccui.Widget.PLIST_TEXTURE);
        if (lotterynumbg2) {
            lotterynumbg2.setScale9Enabled(true);
            lotterynumbg2.setContentSize(cc.size(215, 50));
            lotterynumbg2.setPosition(cc.p(415, 110));
            bg.addChild(lotterynumbg2, 0, 14);

            var usercoupon2 = FYEngine.createAlts("res/num/fishnum10.png", 12, ""+this.info.coinCount, '.');
            if(usercoupon2){
                usercoupon2.setAnchorPoint(cc.p(0, 0.5));
                usercoupon2.setPosition(cc.p(lotterynumbg2.width * 0.2 - 5, lotterynumbg2.height / 2));
                lotterynumbg2.addChild(usercoupon2, 0, 16);
            }

            var lotterypic2 = new cc.Sprite();
            if(lotterypic2){
                lotterypic2.setSpriteFrame(SccomRes.RewardRes.Lotterysmall);
                lotterypic2.setAnchorPoint(cc.p(0.5,0.5));
                lotterypic2.setPosition(cc.p(5,lotterynumbg2.height/2+8));
                lotterynumbg2.addChild(lotterypic2, 0, 15);
            }
        }


        var scrollView = new ccui.ScrollView();
        if(scrollView){
//            cc.log('-------build ok');
            scrollView.setScrollBarEnabled(false);
            scrollView.setContentSize(460, 260);
            scrollView.setAnchorPoint(cc.p(0.5, 0.5));
            scrollView.setPosition(cc.p(560, innerbg.height * 0.5));
            innerbg.addChild(scrollView);
        }

        var container = scrollView.getInnerContainer();

        //var goodsDesc = new cc.LabelTTF();
        var goodsDesc = cc.Label.createWithSystemFont(""+this.info.desc, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei),30);
        if (goodsDesc) {
            goodsDesc.setWidth(460);
            var myHeight = 260;
            if(goodsDesc.getContentSize().height>=260){
                myHeight = goodsDesc.getContentSize().height;
            }else{
                myHeight = 260;
            }
            container.setContentSize(460, myHeight);
            goodsDesc.setAnchorPoint(cc.p(0,1));
            //goodsDesc.setDimensions(cc.size(450, 220));
            goodsDesc.setPosition(cc.p(0,container.height));
            container.addChild(goodsDesc, 0, 100);
            //goodsDesc.setFontSize(30);
            //goodsDesc.setString();
            if (this.info.code == 3) {
                goodsDesc.setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            }
        }
        scrollView.jumpToTop();

        this.updateWealth();
    },

    confirmCallBack: function () {
        FishGlobal.bExchangeType =0;
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.ProductInfoLayer);

        if (layer.info.initStock == 0 || layer.info.stock == 0) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeEmpty));
            return;
        }

        if (appglobal.getPlayer().coupon < Number(layer.info.coinCount)) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.couponNotEnough));
            return;
        }

        if (layer.info.code == 1) {
            var orderlayer = new BillOrderLayer(layer.item, layer.info);
            if (orderlayer) {
                scene.addChild(orderlayer, FishZorder.poplayer, LobbySceneName.BillOrderLayer);
                FYEngine.popupLayerAnimate(orderlayer.layerbg);
            }
        }else if (layer.info.code == 2) {
            var orderlayer = new RealProductLayer(layer.item, layer.info);
            if (orderlayer) {
                scene.addChild(orderlayer, FishZorder.poplayer, LobbySceneName.RealProductLayer);
                FYEngine.popupLayerAnimate(orderlayer.layerbg);
            }
        }else {
            var handler = CoreServiceProxy.getInstance().getLobbyHandler();
            if (handler) {
                var loading = FYEngine.createLoadingLayer(SccomRes.MallRes.loadingbg, SccomRes.MallRes.loadingfish);
                if (loading) {
                    scene.addChild(loading, FishZorder.poplayer, 'loading2');
                }
                handler.sendExchangeProductReq(layer.info.goodsId, '', '', '', '', '');//,'','','',''
                layer.schedule(layer.timeCount, 1);
            }
        }

    },

    updateWealth: function () {
        var self = this;
        var lbg = self.layerbg.getChildByTag(14);
        var usercoupon = lbg.getChildByTag(16);
        if (usercoupon) {
            usercoupon.setString(appglobal.getPlayer().coupon);
        }
    },

    timeCount: function (dt) {
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            var loading2 = this.getParent().getChildByName('loading2');
            if (loading2) {
                loading2.removeFromParent(true);

            }
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.networkTimeOut));
            this.unschedule(this.timeCount);
        }
    }
});

var ProductInfoWin1 = DialogLayer.extend({
    item: 0,
    info: {},
    _time: 0,
    ctor: function (i, info) {
        this._super();
        this.item = i;
        this.info = info;
        this.initUI();

    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(924, 541));
        this.addTitleBg(SccomRes.SmallWinRes.exchangetittle, 924);
        this.addCloseBtn();



        var innerbg = new ccui.ImageView(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        if (innerbg) {
            innerbg.setScale9Enabled(true);
            innerbg.setContentSize(cc.size(850, 312));
            innerbg.setPosition(cc.p(bg.width/2, 300));
            bg.addChild(innerbg, 0, 'innerbg');
        }

        var box = new ProductBox(this.item, this.info);
        if (box) {
            bg.addChild(box, 1, 'box');
            box.setPosition(cc.p(179, 295));
        }

        var confirmbtn = new cc.Sprite(FishSceneRes.DialogPng.ConfirmBtn);
        if (confirmbtn) {
            confirmbtn.setPosition(cc.p(670, 75));
            bg.addChild(confirmbtn, 0, 'btn');
            FYEngine.AddNodeTouchListener(confirmbtn, this.confirmCallBack, FYEngine.ActionType.Fade);
        }
        var confirmtitle = new cc.Sprite(SccomRes.SmallWinRes.exchangebtn);
        if (confirmtitle) {
            confirmtitle.setPosition(confirmbtn.width / 2, confirmbtn.height * 0.6);
            confirmbtn.addChild(confirmtitle, 0);
        }

        var innerbg2 = new ccui.ImageView(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        if (innerbg2) {
            innerbg2.setScale9Enabled(true);
            innerbg2.setContentSize(cc.size(375, 90));
            innerbg2.setPosition(cc.p(350,80));
            bg.addChild(innerbg2, 0, 'innerbg2');
        }

        var qty = FishGlobal.getToolQty(this.info.code);
        var label = new ccui.Text("（您拥有"+qty+"张）", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (label) {
            label.setColor(cc.color("#0090b8"));
            label.setPosition(cc.p(365, 65));
            //label.enableOutline(cc.color("023b8a"), 4);
            bg.addChild(label, 0,"wealth");
        }

        var toolname = FishGlobal.getExchangeGoodsNameById(this.info.code);
        var label2 = new ccui.Text("兑换所需："+toolname+" x 1", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (label2) {
            label2.setColor(cc.color("#ffffff"));
            label2.setPosition(cc.p(365, 95));
            label2.enableOutline(cc.color("023b8a"), 4);
            bg.addChild(label2, 0);
        }


        var scrollView = new ccui.ScrollView();
        if(scrollView){
//            cc.log('-------build ok');
            scrollView.setScrollBarEnabled(false);
            scrollView.setContentSize(460, 260);
            scrollView.setAnchorPoint(cc.p(0.5, 0.5));
            scrollView.setPosition(cc.p(560, innerbg.height * 0.5));
            innerbg.addChild(scrollView);
        }

        var container = scrollView.getInnerContainer();

        //var goodsDesc = new cc.LabelTTF();
        var goodsDesc = cc.Label.createWithSystemFont(""+this.info.desc, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei),30);
        if (goodsDesc) {
            goodsDesc.setWidth(460);
            var myHeight = 260;
            if(goodsDesc.getContentSize().height>=260){
                myHeight = goodsDesc.getContentSize().height;
            }else{
                myHeight = 260;
            }
            container.setContentSize(460, myHeight);
            goodsDesc.setAnchorPoint(cc.p(0,1));
            //goodsDesc.setDimensions(cc.size(450, 220));
            goodsDesc.setPosition(cc.p(0,container.height));
            container.addChild(goodsDesc, 0, 100);
            //goodsDesc.setFontSize(30);
            //goodsDesc.setString();
            if (this.info.code == 3) {
                goodsDesc.setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            }
        }
        scrollView.jumpToTop();

        this.updateWealth();
    },

    confirmCallBack: function () {
        FishGlobal.bExchangeType = 1;
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.ProductInfoLayer);

        if (layer.info.initStock == 0 || layer.info.stock == 0) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeEmpty));
            return;
        }
        var qty = FishGlobal.getToolQty(layer.info.code);
        if (qty <= 0) {
            FYEngine.AddCommToast("兑换券数量不足");
            return;
        }

        if (layer.info.goodsId >= 1000000 && layer.info.goodsId <= 1999999) {
            var orderlayer = new BillOrderLayer(layer.item, layer.info);
            if (orderlayer) {
                scene.addChild(orderlayer, FishZorder.poplayer, LobbySceneName.BillOrderLayer);
                FYEngine.popupLayerAnimate(orderlayer.layerbg);
            }
        }else if (layer.info.goodsId >= 2000000 && layer.info.goodsId <= 2999999) {
            var orderlayer = new RealProductLayer(layer.item, layer.info);
            if (orderlayer) {
                scene.addChild(orderlayer, FishZorder.poplayer, LobbySceneName.RealProductLayer);
                FYEngine.popupLayerAnimate(orderlayer.layerbg);
            }
        }
        //else {
        //    var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        //    if (handler) {
        //        var loading = FYEngine.createLoadingLayer(SccomRes.MallRes.loadingbg, SccomRes.MallRes.loadingfish);
        //        if (loading) {
        //            scene.addChild(loading, FishZorder.poplayer, 'loading2');
        //        }
        //        handler.sendExchangeProductReq(layer.info.goodsId, '', '', '', '', '');//,'','','',''
        //        layer.schedule(layer.timeCount, 1);
        //    }
        //}

    },

    updateWealth: function () {
        var self = this;
        var qty = FishGlobal.getToolQty(this.info.code);
        var usercoupon = self.layerbg.getChildByName("wealth");
        //var usercoupon = lbg.getChildByTag(16);
        if (usercoupon) {
            if(qty>0){
                usercoupon.setColor(cc.color("#ffffff"));
                usercoupon.enableOutline(cc.color("023b8a"), 4);
            }else{
                usercoupon.setColor(cc.color("#0090b8"));
                usercoupon.disableEffect();
            }
            usercoupon.setString("（您拥有"+qty+"张）");
        }
    },

    timeCount: function (dt) {
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            var loading2 = this.getParent().getChildByName('loading2');
            if (loading2) {
                loading2.removeFromParent(true);

            }
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.networkTimeOut));
            this.unschedule(this.timeCount);
        }
    }
});

var ProductBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _status: 0,
    _count:0,
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        this._count =0;
        this.loadTexture("fish_hallnew074.png", ccui.Widget.PLIST_TEXTURE);

        var self = this;

        var labeltop = new cc.LabelTTF();
        if (labeltop) {
            this.addChild(labeltop, 0, 0);
            labeltop.initWithString(this._info.name, FYEngine.LanguageString.getValue(LoginMsgKey.Arial), 24);
            labeltop.setPosition(cc.p(this.width / 2 + 5, 280));
        }


        var IsPic = ProductExchangListArry.indexOf(this._info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this._info.picId;
        }else{
            picName = "nopic.png";
        }

        var pic = new cc.Sprite("#" + picName);
        if (pic) {
            this.addChild(pic, 0, 1);
            pic.setPosition(cc.p(this.width / 2, this.height * 0.5));

        }
    },

    refreshpic: function () {
        var self = this;
        var frame = cc.spriteFrameCache.getSpriteFrame(self._info.picId);
        if(frame){
            cc.log("------------获取到了图片资源1");
            self.unschedule(self.refreshpic);
            var loading = self.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame(frame);
            }
        }else{
            var url = appglobal._downphoto+'/' + self._info.picId;
            if(url){
                var dlname = self._info.picId.split(".");
                app.httpManager.loadImgFromUrl(url, ''+dlname[0]);
            }
        }
        self._count++;
        if(self._count>8){
            self.unschedule(self.refreshpic);
            var loading = self.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame("nopic.png");
            }
        }

    },


});

var BillOrderLayer = SmallLayer.extend({
    item: 0,
    info: {},
    name: '',
    number1: '',
    number2: '',
    _time: 0,
    _count:0,
    ctor: function (item, info) {
        this._super();
        this.item = item;
        this.info = info;
        this._count=0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(789, 474));
        this.addInnerBg(SmallLayerRes.Innerbg, cc.size(700, 290));
        this.addTitleBg(SmallLayerRes.TitleWrite);
        this.addCloseBtn();
        this.addConfirmBtn(this.confirmCallBack);
        this.addCancelBtn();

        var IsPic = ProductExchangListArry.indexOf(this.info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this.info.picId;
        }else{
            picName = "nopic.png";
        }
        //cc.log("-------------picname"+picName);
        var rewardtexture = new cc.Sprite("#" + picName);//从服务器获取spriteFrame后设置
        if (rewardtexture) {
            rewardtexture.setPosition(cc.p(150, 305));
            bg.addChild(rewardtexture, 1, 'rewardtexture');
        }

        // if(this.info.picId ==""){
        //     var pic = new cc.Sprite("#nopic.png");
        //     pic.setPosition(cc.p(150, 305));
        //     pic.setScale(0.8);
        //     bg.addChild(pic, 0, "selfphoto");
        // }else{
        //     var pic = new cc.Sprite();
        //     pic.setPosition(cc.p(150, 305));
        //     bg.addChild(pic, 0, "selfphoto");
        //     // cc.log("-----picid"+this._info.picId);
        //     var frame = cc.spriteFrameCache.getSpriteFrame(this.info.picId);
        //     if(!frame){
        //         var _sprite = new cc.Sprite("#fhis_bloading.png");
        //         if(_sprite){
        //             _sprite.setPosition(cc.p(150, 305));
        //             _sprite.setScale(0.8);
        //             bg.addChild(_sprite, 0, 'loading');
        //             var rotate = new cc.RotateBy(1,240);
        //             _sprite.runAction(new cc.RepeatForever(rotate));
        //         }
        //         this.refreshpic(0);
        //         this.schedule(this.refreshpic, 1);
        //     }
        //     else{
        //         // _sprite.removeFromParent(true);
        //         pic.setSpriteFrame(frame);
        //         pic.setScale(0.8);
        //     }
        // }

        var edit1 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(456, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(SccomMsgKey.exchangeName), cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 28);
        if (edit1) {
            edit1.setFontColor(cc.color(255, 255, 255));
            edit1.setPosition(cc.p(480, 366));
            edit1.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
            bg.addChild(edit1, 2, 21);
            var billname = cc.sys.localStorage.getItem('billname');
            if (billname != null) {
                edit1.setString(billname);
                this.name = billname;
            }
            var delegate1 = {
                editBoxEditingDidBegin: function () {
                    edit1.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit1.getString();
                    str = FYEngine.FilterWord.getInstance().RunFilterWord(str, "*", 1);
                    edit1.setString(str);
                    if (str == "") {
                        edit1.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeName));
                    }
                }
            };
            edit1.setDelegate(delegate1);
        }

        var edit2 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(456, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, FYEngine.LanguageString.getValue(SccomMsgKey.exchangePhoneNo), cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 11);
        if (edit2) {
            edit2.setFontColor(cc.color(255, 255, 255));
            edit2.setPosition(cc.p(480, 303));
            bg.addChild(edit2, 2, 22);
            var billnumber1 = cc.sys.localStorage.getItem('billnumber1');
            if (billnumber1 != null) {
                edit2.setString(billnumber1);
                this.number1 = billnumber1;
            }
            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    edit2.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit2.getString();

                    if (str == "") {
                        edit2.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangePhoneNo));
                    }
                }
            };
            edit2.setDelegate(delegate2);
        }

        var edit3 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(456, 50), cc.EDITBOX_INPUT_MODE_PHONENUMBER, FYEngine.LanguageString.getValue(SccomMsgKey.checkPhoneNo), cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 11);
        if (edit3) {
            edit3.setFontColor(cc.color(255, 255, 255));
            edit3.setPosition(cc.p(480, 240));
            bg.addChild(edit3, 2, 23);
            var billnumber2 = cc.sys.localStorage.getItem('billnumber2');
            if (billnumber2 != null) {
                edit3.setString(billnumber2);
                this.number2 = billnumber2;
            }
            var delegate3 = {
                editBoxEditingDidBegin: function () {
                    edit3.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit3.getString();
                    if (str == "") {
                        edit3.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.checkPhoneNo));
                    }
                }
            };
            edit3.setDelegate(delegate3);
        }

        var tip = new cc.LabelTTF(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeCompleteMsg), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setColor(cc.color(0, 0, 0));
            tip.setPosition(cc.p(376, 162));
            bg.addChild(tip);
        }
    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.BillOrderLayer);
        var edit1 = layer.layerbg.getChildByTag(21);
        var edit2 = layer.layerbg.getChildByTag(22);
        var edit3 = layer.layerbg.getChildByTag(23);
        layer.name = edit1.getString();
        layer.number1 = edit2.getString();
        layer.number2 = edit3.getString();

        if (layer.name == '') {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.noExchangeName));
            return;
        }
        cc.sys.localStorage.setItem('billname', layer.name);

        if (layer.number1 == '') {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.noExchangePhoneNo));
            return;
        }
        cc.sys.localStorage.setItem('billnumber1', layer.number1);

        if (layer.number1.length != 11 || layer.number2.length != 11) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.failedPhoneNo));
            return;
        }

        if (layer.number1 != layer.number2) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.failedPhoneNo1));
            return;
        }
        cc.sys.localStorage.setItem('billnumber2', layer.number2);

        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handler) {
            var loading = FYEngine.createLoadingLayer(SccomRes.MallRes.loadingbg, SccomRes.MallRes.loadingfish);
            if (loading) {
                scene.addChild(loading, FishZorder.poplayer, 'loading2');
            }
            if(FishGlobal.bExchangeType == 0){
                handler.sendExchangeProductReq(layer.info.goodsId, layer.name, layer.number1, '', '', '');
            }else{
                handler.sendToolExchangeReq(layer.info.goodsId, layer.name, layer.number1, '', '', '');
            }

            layer.schedule(layer.timeCount, 1);
        }

    },

    timeCount: function (dt) {
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            var loading2 = FYEngine.getRunningLayer(0).getChildByName('loading2');
            if (loading2) {
                loading2.removeFromParent(true);

            }
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.networkTimeOut));
            this.unschedule(this.timeCount);
        }
    },

    refreshpic : function(dt){
        var self = this;
        var frame = cc.spriteFrameCache.getSpriteFrame(self.info.picId);
        if(frame){
            cc.log("------------获取到了图片资源");
            self.unschedule(self.refreshpic);
            var loading = self.layerbg.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.layerbg.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame(frame);
                pic.setScale(0.8);
            }
        }else{
            var url = appglobal._downphoto+'/' + self.info.picId;
            if(url){
                var dlname = self.info.picId.split(".");
                app.httpManager.loadImgFromUrl(url, ''+dlname[0]);
            }
        }
        self._count++;
        if(self._count>8){
            self.unschedule(self.refreshpic);
            var loading = self.layerbg.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.layerbg.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame("nopic.png");
                pic.setScale(0.8);
            }
        }
    },

});

var RealProductLayer = SmallLayer.extend({
    item: 0,
    info: {},
    content1: '',//姓名
    content2: '',//手机
    content3: '',//邮编
    content4: '',//地址
    content5: '',//备注
    _time: 0,
    _count:0,
    ctor: function (item, info) {
        this._super();
        this.item = item;
        this.info = info;
        this._count=0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(789, 505));
        this.addInnerBg(SmallLayerRes.Innerbg, cc.size(700, 341));
        this.addTitleBg(SmallLayerRes.TitleWrite);
        this.addCloseBtn();
        this.addConfirmBtn(this.confirmCallBack);
        this.addCancelBtn();

        var IsPic = ProductExchangListArry.indexOf(this.info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this.info.picId;
            var rewardtexture = new cc.Sprite("#" + picName);//从服务器获取spriteFrame后设置
            if (rewardtexture) {
                rewardtexture.setPosition(cc.p(150, 365));

                rewardtexture.setScale(0.8);
                bg.addChild(rewardtexture);
            }
        }else{
            picName = "nopic.png";
            var rewardtexture = new cc.Sprite("#" + picName);//从服务器获取spriteFrame后设置
            if (rewardtexture) {
                rewardtexture.setPosition(cc.p(150, 365));
                //rewardtexture.setScale(0.8);
                bg.addChild(rewardtexture);
            }
        }

        // if(this.info.picId ==""){
        //     var pic = new cc.Sprite("#nopic.png");
        //     pic.setPosition(cc.p(150, 365));
        //     pic.setScale(0.8);
        //     bg.addChild(pic, 0, "selfphoto");
        // }else{
        //     var pic = new cc.Sprite();
        //     pic.setPosition(cc.p(150, 365));
        //     bg.addChild(pic, 0, "selfphoto");
        //     // cc.log("-----picid"+this._info.picId);
        //     var frame = cc.spriteFrameCache.getSpriteFrame(this.info.picId);
        //     if(!frame){
        //         var _sprite = new cc.Sprite("#fhis_bloading.png");
        //         if(_sprite){
        //             _sprite.setPosition(cc.p(150, 365));
        //             _sprite.setScale(0.8);
        //             bg.addChild(_sprite, 0, 'loading');
        //             var rotate = new cc.RotateBy(1,240);
        //             _sprite.runAction(new cc.RepeatForever(rotate));
        //         }
        //         this.refreshpic(0);
        //         this.schedule(this.refreshpic, 1);
        //     }
        //     else{
        //         // _sprite.removeFromParent(true);
        //         pic.setSpriteFrame(frame);
        //         pic.setScale(0.8);
        //     }
        // }


        var edit1 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(453, 42), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(SccomMsgKey.exchangeName), cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 28);
        if (edit1) {
            edit1.setFontColor(cc.color(255, 255, 255));
            edit1.setPosition(cc.p(480, 415));
            bg.addChild(edit1, 2, 21);
            edit1.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
            var realcontent1 = cc.sys.localStorage.getItem('realcontent1');
            if (realcontent1 != null) {
                edit1.setString(realcontent1);
                this.content1 = realcontent1;
            }
            var delegate1 = {
                editBoxEditingDidBegin: function () {
                    edit1.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit1.getString();
                    if (str == "") {
                        edit1.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeName));
                    }
                }
            };
            edit1.setDelegate(delegate1);

        }

        var edit2 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(453, 42), cc.EDITBOX_INPUT_MODE_NUMERIC, FYEngine.LanguageString.getValue(SccomMsgKey.exchangePhoneNo), cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 11);
        if (edit2) {
            edit2.setFontColor(cc.color(255, 255, 255));
            edit2.setPosition(cc.p(480, 363));
            bg.addChild(edit2, 2, 22);
            var realcontent2 = cc.sys.localStorage.getItem('realcontent2');
            if (realcontent2 != null) {
                edit2.setString(realcontent2);
                this.content2 = realcontent2;
            }
            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    edit2.setPlaceHolder("");
                },

                //editBoxTextChanged : function(){
                //
                //},

                editBoxEditingDidEnd: function () {
                    var str = edit2.getString();
                    if (str == "") {
                        edit2.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangePhoneNo));
                    }
                    //if (/\s/.test(str)) {
                    //    FYEngine.AddCommToast("手机号码中不能含有空格");
                    //    return;
                    //}
                }
            };
            edit2.setDelegate(delegate2);

        }

        var edit3 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(453, 42), cc.EDITBOX_INPUT_MODE_NUMERIC, FYEngine.LanguageString.getValue(SccomMsgKey.exchangePostCode), cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 6);
        if (edit3) {
            edit3.setFontColor(cc.color(255, 255, 255));
            edit3.setPosition(cc.p(480, 310));
            bg.addChild(edit3, 2, 23);
            var realcontent3 = cc.sys.localStorage.getItem('realcontent3');
            if (realcontent3 != null) {
                edit3.setString(realcontent3);
                this.content3 = realcontent3;
            }
            var delegate3 = {
                editBoxEditingDidBegin: function () {
                    edit3.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit3.getString();
                    if (str == "") {
                        edit3.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangePostCode));
                    }
                }
            };
            edit3.setDelegate(delegate3);
        }

        var edit4 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(633, 73), cc.EDITBOX_INPUT_MODE_ANY, FYEngine.LanguageString.getValue(SccomMsgKey.exchangeAddress), cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 60);
        if (edit4) {
            edit4.setFontColor(cc.color(255, 255, 255));
            edit4.setFontSize(20);
            edit4.setPosition(cc.p(bg.width / 2, 240));
            edit4.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
            bg.addChild(edit4, 2, 24);
            var realcontent4 = cc.sys.localStorage.getItem('realcontent4');
            if (realcontent4 != null) {
                edit4.setString(realcontent4);
                this.content4 = realcontent4;
            }
            var delegate4 = {
                editBoxEditingDidBegin: function () {
                    edit4.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit4.getString();
                    if (str == "") {
                        edit4.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeAddress));
                    }
                }
            };
            edit4.setDelegate(delegate4);
        }

        var edit5 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(638, 42), cc.EDITBOX_INPUT_MODE_ANY, FYEngine.LanguageString.getValue(SccomMsgKey.exchangeTip), cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 30);
        if (edit5) {
            edit5.setMaxLength(20);
            edit5.setFontColor(cc.color(255, 255, 255));
            edit5.setPosition(cc.p(bg.width / 2, 170));
            edit5.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
            bg.addChild(edit5, 2, 25);

            var delegate5 = {
                editBoxEditingDidBegin: function () {
                    edit5.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit5.getString();
                    if (str == "") {
                        edit5.setPlaceHolder(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeTip));
                    }
                }
            };
            edit5.setDelegate(delegate5);
        }

        var tip = new cc.LabelTTF(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeCompleteMsg), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if (tip) {
            tip.setPosition(cc.p(370, 128));
            tip.setColor(cc.color(0, 0, 0));
            bg.addChild(tip);
        }
    },


    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.RealProductLayer);

        var edit1 = layer.layerbg.getChildByTag(21);
        var edit2 = layer.layerbg.getChildByTag(22);
        var edit3 = layer.layerbg.getChildByTag(23);
        var edit4 = layer.layerbg.getChildByTag(24);
        var edit5 = layer.layerbg.getChildByTag(25);
        layer.content1 = edit1.getString();
        layer.content2 = edit2.getString();
        layer.content3 = edit3.getString();
        layer.content4 = edit4.getString();
        layer.content5 = edit5.getString();

        if (layer.content1 == '') {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.noExchangeName));
            return;
        }
        cc.sys.localStorage.setItem('realcontent1', layer.content1);
        if (layer.content2 == '') {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.noExchangePhoneNo));
            return;
        }
        if (layer.content2.length != 11) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.failedPhoneNo));
            return;
        }
        cc.sys.localStorage.setItem('realcontent2', layer.content2);
        if (layer.content3 == '') {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.noPostCode));
            return;
        }
        if (layer.content3.length != 6) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.failedPostCode));
            return;
        }
        cc.sys.localStorage.setItem('realcontent3', layer.content3);
        if (layer.content4 == '') {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.noAddress));
            return;
        }
        cc.sys.localStorage.setItem('realcontent4', layer.content4);

        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handler) {
            var loading = FYEngine.createLoadingLayer(SccomRes.MallRes.loadingbg, SccomRes.MallRes.loadingfish);
            if (loading) {
                scene.addChild(loading, FishZorder.poplayer, 'loading2');
            }
            if(FishGlobal.bExchangeType ==0){
                handler.sendExchangeProductReq(layer.info.goodsId, layer.content1, layer.content2, layer.content3, layer.content4, layer.content5);
            }else{
                handler.sendToolExchangeReq(layer.info.goodsId, layer.content1, layer.content2, layer.content3, layer.content4, layer.content5);
            }

            layer.schedule(layer.timeCount, 1);
        }

    },

    timeCount: function (dt) {
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            var loading2 = FYEngine.getRunningLayer(0).getChildByName('loading2');
            if (loading2) {
                loading2.removeFromParent(true);

            }
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.networkTimeOut));
            this.unschedule(this.timeCount);
        }
    },

    refreshpic : function(dt){
        var self = this;
        var frame = cc.spriteFrameCache.getSpriteFrame(self.info.picId);
        if(frame){
            cc.log("------------获取到了图片资源");
            self.unschedule(self.refreshpic);
            var loading = self.layerbg.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.layerbg.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame(frame);
                pic.setScale(0.8);
            }
        }else{
            var url = appglobal._downphoto+'/' + self.info.picId;
            if(url){
                var dlname = self.info.picId.split(".");
                app.httpManager.loadImgFromUrl(url, ''+dlname[0]);
            }
        }
        self._count++;
        if(self._count>8){
            self.unschedule(self.refreshpic);
            var loading = self.layerbg.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.layerbg.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame("nopic.png");
                pic.setScale(0.8);
            }
        }
    },
});

var ClassifyWin = DialogLayer.extend({
    _value :0,
    ctor: function (value) {
        var that = this;
        this._super();
        this._value = value;
        var bg = this.addLayerBg(cc.size(462, 535));
        var titleBigBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleBigBG, cc.p(bg.width / 2 + 15, bg.height * 0.95), null, cc.size(490, 73), cc.rect(100, 0, 490 - 200, 73));
        bg.addChild(titleBigBg, 0, 3);
        var titleSmallBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleSmallBG, cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56), null, cc.size(276, 54), cc.rect(50, 0, 8, 54));
        titleBigBg.addChild(titleSmallBg, 0, 1);

        var titleName = FYEngine.createSprite(SccomRes.RewardRes.ClassTittle, cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56));
        titleBigBg.addChild(titleName, 0, 2);

        this.addCloseBtn();

        var listview = FYEngine.createListView(cc.size(423, 430), cc.p(bg.width / 2 + 10, bg.height * 0.4 + 40), cc.p(0.5, 0.5), 14, ccui.ScrollView.DIR_VERTICAL);
        if (listview) {
            bg.addChild(listview, 1, 'list');
        }

        if(this._value ==0){
            for (var i = 0; i < ExchangeTemp.classifyArry.length; ++i) {
                var box = new ClassBox(i);
                if (box) {
                    box.setAnchorPoint(cc.p(0.5, 0.5));
                    listview.pushBackCustomItem(box);
                    box.addClickEventListener(that.boxCallBack);
                }
            }
        }else{
            for (var i = 0; i < ExchangeTemp1.classifyArry.length; ++i) {
                var box = new ClassBox1(i);
                if (box) {
                    box.setAnchorPoint(cc.p(0.5, 0.5));
                    listview.pushBackCustomItem(box);
                    box.addClickEventListener(that.boxCallBack);
                }
            }
        }

    },

    boxCallBack: function (sender) {
        var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.ClassifyLayer);
        var tag = sender.getTag();
        if(layer._value ==0){
            if (tag == ExchangeTemp.shopOpenTag) {
                //FYEngine.popoutLayerAnimate(layer.layerbg);//注释掉即每次点击后不关闭这个分类层
                return;
            }
            ExchangeTemp.shopOpenTag = tag;
            layer.updateListView(tag);
            cc.eventManager.dispatchCustomEvent("refreshList", '' + tag);
        }else{
            if (tag == ExchangeTemp1.shopOpenTag) {
                //FYEngine.popoutLayerAnimate(layer.layerbg);//注释掉即每次点击后不关闭这个分类层
                return;
            }
            ExchangeTemp1.shopOpenTag = tag;
            layer.updateListView(tag);
            cc.eventManager.dispatchCustomEvent("refreshList", '' + tag);
        }

        //FYEngine.popoutLayerAnimate(layer.layerbg);//注释掉即每次点击后不关闭这个分类层

    },

    updateListView: function (tag) {
        var list = this.layerbg.getChildByName('list');
        cc.log('---------------updateListView----');
        if (list) {
            var items = list.getItems();
            for (var i = 0; i < items.length; ++i) {
                var item = items[i];
                var gou = item.getChildByTag(1);
                if (i == tag) {
                    gou.setVisible(true);
                } else {
                    gou.setVisible(false);
                }
            }
        }
    }
});

/**分类筛选商品层的盒子
 *
 */
var ClassBox = ccui.ImageView.extend({
    _item: 0,
    ctor: function (i) {
        this._super();
        this._item = i;
        this.setTag(this._item);
        this.loadTexture(SccomRes.RewardRes.Dialog, ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setTouchEnabled(true);
        this.setContentSize(cc.size(399, this.getContentSize().height));

        var name = new cc.LabelTTF(ExchangeTemp.classifyArry[this._item], FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (name) {
            this.addChild(name, 0, 0);
            name.setColor(cc.color(107, 49, 16));
            name.setPosition(cc.p(this.width / 2, this.height / 2 + 2));
        }

        var tip1 = new ccui.ImageView(SccomRes.RewardRes.Gou, ccui.Widget.PLIST_TEXTURE);
        if (tip1) {
            this.addChild(tip1, 0, 1);
            tip1.setPosition(cc.p(this.width * 0.85, this.height / 2));
            if (this._item != ExchangeTemp.shopOpenTag) {
                tip1.setVisible(false);
            }
        }
    }
});

var ClassBox1 = ccui.ImageView.extend({
    _item: 0,
    ctor: function (i) {
        this._super();
        this._item = i;
        this.setTag(this._item);
        this.loadTexture(SccomRes.RewardRes.Dialog, ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setTouchEnabled(true);
        this.setContentSize(cc.size(399, this.getContentSize().height));

        var name = new cc.LabelTTF(ExchangeTemp1.classifyArry[this._item], FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (name) {
            this.addChild(name, 0, 0);
            name.setColor(cc.color(107, 49, 16));
            name.setPosition(cc.p(this.width / 2, this.height / 2 + 2));
        }

        var tip1 = new ccui.ImageView(SccomRes.RewardRes.Gou, ccui.Widget.PLIST_TEXTURE);
        if (tip1) {
            this.addChild(tip1, 0, 1);
            tip1.setPosition(cc.p(this.width * 0.85, this.height / 2));
            if (this._item != ExchangeTemp1.shopOpenTag) {
                tip1.setVisible(false);
            }
        }
    }
});

var ExchangeSuccessLayer = DialogLayer.extend({
    _str: '',
    ctor: function (str) {
        this._super();
        this._str = str;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(null, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeInfo), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            var search = this._str.indexOf(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeGold));
            if (search >= 0) {
                var txt = FYEngine.LanguageString.getValue(SccomMsgKey.exchangeSuccess) + this._str;
                tip.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            } else {
                search = this._str.indexOf("弹头");
                if(search >= 0){
                    var txt = FYEngine.LanguageString.getValue(SccomMsgKey.exchangeSuccess) + this._str;
                    tip.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
                }else{
                var txt = FYEngine.LanguageString.getValue(SccomMsgKey.exchangeSuccess) + this._str + FYEngine.LanguageString.getValue(SccomMsgKey.rewardSendTime);
                }
            }
            tip.setString(txt);
            tip.setTextAreaSize(cc.size(450, 120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },


});

var ExchangeToolSuccessLayer = DialogLayer.extend({
    _str: '',
    ctor: function (str) {
        this._super();
        this._str = str;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(null, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeInfo), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            var txt = FYEngine.LanguageString.getValue(SccomMsgKey.exchangeSuccess) + this._str + FYEngine.LanguageString.getValue(SccomMsgKey.rewardSendTime);
            tip.setString(txt);
            tip.setTextAreaSize(cc.size(450, 120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },


});
var RecordBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _count:0,
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        this._count =0;
        this.loadTexture("rankup021.png", ccui.Widget.PLIST_TEXTURE);
//        FYEngine.logObject(info,"----兑奖记录：");
        this.setScale9Enabled(true);
        this.setContentSize(cc.size(530, 80));
        this.initUI();
    },

    initUI: function () {
        var IsPic = ProductExchangListArry.indexOf(this._info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this._info.picId;
        }else{
            picName = "nopic.png";
        }
        var pic = new cc.Sprite("#" + picName);
        if(pic){
            pic.setScale(0.3);
            pic.setPosition(cc.p(60,45));
            this.addChild(pic, 0, 1);
        }

        var name = new ccui.Text();
        if (name) {
            name.setFontSize(22);
            name.setColor(cc.color("#f84312"));
            name.setAnchorPoint(cc.p(0, 0.5));
            name.setPosition(cc.p(110, 45));
            //name.enableOutline(cc.color("#f84312"), 1);
            this.addChild(name);
            name.setString(this._info.goodsName);
        }

        var timebg = new ccui.Text();
        if (timebg) {
            timebg.setFontSize(18);
            timebg.setColor(cc.color("#6b3110"));
            timebg.setString(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeTime));
            timebg.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(timebg);
            timebg.setPosition(cc.p(303, 60));
        }

        var time1 = new cc.LabelTTF();
        if (time1) {
            this.addChild(time1);
            time1.setFontSize(18);
            time1.setAnchorPoint(cc.p(0, 0.5));
            time1.setPosition(cc.p(390, 60));
            time1.setString(this._info.time);
            time1.setColor(cc.color("#005b81"));
        }

        var statusbg = new ccui.Text();
        if (statusbg) {
            statusbg.setFontSize(18);
            statusbg.setColor(cc.color("#6b3110"));
            statusbg.setString(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeStatus));
            statusbg.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(statusbg);
            statusbg.setPosition(cc.p(303, 30));
        }

        var stat = new cc.LabelTTF();
        if (stat) {
            stat.setFontSize(18);
            this.addChild(stat);
            stat.setAnchorPoint(cc.p(0, 0.5));
            stat.setPosition(cc.p(390, 30));
            if (this._info.status == 0) {
                var st = FYEngine.LanguageString.getValue(SccomMsgKey.sevenDaySend);
                stat.setColor(cc.color("#f84312"));
            } else if (this._info.status == 1) {
                var st = FYEngine.LanguageString.getValue(SccomMsgKey.sendAlready);
                stat.setColor(cc.color(15, 159, 4));
            } else {
                var st = FYEngine.LanguageString.getValue(SccomMsgKey.orderComplete);
                stat.setColor(cc.color(133, 132, 132));
            }
            stat.setString(st);
        }
    },

    refreshpic: function () {
        var self = this;
        var frame = cc.spriteFrameCache.getSpriteFrame(self._info.picId);
        if(frame){
            cc.log("------------获取到了图片资源1");
            self.unschedule(self.refreshpic);
            var loading = self.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame(frame);
                pic.setScale(0.3);
            }
        }else{
            var url = appglobal._downphoto+'/' + self._info.picId;
            if(url){
                var dlname = self._info.picId.split(".");
                app.httpManager.loadImgFromUrl(url, ''+dlname[0]);
            }
        }
        self._count++;
        if(self._count>8){
            self.unschedule(self.refreshpic);
            var loading = self.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var pic = self.getChildByName("selfphoto");
            if(pic){
                pic.setSpriteFrame("nopic.png");
                pic.setScale(0.5);
            }
        }

    },


});

var MallLayer = SccomLayer.extend({
    _time: 0,
    _isClose : false,
    ctor: function () {
        this._super();
        FishGlobal.NYMallTag = false;
        this._isClose = false;
        var self = this;
        var size = cc.winSize;
        this.size = size;
        FishGlobal.mallList = [];
        this.initUI();
        this.scheduleOnce(this.timeOutCheck, 15);
        this.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function () {
            Http.getMessage(function () {
                var service = formservice("shop");
                var time = Date.now();
                var sign = formsign("shop", time);
                time = formTime(time);
                var source = formsource(appglobal.getSource());
                var type = {name: "type", value: 1};
                var checksum = formchecksum(source.value, type.value, sign.value, FYEngine.PrivateKey);
                var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, type, source);
                return url;
            }(), null, function (cfgStr) {
                var scene =FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.MallLayer);
                var jsonInfo = eval('(' + cfgStr + ')');
//               FYEngine.logObject(jsonInfo,'---------充值商城:');
                var errcode = jsonInfo.code;
                if (errcode != 0) {
//                    cc.log('-----获取金豆充值 失败');
                    return;
                }
                if(layer && (layer._isClose == false) && layer._listview){
                    layer.unschedule(layer.timeOutCheck);

                    var loading = layer.layerbg.getChildByName('loading');
                    if(loading){
                        loading.removeFromParent(true);
                    }

                    FishGlobal.mallList = [];
                    if(cc.sys.os == 'iOS'){
                        if(appglobal._switch12==1){
                            var dataValue = jsonInfo.data;
                            for (var i = 0; i < dataValue.length; ++i) {
                                var info = {};
                                info = dataValue[i];
                                FishGlobal.mallList.push(info);
                                var box = new ChargeGoldBox(i, info);
                                if (box) {
                                    box.setAnchorPoint(cc.p(0.5, 0.5));
                                    layer._listview.pushBackCustomItem(box);
                                }
                            }
                        }else{
                            FishGlobal.mallList =[{"count":500000,"desc":"1元=14200金币","goodsId":51000004,"goodsLimitCount":0,"limitCount":0,"money":"50.00","name":"71万金币","picId":"2.jpg"}
                                ,{"count":980000,"desc":"1元=14204金币","goodsId":51000005,"goodsLimitCount":0,"limitCount":0,"money":"98.00","name":"139.2万金币","picId":"2.jpg"}
                                ,{"count":1980000,"desc":"1元=14207金币","goodsId":51000006,"goodsLimitCount":0,"limitCount":0,"money":"198.00","name":"281.3万金币","picId":"2.jpg"}
                                ,{"count":3280000,"desc":"1元=14207金币","goodsId":51000007,"goodsLimitCount":0,"limitCount":0,"money":"328.00","name":"466万金币","picId":"3.jpg"}
                                ,{"count":6480000,"desc":"1元=14213金币","goodsId":51000008,"goodsLimitCount":0,"limitCount":0,"money":"648.00","name":"921万金币","picId":"3.jpg"}];
                            for (var i = 0; i < FishGlobal.mallList.length; ++i) {
                                var box = new ChargeGoldBox(i, FishGlobal.mallList[i]);
                                if (box) {
                                    box.setAnchorPoint(cc.p(0.5, 0.5));
                                    layer._listview.pushBackCustomItem(box);
                                }
                            }
                        }
                    }else{
                        var dataValue = jsonInfo.data;
                        for (var i = 0; i < dataValue.length; ++i) {
                            var info = {};
                            info = dataValue[i];
                            FishGlobal.mallList.push(info);
                            var box = new ChargeGoldBox(i, info);
                            if (box) {
                                box.setAnchorPoint(cc.p(0.5, 0.5));
                                layer._listview.pushBackCustomItem(box);
                            }
                        }
                    }

                }
                //FYEngine.logObject(FishGlobal.mallList,'-----------充值列表:');

            });
        })));


    },

    timeOutCheck: function () {
        this._isClose =true;
        var scene = FYEngine.getRunningLayer(0);
        var rewardLayer = scene.getChildByName(LobbySceneName.MallLayer);
        if (rewardLayer) {
            FYEngine.popoutLayerAnimate(rewardLayer.layerbg);
        }
        var warmTipLayer = new WarmTipLayer(FYEngine.LanguageString.getValue("WarmTipText4"));
        scene.addChild(warmTipLayer, FishZorder.poplayer, LobbySceneName.TimeOutLayer);
    },

    initUI: function () {
        var layerbg = this.addLayerBg(SccomRes.MallRes.Outerbg, cc.size(980, 550), cc.p(this.width / 2, this.height * 0.4 + 30));
        this.addInnerBg(SccomRes.MallRes.Innerbg, cc.size(920, 400),cc.p(this.layerbg.width/2,this.layerbg.height*0.56));
        if(appglobal._switch11 ==1){
            var NYbtnbg = new cc.Sprite('#newyear10.png');
            if(NYbtnbg){
                this.layerbg.addChild(NYbtnbg , 1);
                NYbtnbg.setPosition(cc.p(80,540));
                var rotateact = new cc.RotateBy(5.5, 360);
                NYbtnbg.runAction(new cc.RepeatForever(rotateact));
            }


            var NYbtn = new ccui.Button('newyear8.png','newyear9.png','',ccui.Widget.PLIST_TEXTURE);
            if(NYbtn){
                this.layerbg.addChild(NYbtn , 1, LobbySceneName.UnderBtnName.NYBTN);
                NYbtn.setPosition(cc.p(80,540));
                NYbtn.addClickEventListener(this.UIBtnCallBack);
            }

            var nygold = cc.AnimationCache.getInstance().getAnimation('newyeargold');
            var stemp = new cc.Sprite();
            stemp.setAnchorPoint(cc.p(0.5,0.5));
            stemp.setPosition(cc.p(NYbtn.width/2, NYbtn.height/2));
            NYbtn.addChild(stemp, 1);
            stemp.runAction(new cc.RepeatForever(new cc.Animate(nygold)));
        }


        var titleBg = FYEngine.createSprite("#newyear2.png", cc.p(this.layerbg.width / 2, this.layerbg.height * 1.02));
        this.layerbg.addChild(titleBg, 0, 3);
        var titleName = FYEngine.createSprite(SccomRes.MallRes.Mallname, cc.p(titleBg.width / 2, titleBg.height / 2));
        titleBg.addChild(titleName, 0, 1);

        var btnBack = new ccui.Button(SccomRes.Backbtn.Up, SccomRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.96);
            this.layerbg.addChild(btnBack, 0, 3);
            btnBack.addClickEventListener(this.closeCallBack);
        }

        var listview = this._listview = FYEngine.createListView(cc.size(880, 415), cc.p(this.layerbg.width / 2, this.layerbg.height * 0.56), cc.p(0.5, 0.5), 9, ccui.ScrollView.DIR_HORIZONTAL);
        if (listview) {
            listview.setScrollBarEnabled(false);
            this.layerbg.addChild(listview, 1, "inner_list");
        }

        this.addVipMode();
        var _sprite = new cc.Sprite(SccomRes.MallRes.loadingbg);
        if (_sprite) {
            _sprite.setPosition(cc.p(layerbg.width / 2, layerbg.height * 0.5 + 20));
            layerbg.addChild(_sprite, 99, 'loading');
        }

        var rotate = new cc.RotateBy(1.2, 360);
        _sprite.runAction(new cc.RepeatForever(rotate));

    },

    addVipMode : function(){
        var self = this;
        var player = appglobal.getPlayer();


        var vipbigbg = new ccui.Layout();
        if(vipbigbg){
            this.layerbg.addChild(vipbigbg,10,"vipbigbg");
            vipbigbg.setContentSize(cc.size(920,80));
            vipbigbg.setAnchorPoint(cc.p(0.5,0.5));
            vipbigbg.setPosition(cc.p(this.layerbg.width/2,70));
            // vipbigbg.setBackGroundColor(cc.color.RED);
            // vipbigbg.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        }

        var viplogobg  = this._logonumber= new ccui.ImageView("fish_vip_res"+(10+player.iVIPLevel)+".png",ccui.Widget.PLIST_TEXTURE);
        if(viplogobg){
            vipbigbg.addChild(viplogobg,0,"viplogobg");
            viplogobg.setPosition(cc.p(90,50));
        }

        var warntext = new ccui.Text("适度娱乐 理性消费","",22);
        if(warntext){
            vipbigbg.addChild(warntext,0,"warntext");
            warntext.setPosition(cc.p(90,18));
            warntext.setTextColor(cc.color("00fff6"));
        }

        var progressbg = new cc.Sprite('#fish_vip_res3.png');
        if(progressbg){
            vipbigbg.addChild(progressbg,0,"progressbg");
            progressbg.setPosition(cc.p(410,50));

            var progress = this._progress = new cc.ProgressTimer(new cc.Sprite('#fish_vip_res6.png'));
            if(progress){
                progress.setAnchorPoint(cc.p(0,0));
                progress.setPosition(cc.p(1,-2));
                progress.setType(cc.ProgressTimer.TYPE_BAR);
                progress.setBarChangeRate(cc.p(1,0));
                progress.setMidpoint(cc.p(0,0));
                progressbg.addChild(progress,1,'progress');
                progress.setPercentage(100);
            }

            var mLabel = this._mLabel = new ccui.Text('0/0','微软雅黑',24);
            if(mLabel){
                // mLabel.setTextColor(cc.color("ffe062"));
                mLabel.enableOutline(cc.color("11415b"),2);
                mLabel.setPosition(cc.p(progressbg.width/2,progressbg.height/2));
                progressbg.addChild(mLabel,2,"mLabel");
            }
        }

        var btnSeeVipinfo = new ccui.ImageView("fish_vip_res33.png",ccui.Widget.PLIST_TEXTURE);
        if(btnSeeVipinfo){
            vipbigbg.addChild(btnSeeVipinfo,1,"btnSeeVipinfo");
            btnSeeVipinfo.setPosition(cc.p(780,35));
            btnSeeVipinfo.setTouchEnabled(true);
            btnSeeVipinfo.addTouchEventListener(this.btnTouchEft,this);
            btnSeeVipinfo.addClickEventListener(function(){
                cc.log("点击特权按钮");
                self.removeFromParent(true);
                var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.VIPinfoLayer);
                if(!layer){
                    layer = new VIPinfoLayer();
                    FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.VIPinfoLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
        this.refreshVIPinfo();
    },

    addUnderText : function(){
        var player = appglobal.getPlayer();
        var vipbigbg = this.layerbg.getChildByName("vipbigbg");
        if(vipbigbg){
            var TextTip = vipbigbg.getChildByName("TextTip");
            if(TextTip){
                TextTip.removeFromParent(true);
            }

            if(player.iVIPLevel >=6){
                return;
            }else{
                TextTip = new ccui.Text("再充值","微软雅黑",22);
                if(TextTip){
                    vipbigbg.addChild(TextTip,1,"TextTip");
                    TextTip.setAnchorPoint(cc.p(0,0.5));
                    TextTip.setPosition(cc.p(250,18));
                    TextTip.setTextColor(cc.color("00fff6"));
                    var needmoney = new ccui.Text(""+(player.iVIPNextMoney-player.iMoney),"微软雅黑",30);
                    if(TextTip){
                        TextTip.addChild(needmoney,1,"needmoney");
                        needmoney.setAnchorPoint(cc.p(0,0.5));
                        needmoney.setPosition(cc.p(TextTip.width+5,TextTip.height/2));
                        needmoney.setTextColor(cc.color("f3fc04"));
                    }

                    var text2 = new ccui.Text("元，即可升级为","",22);
                    if(text2){
                        TextTip.addChild(text2,1,"text2");
                        text2.setAnchorPoint(cc.p(0,0.5));
                        text2.setPosition(cc.p(TextTip.width+needmoney.width+10,TextTip.height/2));
                        text2.setTextColor(cc.color("00fff6"));
                    }

                    var logo = new ccui.Text("VIP"+(player.iVIPLevel+1),"",30);

                    if(logo){
                        TextTip.addChild(logo,0,"logo");
                        logo.setAnchorPoint(cc.p(0,0.5));
                        logo.setPosition(cc.p(TextTip.width+needmoney.width+text2.width+15,TextTip.height/2));
                        logo.setTextColor(cc.color("f3fc04"));
                    }
                }
            }
        }
    },

    refreshVIPinfo : function(){
        cc.log("refreshVIPinfo");
        var player =appglobal.getPlayer();
        if(this._logonumber){
            this._logonumber.loadTexture("fish_vip_res"+(10+player.iVIPLevel)+".png",ccui.Widget.PLIST_TEXTURE);
        }

        if(this._mLabel && this._progress){
            if(player.iVIPLevel >=6){
                this._mLabel.setString("已满级");
                this._progress.setPercentage(100);
            }else{
                var range = player.iVIPNextMoney - player.iVIPMoney;//当前等级的范围;
                var sp = player.iMoney-player.iVIPMoney;//当前等级已充值了多少;
                cc.log("sp"+sp+"----range:"+range);
                this._mLabel.setString(""+sp+"/"+range);
                if(range>0){
                    var curper = Math.floor((sp/range)*100);
                    cc.log("---:"+curper);
                    this._progress.setPercentage(curper);
                }else{
                    this._progress.setPercentage(0);
                }
            }
        }
        this.addUnderText();
    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },

    sendGoldMallCfgUrl: function () {
        var service = formservice("shop");
        var time = Date.now();
        var sign = formsign("shop", time);
        time = formTime(time);
        var source = formsource(appglobal.getSource());
        var type = {name: "type", value: 0};
        var checksum = formchecksum(source.value, type.value, sign.value, FYEngine.PrivateKey);
        var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, type);
        return url;
    },

    closeCallBack : function(){
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.MallLayer);
        layer._isClose = true;
        FYEngine.popoutLayerAnimate(layer.layerbg);
    },

    UIBtnCallBack : function(sender){

        var scene = FYEngine.getRunningLayer(0);
        var layermall = scene.getChildByName(LobbySceneName.MallLayer);
        if(layermall){
            layermall.removeFromParent(true);
        }
        var layer = scene.getChildByName(LobbySceneName.NYMallLayer);
        if(!layer){
            layer = new NYMallLayer();
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.NYMallLayer);
            FYEngine.popupLayerAnimate(layer.layerbg, undefined, undefined, cc.p(layer.width / 2, layer.height * 0.4 + 30));
        }
    },

});

var ChargeGoldBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        this.loadTexture(SccomRes.MallRes.Boxbg, ccui.Widget.PLIST_TEXTURE);
        var labeltop = new cc.LabelTTF();
        if (labeltop) {
            this.addChild(labeltop, 0, 0);
            labeltop.initWithString(this._info.name, 'Arial', 24);
            labeltop.setPosition(cc.p(this.width / 2, 340));
        }

        var pic = new ccui.ImageView();
        if (pic) {
            if (this._info.money < 15) {
                pic.loadTexture(SccomRes.MallRes.Goldlittle, ccui.Widget.PLIST_TEXTURE);
            } else if (this._info.money < 150) {
                pic.loadTexture(SccomRes.MallRes.Goldsmall, ccui.Widget.PLIST_TEXTURE);
            } else {
                pic.loadTexture(SccomRes.MallRes.Goldbig, ccui.Widget.PLIST_TEXTURE);
            }
            this.addChild(pic, 0, 1);
            pic.setPosition(cc.p(this.width / 2, this.height * 0.6));
        }

        //var externmoney = Math.round(this._info.count/this._info.money);
        //cc.log('-------------externmoney:'+externmoney);
        if(this._info.desc !=""){
//            cc.log('--创建');
            var labeltip2 = new cc.LabelTTF();
            if (labeltip2) {
                this.addChild(labeltip2, 0, 11);
                labeltip2.initWithString(''+this._info.desc, 'Arial', 22);
                labeltip2.setPosition(cc.p(this.width / 2, 125));
                labeltip2.setColor(cc.color("fd4302"));
            }
        }

        var btn = new ccui.ImageView(SccomRes.MallRes.Boxbtn, ccui.Widget.PLIST_TEXTURE);
        if (btn) {
            var tag = 100 + this._item;
            btn.setTouchEnabled(true);
            this.addChild(btn, 0, tag);
            btn.setPosition(cc.p(this.width / 2, this.height * 0.16));
            FYEngine.AddNodeTouchListener(btn, this.boxbtnCallBack, FYEngine.ActionType.Fade);
        }

        var money = Number(this._info.money) + '';
        var number = FYEngine.createAlts(SccomRes.MallRes.Number, 10, money, '0');
        if (number) {
            btn.addChild(number, 0, 1);
            number.setAnchorPoint(cc.p(0, 0.5));
            var yuan = new cc.Sprite();
            if (yuan) {
                yuan.setSpriteFrame(SccomRes.MallRes.Yuan);
                yuan.setAnchorPoint(cc.p(0, 0.5));
                yuan.setPosition(cc.p(number.width, number.height / 2));
                number.addChild(yuan, 0, 2);
            }
            btn.setSwallowTouches(false);
            number.setPosition(cc.p(btn.width / 2 - (number.width + yuan.width) / 2, btn.height / 2 + 5));
        }
    },

    boxbtnCallBack: function (sender, type) {
        var box = sender.getParent();
        if(appglobal.getSource()==397){
            FYEngine.AddCommToast("未商用版本，无法充值");
            return;
        }
        if(cc.sys.os == 'iOS'){
            var handler = CoreServiceProxy.getInstance().getLobbyHandler();
            if (handler) {
//                cc.log('——————————————发送充值请求-IOS------------');
                if(appglobal._switch12==1){
                    FishGlobal.iosPayTag = 1;
                }else{
                    FishGlobal.iosPayTag = 0;
                }
                handler.sendQueryDailyChargeReq(box._info.goodsId);
                //handler.sendGetPayOrderReq(box._info);
            }
        }else{
            if(!appglobal.isWechatLogin && !FishGlobal.is3rdLogin && appglobal._switch17 == 0){
                var scene = FYEngine.getRunningLayer(0);
                var inlayer = scene.getChildByName(LobbySceneName.MultiPayLayer);
                if (!inlayer) {
                    inlayer = new MultiPayLayer(box._info);
                    if (inlayer) {
                        scene.addChild(inlayer, FishZorder.poplayer, LobbySceneName.MultiPayLayer);
                        FYEngine.popupLayerAnimate(inlayer.layerbg);
                    }
                }
            }else{
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if (handler) {
//                cc.log('——————————————发送充值请求-------------');
                    handler.sendQueryDailyChargeReq(box._info.goodsId);
                }
            }

        }
    },
});

var NYchargeList = ['nypic001.png','nypic002.png',"nypic003.png","nypic004.png","nypic005.png"];

var IntergralMallLayer = SccomLayer.extend({
    _isClose : false,
    _time :0,
    _BuyResult :null,
    _QueryTimeResult :null,
    ctor: function () {
        this._super();
        var self = this;
        this._time = 0;
        this._isClose = false;
        var size = cc.winSize;
        this.size = size;
        this.initUI();
        this.scheduleOnce(this.timeOutCheck, 15);
        this.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function() {

            Http.getMessage(function () {
                var service = formservice("GameExchangeListRole");
                var time = Date.now();
                var sign = formsign("GameExchangeListRole", time);
                time = formTime(time);
                var source = formsource(appglobal.getSource());
                var rid = {name: "role", value : appglobal.getPlayer().roleid};
                var checksum = formchecksum(source.value, sign.value, FYEngine.PrivateKey);
                var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, source,rid);
//                FYEngine.logObject(url,'-------------积分网址的URL:');
                return url;
            }(), null, function (cfgStr) {
                //FYEngine.logObject(cfgStr,'----------新春礼包:');
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.IntergralLayer);
                var jsonInfo = eval('(' + cfgStr + ')');
                var errcode = jsonInfo.code;
                if(errcode == 1){
                    if(layer){
                        layer.unschedule(layer.timeOutCheck);
                        var loading = layer.layerbg.getChildByName('loading');
                        if(loading){
                            loading.removeFromParent(true);
                        }
                        var nosprite = new ccui.Text('积分兑换功能已关闭', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei),30);
                        if(nosprite){
                            nosprite.setPosition(cc.p(layer.layerbg.width / 2, layer.layerbg.height * 0.5+35));
                            nosprite.enableOutline(cc.color(255, 255, 255, 255), 1);
                            layer.layerbg.addChild(nosprite, 1, 100);
                        }
                    }
                    return;
                }
                //FYEngine.logObject(jsonInfo.data,'------积分商城的配置:');
                if (layer && (layer._isClose == false)){
                    layer.unschedule(layer.timeOutCheck);
                    var loading = layer.layerbg.getChildByName(SccomLayerName.loading);
                    if (loading) {
                        loading.removeFromParent(true);
                    }

                    var listview = layer.layerbg.getChildByName("inter_list");
                    if(listview){
                        return;
                    }
                    listview = FYEngine.createListView(cc.size(880, 364), cc.p(layer.layerbg.width / 2, layer.layerbg.height * 0.5+10), cc.p(0.5, 0.5), 5, ccui.ScrollView.DIR_HORIZONTAL);
                    if (listview) {
                        layer.layerbg.addChild(listview, 1, "inter_list");
                        listview.setScrollBarPositionFromCornerForHorizontal(cc.p(0, 0));
                    }

                    var dataValue = jsonInfo.data;
                    if(FishGlobal.LiveLevel <=3){
                        for (var i = 0; i < dataValue.length; ++i) {
                            if(dataValue[i].coinCode == "CRYSTAL"){
                                continue;
                            }
                            var box = new IntergralExchangeBox(i, dataValue[i]);
                            if (box) {
                                box.setAnchorPoint(cc.p(0.5, 0.5));
                                listview.pushBackCustomItem(box);
                            }
                        }
                    }else{
                        for (var i = 0; i < dataValue.length; ++i) {
                            var box = new IntergralExchangeBox(i, dataValue[i]);
                            if (box) {
                                box.setAnchorPoint(cc.p(0.5, 0.5));
                                listview.pushBackCustomItem(box);
                            }
                        }
                    }

                }
            });
        })));
    },

    timeOutCheck: function () {
//        cc.log('-------超时判断');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntergralLayer);
        if(layer){
            this._isClose = true;
            var loading = layer.layerbg.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var nosprite = new ccui.Text('获取积分商品列表失败，请稍后再试', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei),30);
            if(nosprite){
                nosprite.setPosition(cc.p(layer.layerbg.width / 2, layer.layerbg.height * 0.5+20));
                nosprite.enableOutline(cc.color(255, 255, 255, 255), 1);
                layer.layerbg.addChild(nosprite, 1, 100);
            }
        }


    },

    initUI: function () {
        var layerbg = this.addLayerBg(SccomRes.MallRes.Outerbg, cc.size(980, 530), cc.p(this.width / 2, this.height * 0.4 + 30));

        var innerBg = FYEngine.createImageView(SccomRes.MallRes.Innerbg, cc.p(this.layerbg.width / 2, this.layerbg.height / 2+20), cc.p(0.5, 0.5), cc.size(920, 400));
        this.layerbg.addChild(innerBg, 0, 2);

        var titleBg = FYEngine.createSprite("#newyear2.png", cc.p(this.layerbg.width / 2, this.layerbg.height * 1.02));
        this.layerbg.addChild(titleBg, 0, 3);
        var titleName = FYEngine.createSprite('#integral14.png', cc.p(titleBg.width / 2, titleBg.height / 2));
        titleBg.addChild(titleName, 0, 1);

        var btnBack = new ccui.Button(SccomRes.Backbtn.Up, SccomRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.96);
            this.layerbg.addChild(btnBack, 0, 3);
            btnBack.addClickEventListener(this.closeCallBack);
        }


        var _sprite = new cc.Sprite(SccomRes.MallRes.loadingbg);
        if (_sprite) {
            _sprite.setPosition(cc.p(layerbg.width / 2, layerbg.height * 0.5 + 20));
            layerbg.addChild(_sprite, 99, 'loading');
        }

        var rotate = new cc.RotateBy(1.2, 360);
        _sprite.runAction(new cc.RepeatForever(rotate));


        for(var i = 0; i< 2;++i){
            var sbg = new ccui.ImageView('rankup003.png',ccui.Widget.PLIST_TEXTURE);
            if(sbg){
                sbg.setScale9Enabled(true);
                sbg.setContentSize(cc.size(190,sbg.height));
                this.layerbg.addChild(sbg);
                sbg.setPosition(cc.p(140+i*200,53));

                var sbgg = new cc.Sprite(i ==0?'#integral19.png':'#hall82.png');
                if(sbgg){
                    sbg.addChild(sbgg);
                    sbgg.setPosition(cc.p(10,sbg.height/2+3));
                }
            }
        }

        var tips = new cc.Sprite('#integral18.png');
        if(tips){
            this.layerbg.addChild(tips);
            tips.setPosition(cc.p(690,53));
        }

        var player = appglobal.getPlayer();
        if(player.gold<100000){
            var usergold = FYEngine.createAlts('res/num/fishnum10.png', 12, player.gold, '.');
            usergold.setAnchorPoint(cc.p(0, 0.5));
            usergold.setPosition(cc.p(275, 53));
            this.layerbg.addChild(usergold, 0, 16);
            this.usergold = usergold;
        }else{
            var numgold = Math.floor(player.gold/1000);
            numgold = numgold/10;
            var usergold = FYEngine.createAlts('res/num/fishnum10.png', 12, numgold, '.');
            usergold.setAnchorPoint(cc.p(0, 0.5));
            usergold.setPosition(cc.p(275, 53));
            this.layerbg.addChild(usergold, 0, 16);
            this.usergold = usergold;

            var wansprite = new cc.Sprite('#integral60.png');
            if(wansprite){
                wansprite.setAnchorPoint(cc.p(0,0.5));
                usergold.addChild(wansprite,0,'tip');
                wansprite.setPosition(cc.p(usergold.width, usergold.height/2));
            }
        }


        if(player.score<100000){
            var usercoupon = FYEngine.createAlts('res/num/fishnum10.png', 12, player.score, '.');
            usercoupon.setAnchorPoint(cc.p(0, 0.5));
            usercoupon.setPosition(cc.p(76, 53));
            this.layerbg.addChild(usercoupon, 0, 16);
            this.usercoupon = usercoupon;
        }else{
            var usercoupon = Math.floor(player.score/1000);
            usercoupon = usercoupon/10;
            var usercoupon = FYEngine.createAlts('res/num/fishnum10.png', 12, usercoupon, '.');
            usercoupon.setAnchorPoint(cc.p(0, 0.5));
            usercoupon.setPosition(cc.p(76, 53));
            this.layerbg.addChild(usercoupon, 0, 16);
            this.usercoupon = usercoupon;

            var wansprite1 = new cc.Sprite('#integral60.png');
            if(wansprite1){
                wansprite1.setAnchorPoint(cc.p(0,0.5));
                usercoupon.addChild(wansprite1,0,'tip');
                wansprite1.setPosition(cc.p(usercoupon.width, usercoupon.height/2));
            }
        }


    },

    updateWealth : function(){
//        cc.log('-----刷新财富 inter');
        var player=appglobal.getPlayer();
        if(player.gold<100000){
            var tip = this.usergold.getChildByName('tip');
            if(tip){
                tip.removeFromParent(true);
            }
            this.usergold.setString(player.gold);
        }else{
            var numgold = Math.floor(player.gold/1000);
            numgold = numgold/10;
            var tip = this.usergold.getChildByName('tip');
            if(tip){
                this.usergold.setString(numgold);
                tip.setPosition(cc.p(this.usergold.width, this.usergold.height/2));
            }else{
                this.usergold.setString(numgold);
                var wansprite = new cc.Sprite('#integral60.png');
                if(wansprite){
                    wansprite.setAnchorPoint(cc.p(0,0.5));
                    this.usergold.addChild(wansprite,0,'tip');
                    wansprite.setPosition(cc.p(this.usergold.width, this.usergold.height/2));
                }
            }
        }

        if(player.score<100000){
            var tip = this.usercoupon.getChildByName('tip');
            if(tip){
                tip.removeFromParent(true);
            }
            this.usercoupon.setString(player.score);
        }else{
            var usercoupon = Math.floor(player.score/1000);
            usercoupon = usercoupon/10;
            var tip = this.usercoupon.getChildByName('tip');
            if(tip){
                this.usercoupon.setString(usercoupon);
                tip.setPosition(cc.p(this.usercoupon.width, this.usercoupon.height/2));
            }else{
                this.usercoupon.setString(usercoupon);
                var wansprite1 = new cc.Sprite('#integral60.png');
                if(wansprite1){
                    wansprite1.setAnchorPoint(cc.p(0,0.5));
                    this.usercoupon.addChild(wansprite1,0,'tip');
                    wansprite1.setPosition(cc.p(this.usercoupon.width, this.usercoupon.height/2));
                }
            }

        }
    },

    closeCallBack : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntergralLayer);
        layer._isClose = true;
        FYEngine.popoutLayerAnimate(layer.layerbg);
    },

    timeCount: function (dt) {
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.clearTempResult();
            var loading2 = this.getParent().getChildByName('loading2');
            if (loading2) {
                loading2.removeFromParent(true);

            }
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.networkTimeOut));
            this.unschedule(this.timeCount);
        }
    },

    clearTempResult : function(){
        this._BuyResult = null;
        this._QueryTimeResult = null;
    },

    setBuyResult : function(data){
        this._BuyResult = data;
        if(this._BuyResult && this._QueryTimeResult){
            this.showResult();
        }
        // if(this._BuyResult){
        //     this.showResult();
        // }
    },

    setQueryResult : function(data){
        this._QueryTimeResult = data;
        if(this._BuyResult && this._QueryTimeResult){
            this.showResult();
        }
    },

    showResult : function(){
        this.unschedule(this.timeCount);
        var scene = FYEngine.getRunningLayer(0);
        var loading2 = scene.getChildByName('loading2');
        if (loading2) {
            loading2.removeFromParent(true);
        }

        if(this._BuyResult.iResult == 0){//兑换成功
            cc.log("--"+this._QueryTimeResult.iResult);
            if(this._QueryTimeResult && this._QueryTimeResult.iResult == 0){
                this.showResultLayer(1,this._QueryTimeResult.iDayLimit,this._QueryTimeResult.iDayCount);
            }else{
                FYEngine.AddCommToast('兑换成功');
                //this.showResultLayer(0,5,3);
            }

        }else{
            if(this._BuyResult.iResult == -50){//超过限制次数
                this.showResultLayer(0,this._QueryTimeResult.iDayLimit,this._QueryTimeResult.iDayCount);
            }else if(this._BuyResult.iResult == -42){
                FYEngine.AddCommToast('金币或积分不足');
            }else{
                FYEngine.AddCommToast('兑换失败');
            }
        }

    },
    /**
     *
     * @param tag  0或者1表示失败成功
     * @param daylimit  每天限制次数
     * @param daycount  每天已次数
     */
    showResultLayer : function(tag,daylimit,daycount){
        if(tag == 1 && daylimit<=0){
            FYEngine.AddCommToast('兑换成功');
            return;
        }
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntgralLimitLayer);
        if(!layer){
            layer = new IntgralLimitLayer(tag,daylimit,daycount);
            scene.addChild(layer,FishZorder.poplayer,LobbySceneName.IntgralLimitLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },

});


var IntergralArry = ['intergral50.png','intergral52.png','intergral54.png','intergral56.png'
    ,"fishnewboompic1.png","fishnewboompic10.png","fishnewboompic100.png"];
var IntergralExchangeBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _status: 0,
    _time :0,
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        this._time = 0;
        this.loadTexture(SccomRes.MallRes.Boxbg, ccui.Widget.PLIST_TEXTURE);

        var labeltop = new cc.LabelTTF();
        if (labeltop) {
            this.addChild(labeltop, 0, 0);
            labeltop.initWithString(this._info.name, FYEngine.LanguageString.getValue(LoginMsgKey.Arial), 24);
            labeltop.setPosition(cc.p(this.width / 2, 340));
        }

        var IsPic = IntergralArry.indexOf(this._info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this._info.picId;
        }else{
            picName = "nopic.png";
        }
        var pic = new cc.Sprite("#" + picName);
        if(pic){
            pic.setPosition(cc.p(this.width / 2, this.height * 0.55 + 20));
            this.addChild(pic, 0, 1);
        }

        this.setTouchEnabled(true);


        var colorbg = new cc.Sprite('#integral29.png');
        if(colorbg){
            this.addChild(colorbg);
            colorbg.setPosition(cc.p(this.width/2,65));
        }

        var fennum = this._info.score;

        var cost1 =new cc.Sprite('#integral6.png');
        if(cost1){
            cost1.setAnchorPoint(cc.p(0,0.5));
            colorbg.addChild(cost1);
            if(fennum>=100000){
                fennum = Math.floor(fennum/1000);
                fennum = fennum/10;
                var fen = FYEngine.createAlts('res/num/fishnum9.png', 12, fennum, '.');
                fen.setAnchorPoint(cc.p(0, 0.5));
                fen.setPosition(cc.p(cost1.width+1,cost1.height/2));
                cost1.addChild(fen, 0, 16);

                var wansprite = new cc.Sprite('#integral3.png');
                if(wansprite){
                    cost1.addChild(wansprite);
                    wansprite.setAnchorPoint(cc.p(0,0.5));
                    wansprite.setPosition(cc.p(cost1.width+1+fen.width,cost1.height/2));
                }

                var fensprite = new cc.Sprite('#integral4.png');
                if(fensprite){
                    cost1.addChild(fensprite);
                    fensprite.setAnchorPoint(cc.p(0,0.5));
                    fensprite.setPosition(cc.p(cost1.width+1+fen.width+wansprite.width,cost1.height/2));
                }

                cost1.setPosition(cc.p(colorbg.width/2-(cost1.width+1+fen.width+wansprite.width+fensprite.width)/2,colorbg.height*0.7));
            }else{
                var fen = FYEngine.createAlts('res/num/fishnum9.png', 12, fennum, '.');
                fen.setAnchorPoint(cc.p(0, 0.5));
                fen.setPosition(cc.p(cost1.width+1,cost1.height/2));
                cost1.addChild(fen, 0, 16);

                var wansprite = new cc.Sprite('#integral4.png');
                if(wansprite){
                    cost1.addChild(wansprite);
                    wansprite.setAnchorPoint(cc.p(0,0.5));
                    wansprite.setPosition(cc.p(cost1.width+1+fen.width,cost1.height/2));
                }
                cost1.setPosition(cc.p(colorbg.width/2-(cost1.width+1+fen.width+wansprite.width)/2,colorbg.height*0.7));
            }
        }

        var goldnum = this._info.gold;
        var cost2 =new cc.Sprite('#integral7.png');
        if(cost2){
            cost2.setAnchorPoint(cc.p(0,0.5));
            colorbg.addChild(cost2);
            if(goldnum>=100000){
                goldnum = Math.floor(goldnum/1000);
                goldnum = goldnum/10;
                var goldn = FYEngine.createAlts('res/num/fishnum9.png', 12, goldnum, '.');
                goldn.setAnchorPoint(cc.p(0, 0.5));
                goldn.setPosition(cc.p(cost2.width+1,cost2.height/2));
                cost2.addChild(goldn);

                var wansprite1 = new cc.Sprite('#integral3.png');
                if(wansprite1){
                    cost2.addChild(wansprite1);
                    wansprite1.setAnchorPoint(cc.p(0,0.5));
                    wansprite1.setPosition(cc.p(cost2.width+1+goldn.width,cost2.height/2));
                }

                var fensprite1 = new cc.Sprite('#integral5.png');
                if(fensprite1){
                    cost2.addChild(fensprite1);
                    fensprite1.setAnchorPoint(cc.p(0,0.5));
                    fensprite1.setPosition(cc.p(cost2.width+1+goldn.width+wansprite1.width,cost2.height/2));
                }
                cost2.setPosition(cc.p(colorbg.width/2-(cost2.width+1+goldn.width+wansprite1.width+fensprite1.width)/2,colorbg.height*0.3));
            }else{
                var goldn = FYEngine.createAlts('res/num/fishnum9.png', 12, goldnum, '.');
                goldn.setAnchorPoint(cc.p(0, 0.5));
                goldn.setPosition(cc.p(cost2.width+1,cost2.height/2));
                cost2.addChild(goldn);

                var wansprite1 = new cc.Sprite('#integral5.png');
                if(wansprite1){
                    cost2.addChild(wansprite1);
                    wansprite1.setAnchorPoint(cc.p(0,0.5));
                    wansprite1.setPosition(cc.p(cost2.width+1+goldn.width,cost2.height/2));
                }
                cost2.setPosition(cc.p(colorbg.width/2-(cost2.width+1+goldn.width+wansprite1.width)/2,colorbg.height*0.3));
            }
        }

        //FYEngine.AddNodeTouchListener(this, this.boxbtnCallBack,FYEngine.ActionType.Fade);
        //this.addClickEventListener(this.boxbtnCallBack);
        this.addTouchEventListener(this.boxbtnCallBack,this)


    },

    boxbtnCallBack: function (sender, type) {
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{

                sender.setOpacity(180);
            }break;
            case ccui.Widget.TOUCH_MOVED : {

                sender.setOpacity(180);
            }break;
            case ccui.Widget.TOUCH_CANCELED : {

                sender.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                var data = sender._info;
                var scene = FYEngine.getRunningLayer(0);
                var layer = new BuyIntergralLayer(data);
                if(layer){
                    scene.addChild(layer,FishZorder.poplayer,LobbySceneName.IntergralConfirmLayer);
                }
            }break;
        }
    },



});


var NYMallLayer = SccomLayer.extend({
    _time: 0,
    _isClose : false,
    ctor: function () {
        this._super();
        var self = this;
        this._isClose = false;
        FishGlobal.NYMallTag = true;
        var size = cc.winSize;
        this.size = size;
        FishGlobal.mallList = [];
        this.initUI();
        this.scheduleOnce(this.timeOutCheck, 15);
        this.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function() {
            Http.getMessage(function () {
                var service = formservice("springGift");
                var time = Date.now();
                var sign = formsign("springGift", time);
                time = formTime(time);
                var source = formsource(appglobal.getSource());
                var type = {name: "type", value: 2};
                var uid = {name : 'userId', value : appglobal.getPlayer().userid};
                var checksum = formchecksum(source.value, type.value, uid.value, sign.value, FYEngine.PrivateKey);
                var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, type, uid, source);
                return url;
            }(), null, function (cfgStr) {
//                FYEngine.logObject(cfgStr,'----------新春礼包2:');
                var scene =FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.NYMallLayer);
                var jsonInfo = eval('(' + cfgStr + ')');
                var errcode = jsonInfo.code;
                if(errcode == 1){
                    if(layer){
                        layer.unschedule(layer.timeOutCheck);
                        var loading = layer.layerbg.getChildByName('loading');
                        if(loading){
                            loading.removeFromParent(true);
                        }

                        var nosprite = new cc.Sprite("#newyear12.png");
                        if(nosprite){
                            layer.layerbg.addChild(nosprite);
                            nosprite.setPosition(cc.p(layer.layerbg.width / 2, layer.layerbg.height * 0.5));
                        }
                    }
                    return;
                }
                if (errcode != 0) {
                    cc.log('-----获取金豆充值 失败');
                    return;
                }

                if(layer && (layer._isClose == false)&& layer._listview){
                    layer.unschedule(layer.timeOutCheck);

                    var loading = layer.layerbg.getChildByName('loading');
                    if(loading){
                        loading.removeFromParent(true);
                    }

                    if(jsonInfo.data == ""){
                        var nosprite = new cc.Sprite("#newyear12.png");
                        if(nosprite){
                            layer.layerbg.addChild(nosprite);
                            nosprite.setPosition(cc.p(layer.layerbg.width / 2, layer.layerbg.height * 0.5));
                        }
                        return;
                    }

                    var dataValue = jsonInfo.data;
                    for (var i = 0; i < dataValue.length; ++i) {
                        var info = {};
                        info = dataValue[i];
                        FishGlobal.mallList.push(info);
                        var box = new NYChargeGoldBox(i, info);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            layer._listview.pushBackCustomItem(box);
                        }
                    }
                }
                // FYEngine.logObject(FishGlobal.NYmallList,'-----------充值列表:');
            });
        })));
    },

    setBuyedFunction : function(){
        cc.log("setBuyedFunction1");
        var list = this.layerbg.getChildByName("inner_list");
        if(list){
//            cc.log('----------充值成功2');
            var box = list.getItem(FishGlobal.NYBuyTag);
            if(box && box.setBuyedFunction){
                box.setBuyedFunction()
            }
        }
    },

    timeOutCheck: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.NYMallLayer);
        if(layer){
            this._isClose =true;
            var loading = layer.layerbg.getChildByName('loading');
            if(loading){
                loading.removeFromParent(true);
            }
            var tip = new cc.Sprite('#newyear11.png');
            if(tip){
                layer.layerbg.addChild(tip);
                tip.setPosition(cc.p(layer.layerbg.width / 2, layer.layerbg.height * 0.5))
            }
        }


    },
    initUI: function () {
        var layerbg = this.addLayerBg(SccomRes.MallRes.Outerbg, cc.size(980, 570), cc.p(this.width / 2, this.height * 0.4 + 30));
        var innerBg = FYEngine.createImageView(SccomRes.MallRes.Innerbg, cc.p(this.layerbg.width / 2, this.layerbg.height*0.55), cc.p(0.5, 0.5), cc.size(920, 410));
        this.layerbg.addChild(innerBg, 0, 2);

        var titleBg = FYEngine.createSprite("#newyear2.png", cc.p(this.layerbg.width / 2, this.layerbg.height * 1.02));
        this.layerbg.addChild(titleBg, 0, 3);
        var titleName = FYEngine.createSprite('#newyear6.png', cc.p(titleBg.width / 2, titleBg.height / 2));
        titleBg.addChild(titleName, 0, 1);

        var btnBack = new ccui.Button(SccomRes.Backbtn.Up, SccomRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.96);
            this.layerbg.addChild(btnBack, 0, 3);
            btnBack.addClickEventListener(this.closeCallBack);
        }

        var nytip = new ccui.Text('每种礼包每天限购一次', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei),26);
        if(nytip){
            nytip.setPosition(cc.p(innerBg.width/2, 388));
            nytip.setTextColor(cc.color("f3fc04"));
            nytip.enableOutline(cc.color("f3fc04"), 1);
            innerBg.addChild(nytip, 1, 100);

        }

        var listview = this._listview = FYEngine.createListView(cc.size(880, 415), cc.p(this.layerbg.width / 2, this.layerbg.height * 0.52), cc.p(0.5, 0.5), 9, ccui.ScrollView.DIR_HORIZONTAL);
        if (listview) {
            listview.setScrollBarEnabled(false);
            this.layerbg.addChild(listview, 1, "inner_list");
        }

        this.addVipMode();
        var _sprite = new cc.Sprite(SccomRes.MallRes.loadingbg);
        if (_sprite) {
            _sprite.setPosition(cc.p(layerbg.width / 2, layerbg.height * 0.5 + 20));
            layerbg.addChild(_sprite, 99, 'loading');
        }

        var rotate = new cc.RotateBy(1.2, 360);
        _sprite.runAction(new cc.RepeatForever(rotate));

    },

    addVipMode : function(){
        var self = this;
        var player = appglobal.getPlayer();


        var vipbigbg = new ccui.Layout();
        if(vipbigbg){
            this.layerbg.addChild(vipbigbg,10,"vipbigbg");
            vipbigbg.setContentSize(cc.size(920,80));
            vipbigbg.setAnchorPoint(cc.p(0.5,0.5));
            vipbigbg.setPosition(cc.p(this.layerbg.width/2,70));
            // vipbigbg.setBackGroundColor(cc.color.RED);
            // vipbigbg.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        }

        var viplogobg  = this._logonumber= new ccui.ImageView("fish_vip_res"+(10+player.iVIPLevel)+".png",ccui.Widget.PLIST_TEXTURE);
        if(viplogobg){
            vipbigbg.addChild(viplogobg,0,"viplogobg");
            viplogobg.setPosition(cc.p(90,50));
        }

        var warntext = new ccui.Text("适度娱乐 理性消费","",22);
        if(warntext){
            vipbigbg.addChild(warntext,0,"warntext");
            warntext.setPosition(cc.p(90,18));
            warntext.setTextColor(cc.color("00fff6"));
        }

        var progressbg = new cc.Sprite('#fish_vip_res3.png');
        if(progressbg){
            vipbigbg.addChild(progressbg,0,"progressbg");
            progressbg.setPosition(cc.p(410,50));

            var progress = this._progress = new cc.ProgressTimer(new cc.Sprite('#fish_vip_res6.png'));
            if(progress){
                progress.setAnchorPoint(cc.p(0,0));
                progress.setPosition(cc.p(1,-2));
                progress.setType(cc.ProgressTimer.TYPE_BAR);
                progress.setBarChangeRate(cc.p(1,0));
                progress.setMidpoint(cc.p(0,0));
                progressbg.addChild(progress,1,'progress');
                progress.setPercentage(100);
            }

            var mLabel = this._mLabel = new ccui.Text('0/0','微软雅黑',24);
            if(mLabel){
                // mLabel.setTextColor(cc.color("ffe062"));
                mLabel.enableOutline(cc.color("11415b"),2);
                mLabel.setPosition(cc.p(progressbg.width/2,progressbg.height/2));
                progressbg.addChild(mLabel,2,"mLabel");
            }
        }

        var btnSeeVipinfo = new ccui.ImageView("fish_vip_res33.png",ccui.Widget.PLIST_TEXTURE);
        if(btnSeeVipinfo){
            vipbigbg.addChild(btnSeeVipinfo,1,"btnSeeVipinfo");
            btnSeeVipinfo.setPosition(cc.p(780,35));
            btnSeeVipinfo.setTouchEnabled(true);
            btnSeeVipinfo.addTouchEventListener(this.btnTouchEft,this);
            btnSeeVipinfo.addClickEventListener(function(){
                cc.log("点击特权按钮");
                self.removeFromParent(true);
                var layer = new VIPinfoLayer();
                FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.VIPinfoLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            });
        }
        this.refreshVIPinfo();
    },

    addUnderText : function(){
        var player = appglobal.getPlayer();
        var vipbigbg = this.layerbg.getChildByName("vipbigbg");
        if(vipbigbg){
            var TextTip = vipbigbg.getChildByName("TextTip");
            if(TextTip){
                TextTip.removeFromParent(true);
            }

            if(player.iVIPLevel >=6){
                return;
            }else{
                TextTip = new ccui.Text("再充值","微软雅黑",22);
                if(TextTip){
                    vipbigbg.addChild(TextTip,1,"TextTip");
                    TextTip.setAnchorPoint(cc.p(0,0.5));
                    TextTip.setPosition(cc.p(250,18));
                    TextTip.setTextColor(cc.color("00fff6"));
                    var needmoney = new ccui.Text(""+(player.iVIPNextMoney-player.iMoney),"微软雅黑",30);
                    if(TextTip){
                        TextTip.addChild(needmoney,1,"needmoney");
                        needmoney.setAnchorPoint(cc.p(0,0.5));
                        needmoney.setPosition(cc.p(TextTip.width+5,TextTip.height/2));
                        needmoney.setTextColor(cc.color("f3fc04"));
                    }

                    var text2 = new ccui.Text("元，即可升级为","",22);
                    if(text2){
                        TextTip.addChild(text2,1,"text2");
                        text2.setAnchorPoint(cc.p(0,0.5));
                        text2.setPosition(cc.p(TextTip.width+needmoney.width+10,TextTip.height/2));
                        text2.setTextColor(cc.color("00fff6"));
                    }

                    var logo = new ccui.Text("VIP"+(player.iVIPLevel+1),"",30);

                    if(logo){
                        TextTip.addChild(logo,0,"logo");
                        logo.setAnchorPoint(cc.p(0,0.5));
                        logo.setPosition(cc.p(TextTip.width+needmoney.width+text2.width+15,TextTip.height/2));
                        logo.setTextColor(cc.color("f3fc04"));
                    }
                }
            }
        }
    },

    refreshVIPinfo : function(){
        var player =appglobal.getPlayer();
        if(this._logonumber){
            this._logonumber.loadTexture("fish_vip_res"+(10+player.iVIPLevel)+".png",ccui.Widget.PLIST_TEXTURE);
        }

        if(this._mLabel && this._progress){
            if(player.iVIPLevel >=6){
                this._mLabel.setString("已满级");
                this._progress.setPercentage(100);
            }else{
                var range = player.iVIPNextMoney - player.iVIPMoney;//当前等级的范围;
                var sp = player.iMoney-player.iVIPMoney;//当前等级已充值了多少;
                this._mLabel.setString(""+sp+"/"+range);
                if(range>0){
                    var curper = Math.floor((sp/range)*100);
                    cc.log("---:"+curper);
                    this._progress.setPercentage(curper);
                }else{
                    this._progress.setPercentage(0);
                }
            }
        }
        this.addUnderText();
    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },

    closeCallBack : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.NYMallLayer);
        layer._isClose = true;
        FYEngine.popoutLayerAnimate(layer.layerbg);
    },

    sendGoldMallCfgUrl: function () {
        var service = formservice("shop");
        var time = Date.now();
        var sign = formsign("shop", time);
        time = formTime(time);
        var source = formsource(appglobal.getSource());
        var type = {name: "type", value: 0};
        var checksum = formchecksum(source.value, type.value, sign.value, FYEngine.PrivateKey);
        var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, type);
        return url;
    },

    refreshList : function(){
        var _sprite = new cc.Sprite(SccomRes.MallRes.loadingbg);
        if (_sprite) {
            _sprite.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5 + 20));
            this.layerbg.addChild(_sprite, 99, 'loading');
        }
        var rotate = new cc.RotateBy(1.5, 360);
        _sprite.runAction(new cc.RepeatForever(rotate));

        var list = this.layerbg.getChildByTag(10);
        if(list){
            list.removeAllItems();
        }

        this.scheduleOnce(this.timeOutCheck, 15);
        this.runAction(new cc.Sequence(new cc.CallFunc(function () {
            Http.getMessage(function () {
                var service = formservice("springGift");
                var time = Date.now();
                var sign = formsign("springGift", time);
                time = formTime(time);
                var source = formsource(appglobal.getSource());
                var type = {name: "type", value: 2};
                var uid = {name : 'userId', value : appglobal.getPlayer().userid};
                var checksum = formchecksum(source.value, type.value, uid.value, sign.value, FYEngine.PrivateKey);
                var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, type, uid, source);
                return url;
            }(), null, function (cfgStr) {
//                FYEngine.logObject(cfgStr,'----------新春礼包2:');
                var scene =FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.NYMallLayer);
                var jsonInfo = eval('(' + cfgStr + ')');
                var errcode = jsonInfo.code;
                if (errcode != 0) {
                    cc.log('-----获取金豆充值 失败');
                    return;
                }
                if(layer){
                    layer.unschedule(layer.timeOutCheck);

                    var loading = layer.layerbg.getChildByName('loading');
                    if(loading){
                        loading.removeFromParent(true);
                    }

                    var dataValue = jsonInfo.data;
                    for (var i = 0; i < dataValue.length; ++i) {
                        var info = {};
                        info = dataValue[i];
                        FishGlobal.mallList.push(info);
                        var box = new NYChargeGoldBox(i, info);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            list.pushBackCustomItem(box);
                        }
                    }
                }
                //FYEngine.logObject(FishGlobal.mallList,'-----------充值列表:');

            });
        })));
    }

});

var NYChargeGoldBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _buyed : false,
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        if(this._info.limitCount > this._info.goodsLimitCount ){
            this._buyed = false;
        }else{
            this._buyed = true;
            this.setColor(cc.color(145, 145, 145, 255));
        }
        this.loadTexture(SccomRes.MallRes.Boxbg, ccui.Widget.PLIST_TEXTURE);
        var labeltop = new cc.LabelTTF();
        if (labeltop) {
            this.addChild(labeltop, 0, 'labeltop');
            labeltop.initWithString(this._info.name, 'Arial', 24);
            labeltop.setPosition(cc.p(this.width / 2, 340));
            if(this._buyed == true ){
                labeltop.setColor(cc.color(145,145,145,255));
            }
        }

        var IsPic = NYchargeList.indexOf(this._info.picId);
        var picName = "";
        if(IsPic >= 0){
            picName = this._info.picId;
        }else{
            picName = "nopic.png";
        }
        var pic = new ccui.ImageView(picName, ccui.Widget.PLIST_TEXTURE);
        if (pic) {
            this.addChild(pic, 0, 1);
            pic.setPosition(cc.p(this.width / 2, this.height * 0.55+40));
        }

        var picDisCount = new ccui.ImageView('newyear14.png', ccui.Widget.PLIST_TEXTURE);
        if (picDisCount) {
            this.addChild(picDisCount, 0, 2);
            picDisCount.setPosition(cc.p(40, 270));
        }





        var btn = new ccui.ImageView(SccomRes.MallRes.Boxbtn, ccui.Widget.PLIST_TEXTURE);
        if (btn) {
            var tag = 100 + this._item;
            btn.setTouchEnabled(true);
            this.addChild(btn, 0, tag);
            btn.setPosition(cc.p(this.width / 2, this.height * 0.16));
            if(this._buyed == false ){
                //FYEngine.AddNodeTouchListener(btn, this.boxbtnCallBack, FYEngine.ActionType.Fade);
                btn.addTouchEventListener(this.boxbtnCallBack,this)
            }else{
                btn.setColor(cc.color(145,145,145,255));
            }
        }

        var money = Number(this._info.money) + '';
        var number = FYEngine.createAlts(SccomRes.MallRes.Number, 10, money, '0');
        if (number) {
            btn.addChild(number, 0, 1);
            number.setAnchorPoint(cc.p(0, 0.5));
            var yuan = new cc.Sprite();
            if (yuan) {
                yuan.setSpriteFrame(SccomRes.MallRes.Yuan);
                yuan.setAnchorPoint(cc.p(0, 0.5));
                yuan.setPosition(cc.p(number.width, number.height / 2));
                number.addChild(yuan, 0, 2);
            }
            btn.setSwallowTouches(false);
            number.setPosition(cc.p(btn.width / 2 - (number.width + yuan.width) / 2, btn.height / 2 + 5));

        }

        var textdesc = this._info.desc.split(",");
//        FYEngine.logObject(textdesc);
        var labeltip1 = new cc.LabelTTF();
        if (labeltip1) {
            this.addChild(labeltip1, 0, 10);
            labeltip1.initWithString(textdesc[0], 'Arial', 22);
            labeltip1.setPosition(cc.p(this.width / 2, 155));
            labeltip1.setColor(cc.color("007290"));
        }
        var labeltip2 = new cc.LabelTTF();
        if (labeltip2) {
            this.addChild(labeltip2, 0, 11);
            labeltip2.initWithString(textdesc[1], 'Arial', 22);
            labeltip2.setPosition(cc.p(this.width / 2, 125));
            labeltip2.setColor(cc.color("fd4302"));
        }
        if(this._buyed == true ){
            number.setColor(cc.color(145,145,145,255));
            yuan.setColor(cc.color(145,145,145,255));
            //labeltip2.setColor(cc.color(145,145,145,255));
            pic.setColor(cc.color(145,145,145,255));
        }

        var BUYED = new cc.Sprite('#newyear7.png');
        if(BUYED){
            this.addChild(BUYED, 0, 12);
            BUYED.setPosition(cc.p(this.width / 2, this.height/2+20));
            if( this._buyed == false ){
                BUYED.setVisible(false);
            }else{
                BUYED.setVisible(true);
            }
        }

    },

    setBuyedFunction : function(){
        cc.log("setBuyedFunction2");
        this.setColor(cc.color(145, 145, 145, 255));
        var labeltop = this.getChildByName('labeltop');
        if(labeltop){
            labeltop.setColor(cc.color(145,145,145,255));
        }

        var pic = this.getChildByTag(1);
        if(pic){
            pic.setColor(cc.color(145,145,145,255));
        }


        var buyed = this.getChildByTag(12);
        if(buyed){
            buyed.setVisible(true);
        }

        var btn = this.getChildByTag((100+this._item));
        if(btn){
//            cc.log('-----充值成功后设置按钮无法点击'+(100+this._item));
            btn.setTouchEnabled(false);
            this._buyed =true;
            btn.setColor(cc.color(145,145,145,255));
        }

        var number = btn.getChildByTag(1);
        if(number){
            number.setColor(cc.color(145,145,145,255));
            var yuan = number.getChildByTag(2);
            if(yuan){
                yuan.setColor(cc.color(145,145,145,255));
            }
        }
    },

    boxbtnCallBack: function (sender, type) {
        var box = sender.getParent();
        if(box._buyed ==true){
            cc.log('------已经购买过了');
            return;
        }

        FishGlobal.NYBuyTag = box._item;
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{
                sender.setOpacity(180);
            }break;
            case ccui.Widget.TOUCH_MOVED : {
                sender.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);

                if(cc.sys.os == 'iOS'){
                    var chargernum = appglobal.getPlayer().totalpay;
                    cc.log("---------玩家的edu:"+chargernum);
                    var money = parseInt(box._info.money);
                    if(chargernum<FishGlobal.chargegoodsplayerdown){
                        if(money>=FishGlobal.chargegoodslevel){
                            FishGlobal.iosPayTag = 0;//调用苹果支付
                        }else{
                            FishGlobal.iosPayTag = 1;//调用ibay支付
                        }
                    }else if(chargernum<FishGlobal.chargegoodsplayerup){
                        if(money>=FishGlobal.chargegoodslevel){
                            var scene = FYEngine.getRunningLayer(0);
                            var inlayer = scene.getChildByName('lay3');
                            if (!inlayer) {
                                var infolayer = new IosPayLayer(box._info);
                                if (infolayer) {
                                    scene.addChild(infolayer, FishZorder.poplayer, LobbySceneName.IosPayLayer);
                                    FYEngine.popupLayerAnimate(infolayer.layerbg);
                                }

                            }
                            return;
                        }else{
                            FishGlobal.iosPayTag = 1;
                        }

                    }else{
                        FishGlobal.iosPayTag = 1;
                    }
                    var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                    if (handler) {
                        handler.sendQueryDailyChargeReq(box._info.goodsId);
                    }
                }else{
                    var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                    if (handler) {
//                        cc.log('——————————————发送充值请求-------------');
                        handler.sendQueryDailyChargeReq(box._info.goodsId);
                    }
                }

            }
        }
    },
});

var InviteFriendLayer = SccomLayer.extend({
    _time: 0,
    _isClose: false,
    ctor: function () {
        this._super();
        this._isClose = false;
        this.initUI();
        this.scheduleOnce(this.timeOutCheck, 15);
        this.sendMsg();
    },

    sendMsg: function () {
        Http.getMessage(function () {
            var service = formservice("taskList");
            var time = Date.now();
            var sign = formsign("taskList", time);
            time = formTime(time);
            var userid ={name:"uid",value:appglobal.getPlayer().userid};
            var task = {name: "taskId", value: 1};
            var checksum = formchecksum(userid.value,task.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, task, userid, sign,checksum);
            return url;
        }(), null, function (cfgStr) {
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(LobbySceneName.InviteFriendLayer);
            var jsonInfo = eval('(' + cfgStr + ')');
            FYEngine.logObject(jsonInfo, '---------获取任务列表:');
            var errcode = jsonInfo.code;

            if (errcode == 1) {
                if (layer && (layer._isClose == false)) {
                    layer.unschedule(layer.timeOutCheck);
                    layer.removeNewLoading();
                    layer.addNoProductTip();
                }
                return;
            }

            if (errcode != 0) {
//                    cc.log('-----获取金豆充值 失败');
                if (layer && (layer._isClose == false)) {
                    layer.unschedule(layer.timeOutCheck);
                    layer.removeNewLoading();
                    layer.addLoadFailTip();
                }
                return;
            }
            if (layer && (layer._isClose == false) && layer._listview) {
                layer.unschedule(layer.timeOutCheck);
                layer.removeNewLoading();
                var dataValue = jsonInfo.data;

                if (dataValue.tasks.length == 0) {
                    layer.addNoProductTip();
                    return;
                }

                layer.initProgress(dataValue.alreadyTimes,dataValue.maxTimes);
                layer.initListItem(dataValue.tasks);


            }
            //FYEngine.logObject(FishGlobal.mallList,'-----------充值列表:');

        });
    },

    initProgress : function(already,total){
        this._mLabel.setString(""+already+"/"+total);
        if(already>=total){
            this._progress.setPercentage(100);
        }else{
            this._progress.setPercentage( Math.floor((already / total) * 100));
        }

    },

    initListItem : function(dataValue){
        this._listview.removeAllItems();
        for (var i = 0; i < dataValue.length; ++i) {
            var box = new InviteBox(i, dataValue[i], dataValue.length - 1);
            if (box) {
                this._listview.pushBackCustomItem(box);
            }
        }
    },

    timeOutCheck: function () {
        this._isClose = true;
        this.removeNewLoading();
        this.addLoadFailTip();
    },

    initUI: function () {
        var self = this;
        var bg = this.layerbg = new ccui.ImageView("fish_share_res8.png",ccui.Widget.PLIST_TEXTURE);
        if(bg){
            bg.setPosition(cc.p(this.width/2,this.height/2));
            this.addChild(bg,0,"layerbg");
        }

        var btnBack = new ccui.Button(SccomRes.Backbtn.Up, SccomRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(this.layerbg.width * 0.98, this.layerbg.height * 0.88);
            this.layerbg.addChild(btnBack, 0, "btnback");
            btnBack.addClickEventListener(function () {
                self.closeCallBack();
            });
        }

        var listview = this._listview = FYEngine.createListView(cc.size(875, 305), cc.p(this.layerbg.width / 2+50, this.layerbg.height * 0.5-15), cc.p(0.5, 0.5), 0, ccui.ScrollView.DIR_HORIZONTAL);
        if (listview) {
            listview.setScrollBarEnabled(false);
            this.layerbg.addChild(listview, 1, "inner_list");
        }


        var tip1  = new ccui.Text('累计邀请人数', '微软雅黑', 28);
        if (tip1) {
            tip1.setPosition(cc.p(270, 80));
            this.layerbg.addChild(tip1, 2, "tip1");
        }

        var progressbg = new cc.Sprite('#fish_vip_res3.png');
        if (progressbg) {
            this.layerbg.addChild(progressbg, 0, "progressbg");
            progressbg.setScaleX(0.8);
            progressbg.setPosition(cc.p(540, 80));

            var progress = this._progress = new cc.ProgressTimer(new cc.Sprite('#fish_vip_res6.png'));
            if (progress) {
                progress.setAnchorPoint(cc.p(0, 0));
                progress.setPosition(cc.p(1,-2));
                progress.setType(cc.ProgressTimer.TYPE_BAR);
                progress.setBarChangeRate(cc.p(1, 0));
                progress.setMidpoint(cc.p(0, 0));
                progressbg.addChild(progress, 1, 'progress');
                progress.setPercentage(0);
            }

            var mLabel = this._mLabel = new ccui.Text('0/0', '微软雅黑', 20);
            if (mLabel) {
                mLabel.enableOutline(cc.color("11415b"),2);
                mLabel.setPosition(cc.p(540, 80));
                this.layerbg.addChild(mLabel, 2, "mLabel");
            }
        }

        var btn_invite = new ccui.ImageView("fish_share_res4.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_invite) {
            this.layerbg.addChild(btn_invite, 10, "btn_invite");
            btn_invite.setTouchEnabled(true);
            btn_invite.setPosition(cc.p(870, 75));
            btn_invite.addTouchEventListener(this.btnTouchEft, this);
            btn_invite.addClickEventListener(function (sender) {
                self.inviteCallBack();
            });
        }

        this.addNewLoading();
    },

    inviteCallBack: function () {
        cc.log("inviteCallBack");
        var scene = FYEngine.getRunningLayer(0);
        var jsonStr = app.sdkPlugin.callNativeMethod("ISWXShare", "");
        cc.log("jsonStr:"+jsonStr);
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined') {
            var base = new Base64();
            var data = {
                type :1,
                data1:appglobal.getShareUrl(),
                data2:"",
                data3:"",
                tag: 0,
                title : base.encode(appglobal.getAppName()),
                description : base.encode("满屏爆金High翻天，百万金币每天领，天降红包挡不住，街机捕鱼等你来，千人竞技嗨到底！"),
                imageUrl : appglobal.getImageUrl()
            };

            app.sdkPlugin.callNativeMethod("WXShare", JSON.stringify(data));
        }else{
            var layer = scene.getChildByName(LobbySceneName.ShareFriendLayer);
            if(!layer){
                layer = new ShareFriendLayer();
                scene.addChild(layer,FishZorder.poplayer, LobbySceneName.ShareFriendLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
        }
    },


    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    addGetLoading : function(){
        var loading = FYEngine.CreateAccRelatedLoading();
        if(loading){
            this.addChild(loading,1000,"accloading");
        }
    },

    removeGetLoading : function(){
        var loading = this.getChildByName("accloading");
        if(loading){
            loading.removeFromParent(true);
        }
    },

    getTimeOut: function () {
        this.removeGetLoading();
        FYEngine.AddCommToast("超时请重试");
    },

    addNewLoading: function () {
        var _sprite = FYEngine.createSprite(SccomRes.MallRes.loadingbg, cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5));
        if(_sprite){
            this.layerbg.addChild(_sprite, 99, SccomLayerName.loading);
            var rotate = new cc.RotateBy(1.2, 360);
            _sprite.runAction(new cc.RepeatForever(rotate));
        }
    },

    removeNewLoading: function () {
        var fish = this.layerbg.getChildByName(SccomLayerName.loading);
        if (fish) {
            fish.removeFromParent(true);
        }
    },

    addNoProductTip: function () {
        this._isClose = true;
       FYEngine.AddCommToast("请稍后再试");
    },

    addLoadFailTip: function () {
        this._isClose = true;
        FYEngine.AddCommToast("请稍后再试");
    },


    closeCallBack: function () {
        this._isClose = true;
        FYEngine.popoutLayerAnimate(this.layerbg);
    },

    UIBtnCallBack: function (sender) {

    },

});

/**
 * awardStatus:   0可领  1已领 2未完成
 * awardValue: 奖励数量
 * awardCode: 奖励货币类型  1奖券  2 金豆
 */
var InviteBox = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _length: 0,
    ctor: function (i, info, length) {
        this._super();
        this._item = i;
        this._info = info;
        this._length = length;
        this.initUI();

    },

    initUI: function () {
        var self = this;
        this.loadTexture("fish_share_res7.png",ccui.Widget.PLIST_TEXTURE);
        this.setEnabled(true);

        var titlecontent = "累计邀请{0}名好友".format(this._info.times);
        var title = new ccui.Text(titlecontent, "微软雅黑", 22);
        if (title) {
            this.addChild(title, 1, "title1");
            title.setPosition(cc.p(this.width/2,265));
            title.setTextColor(cc.color("683907"));
        }

        var pic_scale = 1;
        var picname = "";
        var textype = "金币：";
        if (this._info.awardCode == 2) {
            var textype = "金币：";
            pic_scale = 0.5;
            if (this._info.picName == "0") {
                picname = SccomRes.MallRes.Goldlittle;
            } else if (this._info.picName == "1") {
                picname = SccomRes.MallRes.Goldsmall;
            } else {
                picname = SccomRes.MallRes.Goldbig;
            }
        } else {
            var textype = "奖券：";
            pic_scale = 0.7;
            if (this._info.picName == "0") {
                picname = "intergral50.png";
            } else if (this._info.picName == "1") {
                picname = "intergral54.png";
            } else {
                picname = "intergral56.png";
            }
        }
        var pro_pic = new cc.Sprite("#"+picname);
        if(pro_pic){
            this.addChild(pro_pic);
            pro_pic.setScale(pic_scale);
            pro_pic.setPosition(cc.p(this.width/2,185));
        }

        var descontent = textype+this._info.awardValue;
        var des = new ccui.Text(descontent, "", 24);
        if (des) {
            this.addChild(des, 1, "des1");
            des.setPosition(cc.p(this.width/2,105));
            des.setTextColor(cc.color("791974"));
        }

        var btnpic = "";
        if(this._info.awardStatus == 1){
            btnpic ="fish_share_res3.png";
        }else if(this._info.awardStatus == 0){
            btnpic ="fish_share_res1.png";
        }else{
            btnpic ="fish_share_res2.png";
        }

        var btn_click = new ccui.ImageView(btnpic,ccui.Widget.PLIST_TEXTURE);
        if(btn_click){
            this.addChild(btn_click,3,"btn_click");
            btn_click.setTouchEnabled(true);
            btn_click.setPosition(cc.p(this.width/2,55));
            btn_click.addTouchEventListener(this.toucheft,this);
            btn_click.addClickEventListener(function(){
                self.clickCallBack();
            });
        }

        this.changeStatus();
    },

    clickCallBack : function(){
        if(this._info.awardStatus == 0){
            this.sendMsg();
        }else if(this._info.awardStatus == 1){
            FYEngine.AddCommToast("该奖励你已经领过啦");
        }else{
            FYEngine.AddCommToast("无法领取");
        }
    },

    getAwardId : function(){
        if(this._item == 0){
            return 1;
        }else if(this._item == 1){
            return 2;
        }else if(this._item == 2){
            return 4;
        }else if(this._item == 3){
            return 8;
        }else if(this._item == 4){
            return 16;
        }
    },

    sendMsg: function () {
        var self = this;
        var scene1 = FYEngine.getRunningLayer(0);
        var layer1 = scene1.getChildByName(LobbySceneName.InviteFriendLayer);
        if(layer1){
            layer1.addGetLoading();
            layer1.scheduleOnce(layer1.getTimeOut,15);
        }
        Http.getMessage(function () {
            var service = formservice("taskAward");
            var time = Date.now();
            var sign = formsign("taskAward", time);
            time = formTime(time);
            var userid ={name:"uid",value:appglobal.getPlayer().userid};
            var task = {name: "taskId", value: 1};
            var award = {name: "awardId", value: self.getAwardId()};
            var checksum = formchecksum(userid.value,task.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, task, userid, award,sign,checksum);
            return url;
        }(), null, function (cfgStr) {
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(LobbySceneName.InviteFriendLayer);
            if(layer){
                var jsonInfo = eval('(' + cfgStr + ')');
                FYEngine.logObject(jsonInfo, '---------任务领取返回:');
                var errcode = jsonInfo.code;
                layer.removeGetLoading();
                layer.unschedule(layer.getTimeOut);

                if (errcode != 0) {
                    FYEngine.AddCommToast("领取失败，请重启游戏再试");
                    return;
                }
                FYEngine.AddCommToast("领取成功");
                layer.sendMsg();
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if(handler && handler._canSendNormalMsg){
                    handler.sendUpdateWealthReq();
                }
            }

            //FYEngine.logObject(FishGlobal.mallList,'-----------充值列表:');

        });
    },

    changeStatus : function(){
        if(this._info.awardStatus == 1){
            var picname = "fish_share_res3.png";
            var btn = this.getChildByName("btn_click");
            if(btn){
                btn.loadTexture(picname,ccui.Widget.PLIST_TEXTURE);
                btn.setColor(cc.color(155, 155, 155, 255));
            }

            // this.setCascadeColorEnabled(true);
            this.setColor(cc.color(155, 155, 155, 255));

            var buyedtip = new cc.Sprite("#fish_share_res0.png");
            if(buyedtip){
                this.addChild(buyedtip,10,"buyedTip");
                buyedtip.setPosition(cc.p(this.width/2,this.height/2+30));

            }
        }
    },

    toucheft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN: {
                sender.setScale(1.1);
            }
                break;
            case ccui.Widget.TOUCH_MOVED: {
                sender.setScale(1.0);
            }
                break;
            case ccui.Widget.TOUCH_CANCELED: {
                sender.setScale(1.0);
            }
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1.0);
            }
                break;
        }
    },


});