/**
 * Created by mintao on 2016/11/14.
 * 大厅数据存储
 * data对象必须依托于handler对象存在
 * 定义在handler中，通过handler获取
 */

var RoomInfo = {
    iType : 0, //场次id
    szName : '', ///名字
    iLength : 0, ///在线人数
    szIP : '', // 32
    iPort : 0,
    szParams : ''//256
};

var LobbyData = cc.Class.extend({
    _roomList : null,
    _lobbyBroadExchange:null,
    _lobbyBroad:null,
    _crystalMsg : [],
    ctor : function(){
        this._roomList = {};
        this._lobbyBroadExchange = [];
        this._lobbyBroad=[];
        this._crystalMsg = [];
    },

    putRoom : function(key,value){
        this._roomList[key] = value;
    },

    getRoom : function(key){
        if (this._roomList[key]){
            return this._roomList[key];
        }
        cc.log("-----no room with type : "+key);
        return null;
    },
    putLobbyBroadExchange:function(broad){
        this._lobbyBroadExchange.unshift(broad);
        if(this._lobbyBroadExchange.length>20){
            this._lobbyBroadExchange.pop();
        }

    },
    putLobbyBroadExchangeBase:function(broad){
        this._lobbyBroadExchange.push(broad);
    },
    getLobbyBroadExchange:function(){
        return this._lobbyBroadExchange;
    },
    putLobbyBroad:function(broad){
        this._lobbyBroad.push(broad);

    },
    getLobbyBroad:function(){
        return this._lobbyBroad;
    }

});

