var SettingMsgKey = {
    settingMusic: "settingMusic",
    settingEffect: "settingEffect",
    settingVibration: "settingVibration",
    settingNick: "settingNick",
    settingAccount: "settingAccount",
    settingEmpAccount: "settingEmpAccount",
    settingUserId: "settingUserId",
    settingCompleteAccount: "settingCompleteAccount",
    settingNowNick: "settingNowNick",
    settingNewNick: "settingNewNick",
    settingInputNewNick: "settingInputNewNick",
    settingErrEmpNick: "settingErrEmpNick",
    settingErrSpaceNick: "settingErrSpaceNick",
    settingErrEmoji: "settingErrEmoji",
    settingErrNickLong: "settingErrNickLong",
    settingNickSuccess: "settingNickSuccess",
    settingNickFailed: "settingNickFailed",
    settingPassCheck: "settingPassCheck",
    settingPassRule: "settingPassRule",
    settingPassNow: "settingPassNow",
    settingSureNewPass: "settingSureNewPass",
    settingNewPass: "settingNewPass",
    settingNowPass: "settingNowPass",
    settingPassErr1: "settingPassErr1",
    settingPassErr2: "settingPassErr2",
    settingPassErr3: "settingPassErr3",
    settingPassErr4: "settingPassErr4",
    settingPassErr5: "settingPassErr5",
    settingPassErr6: "settingPassErr6",
    settingPassErr7: "settingPassErr7",
    settingPassErr8: "settingPassErr8",
    settingPassErr9: "settingPassErr9",
    settingAccount1: "settingAccount1",
    settingAccount2: "settingAccount2",
    settingAccount3: "settingAccount3",
    settingAccount4: "settingAccount4",
    settingAccount5: "settingAccount5",
    settingAccount6: "settingAccount6",
    settingAccount7: "settingAccount7",
    settingAccount8: "settingAccount8",
    settingAccount9: "settingAccount9",
    settingSign1: "settingSign1",
    settingSign2: "settingSign2",
    settingSign3: "settingSign3",
    settingSign4: "settingSign4",
    settingSign5: "settingSign5",
    crystalRank1: "crystalRank1",


};
var SettingLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        cc.log("SettingLayer");
        //this.loadResource();
        this.initUI();
    },
    initUI: function () {
        this.addLayerBg(cc.size(810, 520));
        this.addTitleBg(SettingRes.settingTitle, 810);
        this.addCloseBtn();
        // this.initImageViewBtn();
        var spriteH = new cc.Scale9Sprite(SettingRes.settingLineH);
        spriteH.setContentSize(cc.size(630, 4));
        spriteH.attr({x: 397, y: 223});
        this.layerbg.addChild(spriteH);

        //var spriteH2 = new cc.Scale9Sprite(SettingRes.settingLineH);
        //spriteH2.setContentSize(cc.size(630, 4));
        //spriteH2.attr({x: 397, y: 143});
        //this.layerbg.addChild(spriteH2);

        var spriteV = new cc.Scale9Sprite(SettingRes.settingLineV);
        spriteV.setContentSize(cc.size(4, 185));
        spriteV.attr({x: 530, y: 25, anchorX: 0, anchorY: 0});
        this.layerbg.addChild(spriteV);

        this.nickNameAndAccount();
        this.changePassAndCheckOut();
        this.addSign();
        this.addHead();
        this.addMusicBtn();
        if(appglobal._switch22 == 1 && appglobal._switch14 ==1 ){
            this.addIDcheckBtn();
        }
        this.addFamilyBtn();
    },

    addMusicBtn : function(){
        var btn_Music = new ccui.ImageView("fish_vip_res21.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_Music){
            this.layerbg.addChild(btn_Music,1,"btn_Music");
            btn_Music.setTouchEnabled(true);
            btn_Music.setPosition(cc.p(660,180));
            btn_Music.addTouchEventListener(this.btnTouchEft,this);
            btn_Music.addClickEventListener(function(sender){
                cc.log("btn_Music");
                var layer = new MusicSetLayer();
                if(layer){
                    FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.MusicSetLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
    },

    addFamilyBtn : function(){
        var btn_family = new ccui.ImageView("fish_vip_res22.png",ccui.Widget.PLIST_TEXTURE);//家长监护工程
        if(btn_family){
            this.layerbg.addChild(btn_family,1,"btn_family");
            btn_family.setTouchEnabled(true);
            btn_family.setPosition(cc.p(660,60));
            btn_family.addTouchEventListener(this.btnTouchEft,this);
            btn_family.addClickEventListener(function(sender){
                cc.sys.openURL(appglobal._URLfamily);
            });
        }
    },

    addIDcheckBtn : function(){
        var btn_IDverify = new ccui.ImageView("fish_vip_res20.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_IDverify){
            this.layerbg.addChild(btn_IDverify,1,"btn_IDverify");
            btn_IDverify.setTouchEnabled(true);
            btn_IDverify.setPosition(cc.p(660,120));
            btn_IDverify.addTouchEventListener(this.btnTouchEft,this);
            btn_IDverify.addClickEventListener(function(sender){
                var player = appglobal.getPlayer();
                if(player.realIDnumber == ""){
                    var layer = new IDverifyLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }else{
                    var layer = new IDverifyShowLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },
    refreshIDcheckBtn : function(){
        // var player = appglobal.getPlayer();
        // var btn_noid = this.layerbg.getChildByName("btn_noid");
        // var btn_hasid = this.layerbg.getChildByName("btn_hasid");
        //
        // if(player.realIDnumber != ""){
        //     btn_noid.setVisible(false);
        //     btn_hasid.setVisible(true);
        // }else{
        //     btn_noid.setVisible(true);
        //     btn_hasid.setVisible(false);
        // }
    },

    addHead : function(){

        var player = appglobal.getPlayer();
            var headK = new FYEngine.WebImage('#rankup020.png','#fish_hallnew01.png','#rankup012.png', player.facestatus ,player.faceid ,player.userid);
            if(headK){
                this.layerbg.addChild(headK);
                headK.attr({x:120, y:370, anchorX:0.5, anchorY:0.5});
                this.headnode = headK;

                if(appglobal.idVerifySwitch1){
                    if(appglobal._switch1 ==1){
                        headK.setTouchEnabled(true);
                        this.headnode.addTouchEventListener(this.changeHeadImageCallBack, this);
                        var changetip = new cc.Sprite("#fish_idverify_19.png");
                        if(changetip){
                            headK.addChild(changetip);
                            changetip.setAnchorPoint(cc.p(0.5,0));
                            changetip.setPosition(cc.p(headK.width/2,8));
                        }
                    }
                }

            }


    },

    changeHeadImageCallBack : function(sender, type){
        cc.log('--------切换头像'+type);
        var scene = FYEngine.getRunningLayer(0);
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{
                sender.setOpacity(180);
                sender._kuang.setOpacity(180);
                sender._headsprite.setOpacity(180);
            }break;
            //case ccui.Widget.TOUCH_MOVED : {
            //    sender.setOpacity(255);
            //    sender._kuang.setOpacity(255);
            //    sender._headsprite.setOpacity(255);
            //}break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
                var layer = new ChangeHeadLayer();
                if(layer){
                    scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
                }
            }
        }

    },

    changeHeadImageCallBackNoid : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        var layer = new ChangeHeadLayer();
        if(layer){
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
        }

    },

    headImgSuccess: function (faceid) {
        var that = this;
//        cc.log('-----------设置头像为待审核状态:'+faceid);
        that.headnode._headsprite.setColor(cc.color(150,150,150));
        that.headnode._facestatus = 0;
        that.headnode._faceId = faceid+'';
        appglobal.getPlayer().faceid = faceid+'';
        that.headnode.refreshPic();
        //that.headnode._headsprite.setSpriteFrame("待审核");
        //that.headnode._headsprite.setScale(1);
        var lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if(lobbyhandler.getState() == eClientState.CLIENT_STATE_CONNECTED){
            lobbyhandler.sendSetFaceIdReq(faceid);
        }
    },

    initImageViewBtn: function () {

        var posArr = [215, 150, 85];
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        var textArr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingMusic), FYEngine.LanguageString.getValue(SettingMsgKey.settingEffect), "震动"];
        for (var i = 0; i < arr.length; i++) {
            var imageView = new ccui.ImageView(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
            imageView.setTouchEnabled(true);
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (temp > 0 && i != 2) {

                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            } else if (temp == 0 && i == 2) {
                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            }
            imageView.setName(arr[i]);
            //imageView.attr({x: posArr[i], y: 183, anchorX: 0, anchorY: 1});
            imageView.attr({x: 630, y: posArr[i], anchorX: 0, anchorY: 1});
            this.layerbg.addChild(imageView);
            var textLabel = cc.Label.createWithSystemFont("" + textArr[i], "", 22);
            textLabel.setColor(cc.color("8ef3ff"));
            textLabel.attr({x: 610, y: posArr[i]-16, anchorX: 1, anchorY: 1});

            this.layerbg.addChild(textLabel);
            imageView.addClickEventListener(this.imageViewBtnCallback);
        }

    },

    imageViewBtnCallback: function (sender) {
        var name = sender.getName();
        var image = sender.getRenderFile().file;
        if (image == SettingRes.settingOff1) {
            sender.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
        } else {
            sender.loadTexture(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
        }

//        cc.log(name + "-------------" + cc.sys.localStorage.getItem(name));
        if (cc.sys.localStorage.getItem(name) > 0) {
            cc.sys.localStorage.setItem(name, 0);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(false);
                    cc.audioEngine.stopMusic();
                    break;
                case "eftVolum":
                    //cc.audioEngine.stopAllEffects();
                    FYEngine.Audio.setOpenEffect(false);
                    break;
                case "isVibration":
                    break;
            }
        } else {
            cc.sys.localStorage.setItem(name, 1);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(true);
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
                    break;

                case "eftVolum":
                    FYEngine.Audio.setEffectVolume(0.5);
                    FYEngine.Audio.setOpenEffect(true);
                    break;
                case "isVibration":
                    break;
            }
        }

    },
    nickNameAndAccount: function () {
        var userInfo = appglobal.getPlayer();
        var self = this;
        /**
         * 账户
         */
        var btnBg2 = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        btnBg2.setContentSize(cc.size(360, 50));
        btnBg2.attr({x: 110, y: 158, anchorX: 0, anchorY: 0});
        var accountSprite = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount), "", 25);
        accountSprite.setColor(cc.color("8ef3ff"));
        accountSprite.attr({x: 49, y: 183, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(btnBg2);
        btnBg2.setName("btnBg2");
        this.layerbg.addChild(accountSprite);
        var accountValue = userInfo.account == userInfo.userid ? FYEngine.LanguageString.getValue(SettingMsgKey.settingEmpAccount) : userInfo.account;
        var account = new cc.LabelTTF(accountValue, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        account.attr({x: 20, y: 25, anchorX: 0, anchorY: 0.5});
        account.setName("accountMsg");
        btnBg2.addChild(account);
        var btn2 = cc.Sprite(SettingRes.settingBgBtn);
        btn2.attr({x: 490, y: 158, anchorX: 1, anchorY: 0});
        this.layerbg.addChild(btn2);
        btn2.setName("accountBtn");
        var sprite = cc.Sprite("#fish_acbind_2.png");
        sprite.setPosition(btn2.width / 2, btn2.height / 2);
        btn2.addChild(sprite, 0, 0);
        if(userInfo.account != userInfo.userid){
            sprite.setSpriteFrame("fish_acbind_27.png");
        }
        FYEngine.AddNodeTouchListener(btn2, function () {
            if (userInfo.account == userInfo.userid) {
                var layer = new CompleteInfoLayer();
                FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.CompleteInfoLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            } else {
                var layer = new ChangePSWchoseDialog();
                FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangePSWchoseDialog);
            }
        }, FYEngine.ActionType.Fade);
        /**
         * 号码
         */
        var btnBgphone = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        btnBgphone.setContentSize(cc.size(360, 50));
        btnBgphone.attr({x: 110, y: 98, anchorX: 0, anchorY: 0});
        var phoneSprite = cc.Label.createWithSystemFont("手机", "", 25);
        phoneSprite.setColor(cc.color("8ef3ff"));
        phoneSprite.attr({x: 49, y: 123, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(btnBgphone);
        btnBgphone.setName("btnBgphone");
        this.layerbg.addChild(phoneSprite);
        var phoneValue = (userInfo.phonenumber == 0 || userInfo.phonenumber == "") ? "未绑定" : userInfo.getFreshPhoneNumber();
        var phone = new cc.LabelTTF(phoneValue, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        phone.attr({x: 20, y: 25, anchorX: 0, anchorY: 0.5});
        phone.setName("phoneMsg");
        btnBgphone.addChild(phone);
        var btncp = cc.Sprite(SettingRes.settingBgBtn);
        btncp.attr({x: 490, y: 98, anchorX: 1, anchorY: 0});
        this.layerbg.addChild(btncp);
        btncp.setName("phoneBtn");
        var sprite1 = cc.Sprite("#fish_acbind_5.png");
        sprite1.setPosition(btncp.width / 2, btncp.height / 2);
        btncp.addChild(sprite1, 0, 0);
        if(!(userInfo.phonenumber == 0 || userInfo.phonenumber == "")){
            sprite1.setSpriteFrame("fish_acbind_4.png");
        }
        FYEngine.AddNodeTouchListener(btncp, function () {
            if(userInfo.account == userInfo.userid){
                FYEngine.AddCommToast("请先完善账号");
            }else{
                var scene = FYEngine.getRunningLayer(0);
                if(userInfo.phonenumber != 0 && userInfo.phonenumber != ""){//解绑手机
                    cc.log('------解绑手机');
                    var layer = scene.getChildByName(LobbySceneName.UnBindPhoneConfirmDialog);
                    if(!layer){
                        layer= new UnBindPhoneConfirmDialog();
                        scene.addChild(layer,FishZorder.poplayer,LobbySceneName.UnBindPhoneConfirmDialog);
                        //FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                }else{//绑定手机
                    cc.log('------绑定手机');
                    var layer = scene.getChildByName(LobbySceneName.BindPhoneDialog);
                    if(!layer){
                        layer= new BindPhoneDialog();
                        scene.addChild(layer,FishZorder.poplayer,LobbySceneName.BindPhoneDialog);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                }
            }
        }, FYEngine.ActionType.Fade);

        /**
         * 昵称
         */
        var btnBg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        btnBg.setContentSize(cc.size(270, 46));
        btnBg.attr({x: 270, y: 388, anchorX: 0, anchorY: 0});

        var nickSprite = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingNick), "", 25);
        nickSprite.setColor(cc.color("8ef3ff"));
        nickSprite.attr({x: 210, y: 413, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(btnBg);
        this.layerbg.addChild(nickSprite);

        //var nick = new cc.LabelTTF(userInfo.nickname, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        var nick = FYEngine.createLengthText(userInfo.nickname,22,170);
        nick.attr({x: 285, y: 410, anchorX: 0, anchorY: 0.5});
        nick.setName("nick");
        this.layerbg.addChild(nick);
        var btn = cc.Sprite("#rankup011.png");
        //var sprite1 = cc.Sprite("#rankup011.png");
        //sprite1.setPosition(btn.width / 2, btn.height / 2);
        //btn.addChild(sprite1);
        btn.attr({x: 545, y: 389, anchorX: 1, anchorY: 0});
        this.layerbg.addChild(btn, 15);
        FYEngine.AddNodeTouchListener(btn, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            var Snick = userInfo.nickname;
            var layer = new ChangeNickLayer(Snick);

            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeNickNameLayer);

            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);
        /**
         * Id
         */
        var userIdSprite = new cc.Sprite("#fish_acbind_31.png");
        if(userIdSprite){
            userIdSprite.attr({x:25, y:265, anchorX:0, anchorY:0.5});
            this.layerbg.addChild(userIdSprite);
        }

        var UID = new cc.LabelTTF(""+userInfo.userid, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if(UID){
            UID.setColor(cc.color("03394f"));
            userIdSprite.addChild(UID);
            UID.setPosition(cc.p(55,userIdSprite.height/2));
            UID.setAnchorPoint(cc.p(0,0.5));
        }

        /**
         * VIP等级
         */
        var Vipbg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        Vipbg.setContentSize(cc.size(120, 45));
        Vipbg.attr({x: 630, y: 412, anchorX: 0, anchorY: 0.5});

        var VIPtip = cc.Label.createWithSystemFont("VIP等级", "", 22);
        VIPtip.setColor(cc.color("8ef3ff"));
        VIPtip.attr({x: 550, y: 412, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(Vipbg);
        this.layerbg.addChild(VIPtip);

        var iVIPLevel  = this._uservip = new ccui.Text(""+userInfo.iVIPLevel,"",20);
        iVIPLevel.setTextColor(cc.color("ffec4d"));
        iVIPLevel.attr({x: 660, y: 415, anchorX: 0, anchorY: 0.5});
        iVIPLevel.setName("nick");
        this.layerbg.addChild(iVIPLevel);
        var vipbtn = cc.Sprite("#fish_vip_res19.png");
        vipbtn.attr({x: 690, y: 412, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(vipbtn, 15);

        FYEngine.AddNodeTouchListener(vipbtn, function (sender) {
            cc.log("点击特权按钮");
            self.removeFromParent(true);
            var layer = new VIPinfoLayer();
            FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.VIPinfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);

    },

    refreshVIPinfo : function(){
        if(this._uservip){
            var player = appglobal.getPlayer();
            this._uservip.setString(""+player.iVIPLevel);
        }
    },

    changePassAndCheckOut: function () {

        var btnCheckOut = cc.Sprite(SettingRes.settingCheckOut);
        btnCheckOut.attr({x: 135, y: 22, anchorX: 0, anchorY: 0});

        this.layerbg.addChild(btnCheckOut);
        FYEngine.AddNodeTouchListener(btnCheckOut, function (sender) {
            var userInfochcek = appglobal.getPlayer();

            if (userInfochcek.account == userInfochcek.userid) {
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingCompleteAccount));
                return;
            }
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkLobbyClient();
            NoticeComm.resetNoticeComm();
            app.accountManager.userLogout();
            appglobal._runLobby = false;
            FishGlobal.deletaccount = true;
            cc.director.runScene(LoginLayer.createScene());

        }, FYEngine.ActionType.Fade);

    },

    addSign: function () {
        var bg = new cc.Scale9Sprite("dialog_4.png");
        bg.setContentSize(cc.size(560, 135));
        bg.setPosition(cc.p(490, 308));
        this.layerbg.addChild(bg);
        var btChange = cc.Sprite("#crystal31.png");
        btChange.attr({x: 690, y: 250, anchorX: 0, anchorY: 0});
        var sprite = cc.Sprite("#crystal38.png");
        sprite.setPosition(btChange.width / 2, btChange.height / 2);
        btChange.addChild(sprite);
        this.layerbg.addChild(btChange);
        var sign = appglobal.getPlayer().getSign()!=""?appglobal.getPlayer().getSign():FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3);
        var signLabel = cc.Label.createWithSystemFont(sign, "", 22);
        signLabel.attr({x: 225, y: 368, anchorX: 0, anchorY: 1});
        signLabel.setWidth(540);
        this.layerbg.addChild(signLabel,0,"signLabel");
        FYEngine.AddNodeTouchListener(btChange, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            //var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeSignLayer();
            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeSignLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);


    },

    updateAccount: function (account) {
        var accountMsgLabel = this.layerbg.getChildByName("btnBg2").getChildByName("accountMsg");
        if(accountMsgLabel){
            accountMsgLabel.setString(account);
        }
        var btn = this.layerbg.getChildByName("accountBtn");
        if(btn){
            btn.getChildByTag(0).setSpriteFrame("fish_acbind_27.png");
        }
    },

    updatePhonenumber: function () {
        var phoneMsgLabel = this.layerbg.getChildByName("btnBgphone").getChildByName("phoneMsg");
        if(phoneMsgLabel){
            phoneMsgLabel.setString(""+appglobal.getPlayer().getFreshPhoneNumber());
        }
        var btn = this.layerbg.getChildByName("phoneBtn");
        if(btn){
            btn.getChildByTag(0).setSpriteFrame("fish_acbind_4.png");
        }

    },

    updateUnPhonenumber: function () {
        var phoneMsgLabel = this.layerbg.getChildByName("btnBgphone").getChildByName("phoneMsg");
        if(phoneMsgLabel){
            phoneMsgLabel.setString("未绑定");
        }
        var btn = this.layerbg.getChildByName("phoneBtn");
        if(btn){
            btn.getChildByTag(0).setSpriteFrame("fish_acbind_5.png");
        }

    },

    updateSign:function(){
        var label = this.layerbg.getChildByName("signLabel");
        if(label){
            label&&label.setString(appglobal.getPlayer().getSign());
        }

    },
    refreshNickName: function () {
        var nick = this.layerbg.getChildByName("nick");
        if(nick){
            var str = appglobal.getPlayer().nickname;
            nick.setString(appglobal.getPlayer().nickname);
            if(nick.getContentSize().width>200){
                var newstr = str;
                var newstr2 = str+"...";
                nick.setString(newstr2);
                while(nick.getContentSize().width>200){
                    newstr = newstr.substring(0,newstr.length-1);
                    //cc.log("---------标签的长度大"+newstr);
                    var newstr2 = newstr+"...";
                    nick.setString(newstr2);
                }
                nick.setString(newstr2);
            }
        }

    }

});

var SettingLayer3rd = DialogLayer.extend({
    ctor: function () {
        this._super();
        cc.log("SettingLayer3rd");
        //this.loadResource();
        this.initUI();
    },
    initUI: function () {
        this.addLayerBg(cc.size(810, 420));
        this.addTitleBg(SettingRes.settingTitle, 810);
        this.addCloseBtn();
        this.initImageViewBtn();
        var spriteH = new cc.Scale9Sprite(SettingRes.settingLineH);
        spriteH.setContentSize(cc.size(630, 4));
        spriteH.attr({x: 397, y: 140});
        this.layerbg.addChild(spriteH);
        this.nickNameAndAccount();
        //this.changePassAndCheckOut();
        this.addSign();
        this.addHead();
        if(appglobal._switch22 == 1 && appglobal._switch14 ==1 ){
            this.addIDcheckBtn();
        }
        this.addFamilyBtn();
    },

    addFamilyBtn : function(){
        if(appglobal.getSource() == 339){
            return;
        }
        var btn_family = new ccui.ImageView("hall06.png",ccui.Widget.PLIST_TEXTURE);//家长监护工程
        if(btn_family){
            this.layerbg.addChild(btn_family,1,"btn_family");
            btn_family.setTouchEnabled(true);
            btn_family.setPosition(cc.p(720,80));
            btn_family.addTouchEventListener(this.btnTouchEft,this);
            btn_family.addClickEventListener(function(sender){
                cc.sys.openURL(appglobal._URLfamily);
            });
        }
    },

    addIDcheckBtn : function(){
        var btn_noid = new ccui.ImageView("hall05.png",ccui.Widget.PLIST_TEXTURE);//未认证
        if(btn_noid){
            this.layerbg.addChild(btn_noid,1,"btn_noid");
            btn_noid.setTouchEnabled(true);
            btn_noid.setPosition(cc.p(600,80));
            btn_noid.addTouchEventListener(this.btnTouchEft,this);
            btn_noid.addClickEventListener(function(sender){
                var layer = new IDverifyLayer();
                FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            });
        }

        var btn_hasid = new ccui.ImageView("hall04.png",ccui.Widget.PLIST_TEXTURE);//已认证
        if(btn_hasid){
            this.layerbg.addChild(btn_hasid,1,"btn_hasid");
            btn_hasid.setTouchEnabled(true);
            btn_hasid.setPosition(cc.p(600,80));
            btn_hasid.addTouchEventListener(this.btnTouchEft,this);
            btn_hasid.addClickEventListener(function(sender){
                var layer = new IDverifyShowLayer();
                FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            });
        }

        this.refreshIDcheckBtn();
    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },
    refreshIDcheckBtn : function(){
        var player = appglobal.getPlayer();
        var btn_noid = this.layerbg.getChildByName("btn_noid");
        var btn_hasid = this.layerbg.getChildByName("btn_hasid");

        if(player.realIDnumber != ""){
            btn_noid.setVisible(false);
            btn_hasid.setVisible(true);
        }else{
            btn_noid.setVisible(true);
            btn_hasid.setVisible(false);
        }
    },

    addHead : function(){

        var player = appglobal.getPlayer();
            var headK = new FYEngine.WebImage('#rankup020.png','#fish_hallnew01.png','#rankup012.png', player.facestatus ,player.faceid ,player.userid);
            if(headK){
                this.layerbg.addChild(headK);
                headK.attr({x:110, y:285, anchorX:0.5, anchorY:0.5});
                this.headnode = headK;
                if(appglobal.idVerifySwitch1){
                    if(appglobal._switch1 ==1){
                        headK.setTouchEnabled(true);
                        this.headnode.addTouchEventListener(this.changeHeadImageCallBack, this);
                        var changetip = new cc.Sprite("#fish_idverify_19.png");
                        if(changetip){
                            headK.addChild(changetip);
                            changetip.setAnchorPoint(cc.p(0.5,0));
                            changetip.setPosition(cc.p(headK.width/2,8));
                        }
                    }
                }
            }

        //var headK = new ccui.ImageView('rankup020.png',ccui.Widget.PLIST_TEXTURE);
        //if(headK){
        //    this.layerbg.addChild(headK);
        //    headK.attr({x:110, y:345, anchorX:0.5, anchorY:0.5});
        //}
      


    },

    changeHeadImageCallBack : function(sender, type){
        cc.log('--------切换头像');
        var scene = FYEngine.getRunningLayer(0);
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{
                sender.setOpacity(180);
                sender._kuang.setOpacity(180);
                sender._headsprite.setOpacity(180);
            }break;
            //case ccui.Widget.TOUCH_MOVED : {
            //    sender.setOpacity(255);
            //    sender._kuang.setOpacity(255);
            //    sender._headsprite.setOpacity(255);
            //}break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
                var layer = new ChangeHeadLayer();
                if(layer){
                    scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
                }
            }
        }

    },

    changeHeadImageCallBackNoid : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        var layer = new ChangeHeadLayer();
        if(layer){
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
        }

    },

    headImgSuccess: function (faceid) {
        var that = this;
//        cc.log('-----------设置头像为待审核状态:'+faceid);
        that.headnode._headsprite.setColor(cc.color(150,150,150));
        that.headnode._facestatus = 0;
        that.headnode._faceId = faceid+'';
        appglobal.getPlayer().faceid = faceid+'';
        that.headnode.refreshPic();
        //that.headnode._headsprite.setSpriteFrame("待审核");
        //that.headnode._headsprite.setScale(1);
        var lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if(lobbyhandler.getState() == eClientState.CLIENT_STATE_CONNECTED){
            lobbyhandler.sendSetFaceIdReq(faceid);
        }
    },

    initImageViewBtn: function () {

        var posArr = [110, 270, 430];
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        var textArr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingMusic), FYEngine.LanguageString.getValue(SettingMsgKey.settingEffect), FYEngine.LanguageString.getValue(SettingMsgKey.settingVibration)];
        for (var i = 0; i < arr.length; i++) {
            var imageView = new ccui.ImageView(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
            imageView.setTouchEnabled(true);
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (temp > 0 && i != 2) {

                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            } else if (temp == 0 && i == 2) {
                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            }
            imageView.setName(arr[i]);
            imageView.attr({x: posArr[i], y: 60, anchorX: 0.5, anchorY: 0.5});
            this.layerbg.addChild(imageView);
            var textLabel = cc.Label.createWithSystemFont("" + textArr[i], "", 22);
            textLabel.setColor(cc.color("8ef3ff"));
            textLabel.attr({x: posArr[i], y: 110, anchorX: 0.5, anchorY: 0.5});

            this.layerbg.addChild(textLabel);
            imageView.addClickEventListener(this.imageViewBtnCallback);
        }

    },

    imageViewBtnCallback: function (sender) {
        var name = sender.getName();
        var image = sender.getRenderFile().file;
        if (image == SettingRes.settingOff1) {
            sender.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
        } else {
            sender.loadTexture(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
        }

//        cc.log(name + "-------------" + cc.sys.localStorage.getItem(name));
        if (cc.sys.localStorage.getItem(name) > 0) {
            cc.sys.localStorage.setItem(name, 0);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(false);
                    cc.audioEngine.stopMusic();
                    break;
                case "eftVolum":
                    //cc.audioEngine.stopAllEffects();
                    FYEngine.Audio.setOpenEffect(false);
                    break;
                case "isVibration":
                    break;
            }
        } else {
            cc.sys.localStorage.setItem(name, 1);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(true);
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
                    break;

                case "eftVolum":
                    FYEngine.Audio.setEffectVolume(0.5);
                    FYEngine.Audio.setOpenEffect(true);
                    break;
                case "isVibration":
                    break;
            }
        }

    },
    nickNameAndAccount: function () {
        var userInfo = appglobal.getPlayer();
        var self = this;

        /**
         * 昵称
         */
        var btnBg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        btnBg.setContentSize(cc.size(260, 45));
        btnBg.attr({x: 270, y: 300, anchorX: 0, anchorY: 0});

        var nickSprite = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingNick), "", 25);
        nickSprite.setColor(cc.color("8ef3ff"));
        nickSprite.attr({x: 210, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(btnBg);
        this.layerbg.addChild(nickSprite);

        var nick = FYEngine.createLengthText(userInfo.nickname,20,170);
        nick.attr({x: 285, y: 325, anchorX: 0, anchorY: 0.5});
        nick.setName("nick");
        this.layerbg.addChild(nick);
        var btn = cc.Sprite("#rankup011.png");

        btn.attr({x: 540, y: 300, anchorX: 1, anchorY: 0});
        this.layerbg.addChild(btn, 15);
        FYEngine.AddNodeTouchListener(btn, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeNickLayer(nick);

            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeNickNameLayer);

            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);
        /**
         * Id
         */
        var userIdSprite = new cc.Sprite("#fish_acbind_31.png");
        if(userIdSprite){
            userIdSprite.attr({x:25, y:180, anchorX:0, anchorY:0.5});
            this.layerbg.addChild(userIdSprite);
        }

        var UID = new cc.LabelTTF(""+userInfo.userid, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if(UID){
            UID.setColor(cc.color("03394f"));
            userIdSprite.addChild(UID);
            UID.setPosition(cc.p(55,userIdSprite.height/2));
            UID.setAnchorPoint(cc.p(0,0.5));
        }


        /**
         * VIP等级
         */
        var Vipbg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        Vipbg.setContentSize(cc.size(120, 45));
        Vipbg.attr({x: 630, y: 325, anchorX: 0, anchorY: 0.5});

        var VIPtip = cc.Label.createWithSystemFont("VIP等级", "", 22);
        VIPtip.setColor(cc.color("8ef3ff"));
        VIPtip.attr({x: 550, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(Vipbg);
        this.layerbg.addChild(VIPtip);

        var iVIPLevel  = this._uservip = new ccui.Text(""+userInfo.iVIPLevel,"",20);
        iVIPLevel.setTextColor(cc.color("ffec4d"));
        iVIPLevel.attr({x: 660, y: 325, anchorX: 0, anchorY: 0.5});
        iVIPLevel.setName("nick");
        this.layerbg.addChild(iVIPLevel);
        var vipbtn = cc.Sprite("#fish_vip_res19.png");
        vipbtn.attr({x: 690, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(vipbtn, 15);

        FYEngine.AddNodeTouchListener(vipbtn, function (sender) {
            cc.log("点击特权按钮");
            self.removeFromParent(true);
            var layer = new VIPinfoLayer();
            FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.VIPinfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);


    },
    changePassAndCheckOut: function () {
        var jsonStr = app.sdkPlugin.callNativeMethod("is3rdSdkLogin","");
        var is3rdLogin = false;
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined') {
            var json = JSON.parse(jsonStr);
            is3rdLogin = appglobal.isBaiduSource()?false :json.is3rdSdkLogin;
            cc.log('------------is3rdLogin## : '+is3rdLogin);
        }
        if (is3rdLogin) return;

        var btnCheckOut = cc.Sprite(SettingRes.settingCheckOut);
        btnCheckOut.attr({x: 536, y: 32, anchorX: 0, anchorY: 0});

        this.layerbg.addChild(btnCheckOut);
        FYEngine.AddNodeTouchListener(btnCheckOut, function (sender) {
            var userInfochcek = appglobal.getPlayer();

            if (userInfochcek.account == userInfochcek.userid) {
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingCompleteAccount));
                return;
            }
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkLobbyClient();
            NoticeComm.resetNoticeComm();
            app.accountManager.userLogout();
            appglobal._runLobby = false;
            FishGlobal.deletaccount = true;
            cc.director.runScene(LoginLayer.createScene());

        }, FYEngine.ActionType.Fade);

    },
    addSign: function () {
        var bg = new cc.Scale9Sprite("dialog_4.png");
        bg.setContentSize(cc.size(560, 135));
        bg.setPosition(cc.p(490, 225));
        this.layerbg.addChild(bg);
        var btChange = cc.Sprite("#crystal31.png");
        btChange.attr({x: 690, y: 172, anchorX: 0, anchorY: 0});
        var sprite = cc.Sprite("#crystal38.png");
        sprite.setPosition(btChange.width / 2, btChange.height / 2);
        btChange.addChild(sprite);
        this.layerbg.addChild(btChange);
        var sign = appglobal.getPlayer().getSign()!=""?appglobal.getPlayer().getSign():FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3);
        var signLabel = cc.Label.createWithSystemFont(sign, "", 22);
        signLabel.attr({x: 225, y: 280, anchorX: 0, anchorY: 1});
        signLabel.setWidth(540);
        this.layerbg.addChild(signLabel,0,"signLabel");
        FYEngine.AddNodeTouchListener(btChange, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            //var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeSignLayer();
            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeSignLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);


    },
    updateAccount: function (account) {
        var accountMsgLabel = this.layerbg.getChildByName("btnBg2").getChildByName("accountMsg");
        if(accountMsgLabel){
            accountMsgLabel.setString(account);
        }
        var btn = this.layerbg.getChildByName("accountBtn");
        if(btn){
            btn.getChildByTag(0).setSpriteFrame(SettingRes.settingChangePass);
        }

        //FYEngine.AddNodeTouchListener(btn, function () {
        //    var layer = new ChangePasswordLayer();
        //    FYEngine.getRunningLayer(0).addChild(layer, 101, "lay3");
        //    FYEngine.popupLayerAnimate(layer.layerbg);
        //}, FYEngine.ActionType.Fade);

    },
    updateSign:function(){
        var label = this.layerbg.getChildByName("signLabel");
        if(label){
            label&&label.setString(appglobal.getPlayer().getSign());
        }

    },
    refreshNickName: function () {
        var nick = this.layerbg.getChildByName("nick");
        if(nick){
            nick.setString(appglobal.getPlayer().nickname);
        }

    }

});

var SettingLayerForWechat = DialogLayer.extend({
    ctor: function () {
        this._super();
        //this.loadResource();
        cc.log("SettingLayerForWechat");
        this.initUI();
    },
    initUI: function () {
        this.addLayerBg(cc.size(810, 420));
        this.addTitleBg(SettingRes.settingTitle, 810);
        this.addCloseBtn();
        // this.initImageViewBtn();
        var spriteH = new cc.Scale9Sprite(SettingRes.settingLineH);
        spriteH.setContentSize(cc.size(630, 4));
        spriteH.attr({x: 397, y: 140});
        this.layerbg.addChild(spriteH);

        this.nickNameAndAccount();
        this.changePassAndCheckOut();
        this.addSign();
        this.addHead();
        this.addMusicBtn();
        if(appglobal._switch22 == 1 && appglobal._switch14 ==1 ){
            this.addIDcheckBtn();
        }
        this.addFamilyBtn();
    },
    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },

    addMusicBtn : function(){
        var btn_Music = new ccui.ImageView("fish_vip_res26.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_Music){
            this.layerbg.addChild(btn_Music,1,"btn_Music");
            btn_Music.setTouchEnabled(true);
            btn_Music.setPosition(cc.p(110,80));
            btn_Music.addTouchEventListener(this.btnTouchEft,this);
            btn_Music.addClickEventListener(function(sender){
                cc.log("btn_Music");
                var layer = new MusicSetLayer();
                if(layer){
                    FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.MusicSetLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
    },

    addFamilyBtn : function(){
        var btn_family = new ccui.ImageView("fish_vip_res25.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_family){
            this.layerbg.addChild(btn_family,1,"btn_family");
            btn_family.setTouchEnabled(true);
            btn_family.setPosition(cc.p(430,80));
            btn_family.addTouchEventListener(this.btnTouchEft,this);
            btn_family.addClickEventListener(function(sender){
                cc.sys.openURL(appglobal._URLfamily);
            });
        }
    },

    addIDcheckBtn : function(){

        var btn_IDverify = new ccui.ImageView("fish_vip_res24.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_IDverify){
            this.layerbg.addChild(btn_IDverify,1,"btn_IDverify");
            btn_IDverify.setTouchEnabled(true);
            btn_IDverify.setPosition(cc.p(270,80));
            btn_IDverify.addTouchEventListener(this.btnTouchEft,this);
            btn_IDverify.addClickEventListener(function(sender){
                var player = appglobal.getPlayer();
                if(player.realIDnumber == ""){
                    var layer = new IDverifyLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }else{
                    var layer = new IDverifyShowLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
        this.refreshIDcheckBtn();
    },

    refreshIDcheckBtn : function(){
        var player = appglobal.getPlayer();
        var btn_IDverify = this.layerbg.getChildByName("btn_IDverify");
        if(player.realIDnumber != ""){
            btn_IDverify.loadTexture("fish_vip_res23.png",ccui.Widget.PLIST_TEXTURE);
        }else{
            btn_IDverify.loadTexture("fish_vip_res24.png",ccui.Widget.PLIST_TEXTURE);
        }
    },

    addHead : function(){

        var player = appglobal.getPlayer();
        var headK = new FYEngine.WebImage('#rankup020.png','#fish_hallnew01.png','#rankup012.png', player.facestatus ,player.faceid ,player.userid);
        if(headK){
            this.layerbg.addChild(headK);
            headK.attr({x:110, y:285, anchorX:0.5, anchorY:0.5});
            this.headnode = headK;
            if(appglobal.idVerifySwitch1){
                if(appglobal._switch1 ==1){
                    headK.setTouchEnabled(true);
                    this.headnode.addTouchEventListener(this.changeHeadImageCallBack, this);
                    var changetip = new cc.Sprite("#fish_idverify_19.png");
                    if(changetip){
                        headK.addChild(changetip);
                        changetip.setAnchorPoint(cc.p(0.5,0));
                        changetip.setPosition(cc.p(headK.width/2,8));
                    }
                }
            }
        }

       

    },

    changeHeadImageCallBackNoid : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        var layer = new ChangeHeadLayer();
        if(layer){
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
        }

    },

    changeHeadImageCallBack : function(sender, type){
        cc.log('--------切换头像');
        var scene = FYEngine.getRunningLayer(0);
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{
                sender.setOpacity(180);
                sender._kuang.setOpacity(180);
                sender._headsprite.setOpacity(180);
            }break;
            //case ccui.Widget.TOUCH_MOVED : {
            //    sender.setOpacity(255);
            //    sender._kuang.setOpacity(255);
            //    sender._headsprite.setOpacity(255);
            //}break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
                var layer = new ChangeHeadLayer();
                if(layer){
                    scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
                }
            }
        }

    },

    headImgSuccess: function (faceid) {
        var that = this;
//        cc.log('-----------设置头像为待审核状态:'+faceid);
        that.headnode._headsprite.setColor(cc.color(150,150,150));
        that.headnode._facestatus = 0;
        that.headnode._faceId = faceid+'';
        appglobal.getPlayer().faceid = faceid+'';
        that.headnode.refreshPic();
        //that.headnode._headsprite.setSpriteFrame("待审核");
        //that.headnode._headsprite.setScale(1);
        var lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if(lobbyhandler.getState() == eClientState.CLIENT_STATE_CONNECTED){
            lobbyhandler.sendSetFaceIdReq(faceid);
        }
    },

    initImageViewBtn: function () {

        var posArr = [60, 220, 380];
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        var textArr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingMusic), FYEngine.LanguageString.getValue(SettingMsgKey.settingEffect), FYEngine.LanguageString.getValue(SettingMsgKey.settingVibration)];
        for (var i = 0; i < arr.length; i++) {
            var imageView = new ccui.ImageView(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
            imageView.setTouchEnabled(true);
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (temp > 0 && i != 2) {

                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            } else if (temp == 0 && i == 2) {
                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            }
            imageView.setName(arr[i]);
            imageView.attr({x: posArr[i], y: 90, anchorX: 0, anchorY: 1});
            this.layerbg.addChild(imageView);
            var textLabel = cc.Label.createWithSystemFont("" + textArr[i], "", 22);
            textLabel.setColor(cc.color("8ef3ff"));
            textLabel.attr({x: posArr[i]+30, y: 127, anchorX: 0, anchorY: 1});

            this.layerbg.addChild(textLabel);
            imageView.addClickEventListener(this.imageViewBtnCallback);
        }

    },

    imageViewBtnCallback: function (sender) {
        var name = sender.getName();
        var image = sender.getRenderFile().file;
        if (image == SettingRes.settingOff1) {
            sender.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
        } else {
            sender.loadTexture(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
        }

//        cc.log(name + "-------------" + cc.sys.localStorage.getItem(name));
        if (cc.sys.localStorage.getItem(name) > 0) {
            cc.sys.localStorage.setItem(name, 0);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(false);
                    cc.audioEngine.stopMusic();
                    break;
                case "eftVolum":
                    //cc.audioEngine.stopAllEffects();
                    FYEngine.Audio.setOpenEffect(false);
                    break;
                case "isVibration":
                    break;
            }
        } else {
            cc.sys.localStorage.setItem(name, 1);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(true);
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
                    break;

                case "eftVolum":
                    FYEngine.Audio.setEffectVolume(0.5);
                    FYEngine.Audio.setOpenEffect(true);
                    break;
                case "isVibration":
                    break;
            }
        }

    },
    nickNameAndAccount: function () {
        var userInfo = appglobal.getPlayer();
        var self = this;
        /**
         * 昵称
         */
        var btnBg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        btnBg.setContentSize(cc.size(260, 45));
        btnBg.attr({x: 270, y: 300, anchorX: 0, anchorY: 0});

        var nickSprite = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingNick), "", 25);
        nickSprite.setColor(cc.color("8ef3ff"));
        nickSprite.attr({x: 210, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(btnBg);
        this.layerbg.addChild(nickSprite);

        var nick = FYEngine.createLengthText(userInfo.nickname,20,170);
        nick.attr({x: 285, y: 325, anchorX: 0, anchorY: 0.5});
        nick.setName("nick");
        this.layerbg.addChild(nick);
        var btn = cc.Sprite("#rankup011.png");

        btn.attr({x: 545, y: 300, anchorX: 1, anchorY: 0});
        this.layerbg.addChild(btn, 15);
        FYEngine.AddNodeTouchListener(btn, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeNickLayer(nick);

            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeNickNameLayer);

            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);
        /**
         * Id
         */

        var userIdSprite = new cc.Sprite("#fish_acbind_31.png");
        if(userIdSprite){
            userIdSprite.attr({x:25, y:180, anchorX:0, anchorY:0.5});
            this.layerbg.addChild(userIdSprite);
        }

        var UID = new cc.LabelTTF(""+userInfo.userid, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if(UID){
            UID.setColor(cc.color("03394f"));
            userIdSprite.addChild(UID);
            UID.setPosition(cc.p(55,userIdSprite.height/2));
            UID.setAnchorPoint(cc.p(0,0.5));
        }
        /**
         * VIP等级
         */
        var Vipbg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        Vipbg.setContentSize(cc.size(120, 45));
        Vipbg.attr({x: 630, y: 325, anchorX: 0, anchorY: 0.5});

        var VIPtip = cc.Label.createWithSystemFont("VIP等级", "", 22);
        VIPtip.setColor(cc.color("8ef3ff"));
        VIPtip.attr({x: 550, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(Vipbg);
        this.layerbg.addChild(VIPtip);

        var iVIPLevel  = this._uservip = new ccui.Text(""+userInfo.iVIPLevel,"",20);
        iVIPLevel.setTextColor(cc.color("ffec4d"));
        iVIPLevel.attr({x: 660, y: 325, anchorX: 0, anchorY: 0.5});
        iVIPLevel.setName("nick");
        this.layerbg.addChild(iVIPLevel);
        var vipbtn = cc.Sprite("#fish_vip_res19.png");
        vipbtn.attr({x: 690, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(vipbtn, 15);

        FYEngine.AddNodeTouchListener(vipbtn, function (sender) {
            cc.log("点击特权按钮");
            self.removeFromParent(true);
            var layer = new VIPinfoLayer();
            FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.VIPinfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);
    },

    refreshVIPinfo : function(){
        if(this._uservip){
            var player = appglobal.getPlayer();
            this._uservip.setString(""+player.iVIPLevel);
        }
    },

    changePassAndCheckOut: function () {//todo
        var checkoutsp = "#fish_wechatlogout.png";

        var btnCheckOut = cc.Sprite(checkoutsp);
        btnCheckOut.attr({x: 536, y: 40, anchorX: 0, anchorY: 0});

        this.layerbg.addChild(btnCheckOut);
        FYEngine.AddNodeTouchListener(btnCheckOut, function (sender) {
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkLobbyClient();
            NoticeComm.resetNoticeComm();
            app.accountManager.userLogout();
            appglobal._runLobby = false;
            FishGlobal.deletaccount = true;
            FYEngine.javascriptJavaBridge.handleWXLogout();
            cc.director.runScene(LoginLayer.createScene());

        }, FYEngine.ActionType.Fade);

    },
    addSign: function () {
        var bg = new cc.Scale9Sprite("dialog_4.png");
        bg.setContentSize(cc.size(560, 135));
        bg.setPosition(cc.p(490, 225));
        this.layerbg.addChild(bg);
        var btChange = cc.Sprite("#crystal31.png");
        btChange.attr({x: 690, y: 172, anchorX: 0, anchorY: 0});
        var sprite = cc.Sprite("#crystal38.png");
        sprite.setPosition(btChange.width / 2, btChange.height / 2);
        btChange.addChild(sprite);
        this.layerbg.addChild(btChange);
        var sign = appglobal.getPlayer().getSign()!=""?appglobal.getPlayer().getSign():FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3);
        var signLabel = cc.Label.createWithSystemFont(sign, "", 22);
        signLabel.attr({x: 225, y: 280, anchorX: 0, anchorY: 1});
        signLabel.setWidth(540);
        this.layerbg.addChild(signLabel,0,"signLabel");
        FYEngine.AddNodeTouchListener(btChange, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            //var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeSignLayer();
            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeSignLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);


    },
    updateAccount: function (account) {
        var accountMsgLabel = this.layerbg.getChildByName("btnBg2").getChildByName("accountMsg");
        if(accountMsgLabel){
            accountMsgLabel.setString(account);
        }
        var btn = this.layerbg.getChildByName("accountBtn");
        if(btn){
            btn.getChildByTag(0).setSpriteFrame(SettingRes.settingChangePass);
        }

    },
    updateSign:function(){
        var label = this.layerbg.getChildByName("signLabel");
        if(label){
            label&&label.setString(appglobal.getPlayer().getSign());
        }

    },
    refreshNickName: function () {
        var nick = this.layerbg.getChildByName("nick");
        if(nick){
            nick.setString(appglobal.getPlayer().nickname);
        }

    }

});

var SettingLayer3rdWithLogout = DialogLayer.extend({
    ctor: function () {
        this._super();
        cc.log("SettingLayer3rdWithLogout");
        //this.loadResource();
        this.initUI();
    },
    initUI: function () {
        this.addLayerBg(cc.size(810, 420));
        this.addTitleBg(SettingRes.settingTitle, 810);
        this.addCloseBtn();
        // this.initImageViewBtn();
        var spriteH = new cc.Scale9Sprite(SettingRes.settingLineH);
        spriteH.setContentSize(cc.size(630, 4));
        spriteH.attr({x: 397, y: 140});
        this.layerbg.addChild(spriteH);

        this.nickNameAndAccount();
        this.changePassAndCheckOut();
        this.addSign();
        this.addHead();
        this.addMusicBtn();
        if(appglobal._switch22 == 1 && appglobal._switch14 ==1 ){
            this.addIDcheckBtn();
        }
        this.addFamilyBtn();
    },
    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },

    addMusicBtn : function(){
        var btn_Music = new ccui.ImageView("fish_vip_res26.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_Music){
            this.layerbg.addChild(btn_Music,1,"btn_Music");
            btn_Music.setTouchEnabled(true);
            btn_Music.setPosition(cc.p(110,80));
            btn_Music.addTouchEventListener(this.btnTouchEft,this);
            btn_Music.addClickEventListener(function(sender){
                cc.log("btn_Music");
                var layer = new MusicSetLayer();
                if(layer){
                    FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.MusicSetLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
    },

    addFamilyBtn : function(){
        var btn_family = new ccui.ImageView("fish_vip_res25.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_family){
            this.layerbg.addChild(btn_family,1,"btn_family");
            btn_family.setTouchEnabled(true);
            btn_family.setPosition(cc.p(430,80));
            btn_family.addTouchEventListener(this.btnTouchEft,this);
            btn_family.addClickEventListener(function(sender){
                cc.sys.openURL(appglobal._URLfamily);
            });
        }
    },

    addIDcheckBtn : function(){

        var btn_IDverify = new ccui.ImageView("fish_vip_res24.png",ccui.Widget.PLIST_TEXTURE);
        if(btn_IDverify){
            this.layerbg.addChild(btn_IDverify,1,"btn_IDverify");
            btn_IDverify.setTouchEnabled(true);
            btn_IDverify.setPosition(cc.p(270,80));
            btn_IDverify.addTouchEventListener(this.btnTouchEft,this);
            btn_IDverify.addClickEventListener(function(sender){
                var player = appglobal.getPlayer();
                if(player.realIDnumber == ""){
                    var layer = new IDverifyLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }else{
                    var layer = new IDverifyShowLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
        this.refreshIDcheckBtn();
    },

    refreshIDcheckBtn : function(){
        var player = appglobal.getPlayer();
        var btn_IDverify = this.layerbg.getChildByName("btn_IDverify");
        if(player.realIDnumber != ""){
            btn_IDverify.loadTexture("fish_vip_res23.png",ccui.Widget.PLIST_TEXTURE);
        }else{
            btn_IDverify.loadTexture("fish_vip_res24.png",ccui.Widget.PLIST_TEXTURE);
        }
    },

    addHead : function(){

        var player = appglobal.getPlayer();
        var headK = new FYEngine.WebImage('#rankup020.png','#fish_hallnew01.png','#rankup012.png', player.facestatus ,player.faceid ,player.userid);
        if(headK){
            this.layerbg.addChild(headK);
            headK.attr({x:110, y:285, anchorX:0.5, anchorY:0.5});
            this.headnode = headK;
            if(appglobal.idVerifySwitch1){
                if(appglobal._switch1 ==1){
                    headK.setTouchEnabled(true);
                    this.headnode.addTouchEventListener(this.changeHeadImageCallBack, this);
                    var changetip = new cc.Sprite("#fish_idverify_19.png");
                    if(changetip){
                        headK.addChild(changetip);
                        changetip.setAnchorPoint(cc.p(0.5,0));
                        changetip.setPosition(cc.p(headK.width/2,8));
                    }
                }
            }
        }

       

    },

    changeHeadImageCallBackNoid : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        var layer = new ChangeHeadLayer();
        if(layer){
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
        }

    },

    changeHeadImageCallBack : function(sender, type){
        cc.log('--------切换头像');
        var scene = FYEngine.getRunningLayer(0);
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{
                sender.setOpacity(180);
                sender._kuang.setOpacity(180);
                sender._headsprite.setOpacity(180);
            }break;
            //case ccui.Widget.TOUCH_MOVED : {
            //    sender.setOpacity(255);
            //    sender._kuang.setOpacity(255);
            //    sender._headsprite.setOpacity(255);
            //}break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
            }break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                sender._kuang.setOpacity(255);
                sender._headsprite.setOpacity(255);
                var layer = new ChangeHeadLayer();
                if(layer){
                    scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeHeadLayer);
                }
            }
        }

    },

    headImgSuccess: function (faceid) {
        var that = this;
//        cc.log('-----------设置头像为待审核状态:'+faceid);
        that.headnode._headsprite.setColor(cc.color(150,150,150));
        that.headnode._facestatus = 0;
        that.headnode._faceId = faceid+'';
        appglobal.getPlayer().faceid = faceid+'';
        that.headnode.refreshPic();
        //that.headnode._headsprite.setSpriteFrame("待审核");
        //that.headnode._headsprite.setScale(1);
        var lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if(lobbyhandler.getState() == eClientState.CLIENT_STATE_CONNECTED){
            lobbyhandler.sendSetFaceIdReq(faceid);
        }
    },

    initImageViewBtn: function () {

        var posArr = [60, 220, 380];
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        var textArr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingMusic), FYEngine.LanguageString.getValue(SettingMsgKey.settingEffect), FYEngine.LanguageString.getValue(SettingMsgKey.settingVibration)];
        for (var i = 0; i < arr.length; i++) {
            var imageView = new ccui.ImageView(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
            imageView.setTouchEnabled(true);
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (temp > 0 && i != 2) {

                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            } else if (temp == 0 && i == 2) {
                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            }
            imageView.setName(arr[i]);
            imageView.attr({x: posArr[i], y: 90, anchorX: 0, anchorY: 1});
            this.layerbg.addChild(imageView);
            var textLabel = cc.Label.createWithSystemFont("" + textArr[i], "", 22);
            textLabel.setColor(cc.color("8ef3ff"));
            textLabel.attr({x: posArr[i]+30, y: 127, anchorX: 0, anchorY: 1});

            this.layerbg.addChild(textLabel);
            imageView.addClickEventListener(this.imageViewBtnCallback);
        }

    },

    imageViewBtnCallback: function (sender) {
        var name = sender.getName();
        var image = sender.getRenderFile().file;
        if (image == SettingRes.settingOff1) {
            sender.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
        } else {
            sender.loadTexture(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
        }

//        cc.log(name + "-------------" + cc.sys.localStorage.getItem(name));
        if (cc.sys.localStorage.getItem(name) > 0) {
            cc.sys.localStorage.setItem(name, 0);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(false);
                    cc.audioEngine.stopMusic();
                    break;
                case "eftVolum":
                    //cc.audioEngine.stopAllEffects();
                    FYEngine.Audio.setOpenEffect(false);
                    break;
                case "isVibration":
                    break;
            }
        } else {
            cc.sys.localStorage.setItem(name, 1);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(true);
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
                    break;

                case "eftVolum":
                    FYEngine.Audio.setEffectVolume(0.5);
                    FYEngine.Audio.setOpenEffect(true);
                    break;
                case "isVibration":
                    break;
            }
        }

    },
    nickNameAndAccount: function () {
        var userInfo = appglobal.getPlayer();
        var self = this;
        /**
         * 昵称
         */
        var btnBg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        btnBg.setContentSize(cc.size(260, 45));
        btnBg.attr({x: 270, y: 300, anchorX: 0, anchorY: 0});

        var nickSprite = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingNick), "", 25);
        nickSprite.setColor(cc.color("8ef3ff"));
        nickSprite.attr({x: 210, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(btnBg);
        this.layerbg.addChild(nickSprite);

        var nick = FYEngine.createLengthText(userInfo.nickname,20,170);
        nick.attr({x: 285, y: 325, anchorX: 0, anchorY: 0.5});
        nick.setName("nick");
        this.layerbg.addChild(nick);
        var btn = cc.Sprite("#rankup011.png");

        btn.attr({x: 545, y: 300, anchorX: 1, anchorY: 0});
        this.layerbg.addChild(btn, 15);
        FYEngine.AddNodeTouchListener(btn, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeNickLayer(nick);

            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeNickNameLayer);

            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);
        /**
         * Id
         */

        var userIdSprite = new cc.Sprite("#fish_acbind_31.png");
        if(userIdSprite){
            userIdSprite.attr({x:25, y:180, anchorX:0, anchorY:0.5});
            this.layerbg.addChild(userIdSprite);
        }

        var UID = new cc.LabelTTF(""+userInfo.userid, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if(UID){
            UID.setColor(cc.color("03394f"));
            userIdSprite.addChild(UID);
            UID.setPosition(cc.p(55,userIdSprite.height/2));
            UID.setAnchorPoint(cc.p(0,0.5));
        }
        /**
         * VIP等级
         */
        var Vipbg = new cc.Scale9Sprite(SettingRes.settingBtnBg);
        Vipbg.setContentSize(cc.size(120, 45));
        Vipbg.attr({x: 630, y: 325, anchorX: 0, anchorY: 0.5});

        var VIPtip = cc.Label.createWithSystemFont("VIP等级", "", 22);
        VIPtip.setColor(cc.color("8ef3ff"));
        VIPtip.attr({x: 550, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(Vipbg);
        this.layerbg.addChild(VIPtip);

        var iVIPLevel  = this._uservip = new ccui.Text(""+userInfo.iVIPLevel,"",20);
        iVIPLevel.setTextColor(cc.color("ffec4d"));
        iVIPLevel.attr({x: 660, y: 325, anchorX: 0, anchorY: 0.5});
        iVIPLevel.setName("nick");
        this.layerbg.addChild(iVIPLevel);
        var vipbtn = cc.Sprite("#fish_vip_res19.png");
        vipbtn.attr({x: 690, y: 325, anchorX: 0, anchorY: 0.5});
        this.layerbg.addChild(vipbtn, 15);

        FYEngine.AddNodeTouchListener(vipbtn, function (sender) {
            cc.log("点击特权按钮");
            self.removeFromParent(true);
            var layer = new VIPinfoLayer();
            FYEngine.getRunningLayer(0).addChild(layer,FishZorder.poplayer,LobbySceneName.VIPinfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);
    },

    refreshVIPinfo : function(){
        if(this._uservip){
            var player = appglobal.getPlayer();
            this._uservip.setString(""+player.iVIPLevel);
        }
    },

    changePassAndCheckOut: function () {//todo
        var checkoutsp = "#fish_wechatlogout.png";

        var btnCheckOut = cc.Sprite(checkoutsp);
        btnCheckOut.attr({x: 536, y: 40, anchorX: 0, anchorY: 0});

        this.layerbg.addChild(btnCheckOut);
        FYEngine.AddNodeTouchListener(btnCheckOut, function (sender) {
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkLobbyClient();
            NoticeComm.resetNoticeComm();
            app.accountManager.userLogout();
            appglobal._runLobby = false;
            FishGlobal.deletaccount = true;
            FYEngine.javascriptJavaBridge.handleWXLogout();
            cc.director.runScene(LoginLayer.createScene());

        }, FYEngine.ActionType.Fade);

    },
    addSign: function () {
        var bg = new cc.Scale9Sprite("dialog_4.png");
        bg.setContentSize(cc.size(560, 135));
        bg.setPosition(cc.p(490, 225));
        this.layerbg.addChild(bg);
        var btChange = cc.Sprite("#crystal31.png");
        btChange.attr({x: 690, y: 172, anchorX: 0, anchorY: 0});
        var sprite = cc.Sprite("#crystal38.png");
        sprite.setPosition(btChange.width / 2, btChange.height / 2);
        btChange.addChild(sprite);
        this.layerbg.addChild(btChange);
        var sign = appglobal.getPlayer().getSign()!=""?appglobal.getPlayer().getSign():FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3);
        var signLabel = cc.Label.createWithSystemFont(sign, "", 22);
        signLabel.attr({x: 225, y: 280, anchorX: 0, anchorY: 1});
        signLabel.setWidth(540);
        this.layerbg.addChild(signLabel,0,"signLabel");
        FYEngine.AddNodeTouchListener(btChange, function (sender) {

            var sequence = cc.Sequence(cc.fadeTo(0.2, 180), cc.fadeTo(0.2, 255));
            sender.runAction(sequence);
            //var nick = sender.getParent().getChildByName("nick").getString();
            var layer = new ChangeSignLayer();
            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangeSignLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, FYEngine.ActionType.Fade);


    },
    updateAccount: function (account) {
        var accountMsgLabel = this.layerbg.getChildByName("btnBg2").getChildByName("accountMsg");
        if(accountMsgLabel){
            accountMsgLabel.setString(account);
        }
        var btn = this.layerbg.getChildByName("accountBtn");
        if(btn){
            btn.getChildByTag(0).setSpriteFrame(SettingRes.settingChangePass);
        }

        //FYEngine.AddNodeTouchListener(btn, function () {
        //    var layer = new ChangePasswordLayer();
        //    FYEngine.getRunningLayer(0).addChild(layer, 101, "lay3");
        //    FYEngine.popupLayerAnimate(layer.layerbg);
        //}, FYEngine.ActionType.Fade);

    },
    updateSign:function(){
        var label = this.layerbg.getChildByName("signLabel");
        if(label){
            label&&label.setString(appglobal.getPlayer().getSign());
        }

    },
    refreshNickName: function () {
        var nick = this.layerbg.getChildByName("nick");
        if(nick){
            nick.setString(appglobal.getPlayer().nickname);
        }

    }

});

var SettingRes = {
    png: "res/setting/setting.png",
    plist: "res/setting/setting.plist",
    settingTitle: "#crystal33.png",
    settingOff: "setting_btn_off.png",
    settingOn: "setting_btn_on.png",
    settingOff1: "crystal36.png",
    settingOn1: "crystal37.png",
    settingLineH: "setting_line_h.png",
    settingLineV: "setting_line_v.png",
    settingNickName: "#setting_nickname.png",
    settingAccount: "#setting_account.png",
    settingUserId: "#setting_userId.png",
    settingBtnBg: "setting_btnbg.png",
    settingChangeNick: "#crystal34.png",
    settingCommitAccount: "#crystal35.png",
    settingBgBtn: "#crystal32.png",
    settingChangePass: "crystal47.png",
    settingCheckOut: "#setting_checkout.png"
};
var ChangeNickLayer = SmallLayer.extend({
    ctor: function (nickName) {
        this._super();
        this.initUI(nickName);
    },
    initUI: function (nickName) {
        var self = this;
        var bg = this.addLayerBg(cc.size(603, 300));
        this.addTitleBg(SccomRes.SmallWinRes.changeName,cc.p(160,44));
        this.addCloseBtn();
        var callfun = function(sender){
            self.confirmCallBack(sender);
        };
        this.addConfirmBtn(callfun, undefined, cc.p(435, 80));
        this.addCancelBtn(undefined, cc.p(175, 80));

        var editBox = new cc.EditBox(cc.size(440, 53), new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg));
        editBox.attr({x: 294, y: 185});
        if (nickName != "") {
            editBox.setString(nickName);
        } else {
            editBox.setPlaceHolder("");
        }
        editBox.setPlaceholderFontSize(22);
        editBox.setPlaceholderFontColor(cc.color("#ffffff"));
        editBox.setFontSize(22);
        editBox.setMaxLength(20);
        editBox.setTag(100);
        editBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
        editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
        editBox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
        var delegate = {
            editBoxEditingDidBegin: function () {
                if (editBox.getString() == "") {
                    editBox.setPlaceHolder("");
                }
                //editBox.setString(nickName);
            },
            editBoxEditingDidEnd: function () {
                var str = editBox.getString();
                if (/\s/.test(str)) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrSpaceNick));
                    return;
                }

                //if(str.length>8){
                //    str = str.substring(0,8);
                //    editBox.setString(str);
                //}

                if (str != '') {
                    str = FYEngine.FilterWord.getInstance().RunFilterWord(str, "*", 1);
                    editBox.setString(str);
                }
                if (str == "") {
                    editBox.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingInputNewNick));
                }

            }
        };
        editBox.setDelegate(delegate);
        bg.addChild(editBox);

    },

    getStringByteLen : function(str){
        if(str.length>16){
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrNickLong));
            return false;
        }

        var ccount = 0;
        var ecount = 0;
        var bytecount =0;
        for(var i = 0; i < str.length; i++){
            var c = str.charAt(i);
            if (/^[\u0000-\u00ff]$/.test(c)){
                bytecount+=1;
                ecount+=1;
            }else{
                bytecount+=2;
                ccount+=1
            }
        }
        if(ecount>16){
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrNickLong));
            return false;
        }
        if(ccount>8){
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrNickLong));
            return false;
        }
        if(bytecount>16){
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrNickLong));
            return false;
        }
        return true;
    },


    confirmCallBack: function (sender) {
        var editNickBox = sender.getParent().getChildByTag(100);
        var editNick = editNickBox.getString();
        editNick = editNick.replace("\\\'","");
        if (editNick == "") {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrEmpNick));
            return;
        }

        if (editNick == appglobal._player.nickname) {
            FYEngine.AddCommToast("未修改昵称");
            return;
        }

        if (/\s/.test(editNick)) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrSpaceNick));
            return;
        }
        var isEmojiCharacter = function (substring) {
            // var reg = new RegExp("[~#^$@%&!?%*]", 'g');
            // if (substring.match(reg)) {
            //     return true;
            // }
            for (var i = 0; i < substring.length; i++) {
                var hs = substring.charCodeAt(i);
                if (0xd800 <= hs && hs <= 0xdbff) {
                    if (substring.length > 1) {
                        var ls = substring.charCodeAt(i + 1);
                        var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
                        if (0x1d000 <= uc && uc <= 0x1f77f) {
                            return true;
                        }
                    }
                } else if (substring.length > 1) {
                    var ls = substring.charCodeAt(i + 1);
                    if (ls == 0x20e3) {
                        return true;
                    }
                } else {
                    if (0x2100 <= hs && hs <= 0x27ff) {
                        return true;
                    } else if (0x2B05 <= hs && hs <= 0x2b07) {
                        return true;
                    } else if (0x2934 <= hs && hs <= 0x2935) {
                        return true;
                    } else if (0x3297 <= hs && hs <= 0x3299) {
                        return true;
                    } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030
                        || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b
                        || hs == 0x2b50) {
                        return true;
                    }
                }
            }
        };
        if (isEmojiCharacter(editNick)) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrEmoji));
            return;
        }
        //if (editNick.length > 8) {
        //    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingErrNickLong));
        //    return;
        //}

        if(this.getStringByteLen(editNick)==false){
            return;
        }

        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        handler.sendModNickReq(editNick);
    },


});

var ChangePasswordLayer = SmallLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(689, 447));
        this.addInnerBg(SccomRes.SmallWinRes.Innerbg, cc.size(607, 254));
        this.addTitleBg(SccomRes.SmallWinRes.Passwordchange,cc.p(160,44));
        this.addCloseBtn();
        this.addConfirmBtn(this.confirmCallBack);
        this.addCancelBtn();
        var placeHoldStr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingPassCheck), FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule), FYEngine.LanguageString.getValue(SettingMsgKey.settingPassNow)];
        for (var i = 0; i < 3; i++) {
            var passwordbg = new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg);
            if (passwordbg) {
                // passwordbg.setContentSize(cc.size(416, 58));
                var editBox = cc.EditBox(cc.size(416, 58), passwordbg);
                editBox.setFontSize(24);
                editBox.setPlaceHolder(placeHoldStr[i]);
                editBox.setPlaceholderFontSize(22);
                editBox.setPlaceholderFontColor(cc.color("#aaffff"));
                editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
                editBox.setPosition(cc.p(426, 196 + i * 66));
                editBox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
                bg.addChild(editBox, 0, i + 100);
                editBox.setMaxLength(18);

            }

        }

        var name1 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingSureNewPass), "", 25);
        name1.setColor(cc.color("8ef3ff"));
        if (name1) {
            name1.setAnchorPoint(cc.p(0, 0.5));
            name1.setPosition(cc.p(60, 196));
            bg.addChild(name1);
        }
        var name2 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingNewPass), "", 25);
        name2.setColor(cc.color("8ef3ff"));
        if (name2) {
            name2.setAnchorPoint(cc.p(0, 0.5));
            name2.setPosition(cc.p(60, 262));

            bg.addChild(name2);
        }
        var name3 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingNowPass), "", 25);
        name3.setColor(cc.color("8ef3ff"));
        if (name3) {
            name3.setAnchorPoint(cc.p(0, 0.5));
            name3.setPosition(cc.p(60, 328));
            bg.addChild(name3);
        }
        var editpassmodify = bg.getChildByTag(100);
        var editPass = bg.getChildByTag(101);
        var editNowPass = bg.getChildByTag(102);

        editpassmodify.setDelegate({
            editBoxEditingDidBegin: function () {
                editpassmodify.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                if (editPass.getString() != editpassmodify.getString()) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr1));
                }
                editpassmodify.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassCheck));
                editpassmodify.setFontSize(24);
            },

        })
        editPass.setDelegate({
            editBoxEditingDidBegin: function () {
                editPass.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                if (editPass.getString() == "") {
                    editPass.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule));
                } else if (!/^\w{6,18}$/.test(editPass.getString())) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr3));
                }
                editPass.setFontSize(24);
            }
        })
        editNowPass.setDelegate({
            editBoxEditingDidBegin: function () {
                editNowPass.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                editNowPass.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassNow));
                editNowPass.setFontSize(24);
            }
        })

    },


    confirmCallBack: function (sender) {
        var bg = sender.getParent();
        var editpassmodify = bg.getChildByTag(100);
        var editPass = bg.getChildByTag(101);
        var editNowPass = bg.getChildByTag(102);
        if (editPass.getString() == "" || editNowPass.getString() == "") {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr9));
            return;
        }
        if (editPass.getString() == editNowPass.getString()) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr4));
            return;
        }
        if (editpassmodify.getString() != editPass.getString()) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr5));
            return;
        }

        if (!/^\w{6,18}$/.test(editPass.getString()) || !/[A-Za-z].*[0-9]|[0-9].*[A-Za-z]/.test(editPass.getString())) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule));
            return;
        }
        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        handler.sendModPassReq(hex_md5(editNowPass.getString()).toUpperCase(), hex_md5(editPass.getString()).toUpperCase());

    }

});
var CompleteInfoLayer = SmallLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(689, 447));
        this.addInnerBg(SccomRes.SmallWinRes.Innerbg, cc.size(607, 256));
        bg.getChildByTag(2).setPositionY(263);
        this.addTitleBg(SccomRes.SmallWinRes.Completeinfor,cc.p(160,44));
        this.addCloseBtn();
        this.addConfirmBtn(this.confirmCallBack, SccomRes.SmallWinRes.Confirmtitle2, cc.p(bg.width / 2, bg.height * 0.12));
        var placeHoldStr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingPassCheck), FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule), FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount1)];

        for (var i = 0; i < 3; i++) {

            var passwordbg = new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg);
            if (passwordbg) {
                var editBox = cc.EditBox(cc.size(416, 58), passwordbg);
                editBox.setFontSize(24);
                editBox.setPlaceHolder(placeHoldStr[i]);
                editBox.setPlaceholderFontSize(22);
                editBox.setPlaceholderFontColor(cc.color("#aaffff"));
                editBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
                if (i != 2) {
                    editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
                }else{
                    editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
                }
                editBox.setMaxLength(18);
                editBox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
                editBox.setPosition(cc.p(426, 196 + i * 66));
                bg.addChild(editBox, 0, i + 100);
            }

        }
        var name1 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount2), "", 25);
        name1.setColor(cc.color("8ef3ff"));
        if (name1) {
            name1.setPosition(cc.p(60, 196));
            name1.setAnchorPoint(cc.p(0, 0.5));
            bg.addChild(name1);
        }

        var name2 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount3), "", 25);
        name2.setColor(cc.color("8ef3ff"));
        if (name2) {
            name2.setPosition(cc.p(60, 262));
            name2.setAnchorPoint(cc.p(0, 0.5));
            bg.addChild(name2);
        }
        var name3 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount), "", 25);
        name3.setColor(cc.color("8ef3ff"));
        
        if (name3) {
            name3.setPosition(cc.p(60, 328));
            name3.setAnchorPoint(cc.p(0, 0.5));
            bg.addChild(name3);
        }
        var editpassmodify = bg.getChildByTag(100);
        var editPass = bg.getChildByTag(101);
        var editAccount = bg.getChildByTag(102);

        editpassmodify.setDelegate({
            editBoxEditingDidBegin: function () {
                editpassmodify.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                editpassmodify.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassNow));
                editpassmodify.setFontSize(24);
            },

        });
        editPass.setDelegate({
            editBoxEditingDidBegin: function () {
                editPass.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                if (!/^\w{6,18}$/.test(editPass.getString())) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr2));
                }
                editPass.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr2));
                editPass.setFontSize(24);
            }
        });
        editAccount.setDelegate({
            editBoxEditingDidBegin: function () {
                editAccount.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                if (!/^[A-Za-z0-9_@.-]{6,18}$/.test(editAccount.getString())) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount1));
                    // FYEngine.ToastManager.getInstance().AddTextToToastList(LobbyRes.SmallWinRes.Innerbg2, '账号为6-12位的字母或数字及其组合', ToastActionType.Bottom);
                }
                editAccount.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount4));
            }
        });


    },
    confirmCallBack: function (sender) {
        var bg = sender.getParent();
        var editpassmodify = bg.getChildByTag(100);
        var editPass = bg.getChildByTag(101);
        var editAccount = bg.getChildByTag(102).getString();
        editAccount = editAccount.replace("\\\'","");
        if (!/^[A-Za-z0-9_@.-]{6,18}$/.test(editAccount)) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount1));
            //FYEngine.ToastManager.getInstance().AddTextToToastList(LobbyRes.SmallWinRes.Innerbg2, '账号为6-12位的字母或数字及其组合', ToastActionType.Bottom);
            return;
        }

        if(/^[0-9]+$/.test(""+editAccount)){
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount9));
            return;
        }

        if (!/^\w{6,18}$/.test(editPass.getString()) || !/[A-Za-z].*[0-9]|[0-9].*[A-Za-z]/.test(editPass.getString())) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr2));
            // FYEngine.ToastManager.getInstance().AddTextToToastList(LobbyRes.SmallWinRes.Innerbg2, '请输入8-16位包含字母与数字的组合密码', ToastActionType.Bottom);
            return;
        }
        if (editpassmodify.getString() != editPass.getString()) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr5));
            //FYEngine.ToastManager.getInstance().AddTextToToastList(LobbyRes.SmallWinRes.Innerbg2, '请输入相同的密码', ToastActionType.Bottom);
            return;
        }
        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        handler.sendBindAccountReq(editAccount, hex_md5(editPass.getString()).toUpperCase());
        //bg.getParent().accountUsedCheckUrl(editAccount.getString());
        //app.SdkService.userBinding(editAccount.getString(), hex_md5(editPass.getString()).toUpperCase());
    }

});

var ChangeSignLayer = SmallLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },
    initUI: function () {
        var bg = this.addLayerBg(cc.size(602, 331));

        this.addTitleBg(SccomRes.SmallWinRes.changeSign,cc.p(160,44));
        this.addCloseBtn();
        this.addConfirmBtn(this.confirmCallBack, undefined, cc.p(435, 75));
        this.addCancelBtn(undefined, cc.p(175, 75));
        var sign = appglobal.getPlayer().getSign();

        //var bgSprite = new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg);
        //bgSprite.setContentSize(cc.size(500, 126))
        //var textField = new ccui.TextField("","",22);
        //
        //textField.setTextAreaSize(cc.size(500, 126));
        //textField.setPosition(cc.p(500/2,126/2));
        //bgSprite.setPosition(cc.p(301,205));
        //textField.setTouchSize(cc.size(500, 126));
        //bg.addChild(bgSprite);
        //bgSprite.addChild(textField);
        //if (sign == undefined || sign == "") {
        //    textField.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3));
        //} else {
        //    textField.setString(sign);
        //}
        //textField.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_RIGHT);
        //textField.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_TOP);
        //textField.setPlaceHolderColor(cc.color("#ffffff"));
        //cc.log("touch size===="+JSON.stringify(textField.getTouchSize()));
        //textField.addEventListener(this.textFieldEvent,this);
        var editBox = new cc.EditBox(cc.size(500, 126), new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg));
        editBox.setAnchorPoint(cc.p(0,1));
        editBox.attr({x: 301-250, y: 205+63});
        if (sign == undefined || sign == "") {
            editBox.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3));
        } else {
            editBox.setString(sign);
        }

        editBox.setPlaceholderFontSize(22);
        editBox.setPlaceholderFontColor(cc.color("#ffffff"));
        editBox.setFontSize(22);
        editBox.setMaxLength(80);
        editBox.setTag(100);
        editBox.setInputMode(cc.EDITBOX_INPUT_MODE_ANY);
        editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
        if(cc.sys.os != 'iOS'){
            editBox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
        }

        var delegate = {
            editBoxEditingDidBegin: function () {
                //editBox.setPlaceHolder("");
                if (editBox.getString() == "") {
                    editBox.setPlaceHolder("");
                }
            },
            editBoxEditingDidEnd: function () {
                var str = editBox.getString();
                //if (/\s/.test(str)) {
                //    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign2));
                //    return;
                //}

                if(str.length>60){
                    str = str.substring(0,60);
                    editBox.setString(str);
                    FYEngine.AddCommToast('签名字数最多为60个汉字');
                }

                if (str != '') {
                    str = FYEngine.FilterWord.getInstance().RunFilterWord(str, "*", 1);
                    editBox.setString(str);
                }
                if (str == "") {
                    editBox.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3));
                }

            }
        };
        editBox.setDelegate(delegate);
        bg.addChild(editBox);



    },

    textFieldEvent: function (textField,type) {
        cc.log("type====="+type);
    },

    confirmCallBack: function (sender) {
        var editNickBox = sender.getParent().getChildByTag(100);
        var editNick = editNickBox.getString();
        editNick = editNick.replace("\\\'","");
        if (editNick == "") {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign1));
            return;
        }

        if (/\s/.test(editNick)&&editNick.replace(new RegExp(/\s/g),"")== "") {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign1));
            return;
        }
        //if (/\s/.test(editNick)) {
        //    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign2));
        //    return;
        //}
        var isEmojiCharacter = function (substring) {
            for (var i = 0; i < substring.length; i++) {
                var hs = substring.charCodeAt(i);
                if (0xd800 <= hs && hs <= 0xdbff) {
                    if (substring.length > 1) {
                        var ls = substring.charCodeAt(i + 1);
                        var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
                        if (0x1d000 <= uc && uc <= 0x1f77f) {
                            return true;
                        }
                    }
                } else if (substring.length > 1) {
                    var ls = substring.charCodeAt(i + 1);
                    if (ls == 0x20e3) {
                        return true;
                    }
                } else {
                    if (0x2100 <= hs && hs <= 0x27ff) {
                        return true;
                    } else if (0x2B05 <= hs && hs <= 0x2b07) {
                        return true;
                    } else if (0x2934 <= hs && hs <= 0x2935) {
                        return true;
                    } else if (0x3297 <= hs && hs <= 0x3299) {
                        return true;
                    } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030
                        || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b
                        || hs == 0x2b50) {
                        return true;
                    }
                }
            }
        };
        if (isEmojiCharacter(editNick)) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign4));
            return;
        }
        if (editNick.length > 60) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingSign5));
            return;
        }

        //nickEditBox.editBoxReturn(sender);
        //sender.getParent().getParent().changeNicknameUrl(editNick);
        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        handler.sendEditSignReq(editNick);
    },


});


//var CrystalRankLayer = DialogLayer.extend({
//    _isClose : false,
//    ctor: function () {
//        var that = this;
//        this._super();
//        this._isClose = false;
//        //this.loadResource();
//        this.initUI();
//        this.runAction(cc.sequence(cc.delayTime(0.5),new cc.CallFunc(function () {
//            that.scheduleOnce(that.timeOutCheck, 15);
//            Http.getMessage(that.getRankUrl(), null, function (cfgStr) {
//                var scene = FYEngine.getRunningLayer(0);
//                var that = scene.getChildByName(LobbySceneName.CrystalRank);
//                //ExchangeTemp.productArry = [];
//                var jsonInfo = eval('(' + cfgStr + ')');
////               FYEngine.logObject(jsonInfo,'----------获取排行榜的消息:');
//                var errcode = jsonInfo.code;
//                if (errcode != 0) {
//                    cc.log('-----获取排行榜 失败');
//                    return;
//                }
//                FishGlobal.rankList = [];
//                // FYEngine.logObject(that.getName(),'---------that');
//                if(that && that.timeOutCheck){
//                    cc.log("222222");
//                    that.unschedule(that.timeOutCheck);
//                }
//
//                if (that && (that._isClose == false)) {
//                    var loading = that.layerbg.getChildByName(SccomLayerName.loading);
//                    if (loading) {
//                        loading.removeFromParent(true);
//                    }
//
//                    var listview = that.layerbg.getChildByName("rank_listview");
//                    if(listview){
//                        return;
//                    }
//                    listview = FYEngine.createListView(cc.size(470, 433), cc.p(that.layerbg.width / 2, (that.layerbg.height * 0.5) - 15), cc.p(0.5, 0.5), 4, ccui.ScrollView.DIR_VERTICAL);
//                    //listview.retain();
//                    listview.setScrollBarEnabled(false);
//                    if (listview) {
//                        that.layerbg.addChild(listview, 1, "rank_listview");
//                        //listview.setScrollBarPositionFromCornerForHorizontal(cc.p(0, 0));
//                    }
//
//                    var dataValue = jsonInfo.data;
//                    if(dataValue.length==0){
//                        var sprite = cc.Sprite("#crystal25.png");
//                        sprite.setPosition(cc.p(that.layerbg.width / 2, that.layerbg.height * 0.5));
//                        that.layerbg.addChild(sprite);
//                        return;
//
//                    }
//                    for (var i = 0; i < dataValue.length; ++i) {
//                        FishGlobal.rankList.push(dataValue[i]);
//                        var box = new CrystalRankItem2(dataValue[i]);
//                        if (box) {
//                            //box.setAnchorPoint(cc.p(0.5, 0.5));
//                            listview.pushBackCustomItem(box);
//                        }
//                    }
//                    scene.onGameEvent(lobbyGameEvent.refreshRank);
//                    //FYEngine.logObject(ExchangeTemp.productArry,"-----ExchangeTemp.productArry-----");
//                }
//            });
//
//
//        })));
//    },
//
//    initUI: function () {
//        var bg = this.addLayerBg(cc.size(532, 547));
//        this.addTitleBg("#fish_boom13.png", 532, cc.size(325, 54));
//        this.addCloseBtn(this.closeCallBack);
//        this.runAction(cc.sequence(cc.delayTime(0.2),cc.callFunc(function(){
//            var _sprite = FYEngine.createSprite(SccomRes.MallRes.loadingbg, cc.p(bg.width / 2, bg.height * 0.5));
//            bg.addChild(_sprite, 99, SccomLayerName.loading);
//
//            var rotate = new cc.RotateBy(1.2, 360);
//            _sprite.runAction(new cc.RepeatForever(rotate));
//        })));
//
//    },
//
//    closeCallBack : function(){
//        var scene = FYEngine.getRunningLayer(0);
//        var layer = scene.getChildByName(LobbySceneName.CrystalRank);
//        layer._isClose = true;
//        FYEngine.popoutLayerAnimate(layer.layerbg);
//    },
//
//    getRankUrl: function () {
//        var service = formservice("crystalRank");
//        var time = Date.now();
//        var sign = formsign("crystalRank", time);
//        time = formTime(time);
//        var checksum = formchecksum(sign.value, FYEngine.PrivateKey);
//        return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum);
//    },
//    timeOutCheck: function () {
//        var that = this;
//        if(that.layerbg.getChildByName(SccomLayerName.loading)){
//            that._isClose = true;
//            var loading = that.layerbg.getChildByName(SccomLayerName.loading);
//            loading.removeFromParent(true);
//            var sprite = cc.Sprite("#crystal29.png");
//            sprite.setPosition(that.layerbg.width/2,that.layerbg.height/2);
//            that.layerbg.addChild(sprite);
//        }
//    },
//});
//
//var CrystalRankWithSignLayer = DialogLayer.extend({
//    _isClose : false,
//    ctor: function () {
//        var that = this;
//        this._super();
//        this._isClose = false;
//        //this.loadResource();
//        this.initUI();
//        this.runAction(cc.sequence(cc.delayTime(0.5),new cc.CallFunc(function () {
//            that.scheduleOnce(that.timeOutCheck, 15);
//            Http.getMessage(that.getRankUrl(), null, function (cfgStr) {
//                var scene = FYEngine.getRunningLayer(0);
//                var that = scene.getChildByName(LobbySceneName.CrystalRank);
//                //ExchangeTemp.productArry = [];
//                var jsonInfo = eval('(' + cfgStr + ')');
////                FYEngine.logObject(jsonInfo,'----------获取排行榜的消息:');
//                var errcode = jsonInfo.code;
//                if (errcode != 0) {
//                    cc.log('-----获取排行榜 失败');
//                    return;
//                }
//                FishGlobal.rankList = [];
//                // FYEngine.logObject(that.getName(),'---------that');
//                if(that && that.timeOutCheck){
//                    cc.log("222222");
//                    that.unschedule(that.timeOutCheck);
//                }
//
//                if (that && (that._isClose == false)) {
//                    var loading = that.layerbg.getChildByName(SccomLayerName.loading);
//                    if (loading) {
//                        loading.removeFromParent(true);
//                    }
//
//                    var listview = that.layerbg.getChildByName("rank_listview");
//                    if(listview){
//                        return;
//                    }
//                    listview = FYEngine.createListView(cc.size(786, 433), cc.p(that.layerbg.width / 2, (that.layerbg.height * 0.5) - 15), cc.p(0.5, 0.5), 4, ccui.ScrollView.DIR_VERTICAL);
//                    //listview.retain();
//                    listview.setScrollBarEnabled(false);
//                    if (listview) {
//                        that.layerbg.addChild(listview, 1, "rank_listview");
//                        //listview.setScrollBarPositionFromCornerForHorizontal(cc.p(0, 0));
//                    }
//
//                    var dataValue = jsonInfo.data;
//                    if(dataValue.length==0){
//                        var sprite = cc.Sprite("#crystal25.png");
//                        sprite.setPosition(cc.p(that.layerbg.width / 2, that.layerbg.height * 0.5));
//                        that.layerbg.addChild(sprite);
//                        return;
//
//                    }
//                    for (var i = 0; i < dataValue.length; ++i) {
//                        FishGlobal.rankList.push(dataValue[i]);
//                        var box = new CrystalRankItem(dataValue[i]);
//                        if (box) {
//                            //box.setAnchorPoint(cc.p(0.5, 0.5));
//                            listview.pushBackCustomItem(box);
//                        }
//                    }
//                    scene.onGameEvent(lobbyGameEvent.refreshRank);
//                    //FYEngine.logObject(ExchangeTemp.productArry,"-----ExchangeTemp.productArry-----");
//                }
//            });
//
//
//        })));
//    },
//
//    initUI: function () {
//        var bg = this.addLayerBg(cc.size(852, 547));
//        this.addTitleBg("#fish_boom13.png", 860, cc.size(325, 54));
//        this.addCloseBtn(this.closeCallBack);
//        this.runAction(cc.sequence(cc.delayTime(0.2),cc.callFunc(function(){
//            var _sprite = FYEngine.createSprite(SccomRes.MallRes.loadingbg, cc.p(bg.width / 2, bg.height * 0.5));
//            bg.addChild(_sprite, 99, SccomLayerName.loading);
//
//            var rotate = new cc.RotateBy(1.2, 360);
//            _sprite.runAction(new cc.RepeatForever(rotate));
//        })));
//
//    },
//
//    closeCallBack : function(){
//        var scene = FYEngine.getRunningLayer(0);
//        var layer = scene.getChildByName(LobbySceneName.CrystalRank);
//        layer._isClose = true;
//        FYEngine.popoutLayerAnimate(layer.layerbg);
//    },
//
//    getRankUrl: function () {
//        var service = formservice("crystalRank");
//        var time = Date.now();
//        var sign = formsign("crystalRank", time);
//        time = formTime(time);
//        var checksum = formchecksum(sign.value, FYEngine.PrivateKey);
//        return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum);
//    },
//    timeOutCheck: function () {
//        var that = this;
//        if(that.layerbg.getChildByName(SccomLayerName.loading)){
//            that._isClose = true;
//            var loading = that.layerbg.getChildByName(SccomLayerName.loading);
//            loading.removeFromParent(true);
//            var sprite = cc.Sprite("#crystal29.png");
//            sprite.setPosition(that.layerbg.width/2,that.layerbg.height/2);
//            that.layerbg.addChild(sprite);
//        }
//    },
//});

var CrystalRankNewLayer = DialogLayer.extend({
    _isClose : false,
    _upList :[],
    _underList :[],
    _canClick : false,
    ctor: function () {
        var self = this;
        this._super();
        this._isClose = false;
        this.initData();
        this.initUI();

    },

    initData : function(){
        this._upList =[];
        this._underList =[];
        this._canClick =false;
    },

    initUI: function () {
        var self = this;
        this.addLayerBg(cc.size(1100, 535));
        this.addInnerBg(cc.size(1050,385));
        this.innerBg.setPosition(cc.p(this.layerbg.width/2,295));

        var titleBg = FYEngine.createSprite("#newyear2.png", cc.p(this.layerbg.width / 2, this.layerbg.height * 1.02));
        this.layerbg.addChild(titleBg, 0, "titleBg");
        var titleName = FYEngine.createSprite('#fishranknew_0.png', cc.p(titleBg.width / 2, titleBg.height *0.4));
        titleBg.addChild(titleName, 0, "titleName");

        var btnQuit = new ccui.Button(SccomRes.Backbtn.Up, SccomRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnQuit) {
            btnQuit.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.96);
            this.layerbg.addChild(btnQuit, 0, "btnQuit");
            btnQuit.addClickEventListener(this.closeCallBack);
        }

        var btnChange = new ccui.Button("fishranknew_4.png","fishranknew_4.png", "", ccui.Widget.PLIST_TEXTURE);
        if(btnChange){
            btnChange.setPosition(this.layerbg.width /2, 60);
            this.layerbg.addChild(btnChange, 0, "btnChange");
            btnChange.addClickEventListener(function(sender){
                self.changeUI(sender);
            });
            btnChange.addTouchEventListener(this.btnEftCallBack,this);
        }

        this.addLoading();
        this.scheduleOnce(this.timeOutCheck, 15);


        // this.runAction(cc.sequence(cc.delayTime(0.2),cc.callFunc(function(){
        //     self.addLoading();
        // })));

        // this.runAction(cc.sequence(cc.delayTime(0.5),cc.callFunc(function(){
        //     self.schedule(self.checkDataReady,1);
        // })));
        // self.schedule(self.checkDataReady,1);
        this.checkDataReady();
    },

    btnEftCallBack : function(sender,type){
        switch(type){
            case ccui.Widget.TOUCH_BEGAN :{
                sender.setScale(1.1);
            }break;
            case ccui.Widget.TOUCH_MOVED :{
                sender.setScale(1.0);
            }break;
            case ccui.Widget.TOUCH_ENDED :{
                sender.setScale(1.0);
            }break;
            case ccui.Widget.TOUCH_CANCELED :{
                sender.setScale(1.0);
            }break;
        }
    },

    changeUI : function(sender){
        var scene = FYEngine.getRunningLayer(0);
        if(this._canClick == true){
            this._canClick = false;
            scene.onGameEvent(lobbyGameEvent.refreshRankNew);
        }else{
            FYEngine.AddCommToast("数据加载中，请稍候");
        }
    },

    checkDataReady:function(){
        var scene = FYEngine.getRunningLayer(0);
        // cc.log("checkDataReady"+scene._rankList.length);
        if(scene._rankList.length>0 && scene._rankList.length!=9){
            // this.unschedule(this.checkDataReady);
            this.unschedule(this.timeOutCheck);
            this.removeLoading();
            this.addNoDataTip();
            return;
        }

        if(scene._rankList.length ==9){
            // this.unschedule(this.checkDataReady);
            this.unschedule(this.timeOutCheck);
            this.removeLoading();
            this.createLittleItem(scene._rankList);
        }
    },

    createLittleItem : function(mylist){
        if(this._isClose ==true || mylist.length<9){
            return;
        }
        // FYEngine.logObject(mylist,"---界面上的list:");
        this.unschedule(this.timeOutCheck);
        this.removeLoading();
        this.innerBg.removeAllChildren();
        for(var i =0;i<9;++i){
            var box = new RankItemNew(mylist[i]);
            if(box){
                this.innerBg.addChild(box);
                box.setPosition(cc.p(185+(i%3)*340,315-(Math.floor(i/3))*125));
            }
        }
        this._canClick = true;
    },

    addLoading : function(){
        var _sprite = FYEngine.createSprite(SccomRes.MallRes.loadingbg, cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5));
        this.layerbg.addChild(_sprite, 99, SccomLayerName.loading);
        var rotate = new cc.RotateBy(1.2, 360);
        _sprite.runAction(new cc.RepeatForever(rotate));
    },

    addNoDataTip : function(){
        var warn = new ccui.Text("暂无明星玩家","微软雅黑",26);
        if(warn){
            warn.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.6));
            this.layerbg.addChild(warn, 99,"warn");
        }
    },

    addLoadFailTip : function(){
        var sprite = cc.Sprite("#crystal29.png");
        sprite.setPosition(this.layerbg.width/2,this.layerbg.height*0.6);
        this.layerbg.addChild(sprite);
    },


    removeLoading : function(){
        var loadingsp = this.layerbg.getChildByName(SccomLayerName.loading);
        if(loadingsp){
            loadingsp.removeFromParent(true);
        }
    },

    closeCallBack : function(){
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.CrystalRank);
        if(layer){
            layer.unscheduleAllCallbacks();
            layer._isClose = true;
            FYEngine.popoutLayerAnimate(layer.layerbg);
            // layer.removeFromParent(true);
        }
    },

    timeOutCheck: function(){
        var self = this;
        this._isClose = true;
        cc.log("---timeout");
        this.unschedule(this.checkDataReady);
        this.removeLoading();
        this.addLoadFailTip();
    },
});

var CrystalRankItem = ccui.ImageView.extend({
    ctor: function (data) {
        this._super();
        this.loadTexture("rankup021.png", ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setContentSize(cc.size(785, 118));
        this.initUI(data);
    },
    initUI: function (data) {
        var rankBg = cc.Sprite("#rankup017.png");
        rankBg.attr({anchorX: 0, anchorY: 1, x: 10, y: 118});
        this.addChild(rankBg);
        var rankIcon;
        if (data.rank <= 3) {
            switch (data.rank) {
                case 1:
                    rankIcon = cc.Sprite("#rankup018.png");
                    break;
                case 2:
                    rankIcon = cc.Sprite("#rankup015.png");
                    break;
                case 3:
                    rankIcon = cc.Sprite("#rankup016.png");
                    break
            }
        } else {
            //rankIcon = ccui.TextAtlas("" + data.rank, "res/num/crystal_num.png", 32, 48, "0");
            rankIcon =FYEngine.createAlts(LobbyRes.Onlinenum.RankNumber, 10, data.rank, '0');
        }
        rankIcon && rankIcon.setPosition(cc.p(rankBg.width / 2-2, 50));
        rankBg.addChild(rankIcon);
        var tempname = SoftReplaceWords(""+data.nickName);
        var nickNameLabel = cc.Label.createWithSystemFont(tempname, "", 25);
        nickNameLabel.setColor(cc.color("#6b3110"));
        //nickNameLabel.enableOutline(cc.color("#c2afa8"),1);

        nickNameLabel.attr({x: 175, y: 90, anchorX: 0});
        this.addChild(nickNameLabel);

        var crystalBg = ccui.ImageView("crystal59.png", ccui.Widget.PLIST_TEXTURE);
        crystalBg.setScale9Enabled(true);
        crystalBg.setContentSize(cc.size(210, 35));
        crystalBg.setPosition(cc.p(591, 92));
        this.addChild(crystalBg);

        var crystalLabel1 = cc.Label.createWithSystemFont(FYEngine.LanguageString.getValue(SettingMsgKey.crystalRank1), "", 22);
        crystalLabel1.setColor(cc.color("#fc3f09"));
        //crystalLabel1.enableOutline(cc.color("#fc3f09"),1);
        crystalLabel1.attr({x: 495, y: 79.5, anchorX: 0, anchorY: 0});
        this.addChild(crystalLabel1);

        var crystalCount = cc.Label.createWithSystemFont("" + data.crystalCount, "", 25);
        crystalCount.setColor(cc.color("#fc3f09"));
        //crystalCount.enableOutline(cc.color("#fc3f09"),1);
        crystalCount.attr({x: 690, y: 77.5, anchorX: 1, anchorY: 0});
        this.addChild(crystalCount);

        var headK = new FYEngine.rangkImage('#rankup042.png','#fish_hallnew02.png','#rankup012.png', 1 ,data.icon ,0,0,0);
        if(headK){
            this.addChild(headK);
            headK.attr({x:122, y:62, anchorX:0.5, anchorY:0.5});
            this.headnode = headK;
        }


        //var signLabel = cc.Label.createWithSystemFont(data.sign != "" ? data.sign : FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3), "", 19);
        //if (data.sign == "") {
        //    signLabel.setColor(cc.color("#7e8182"));
        //} else {
        //    signLabel.setColor(cc.color("#126f88"));
        //}
        //signLabel.setOverflow(3);
        //signLabel.setWidth(600);
        //signLabel.attr({ x: 177,y: 45,anchorX: 0, anchorY: 0.5});
        //this.addChild(signLabel);
        var tempsign = SoftReplaceWords(data.sign != "" ? data.sign : FYEngine.LanguageString.getValue(SettingMsgKey.settingSign3));
        var signLabel = cc.Label.createAutoSystemFont(tempsign, 19,600);
        if (data.sign == "") {
            signLabel.setColor(cc.color("#7e8182"));
        } else {
            signLabel.setColor(cc.color("#126f88"));
        }
        //signLabel.setOverflow(3);
        //signLabel.setWidth(600);
        signLabel.attr({ x: 177,y: 45,anchorX: 0, anchorY: 0.5});
        this.addChild(signLabel);

    }
});

var RankItemNew = ccui.ImageView.extend({
    _data:{},
    ctor: function (data) {
        this._super();
        this.loadTexture("rankup021.png", ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setContentSize(cc.size(340, 120));
        this._data = data;
        this.initUI();
        FYEngine.logObject(data,"------data:");
    },

    initUI: function (){
        var itemname ="";
        var itemicon ="";
        var itemlogo = "";
        switch(this._data.type){
            case 1 :{
                itemname =""+FishGlobal.rankListType1[this._data.rdata].nickName;
                itemicon =""+FishGlobal.rankListType1[this._data.rdata].icon;
                itemlogo = "fishranknew_10.png";
            }break;
            case 2 : {
                itemname =""+FishGlobal.rankListType2[this._data.rdata].nickName;
                itemicon =""+FishGlobal.rankListType2[this._data.rdata].icon;
                itemlogo = "fishranknew_9.png";
            }break;
            case 3:{
                itemname =""+FishGlobal.rankListType3[this._data.rdata].nickName;
                itemicon =""+FishGlobal.rankListType3[this._data.rdata].icon;
                itemlogo = "fishranknew_11.png";
            }break;
        }

        var headK = new FYEngine.rangkImage('#rankup042.png','#fish_hallnew02.png','#rankup012.png', 1 ,itemicon ,0,0,0);
        if(headK){
            this.addChild(headK);
            headK.attr({x:60, y:63, anchorX:0.5, anchorY:0.5});
        }

//        cc.log("--------itemname:"+itemname);
        var tempname = SoftReplaceWords(itemname);
        var nickNameLabel = FYEngine.createLengthText2(tempname,22,220);
        nickNameLabel.setColor(cc.color("022e70"));
        nickNameLabel.attr({x: 217, y: 30});
        this.addChild(nickNameLabel);

        var logo = ccui.ImageView(itemlogo, ccui.Widget.PLIST_TEXTURE);
        logo.setPosition(cc.p(215,80));
        this.addChild(logo);


    }
});

var CrystalRankItem2 = ccui.ImageView.extend({
    ctor: function (data) {
        this._super();
        this.loadTexture("rankup021.png", ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setContentSize(cc.size(468, 118));
        this.initUI(data);
    },
    initUI: function (data) {
        var rankBg = cc.Sprite("#rankup017.png");
        rankBg.attr({anchorX: 0, anchorY: 1, x: 10, y: 118});
        this.addChild(rankBg);
        var rankIcon;
        if (data.rank <= 3) {
            switch (data.rank) {
                case 1:
                    rankIcon = cc.Sprite("#rankup018.png");
                    break;
                case 2:
                    rankIcon = cc.Sprite("#rankup015.png");
                    break;
                case 3:
                    rankIcon = cc.Sprite("#rankup016.png");
                    break
            }
        } else {
            rankIcon =FYEngine.createAlts(LobbyRes.Onlinenum.RankNumber, 10, data.rank, '0');
        }
        rankIcon && rankIcon.setPosition(cc.p(rankBg.width / 2-2, 50));
        rankBg.addChild(rankIcon);
        //var nickNameLabel =new ccui.Text(data.nickName, "", 25);
        //nickNameLabel.setColor(cc.color("#6b3110"));
        //nickNameLabel.attr({x: 180, y: 90, anchorX: 0});
        //this.addChild(nickNameLabel);
        var tempname = SoftReplaceWords(""+data.nickName);
        var nickNameLabel =FYEngine.createLengthText(tempname, 25, 280);
        nickNameLabel.setColor(cc.color("#6b3110"));
        nickNameLabel.attr({x: 180, y: 90, anchorX: 0});
        this.addChild(nickNameLabel);

        var crystalBg = ccui.ImageView("crystal59.png", ccui.Widget.PLIST_TEXTURE);
        crystalBg.setScale9Enabled(true);
        crystalBg.setContentSize(cc.size(270, 35));
        crystalBg.setPosition(cc.p(310, 40));
        this.addChild(crystalBg);

        var crystalLabel1 = new ccui.Text(FYEngine.LanguageString.getValue(SettingMsgKey.crystalRank1), "", 22);
        crystalLabel1.setColor(cc.color("#fc3f09"));
        //crystalLabel1.enableOutline(cc.color("#fc3f09"),1);
        crystalLabel1.attr({x: 5, y: crystalBg.height/2, anchorX: 0, anchorY: 0.5});
        crystalBg.addChild(crystalLabel1);

        var crystalCount = new ccui.Text("" + data.crystalCount, "", 25);
        crystalCount.setColor(cc.color("#fc3f09"));
        //crystalCount.enableOutline(cc.color("#fc3f09"),1);
        crystalCount.attr({x: 185, y: crystalBg.height/2, anchorX: 0.5, anchorY: 0.5});
        crystalBg.addChild(crystalCount);

        var headK = new FYEngine.rangkImage('#rankup042.png','#fish_hallnew02.png','#rankup012.png', 1 ,data.icon ,0,0,0);
        if(headK){
            this.addChild(headK);
            headK.attr({x:122, y:62, anchorX:0.5, anchorY:0.5});
            this.headnode = headK;
        }
    }
});

var IDverifyLayer = SmallLayer.extend({
    _time:0,
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(689, 447));
        this.addInnerBg(SccomRes.SmallWinRes.Innerbg, cc.size(607, 256));
        bg.getChildByTag(2).setPositionY(263);
        this.addTitleBg("#fish_idverify_16.png",cc.p(160,44));
        if(appglobal._switch19 == 1){
            this.addCloseBtn();
        }
        var self = this;
        this.addConfirmBtn(function(){
            self.confirmCallBack();
        }, "#fish_idverify_14.png", cc.p(bg.width / 2, bg.height * 0.15));
        var placeHoldStr = ["请输入身份证号码","请输入姓名"];

        var tips = new cc.Sprite('#fish_idverify_18.png');
        if(tips){
            bg.addChild(tips);
            tips.setPosition(cc.p(bg.width/2,346));
        }

        for (var i = 0; i < 2; i++) {

            var passwordbg = new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg);
            if (passwordbg) {
                var editBox = cc.EditBox(cc.size(380, 58), passwordbg);
                editBox.setFontSize(22);
                editBox.setPlaceHolder(placeHoldStr[i]);
                editBox.setPlaceholderFontSize(22);
                editBox.setPlaceholderFontColor(cc.color("#7ef0fe"));
                editBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
                if(i==0){
                    editBox.setMaxLength(18);
                }else{
                    editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
                    editBox.setMaxLength(6);
                }
                editBox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
                editBox.setPosition(cc.p(378, 196 + i * 80));
                bg.addChild(editBox, 0, i + 100);
            }

        }

        var name1 = new ccui.Text("身份证", "微软雅黑", 24);
        name1.setColor(cc.color(142,243,255));
        if (name1) {
            name1.enableOutline(cc.color(142,243,255, 255), 1);
            name1.setPosition(cc.p(170, 196));
            name1.setAnchorPoint(cc.p(1, 0.5));
            bg.addChild(name1);
        }
        var name2 = new ccui.Text("姓    名", "微软雅黑", 24);
        name2.setColor(cc.color(142,243,255));
        if (name2) {
            name2.enableOutline(cc.color(142,243,255, 255), 1);
            name2.setPosition(cc.p(170, 276));
            name2.setAnchorPoint(cc.p(1, 0.5));
            bg.addChild(name2);
        }



        var useridnumber = bg.getChildByTag(100);
        var username = bg.getChildByTag(101);

        useridnumber.setDelegate({
            editBoxEditingDidBegin: function () {
                useridnumber.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {

            },

            editBoxTextChanged : function(sender){
                var flag = false;
                var str = sender.getString();
                if(FYEngine.isEmojiCharacter(str)){
                    flag = true;
                }

                if(flag){
                    sender.setString("");
                    FYEngine.AddCommToast('身份证中有不支持的字符');
                }
            },

        });
        username.setDelegate({
            editBoxEditingDidBegin: function () {
                username.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {

            },

            editBoxTextChanged : function(sender){
                var flag = false;
                var str = sender.getString();
                if(FYEngine.isEmojiCharacter(str)){
                    flag = true;
                }

                if(flag){
                    sender.setString("");
                    FYEngine.AddCommToast('姓名中有不支持的字符');
                }
            },


        });


    },

    confirmCallBack: function () {
        //var bg = sender.getParent();
        var date = new Date();
        var times = cc.sys.localStorage.getItem('idchecktimes'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(times && parseInt(times)>=FishGlobal.idControl.idcheckdailytime){
            FYEngine.AddCommToast('您今天实名认证太多次啦，请明天再试');
            return;
        }
        //cc.log("---times"+times);

        var useridnumber = this.layerbg.getChildByTag(100).getString().toUpperCase();
        var username = this.layerbg.getChildByTag(101).getString();

        if(username.length ==0){
            FYEngine.AddCommToast("姓名不能为空");
            return;
        }

        //if(useridnumber.length ==0){
        //    FYEngine.AddCommToast("身份证号不能为空");
        //    return;
        //}

        if(username.length<2){
            FYEngine.AddCommToast("您的姓名不符合规范，请重新输入");
            return;
        }

        if(/[^\u4e00-\u9fa5]/.test(username)){
            FYEngine.AddCommToast('您的姓名不符合规范，请重新输入');
            return;
        }

        if(FYEngine.checkIsRealCard(useridnumber)=== false){
            return;
        }



        if(useridnumber.length ==15){
            useridnumber = FYEngine.IDchangeFivteenToEighteen(useridnumber);
        }

        //if(!/^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/.test(useridnumber)){
        //    FYEngine.AddCommToast('您的身份证号码不符合规范，请重新输入');
        //    return;
        //}

        if(times){
            if(parseInt(times)<FishGlobal.idControl.idcheckdailytime){
                var currenttimes = parseInt(times)+1;
                cc.sys.localStorage.setItem('idchecktimes'+date.getFullYear()+date.getMonth()+date.getUTCDate(),""+currenttimes);
            }else{
                FYEngine.AddCommToast('您今天实名认证太多次啦，请明天再试');
                return;
            }
        }else{
            cc.sys.localStorage.setItem('idchecktimes'+date.getFullYear()+date.getMonth()+date.getUTCDate(),"1");
        }

        var loading = FYEngine.CreateAccRelatedLoading();
        if(loading){
            this.addChild(loading,100,'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount,1);
        this.sendMSG(username,useridnumber);
    },

    sendMSG : function(username,useridnumber){
        Http.getMessage(function(){
            var service = formservice("idCardCheck");
            var time = Date.now();
            var uid = {name:"uid",value:appglobal.getPlayer().userid};
            var name ={name:"name",value:encodeURI(username)};
//            var name ={name:"name",value:username};
            var idNo = {name:"idNo",value:useridnumber};
            var imei = {name:"imei",value:appglobal._appCfg.imei};
            var sign = formsign("idCardCheck", time);
            time = formTime(time);
            var checksum = formchecksum(uid.value, idNo.value, imei.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(),"fishService", service, time,uid,name, idNo, imei, sign, checksum);
            cc.log('-------发送验证身份证号请求url:'+url);
            return url;
        }(), null, function(cfgStr){
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(LobbySceneName.IDverifyLayer);
            if(layer){
                layer.removeLoading();
                layer.unschedule(layer.timeCount);
            }
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------获取:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {
                cc.log('-----获取失败');
                switch(errcode){
                    case -1 :{//未实名认证

                    }break;
                    case 1 :{//实名认证失败
                        FYEngine.AddCommToast("认证失败，请输入正确的姓名和身份证号");
                    }break;
                    case 2 :{//连接实名认证服务器失败
                        FYEngine.AddCommToast("认证失败，请输入正确的姓名和身份证号");
                    }break;
                    case 3 :{//身份证不符合规则
                        FYEngine.AddCommToast("认证失败，请输入正确的姓名和身份证号");
                    }break;
                    case -70 :{
                        FYEngine.AddCommToast("系统繁忙");
                    }break;
                    case -90 :{
                        FYEngine.AddCommToast("系统故障");
                    }break;
                    default : break;
                }
            }else{
                if(layer){
                    layer.removeFromParent(true);
                }
                FYEngine.AddCommToast("恭喜您成功完成了实名认证");
                var IDdata = jsonInfo.data;
                var player = appglobal.getPlayer();
                player.realName = IDdata.realName;
                player.realIDnumber = IDdata.idCard;
                var age = FYEngine.getAgeByIdCard(IDdata.idCard);
                if(age>=18){
                    player.isAdult = true;
                }
                var settinglayer = scene.getChildByName(LobbySceneName.SettingInfoLayer);
                if(settinglayer && settinglayer.refreshIDcheckBtn){
                    settinglayer.refreshIDcheckBtn();
                }
            }

        });
    },


    removeLoading : function(){
        var loading = this.getChildByName("accloading");
        if(loading){
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var IDverifyShowLayer = SmallLayer.extend({
    _time:0,
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(689, 447));
        this.addInnerBg(SccomRes.SmallWinRes.Innerbg, cc.size(607, 256));
        bg.getChildByTag(2).setPositionY(263);
        this.addTitleBg("#fish_idverify_16.png",cc.p(160,44));
        this.addCloseBtn();
        var self = this;
        this.addConfirmBtn(function(){
            self.removeFromParent(true);
        }, UsedResName.iknowbtn, cc.p(bg.width / 2, bg.height * 0.15));
        var player = appglobal.getPlayer();
        var tips = new cc.Sprite('#fish_idverify_17.png');
        if(tips){
            bg.addChild(tips);
            tips.setPosition(cc.p(bg.width/2,326));
        }

        var name1 = new ccui.Text("身份证:", "微软雅黑", 24);
        name1.setColor(cc.color(142,243,255));
        if (name1) {
            name1.enableOutline(cc.color(142,243,255, 255), 1);
            name1.setPosition(cc.p(235, 220));
            name1.setAnchorPoint(cc.p(1, 0.5));
            bg.addChild(name1);

            var idnumber = new ccui.Text(""+player.getSrealidnumber(), "微软雅黑", 24);
            if(idnumber){
                name1.addChild(idnumber);
                idnumber.setAnchorPoint(cc.p(0,0.5));
                idnumber.setPosition(cc.p(name1.width+20,name1.height/2));
            }
        }

        var name2 = new ccui.Text("姓    名:", "微软雅黑", 24);
        name2.setColor(cc.color(142,243,255));
        if (name2) {
            name2.enableOutline(cc.color(142,243,255, 255), 1);
            name2.setPosition(cc.p(235, 276));
            name2.setAnchorPoint(cc.p(1, 0.5));
            bg.addChild(name2);

            var playername = new ccui.Text(""+player.getSrealname(), "微软雅黑", 24);
            if(playername){
                name2.addChild(playername);
                playername.setAnchorPoint(cc.p(0,0.5));
                playername.setPosition(cc.p(name2.width+20,name2.height/2));
            }
        }
    },
});
var MusicSetLayer = DialogLayer.extend({
    ctor : function(){
        this._super();
        this.initUI();
    },

    initUI : function(){
        var bg =this.addLayerBg(cc.size(520, 380));
        this.addTitleBg("#fish_vip_res27.png", 530);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(450, 270));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5-10));
        this.initImageViewBtn();
    },

    initImageViewBtn: function () {

        var posArr = [250, 160, 70];
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        var textArr = [FYEngine.LanguageString.getValue(SettingMsgKey.settingMusic), FYEngine.LanguageString.getValue(SettingMsgKey.settingEffect), "震动"];
        for (var i = 0; i < arr.length; i++) {
            var imageView = new ccui.ImageView(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
            imageView.setTouchEnabled(true);
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (temp > 0 && i != 2) {

                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            } else if (temp == 0 && i == 2) {
                imageView.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
            }
            imageView.setName(arr[i]);
            //imageView.attr({x: posArr[i], y: 183, anchorX: 0, anchorY: 1});
            imageView.attr({x: 250, y: posArr[i], anchorX: 0, anchorY: 1});
            this.innerBg.addChild(imageView);
            var textLabel = cc.Label.createWithSystemFont("" + textArr[i], "", 24);
            textLabel.setColor(cc.color("8ef3ff"));
            textLabel.attr({x: 150, y: posArr[i]-16, anchorX: 1, anchorY: 1});

            this.innerBg.addChild(textLabel);
            imageView.addClickEventListener(this.imageViewBtnCallback);
        }

    },

    imageViewBtnCallback: function (sender) {
        var name = sender.getName();
        var image = sender.getRenderFile().file;
        if (image == SettingRes.settingOff1) {
            sender.loadTexture(SettingRes.settingOn1, ccui.Widget.PLIST_TEXTURE);
        } else {
            sender.loadTexture(SettingRes.settingOff1, ccui.Widget.PLIST_TEXTURE);
        }

//        cc.log(name + "-------------" + cc.sys.localStorage.getItem(name));
        if (cc.sys.localStorage.getItem(name) > 0) {
            cc.sys.localStorage.setItem(name, 0);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(false);
                    cc.audioEngine.stopMusic();
                    break;
                case "eftVolum":
                    //cc.audioEngine.stopAllEffects();
                    FYEngine.Audio.setOpenEffect(false);
                    break;
                case "isVibration":
                    break;
            }
        } else {
            cc.sys.localStorage.setItem(name, 1);
            switch (name) {
                case "bgVolum":
                    FYEngine.Audio.setOpenMusic(true);
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
                    break;

                case "eftVolum":
                    FYEngine.Audio.setEffectVolume(0.5);
                    FYEngine.Audio.setOpenEffect(true);
                    break;
                case "isVibration":
                    break;
            }
        }

    },


});