/**
 * Created by mintao on 2016/10/17.
 */

///登录层
var LoginLayerName = {
    Layer1: {
        name: 'layer1',
        register: 'btn1_reg',
        login: 'btn1_log',
    },
    Layer2: {
        name: 'layer2',
        infobg: 'sp1',
        login: 'btn2_log',
        register: 'btn2_reg',
        lost: 'btn2_lost',
        account: 'editaccount',
        password: 'editpassword',
    },
    Loadinglayer: "loadinglayer",
    lobbysmalllayer: 'lobbysmalllayer',
    LoginErrLayer: 'LoginErrLayer',
    UserAgreementLayer :"UserAgreementLayer",
};

//使用的资源名
var UsedResName = {

    Hallbg: 'res/hall/hallbg.png',
    HallLoadingquan: '#loadingquanrevise.png',
    HallLoadingfish: '#loadingfish.png',
    iknowbtn: '#iknow.png',
    ConfirmTitle: '#dialog_15.png',

};

///加载的资源
var LoginResourceName = {
    Png: {
        Commonres1: "res/hall/commonres1.png",
        Commonres2: "res/hall/commonres2.png",
        AccUpdate: "res/updateacc/fishaccountnew.png",
        Wechat: "res/updateqqlogin/fishwechat.png",
        Qlogin: "res/updateqqlogin/fishQlogin.png",
        idverify: "res/updateplayerid/fish_idverifyres.png",
        Vip : "res/updatesend/fishVip.png",
    },
    Plist: {
        Commonres1: "res/hall/commonres1.plist",
        Commonres2: "res/hall/commonres2.plist",
        AccUpdate: "res/updateacc/fishaccountnew.plist",
        Wechat: "res/updateqqlogin/fishwechat.plist",
        Qlogin: "res/updateqqlogin/fishQlogin.plist",
        idverify: "res/updateplayerid/fish_idverifyres.plist",
        Vip : "res/updatesend/fishVip.plist",
    },
    Csb: {
        LoginScene: "res/hall/LoginScene.csb",
    }
};

//提示信息KEY
var LoginMsgKey = {
    networkErrToast: "networkErrToast",
    usernameOrPasswordErrToast: "usernameOrPasswordErrToast",
    username: "username",
    password: "password",
    loadGame: "loadGame",
    Yahei: 'ttfTypeYaHei',
    Arial: "ttfTypeArial",
    serviceDiaLogMsg: 'serviceDiaLogMsg',
    loginTimeOutMsg: "loginTimeOutMsg"
};

var LoginLayer = cc.Layer.extend({
    _layer2show: false,
    _layercount: 0,
    _isAgreeUserText : true,
    ctor: function () {
        this._super();
//        cc.log('-------创建login');
        this.setName(AppSceneName.Login);
        this.loadResources();
        if(appglobal.isVIVOsource()){
            this.initVIVO();
        }else{
            this.init();
        }

        if (FishGlobal.kick == 2) {
            if(appglobal.isVIVOsource()){
                var mstr = ""+FYEngine.LanguageString.getValue("serverKick");
                var layer = new WarmTipLayer(mstr, UsedResName.ConfirmTitle);
                this.addChild(layer, FishZorder.poplayer, "layer_serverKick");
            }else if (appglobal.isWechatLogin) {
                var layer = new WarmTipLayer(FYEngine.LanguageString.getValue("serverKick"), UsedResName.ConfirmTitle);
                this.addChild(layer, FishZorder.poplayer, "layer_serverKick");
            } else {
                if (!FishGlobal.is3rdLogin) {
                    this.showLayer2(true);
                } else {
                    var mstr = ""+FYEngine.LanguageString.getValue("serverKick");
                   
                    var layer = new WarmTipLayer(mstr, UsedResName.ConfirmTitle);
                    this.addChild(layer, FishZorder.poplayer, "layer_serverKick");
                }
            }

        }

        appglobal.isWechatLogin = false;
        //广点通统计接口
        this.gdtApi(100001, 1106059615);

        this.gdtApi2();

        this.gdtApi3();

        this.dspApi1();

        this.dspApi2();

        this.gdtApi4();

        this.gdtApi5();
        //百度推流
        this.ocpcApi1();
        this.ocpcApi2();
        this.ocpcApi3();
		this.ocpcApi4();
        //appglobal.initYXD();
		this.souhu();
    },

    onExit: function () {
        this._super();
        this.unschedule(this.timeOutCheck);
        cc.eventManager.removeCustomListeners(EVENT_3RD_SDK_LOGIN)
    },

    init: function () {
        var that = this;
        this._layer2show = false;
        this._isAgreeUserText = true;

        var layerbg = new cc.Sprite(HallRes.Png.BG);
        layerbg.setAnchorPoint(cc.p(0, 0));
        layerbg.setPosition(cc.p(0, 0));
        this.addChild(layerbg, 0, 0);
        this.initScene();

        var tittle = new cc.Sprite("res/ChannelRes/comtitle.png");
        tittle.setAnchorPoint(cc.p(0.5, 0.5));
        tittle.setPosition(cc.p(573, 486));
        this.addChild(tittle, 0, "tittle");

        this.initKefu();

        this.addAgeTip();

        this.addBFlogo();

        var loginType = app.coreservice.getUserLoginType();
        cc.log('------------login type : ' + loginType);
        // var is3rdLogin = FYEngine.javascriptJavaBridge.is3rdSdkLogin();
        var jsonStr = app.sdkPlugin.callNativeMethod("is3rdSdkLogin", "");
        var is3rdLogin = false;
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined') {
            var json = JSON.parse(jsonStr);
            is3rdLogin = json.is3rdSdkLogin;
            cc.log('------------is3rdLogin## : ' + is3rdLogin);
            FishGlobal.is3rdLogin = appglobal.isBaiduSource()?false :is3rdLogin;
            is3rdLogin = FishGlobal.is3rdLogin;
        }

        cc.log('------------is3rdLogin : ' + is3rdLogin);
        this.initCustomerText();
        this.add3rdSdkLoginListener();

        if (loginType == 1 || is3rdLogin) {
            this._btn1.setVisible(false);
            this._btn2.setVisible(false);
            if (FishGlobal.kick == 2) return;
            this.showLoading();
            if (!is3rdLogin) {
                this.scheduleOnce(this.timeOutCheck, 15);
                this.userQuickLogin();
            } else {
                // 如果账号被踢，不再走第三方登录

                this.scheduleOnce(this.handle3rdSdkLogin, 1);
            }
        } else {
            var cacheUser = eval("(" + app.sdkPlugin.callNativeMethod("getCacheUser", "") + ")");
//            FYEngine.logObject(cacheUser,'------cacheUser---');
            if ((cacheUser.userid != "") && (cacheUser.userid != "0")) {
                this._btn1.setVisible(false);
                this._btn2.setVisible(false);
                this.showLoading();
                this.scheduleOnce(this.timeOutCheck, 15);
                this.userQuickLogin();
            }
        }
    },

    addBFlogo : function(){
        var bf_logo = new cc.Sprite("res/languageString/bf_logo.png");
        if(bf_logo){
            this.addChild(bf_logo, 100, "bf_logo");
            bf_logo.setAnchorPoint(cc.p(1,1));
            bf_logo.setPosition(cc.p(1100,610));
        }
    },

    initKefu : function(){
        if(appglobal._switch1 ==0){
           return;
        }
        var kefutip = new ccui.Text("客服QQ：3003674856","微软雅黑",22);
        if (kefutip) {
            kefutip.setAnchorPoint(cc.p(0, 0.5));
            kefutip.setPosition(cc.p(30, 610));
            kefutip.enableOutline(cc.color("0663b5"),2);
            this.addChild(kefutip, 10, "kefubtn");

        }

    },

    addAgeTip : function(){
        var agetip = new ccui.Text('适合18岁以上使用','微软雅黑',20);
        if(agetip){
            agetip.setAnchorPoint(cc.p(0,0.5));
            agetip.setPosition(cc.p(30,580));
            agetip.enableOutline(cc.color("0663b5"),2);
            this.addChild(agetip,10,"agetip");
        }
    },

    handle3rdSdkLogin: function () {
        var loc = JSON.parse(app.sdkPlugin.getNativeInfo());
        var param = {};
        param.userSdkUrl = appglobal.m_ServiceUserSdkUrl;
        param.locX = loc.location && loc.location.latitude || '0';
        param.locY = loc.location && loc.location.longtitude || '0';
        param.province = loc.location && loc.location.province || '未知';
        param.city = loc.location && loc.location.city || '未知';
        param.sourceid = appglobal.getSource() || 0;
        param.version = 0;

        app.sdkPlugin.callNativeMethod("handle3rdSdkLogin", JSON.stringify(param));
        // FYEngine.javascriptJavaBridge.handle3rdSdkLogin(JSON.stringify(param));
    },
    add3rdSdkLoginListener: function () {
        var self = this;
        cc.eventManager.addCustomListener(EVENT_3RD_SDK_LOGIN, function (event) {
            self.unschedule(self.wechatLogin);
            var data = event.getUserData();
            cc.log('### sdk login user data : ' + JSON.stringify(data));
            var obj = JSON.parse(JSON.stringify(data));
            if (!obj || (obj.result != 0)) {
                if (obj && (obj.result == -100 || obj.result == -300)) {
                    self.removeLoading();
                    FYEngine.AddCommToast("微信尚未登录");
                    return;
                } else if (obj && obj.result == -200) {
                    self.removeLoading();
                    FYEngine.AddCommToast("尚未安装微信客户端");
                    return;
                } else if (obj && (obj.result == -101 || obj.result == -301)) {
                    self.removeLoading();
                    FYEngine.AddCommToast("QQ尚未登录");
                } else if (obj && obj.result == -201) {
                    self.removeLoading();
                    FYEngine.AddCommToast("尚未安装QQ客户端");
                } else if (obj && obj.result == -300) {

                } else if (obj && (obj.result == -400)) {
                    cc.log("----------关闭游戏");
                    FYEngine.closeApp();
                }else if(obj && (obj.result == -10086)){
                    FYEngine.runScene(TempLayer.createScene());
                    return;
                }

                self.runAction(cc.callFunc(function () {
                    FYEngine.AddCommToast('登录失败，请退出游戏重新登录');
                }));
            } else {
                if (!obj.userid) {
                    self.runAction(cc.callFunc(function () {
                        FYEngine.AddCommToast('登录失败，请退出游戏重新登录');
                    }));
                    return;
                }
                if(appglobal.isVIVOsource()){//如果是VIVO且是老账号登录的，则进入下一场景,否则
                    if(self.isOldAcc){
                        FishGlobal.is3rdLogin = false;
                        cc.sys.localStorage.setItem("VIVO_TAG","0");
                        FYEngine.runScene(FourthLayer.createScene());
                    }else{
                        FishGlobal.is3rdLogin = true;
                        cc.sys.localStorage.setItem("VIVO_TAG","1");
                        self.user3rdLogin(obj.userid);
                    }

                }else{
                    self.user3rdLogin(obj.userid);
                }

                // self.scheduleOnce(self.timeOutCheck, 15);
            }
        });
    },

    initScene: function () {
        var mainscene = fycommonfunc.ccsLoadNode(LoginResourceName.Csb.LoginScene);
        this.mainscene = mainscene;

        this.addChild(this.mainscene, 2);
        var layer1  = this._layer1= ccui.helper.seekWidgetByName(mainscene, LoginLayerName.Layer1.name);

        if (appglobal.getSource() == 324
            || appglobal.getSource() == 418
            || appglobal.getSource() == 419
            || appglobal.getSource() == 522
            || appglobal.getSource() == 420
            || appglobal.getSource() == 421
            || appglobal.getSource() == 523
            || appglobal.getSource() == 422
            || appglobal.getSource() == 654) {
            var btn1_reg = layer1.getChildByName(LoginLayerName.Layer1.register);
            var btn1_log = layer1.getChildByName(LoginLayerName.Layer1.login);
            btn1_reg.setSpriteFrame("fish_qqlogin1.png");
            btn1_log.setSpriteFrame("fish_qqlogin2.png");
            btn1_reg.setPosition(cc.p(380, 160));
            btn1_log.setPosition(cc.p(760, 160));
        } else if (this.isWechatLogin()) {
            var btn1_reg = layer1.getChildByName(LoginLayerName.Layer1.register);
            var btn1_log = layer1.getChildByName(LoginLayerName.Layer1.login);
            btn1_reg.setSpriteFrame("fish_wechatlogon.png");
            var animation = new cc.Animation();
            for (var i = 0; i < 15; i++) {
                var sname = 'fish_wechat' + i + '.png';
                var spriteframe = cc.spriteFrameCache.getSpriteFrame(sname);
                animation.addSpriteFrame(spriteframe);
            }
            animation.setRestoreOriginalFrame(true);
            animation.setDelayPerUnit(8 / 60);
            btn1_reg.runAction(new cc.RepeatForever(new cc.Animate(animation)));
            btn1_log.setSpriteFrame("fish_wechataccount.png");

        } else {
            var actionscene = fycommonfunc.ccsLoadAction(LoginResourceName.Csb.LoginScene);
            this.actionscene = actionscene;
            layer1.runAction(this.actionscene);
            this.actionscene.play('animation0', true);
        }



        var self = this;
        var ClickBack = function (sender) {
            self.btnClickCallBack(sender);
        };
        FYEngine.commToastBg = 'commontoast.png';
        var btn1_reg = layer1.getChildByName(LoginLayerName.Layer1.register);
        this._btn1 = btn1_reg;
        FYEngine.AddNodeTouchListener(btn1_reg, ClickBack, FYEngine.ActionType.Dark);

        var btn1_log = layer1.getChildByName(LoginLayerName.Layer1.login);
        this._btn2 = btn1_log;
        if (appglobal._switch13 == 1) {
            FYEngine.AddNodeTouchListener(btn1_log, ClickBack, FYEngine.ActionType.Dark);
        } else {
            btn1_log.setVisible(false);
        }

        this.initPhoneBtnFunc();
        this.initMusiceSet();


    },

    initCustomerText : function(){
        if(FishGlobal.is3rdLogin){
            return;
        }
        var self = this;
        var btnSelect = new ccui.ImageView("fish_vip_res17.png",ccui.Widget.PLIST_TEXTURE);
        if(btnSelect){
            this._layer1.addChild(btnSelect,10,"btnSelect");
            btnSelect.setPosition(cc.p(350,25));
            btnSelect.setTouchEnabled(true);
            btnSelect.addClickEventListener(function(sender){
                if(self._isAgreeUserText){
                    self._isAgreeUserText = false;
                    sender.loadTexture("fish_vip_res18.png",ccui.Widget.PLIST_TEXTURE);
                }else{
                    self._isAgreeUserText = true;
                    sender.loadTexture("fish_vip_res17.png",ccui.Widget.PLIST_TEXTURE);
                }
            })
        }

        var btnText = new ccui.ImageView("fish_vip_res30.png",ccui.Widget.PLIST_TEXTURE);
        if(btnText){
            this._layer1.addChild(btnText,10,"btnUserText");
            btnText.setPosition(cc.p(600,25));
            btnText.setTouchEnabled(true);
            btnText.addClickEventListener(function(sender){
                var layer = self.getChildByName(LoginLayerName.UserAgreementLayer);
                if(!layer){
                    layer = new UserAgreementLayer();
                    self.addChild(layer,FishZorder.poplayer,LoginLayerName.UserAgreementLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });
        }
    },

    initMusiceSet : function(){
        if (!cc.sys.localStorage.getItem("bgVolum") || cc.sys.localStorage.getItem("bgVolum") == 1) {
            FYEngine.Audio.setOpenMusic(true);
            FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
        }
    },

    initPhoneBtnFunc : function(){
        FYEngine.AddCustomLister(this, 'game_on_show', this.loginGameOnShow);
        FYEngine.AddCustomLister(this, 'game_on_hide', this.loginGameOnHide);
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
    },

    loginGameOnHide : function(){
        cc.log("---loginGameOnHide");
        if(cc.sys.os == 'iOS'){
            cc.audioEngine.stopMusic();
        }

    },

    loginGameOnShow: function (event) {
        cc.log("---loginGameOnHide");
        if(cc.sys.os == 'iOS'){
            if (!cc.sys.localStorage.getItem("bgVolum") || cc.sys.localStorage.getItem("bgVolum") == 1) {
                FYEngine.Audio.setOpenMusic(true);
                FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
            }
        }
    },

    userQuickLogin: function () {
        cc.log('-------用户登录');
        app.accountManager.quickLogin();
    },
    user3rdLogin: function (ucusername) {
        cc.log('-------第三方登录');
        app.accountManager.user3rdLogin(ucusername);
    },

    loadResources: function () {
        for (var i in LoginResourceName.Png) {
            cc.director.getTextureCache().addImage(LoginResourceName.Png[i]);
        }
        for (var i in LoginResourceName.Plist) {
            cc.spriteFrameCache.addSpriteFramesWithFile(LoginResourceName.Plist[i]);
        }
    },

    isWechatLogin: function () {
        return appglobal.getSource() == 8000 || appglobal.getSource() == 385 ||appglobal.getSource() == 8001
            || appglobal.getSource() == 646|| appglobal.getSource() == 349|| appglobal.getSource() == 359 ||appglobal.getSource() == 8003
            || (appglobal.isBaiduSource()&& appglobal._switch1 ==1) || (appglobal.getSource()>=785 && appglobal.getSource() <=794)||
            (appglobal.getSource()>=798 && appglobal.getSource() <=802);
    },

    // isBaiduLogin: function () {
    //     return appglobal.getSource() == 308 || appglobal.getSource() == 309 || appglobal.getSource() == 310 || appglobal.getSource() == 311;
    // },

    wechatLogin: function (value) {
        var logintype = value || "";
        FYEngine.javascriptJavaBridge.handleWXLogin(logintype);
    },
    btnClickCallBack: function (sender) {
        if (!sender.isVisible()) {
            return;
        }
        var scene = FYEngine.getRunningLayer(0);
        var name = sender.getName();
        if(scene._isAgreeUserText == false){
            FYEngine.AddCommToast("请同意游戏许可及服务协议");
            return;
        }

        switch (name) {
            case LoginLayerName.Layer1.register:
            case LoginLayerName.Layer2.register: {
                if (!appglobal.isNetwork) {
                    var string = FYEngine.LanguageString.getValue(LoginMsgKey.networkErrToast);
                    if (string) {
                        FYEngine.AddCommToast(string);
                    }

                }
                else {
                    this.showLoading();

                    this._blogin = false;
                    if (appglobal.getSource() == 324
                        || appglobal.getSource() == 418
                        || appglobal.getSource() == 419
                        || appglobal.getSource() == 522
                        || appglobal.getSource() == 420
                        || appglobal.getSource() == 421
                        || appglobal.getSource() == 523
                        || appglobal.getSource() == 422
                        || appglobal.getSource() == 654) {//应用宝微信登录
                        FYEngine.javascriptJavaBridge.handleSdkInit();
                        this.wechatLogin();
                        //this.schedule(this.wechatLogin, 4);
                        appglobal.isWechatLogin = true;
                    } else if (this.isWechatLogin()) {//其他渠道微信登录
                        FYEngine.javascriptJavaBridge.handleSdkInit();
                        this.wechatLogin();
                        //this.schedule(this.wechatLogin, 4);
                        appglobal.isWechatLogin = true;
                    } else {
                        app.accountManager.quickRegister();
                        appglobal.isWechatLogin = false;
                    }

                    //this.schedule(this.refreshLogin, 2);
                    this.scheduleOnce(this.timeOutCheck, 15);
                }
            }
                break;
            case LoginLayerName.Layer1.login:
                //this.actionscene.removeAnimationInfo('animation0');
                if (appglobal.getSource() == 324
                    || appglobal.getSource() == 418
                    || appglobal.getSource() == 419
                    || appglobal.getSource() == 522
                    || appglobal.getSource() == 420
                    || appglobal.getSource() == 421
                    || appglobal.getSource() == 523
                    || appglobal.getSource() == 422
                    || appglobal.getSource() == 654) {//qq登录
                    this.showLoading();

                    this._blogin = false;
                    FYEngine.javascriptJavaBridge.handleSdkInit();
                    this.wechatLogin("1");
                    var self = this;
                    // this.schedule(function(){
                    //     self.wechatLogin("1");
                    // }, 4);
                    appglobal.isWechatLogin = true;
                    this.scheduleOnce(this.timeOutCheck, 15)
                } else {
                    this.showLayer2();
                }
                break;
            case LoginLayerName.Layer2.login: {
                if (!appglobal.isNetwork) {
                    var string = FYEngine.LanguageString.getValue(LoginMsgKey.networkErrToast);
                    if (string) {
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue(LoginMsgKey.networkErrToast));
                    }
                }
                else {

                    var layer2 = ccui.helper.seekWidgetByName(this.mainscene, LoginLayerName.Layer2.name);
                    var infobg = layer2.getChildByName(LoginLayerName.Layer2.infobg);
                    var txt_account = infobg.getChildByName(LoginLayerName.Layer2.account);
                    var txt_passwd = infobg.getChildByName(LoginLayerName.Layer2.password);

                    if (/\s/.test(txt_account.getString()) && txt_account.getString().replace(new RegExp(/\s/g), "") == "") {
                        FYEngine.AddCommToast("账号不能为空");
                        return;
                    }

                    if (!/^[A-Za-z0-9_@.-]{6,18}$/.test(txt_account.getString())) {
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount1));
                        return;
                    }

                    if (txt_account.getString() == "" || txt_passwd.getString() == "") {
                        var string = FYEngine.LanguageString.getValue(LoginMsgKey.usernameOrPasswordErrToast);
                        if (string) {
                            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(LoginMsgKey.usernameOrPasswordErrToast));
                        }
                        return;
                    }

                    this.showLoading();
                    this._blogin = true;
                    //this.UserLogin();
                    // this.schedule(this.refreshLogin, 2);
                    this.scheduleOnce(this.timeOutCheck, 15);
                    this.refreshLogin();
                    appglobal.isWechatLogin = false;
                }
            }
                break;
            case LoginLayerName.Layer2.lost:
                var layer = scene.getChildByName(LobbySceneName.FindPSWenterDialog);
                if (!layer) {
                    var mlayer = new LoginFindPswDialog();
                    //var mlayer = new SourceCheckIDLayer();
                    scene.addChild(mlayer, 99, LobbySceneName.LoginFindPswDialog);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
                break;
        }
    },
    showLayer2: function (toastFlag) {
        var mainscene = this.mainscene;
        var layer1 = ccui.helper.seekWidgetByName(mainscene, LoginLayerName.Layer1.name);
        var layer2 = ccui.helper.seekWidgetByName(mainscene, LoginLayerName.Layer2.name);
        if (this._layer2show) {
            cc.log('已经在layer2');
            return;
        }
        this._layer2show = true;
        if (layer1) {
            layer1.runAction(new cc.Sequence(new cc.MoveBy(0.3, cc.p(-1136, 0)), new cc.CallFunc(function () {
                layer1.removeFromParent();
            })));
        }
        layer2.setVisible(true);
        //layer2.setGlobalZOrder(11);
        layer2.runAction(new cc.Sequence(new cc.MoveTo(0.3, cc.p(0, 0))));

        var self = this;
        var ClickBack = function (sender) {
            self.btnClickCallBack(sender);
        };
        var btn2_log = layer2.getChildByName(LoginLayerName.Layer2.login);
        FYEngine.AddNodeTouchListener(btn2_log, ClickBack, FYEngine.ActionType.Fade);

        var btn2_reg = ccui.helper.seekWidgetByName(layer2, LoginLayerName.Layer2.register);
        var btn2_lost = ccui.helper.seekWidgetByName(layer2, LoginLayerName.Layer2.lost);
        if (this.isWechatLogin()) {
            btn2_reg.loadTextures("fish_wechatl1.png", "fish_wechatl2.png", "", ccui.Widget.PLIST_TEXTURE);
        }
        btn2_lost.addClickEventListener(ClickBack);
        btn2_reg.addClickEventListener(ClickBack);

        var sp_info = layer2.getChildByName(LoginLayerName.Layer2.infobg);
        var editaccount = FYEngine.createEditBox('', cc.size(370, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(LoginMsgKey.username),
            cc.color("#7ef0fe"), cc.color.WHITE, 28, 32);
        editaccount.setPosition(cc.p(116, 147.5));
        editaccount.setAnchorPoint(cc.p(0, 0.5));
        editaccount.setFontSize(26);
        editaccount.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
        sp_info.addChild(editaccount, 100, LoginLayerName.Layer2.account);
        editaccount.setDelegate({
                editBoxEditingDidBegin: function () {
                    editaccount.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    editaccount.setPlaceHolder(FYEngine.LanguageString.getValue(LoginMsgKey.username));
                }
            }
        );
        var editpassword = FYEngine.createEditBox('', cc.size(370, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(LoginMsgKey.password),
            cc.color("#7ef0fe"), cc.color.WHITE, 28, 18);
        editpassword.setDelegate({
                editBoxEditingDidBegin: function () {
                    editpassword.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    editpassword.setPlaceHolder(FYEngine.LanguageString.getValue(LoginMsgKey.password));
                }
            }
        );
        editpassword.setPosition(cc.p(116, 57));
        editpassword.setAnchorPoint(cc.p(0, 0.5));
        editpassword.setFontSize(26);
        editpassword.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
        sp_info.addChild(editpassword, 100, LoginLayerName.Layer2.password);
        if (toastFlag) {
            var mstr = ""+FYEngine.LanguageString.getValue("serverKick");

            var layer = new WarmTipLayer(mstr, UsedResName.ConfirmTitle);
            this.addChild(layer, FishZorder.poplayer, "loginkick");
        }
    },

    /***
     * 显示loading转圈
     */
    showLoading: function () {
        var layer = FYEngine.createLoadingLayer(UsedResName.HallLoadingquan, UsedResName.HallLoadingfish);
        this.addChild(layer, 100, LoginLayerName.Loadinglayer);
        var text_loading = new cc.LabelTTF(FYEngine.LanguageString.getValue(LoginMsgKey.loadGame), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (text_loading) {
            layer.addChild(text_loading, 100, 'text1');
            text_loading.setPosition(cc.p(568, 190));
        }
        return;
    },
    /***
     * 删除loading
     */
    removeLoading: function () {
        var loadlayer = this.getChildByName(LoginLayerName.Loadinglayer);
        if (loadlayer) {
            loadlayer.removeFromParent();
        }
    },
    refreshLogin: function (dt) {
        if (this._blogin) {
            this.UserLogin();
            cc.log('----------登录');
        }
        //else {
        //    app.accountManager.quickRegister();
        //}

    },
    /***
     * 玩家登录
     * @constructor
     */
    UserLogin: function () {
        var layer2 = ccui.helper.seekWidgetByName(this.mainscene, LoginLayerName.Layer2.name);
        var infobg = layer2.getChildByName(LoginLayerName.Layer2.infobg);
        var txt_account = infobg.getChildByName(LoginLayerName.Layer2.account);
        var txt_passwd = infobg.getChildByName(LoginLayerName.Layer2.password);
        var passwdMd5 = hex_md5(txt_passwd.getString()).toUpperCase();
        app.accountManager.userLogin(txt_account.getString(), passwdMd5);
    },

    onSDKEvent: function (action, code) {
        //this.unschedule(this.refreshLogin);
        this.unschedule(this.timeOutCheck);
        if (code != 0) {
            if (!FishGlobal.is3rdLogin) {
                this.removeLoading();
                var layer1 = ccui.helper.seekWidgetByName(this.mainscene, LoginLayerName.Layer1.name);
                if (layer1) {
                    if (this._btn1) {
                        this._btn1.setVisible(true);
                    }
                    if (this._btn2) {
                        this._btn2.setVisible(true);
                    }
                }

                if (code == -111) {
                    var mstr = ""+FYEngine.LanguageString.getValue("loginErr6");

                    var layer = new WarmTipLayer(mstr, UsedResName.ConfirmTitle);
                    this.addChild(layer, FishZorder.poplayer + 10, "kickedbyserver");
                } else if (code == -112 || code == -116) {
                    if(appglobal.isWechatLogin == false){
                        this.showLayer2();
                    }
                } else if (code == -117) {
                    var layer = new KickByServer(1);
                    this.addChild(layer, FishZorder.poplayer + 10, 'kickedbyserver');
                    FYEngine.popupLayerAnimate(layer.layerbg);
                } else if(code == -118){
                    cc.log("-------------弹出-118");
                    var layer = new KickByServer(2);
                    this.addChild(layer, FishZorder.poplayer + 10, 'kickedbyserver');
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }else if(code == -119){
                    cc.log("-------------弹出-119");
                    var layer = new KickByServer(3);
                    this.addChild(layer, FishZorder.poplayer + 10, 'kickedbyserver');
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
                else {
                    var layer = new WarmTipLayer("登录失败，请重启游戏"+code, "#btn_close.png", true);
                    this.addChild(layer, FishZorder.poplayer + 10, "layer_serverKick");
                }
            } else {
                if (code == -111) {
                    var layer = new KickByServer(4);
                    this.addChild(layer, FishZorder.poplayer + 10, "kickedbyserver");
                }else if (code == -117) {
                    var layer = new KickByServer(1);
                    this.addChild(layer, FishZorder.poplayer + 10, 'kickedbyserver');
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
                else if(code == -118){
                    cc.log("-------------弹出-118");
                    var layer = new KickByServer(2);
                    this.addChild(layer, FishZorder.poplayer + 10, 'kickedbyserver');
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }else if(code == -119){
                    cc.log("-------------弹出-119");
                    var layer = new KickByServer(3);
                    this.addChild(layer, FishZorder.poplayer + 10, 'kickedbyserver');
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
                else {
                    var layer = new WarmTipLayer("登录失败"+code, UsedResName.ConfirmTitle, true);
                    this.addChild(layer, FishZorder.poplayer + 10, "layer_serverKick");
                }
            }
        }
    },
    timeOutCheck: function () {
        var layer = this.getChildByName(LoginLayerName.Loadinglayer);
        if(layer){
            layer.removeFromParent();
        }
        FYEngine.AddCommToast(FYEngine.LanguageString.getValue(LoginMsgKey.loginTimeOutMsg));
        if(FishGlobal.is3rdLogin == false && this._layer2show == false){
            this._btn1.setVisible(true);
            this._btn2.setVisible(appglobal._switch13 == 1?true:false);
            if(appglobal.isVIVOsource()){
                this._btn2.setVisible(true);
            }
        }

    },

    phoneKeyCallBack: function (keycode, target) {
        var scene = FYEngine.getRunningLayer(0);
        switch (keycode) {
            case cc.KEY.back : {
                if (scene.getChildByName(LobbySceneName.KickedByServer)
                    || scene.getChildByName('lay4')
                    || scene.getChildByName('layer_serverKick')) {
                    return;
                }
                var layer = scene.getChildByName(LoginLayerName.UserAgreementLayer)
                    ||scene.getChildByName("SourceCheckIDResultLayer")
                    || scene.getChildByName(LobbySceneName.FindPSWenterDialog)
                    || scene.getChildByName(LobbySceneName.LoginFindPswDialog);
                if (layer) {
                    layer.removeFromParent(true);
                    return;
                }
                if (scene.getChildByName(LoginLayerName.lobbysmalllayer)) {
                    scene.getChildByName(LoginLayerName.lobbysmalllayer).removeFromParent();
                } else {
                    var ret = FYEngine.javascriptJavaBridge.is3rdSdkLogout();
                    cc.log('### is3rdSdkLogout = ' + ret);
                    if (!ret) {
                        var exitlay = new ExitGame();
                        if (exitlay) {
                            scene.addChild(exitlay, FishZorder.poplayer, LoginLayerName.lobbysmalllayer);
                            FYEngine.popupLayerAnimate(exitlay.layerbg);
                        }
                    } else {
                        FYEngine.javascriptJavaBridge.handle3rdSdkLogout();
                    }
                }
            }
                break;
        }
    },

    //======================统计接入=============================

    //原始版广点通api方案1
    gdtApi: function (adid, appid) {
        var key = 'gdt_api';
        if (!cc.sys.localStorage.getItem(key)) {
            var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginGDT?service=active&adid=%s&imei=%s&appid=%s';
            Http.getMessage(cc.formatStr(url, adid, appglobal._appCfg.imei, appid), null, function (data) {
                cc.sys.localStorage.setItem(key, 1);
            });
        }
    },

    //新版广点通api方案2
    gdtApi2: function () {
        if (appglobal.getSource() == 418
            || appglobal.getSource() == 419
            || appglobal.getSource() == 522
            || appglobal.getSource() == 420
            || appglobal.getSource() == 421
            || appglobal.getSource() == 523
        ) {
            var key = 'gdt_api_2';
            if (!cc.sys.localStorage.getItem(key)) {
                //var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginOcpc?service=login&imei=%s';
                //var appid = 1106206590;
                //var convType = 'MOBILEAPP_ACTIVITE';
                //var appType = 'android';
                //var advId = 4737064;
                //var data = this.buildData(appid, '', 'a61174df4f2cfb76', 'BAAAAAAAAAAASEgo');
                //cc.log('gdtApi2 tracking successfully->' + cc.formatStr(url, appid, data, convType, appType, advId));

                var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginGDT422?' +
                    'service=active' +
                    '&imei=%s' +
                    '&adid=%s' +
                    '&appid=%s';
                var appid = 1106206590;
                var adid = 100003;
                cc.log('gdtApi2 tracking successfully->' + cc.formatStr(url, appglobal._appCfg.imei, adid, appid));

                //Http.getMessage(cc.formatStr(url, appid, data, convType, appType, advId), null, function (data) {
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei, adid, appid), null, function (data) {
                    var obj = JSON.parse(data);
                    cc.log('gdtApi2 tracking successfully:code->' + obj.code + ",data->" + obj.data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('gdtApi2 tracking successfully');
                    }
                    //}, null, "GET");
                });
            }
        }
    },

    //丰游-自有统计,今日头条
    gdtApi3: function () {
        var key = 'gdt_api3';
        if ((appglobal.getSource() >= 408 && appglobal.getSource() <= 412)
            || (appglobal.getSource() >= 423 && appglobal.getSource() <= 427
            || (appglobal.getSource() >= 429 && appglobal.getSource() <= 438)
            || (appglobal.getSource() >= 526 && appglobal.getSource() <= 530)
                || (appglobal.getSource() >= 538 && appglobal.getSource() <= 542)
                || (appglobal.getSource() >= 558 && appglobal.getSource() <= 577)
                || (appglobal.getSource() >= 333 && appglobal.getSource() <= 334)
                || (appglobal.getSource() >= 353 && appglobal.getSource() <= 354)
                || (appglobal.getSource() >= 336
                || (appglobal.getSource() >= 707 && appglobal.getSource() <= 711))
            )) {
            if (!cc.sys.localStorage.getItem(key)) {
                var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginOcpc?service=login&imei=%s';
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei), null, function (data) {
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('gdtApi3 tracking successfully');
                        // FYEngine.AddCommToast(appglobal.getSource() + '广点通统计');
                    }
                });
            }
        }
    },

    //上海创神ocpa
    gdtApi4: function () {
        var key = 'gdt_api_4';
        if ((appglobal.getSource() == 422)) {
            if (!cc.sys.localStorage.getItem(key)) {
                var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginGDT422?' +
                    'service=active' +
                    '&imei=%s' +
                    '&adid=%s' +
                    '&appid=%s';
                var appid = 1106206590;
                var adid = 100002;
                cc.log('gdt_api_4 tracking ->req' + cc.formatStr(url, appglobal._appCfg.imei, adid, appid));
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei, adid, appid), null, function (data) {
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('gdt_api_4 tracking ->resp' + obj.code);
                    }
                });
            }
        }
    },

    //天睿广点通api方案2
    gdtApi5: function () {
        if (appglobal.getSource() == 516
            || appglobal.getSource() == 517
            || appglobal.getSource() == 518
            || appglobal.getSource() == 519
            || appglobal.getSource() == 520
        ) {
            var key = 'gdt_api_5';
            if (!cc.sys.localStorage.getItem(key)) {
                //var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginOcpc?service=login&imei=%s';
                //var appid = 1106206590;
                //var convType = 'MOBILEAPP_ACTIVITE';
                //var appType = 'android';
                //var advId = 4737064;
                //var data = this.buildData(appid, '', 'a61174df4f2cfb76', 'BAAAAAAAAAAASEgo');
                //cc.log('gdtApi2 tracking successfully->' + cc.formatStr(url, appid, data, convType, appType, advId));

                var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginGDT422?' +
                    'service=active' +
                    '&imei=%s' +
                    '&adid=%s' +
                    '&appid=%s';
                var appid = 1106371114;
                var adid = 100004;
                cc.log('gdtApi5 tracking successfully->' + cc.formatStr(url, appglobal._appCfg.imei, adid, appid));

                //Http.getMessage(cc.formatStr(url, appid, data, convType, appType, advId), null, function (data) {
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei, adid, appid), null, function (data) {
                    var obj = JSON.parse(data);
                    cc.log('gdtApi5 tracking successfully:code->' + obj.code + ",data->" + obj.data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('gdtApi5 tracking successfully');
                    }
                    //}, null, "GET");
                });
            }
        }
    },

    buildData: function (appid, clickid, signkey, encrytkey) {
        //1. 组合参数生成query_string
        var query_string = 'muid=%s&conv_time=%s';
        query_string = cc.formatStr(query_string, hex_md5(appglobal._appCfg.imei).toLowerCase(), Math.floor(Date.now() / 1000));
        //2. 利用query_string构造page
        var page = 'http://t.gdt.qq.com/conv/app/%s/conv?%s';
        page = cc.formatStr(page, appid, query_string);
        //3. 将page进行urlencode得到encode_page
        var encode_page = encodeURIComponent(page);
        //4. 将encode_page组装成property
        var property = '%s&GET&%s';
        property = cc.formatStr(property, signkey, encode_page);
        //5. 利用property生成signature
        var signature = hex_md5(property).toLowerCase();
        //6. 利用signature和query_string生成base_data
        var base_data = '%s&sign=%s';
        base_data = cc.formatStr(base_data, query_string, encodeURIComponent(signature));
        //7. 利用base_data和encrypt_key生成data
        var data = FYEngine.javascriptJavaBridge.simpleXor(base_data, encrytkey);//this.simpleXor(base_data, encrytkey);
        data = new Base64().encode(data);
        data = data.replace(/\r?\n/g, '');
        data = encodeURIComponent(data);
        return data;
    },

    //Mobvista
    dspApi1: function () {
        var key = 'dps_api_1';
        if ((appglobal.getSource() == 485)) {
            if (!cc.sys.localStorage.getItem(key)) {
                var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginDsp?service=login&imei=%s';
                cc.log("dspApi1:imei->" + appglobal._appCfg.imei);
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei), null, function (data) {
                    cc.log("dspApi1:formatStr->" + cc.formatStr(url, appglobal._appCfg.imei));
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('dspApi1 485 tracking successfully');
                    }
                });
            }
        }
    },

    //VidoAds Advertiser Integration Questionnaire
    dspApi2: function () {
        var key = 'dps_api_2';
        if (appglobal.getSource() == 486) {
            if (!cc.sys.localStorage.getItem(key)) {
                // var ip = FYEngine.javascriptJavaBridge.getLocalIp();
                // cc.log('dspApi2:ip->' + ip);
                // if (!ip) return;
                // // appglobal.ip = ip;
                FYEngine.javascriptJavaBridge.getUA();
            }
        }
    },
    //百度推流
    ocpcApi1: function () {
        var key = 'ocpc_api_1';
        if ((appglobal.getSource() >= 346 && appglobal.getSource() <= 349)
        ||(appglobal.getSource() >= 358 && appglobal.getSource() <= 360)) {
            if (!cc.sys.localStorage.getItem(key)) {
                var url ='http://auth.server.phoneunet.com/ttCollect/activeAndLoginBaiduChange1?service=login&imei=%s' +
                '&ua=%s' +
                 '&androidId=%s';
                cc.log("ocpcApi1:imei->" + appglobal._appCfg.imei);
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei,encodeURI(appglobal._appCfg.ua),appglobal._appCfg.androidId), null, function (data) {
                    cc.log("ocpcApi1:formatStr->" + cc.formatStr(url, appglobal._appCfg.imei, appglobal._appCfg.imei,appglobal._appCfg.ua,appglobal._appCfg.androidId));
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('ocpcApi1 tracking successfully');
                    }
                });
            }
        }
    },
    //百度推流2
    ocpcApi2: function () {
        var key = 'ocpc_api_1';
        if (appglobal.getSource() >= 407 && appglobal.getSource() <= 410) {
            if (!cc.sys.localStorage.getItem(key)) {
                var url ='http://auth.server.phoneunet.com/ttCollect/activeAndLoginBaiduChange?service=login&imei=%s' +
                    '&ua=%s' +
                    '&androidId=%s';
                cc.log("ocpcApi1:imei->" + appglobal._appCfg.imei);
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei,encodeURI(appglobal._appCfg.ua),appglobal._appCfg.androidId), null, function (data) {
                    cc.log("ocpcApi1:formatStr->" + cc.formatStr(url, appglobal._appCfg.imei, appglobal._appCfg.imei,appglobal._appCfg.ua,appglobal._appCfg.androidId));
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('ocpcApi1 tracking successfully');
                    }
                });
            }
        }
    },
    //百度推流3
    ocpcApi3: function () {
        var key = 'ocpc_api_1';
        if (appglobal.getSource()==654) {
            if (!cc.sys.localStorage.getItem(key)) {
                var url ='http://auth.server.phoneunet.com/ttCollect//activeAndLoginGDT654?service=active&appid=1106206590&adid=100005&imei=%s';
                cc.log("ocpcApi1:imei->" + appglobal._appCfg.imei);
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei), null, function (data) {
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('ocpcApi1 tracking successfully');
                    }
                });
            }
        }
    },
//百度推流4
    ocpcApi4: function () {
        var key = 'ocpc_api_1';
        if (appglobal.getSource() >= 775 && appglobal.getSource() <= 784) {
            if (!cc.sys.localStorage.getItem(key)) {
				var url ='http://auth.server.phoneunet.com/ttCollect/activeAndLoginBaiduChange1?service=login&appid=10008&adid=10008&imei=%s' +
                    '&ua=%s' +
                    '&androidId=%s';
                cc.log("ocpcApi1:imei->" + appglobal._appCfg.imei);
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei,encodeURI(appglobal._appCfg.ua),appglobal._appCfg.androidId), null, function (data) {
                    cc.log("ocpcApi1:formatStr->" + cc.formatStr(url, appglobal._appCfg.imei, appglobal._appCfg.imei,appglobal._appCfg.ua,appglobal._appCfg.androidId));
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('ocpcApi1 tracking successfully');
                    }
                });
            }
        }
    },
	//搜狐
   souhu: function () {
        var key = 'ocpc_api_1';
        if (appglobal.getSource() >= 798 && appglobal.getSource() <= 802) {
            if (!cc.sys.localStorage.getItem(key)) {
				var url ='http://auth.server.phoneunet.com/ttCollect/loginSohu?service=login&appid=10009&adid=10009&imei=%s';
                cc.log("ocpcApi1:imei->" + appglobal._appCfg.imei);
                Http.getMessage(cc.formatStr(url, appglobal._appCfg.imei), null, function (data) {
                    cc.log("ocpcApi1:formatStr->" + cc.formatStr(url, appglobal._appCfg.imei));
                    var obj = JSON.parse(data);
                    if (obj.code == 0) {
                        cc.sys.localStorage.setItem(key, 1);
                        cc.log('ocpcApi1 tracking successfully');
                    }
                });
            }
        }
    },
	
    initVIVO : function(){

        this.initVIVOdata();

        var layerbg = new cc.Sprite(HallRes.Png.BG);
        layerbg.setAnchorPoint(cc.p(0, 0));
        layerbg.setPosition(cc.p(0, 0));
        this.addChild(layerbg, 0, 0);
        this.initVIVOScene();


        this.add3rdSdkLoginListener();

        this.initVIVOloginMode();
    },

    initVIVOdata : function(){
        appglobal.isWechatLogin = false;
        this._layer2show = false;
        this._isAgreeUserText = true;
        this.isOldAcc = false;
    },

    initVIVOloginMode : function(){
        if (FishGlobal.kick == 2){
            cc.sys.localStorage.setItem("VIVO_TAG","0");
            return;
        }
        var loginType = app.coreservice.getUserLoginType();
        cc.log('------------login type : ' + loginType);

        if(loginType == 1){//有自动登录的标志cache
            this._btn1.setVisible(false);
            this._btn2.setVisible(false);
            this.showLoading();
            if(this.isVIVOtag()){//如果有VIVO标志，就是VIVO自动登录
                FishGlobal.is3rdLogin = true;
                this.isOldAcc = false;
                this.scheduleOnce(this.handle3rdSdkLogin, 1);
            }else{//否则就是老账号账号自动登录
                FishGlobal.is3rdLogin = false;
                this.isOldAcc = true;
                this.scheduleOnce(this.timeOutCheck, 15);
                this.userQuickLogin();
            }
        }
    },

    oldAccountLoginOk : function(){
        if(this.isOldAcc){
            FishGlobal.is3rdLogin = false;
            this.scheduleOnce(this.handle3rdSdkLogin, 1);
        }else{
            FishGlobal.is3rdLogin = true;
            FYEngine.runScene(FourthLayer.createScene());
        }
    },

    isVIVOtag : function(){
        var VIVO_TAG = cc.sys.localStorage.getItem("VIVO_TAG");
        if(VIVO_TAG && VIVO_TAG == "1"){
            return true;
        }else{
            return false;
        }
    },

    initVIVOScene: function () {
        var self = this;
        var ClickBack = function (sender) {
            self.btnVIVOClickCallBack(sender);
        };
        FYEngine.commToastBg = 'commontoast.png';
        var mainscene = fycommonfunc.ccsLoadNode(LoginResourceName.Csb.LoginScene);
        this.mainscene = mainscene;

        this.addChild(this.mainscene, 2);

        var layer1  = this._layer1= ccui.helper.seekWidgetByName(mainscene, LoginLayerName.Layer1.name);
        var btn1_reg = layer1.getChildByName(LoginLayerName.Layer1.register);//VIVO
        this._btn1 = btn1_reg;
        btn1_reg.setSpriteFrame(appglobal.isMEIZUsource()?"meizu_login0.png":"vivo_login0.png");
        btn1_reg.setPosition(cc.p(568,260));
        FYEngine.AddNodeTouchListener(btn1_reg, ClickBack, FYEngine.ActionType.Dark);

        var btn1_log = layer1.getChildByName(LoginLayerName.Layer1.login);//自己账号
        this._btn2 = btn1_log;
        btn1_log.setSpriteFrame("vivo_login2.png");
        btn1_log.setPosition(cc.p(568,120));
        FYEngine.AddNodeTouchListener(btn1_log, ClickBack, FYEngine.ActionType.Dark);

        this.initPhoneBtnFunc();
        this.initMusiceSet();

        var tittle = new cc.Sprite("res/ChannelRes/comtitle.png");
        tittle.setAnchorPoint(cc.p(0.5, 0.5));
        tittle.setPosition(cc.p(573, 486));
        this.addChild(tittle, 0, "tittle");

        this.initKefu();

        this.addAgeTip();

        this.addBFlogo();
    },


    btnVIVOClickCallBack: function (sender) {
        if (!sender.isVisible()) {
            return;
        }
        var scene = FYEngine.getRunningLayer(0);
        var name = sender.getName();

        switch (name) {
            case LoginLayerName.Layer1.register:
            case LoginLayerName.Layer2.register: {
                this.showLoading();
                this.isOldAcc = false;
                this.scheduleOnce(this.handle3rdSdkLogin, 1);
            }
                break;
            case LoginLayerName.Layer1.login:{

                this.showVIVOLayer2();
            }
                break;
            case LoginLayerName.Layer2.login: {
                if (!appglobal.isNetwork) {
                    var string = FYEngine.LanguageString.getValue(LoginMsgKey.networkErrToast);
                    if (string) {
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue(LoginMsgKey.networkErrToast));
                    }
                }
                else {

                    var layer2 = ccui.helper.seekWidgetByName(this.mainscene, LoginLayerName.Layer2.name);
                    var infobg = layer2.getChildByName(LoginLayerName.Layer2.infobg);
                    var txt_account = infobg.getChildByName(LoginLayerName.Layer2.account);
                    var txt_passwd = infobg.getChildByName(LoginLayerName.Layer2.password);

                    if (/\s/.test(txt_account.getString()) && txt_account.getString().replace(new RegExp(/\s/g), "") == "") {
                        FYEngine.AddCommToast("账号不能为空");
                        return;
                    }

                    if (!/^[A-Za-z0-9_@.-]{6,18}$/.test(txt_account.getString())) {
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount1));
                        return;
                    }

                    if (txt_account.getString() == "" || txt_passwd.getString() == "") {
                        var string = FYEngine.LanguageString.getValue(LoginMsgKey.usernameOrPasswordErrToast);
                        if (string) {
                            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(LoginMsgKey.usernameOrPasswordErrToast));
                        }
                        return;
                    }

                    this.showLoading();
                    this._blogin = true;
                    this.isOldAcc = true;
                    // this.schedule(this.refreshLogin, 2);
                    this.scheduleOnce(this.timeOutCheck, 15);
                    this.refreshLogin();
                }
            }
                break;
            case LoginLayerName.Layer2.lost:
                var layer = scene.getChildByName(LobbySceneName.FindPSWenterDialog);
                if (!layer) {
                    var mlayer = new LoginFindPswDialog();
                    //var mlayer = new SourceCheckIDLayer();
                    scene.addChild(mlayer, 2, LobbySceneName.LoginFindPswDialog);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
                break;
        }
    },

    showVIVOLayer2: function (toastFlag) {
        cc.log("showVIVOLayer2");
        var mainscene = this.mainscene;
        var layer1 = ccui.helper.seekWidgetByName(mainscene, LoginLayerName.Layer1.name);
        var layer2 = ccui.helper.seekWidgetByName(mainscene, LoginLayerName.Layer2.name);
        if (this._layer2show) {
            cc.log('已经在layer2');
            return;
        }
        this._layer2show = true;
        if (layer1) {
            layer1.runAction(new cc.Sequence(new cc.MoveBy(0.3, cc.p(-1136, 0)), new cc.CallFunc(function () {
                layer1.removeFromParent();
            })));
        }
        layer2.setVisible(true);

        layer2.runAction(new cc.Sequence(new cc.MoveTo(0.3, cc.p(0, 0))));

        var self = this;
        var ClickBack = function (sender) {
            self.btnVIVOClickCallBack(sender);
        };
        var btn2_log = layer2.getChildByName(LoginLayerName.Layer2.login);
        FYEngine.AddNodeTouchListener(btn2_log, ClickBack, FYEngine.ActionType.Fade);

        var btn2_reg = ccui.helper.seekWidgetByName(layer2, LoginLayerName.Layer2.register);
        if(appglobal.isMEIZUsource()){
            btn2_reg.loadTextures("meizu_login1.png","meizu_login1.png","",ccui.Widget.PLIST_TEXTURE);
        }else{
            btn2_reg.loadTextures("vivo_login1.png","vivo_login1.png","",ccui.Widget.PLIST_TEXTURE);
        }


        var btn2_lost = ccui.helper.seekWidgetByName(layer2, LoginLayerName.Layer2.lost);

        btn2_lost.addClickEventListener(ClickBack);
        btn2_reg.addClickEventListener(ClickBack);

        var sp_info = layer2.getChildByName(LoginLayerName.Layer2.infobg);
        var editaccount = FYEngine.createEditBox('', cc.size(370, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(LoginMsgKey.username),
            cc.color("#7ef0fe"), cc.color.WHITE, 28, 32);
        editaccount.setPosition(cc.p(116, 147.5));
        editaccount.setAnchorPoint(cc.p(0, 0.5));
        editaccount.setFontSize(26);
        editaccount.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
        sp_info.addChild(editaccount, 100, LoginLayerName.Layer2.account);
        editaccount.setDelegate({
                editBoxEditingDidBegin: function () {
                    editaccount.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    editaccount.setPlaceHolder(FYEngine.LanguageString.getValue(LoginMsgKey.username));
                }
            }
        );
        var editpassword = FYEngine.createEditBox('', cc.size(370, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(LoginMsgKey.password),
            cc.color("#7ef0fe"), cc.color.WHITE, 28, 18);
        editpassword.setDelegate({
                editBoxEditingDidBegin: function () {
                    editpassword.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    editpassword.setPlaceHolder(FYEngine.LanguageString.getValue(LoginMsgKey.password));
                }
            }
        );
        editpassword.setPosition(cc.p(116, 57));
        editpassword.setAnchorPoint(cc.p(0, 0.5));
        editpassword.setFontSize(26);
        editpassword.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
        sp_info.addChild(editpassword, 100, LoginLayerName.Layer2.password);
        if (toastFlag) {
            var mstr = ""+FYEngine.LanguageString.getValue("serverKick");

            var layer = new WarmTipLayer(mstr, UsedResName.ConfirmTitle);
            this.addChild(layer, FishZorder.poplayer, "loginkick");
        }
    },
});

LoginLayer.createScene = function () {
    var layer = new LoginLayer();
    var scene = new cc.Scene();
    scene.addChild(layer, 0, 0);
    scene.setName(AppSceneName.Login);
    return scene;
};


var TempLayer = cc.Layer.extend({

    onEnterTransitionDidFinish : function(){
        appglobal._runLobby = false;
        FYEngine.runScene(LoginLayer.createScene());
    },
});

TempLayer.createScene = function(){
    var layer = new TempLayer();
    var scene = new cc.Scene();
    scene.addChild(layer, 0, 0);
    scene.setName("temp");
    return scene;
};

