/**
 * Created by PhoneU on 2018/3/29.
 */


var CopyBattery = ccui.Layout.extend({
    _chairId : 0,
    _bSelf : false,
    _bDown : false,
    _radianx : Math.sin(FYMath.AngletoRadian(0)),
    _radiany : Math.cos(FYMath.AngletoRadian(0)),
    _handler : null,
    _index : 0,
    _type : 0,
    _rate : 0,
    _count : 0,
    _cannon : null,
    _ratelabel : null,
    _bulleteft : null,
    _localBulletArry : [],
    _bRevise : false,
    _cannonRotate : 80,
    _bulletPos : cc.p(0,0),
    _scene : null,
    _actiondone : false,
    _userId : 0,


    ctor : function(){
        this._super();
        this._scene = FYEngine.getRunningLayer(0);
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._userId = this._handler._fishData._userData[0].lRoleId;
        this._rate = this._handler._fishData._userData[0].iRate;
        this._index = 0;
        this._type = FishGlobal.roomId -1 ;
        this._chairId = 0;
        this._bDown = true;
        this._bSelf = true;
        this._bRevise = true;
        this._radianx = Math.sin(FYMath.AngletoRadian(180));
        this._radiany = Math.cos(FYMath.AngletoRadian(180));

        this._count = 1;

        this.setContentSize(cc.size(181,101));
        this.setAnchorPoint(cc.p(0,0));

        this.initBattery();
        this.createUserInfo();
        this.setVisible(false);
    },

    initBattery : function(){
        var self = this;
        var namebg = new cc.Sprite();
        this.addChild(namebg, 1, 'namebg');
        if(appglobal._switch6 ==0){
            namebg.setSpriteFrame('returngold7.png');
            namebg.setFlippedY(true);
            namebg.setAnchorPoint(cc.p(0,0));
            namebg.setPosition(cc.p(0,0));
        }else{
            namebg.setAnchorPoint(cc.p(0,0));
            namebg.setPosition(cc.p(0,0));
            namebg.setSpriteFrame('gameui33.png');
        }

        var name = FYEngine.createLengthText('玩家姓名',18,150);
        name.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        name.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.addChild(name,1,'name');
        name.setAnchorPoint(cc.p(0.5,0.5));
        name.setPosition( cc.p(this.width*0.5,this.height*0.17));

        var batterysprite = this._batterysprite = new cc.Sprite(FishSceneRes.Png.TipsBatteryBg);
        this.addChild(batterysprite,1,'batterybg');
        batterysprite.setAnchorPoint(cc.p(0.5,  0 ));
        batterysprite.setFlippedY(false);

        if(batterysprite){
            var bulleteft = new cc.Sprite();
            batterysprite.addChild(bulleteft, 0, 'bulleteft');
            bulleteft.setAnchorPoint(cc.p(0.5,0.5));
            bulleteft.setVisible(false);
            bulleteft.setSpriteFrame(BatteryRes.BatteryName.BulletEftSelf.format(this._type));
            bulleteft.setPosition(cc.p(batterysprite.width*0.5,125));
            this._bulleteft = bulleteft;

            var cannon = new cc.Sprite();
            batterysprite.addChild(cannon, 0, 'cannon');
            cannon.setAnchorPoint(cc.p(0.5,0.4));
            cannon.setSpriteFrame(BatteryRes.BatteryName.BatterySelf.format(this._type));
            cannon.setPosition(cc.p(batterysprite.width*0.5,60));
            this._cannon = cannon;

            var goldbg = new cc.Sprite(FishSceneRes.Png.TipsGoldBg);
            if(goldbg){
                this._goldbg = goldbg;
                batterysprite.addChild(goldbg,0,'goldbg');
                goldbg.setAnchorPoint(cc.p(0.5,0.5));
                goldbg.setFlippedY(false);
                goldbg.setPosition(cc.p(batterysprite.width*0.5,20));
            }

            var autobtn = new ccui.ImageView(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            autobtn.setTouchEnabled(true);
            autobtn.setSwallowTouches(true);
            autobtn.loadTexture(FishSceneRes.Png.AutoPlayBtn, ccui.Widget.PLIST_TEXTURE);
            autobtn.setPosition(cc.p(-250,80));

            this.addChild(autobtn, 1, 'autobtn');
            autobtn.addClickEventListener(function(sender){
                self.autoBtnClickCallBack(sender);
            });
            this.setPosition(cc.p(955,0));
            batterysprite.setPosition(cc.p(-420,0));

        }

    },


    resetCannon : function(bool){
        this._goldbg.setVisible(true);
        this._cannon.setVisible(true);
        this._ratelabel.setVisible(true);


    },

    createUserInfo : function(){
        var ratetext = this._ratelabel = FYEngine.createAlts('res/num/fishnum5.png', 10, '0', '0');
        this._batterysprite.addChild(ratetext, 0, 'rate');
        ratetext.setPosition(cc.p(this._batterysprite.width*0.5,16));

        if(appglobal._switch6 ==0){
            var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labgold.setPosition(cc.p(31, 47));
            labgold.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(labgold, 1, 'labgold');
            this._labgold = labgold;
        }else{
            var pos = cc.p(31, 83) ;
            var labgold = this._labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labgold.setPosition(pos);
            labgold.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(labgold, 1, 'labgold');

            var pos1 = cc.p(31, 47);
            var labcoupon = this._labcoupon = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labcoupon.setPosition(pos1);
            labcoupon.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(labcoupon, 1, 'labcoupon');
        }
    },

    showUserInfo : function(){
        var userinfo = this._handler._fishData._userData[0];

//        FYEngine.logObject(userinfo,"userinfo:")
        this.setVisible(true);
        var nametext = this.getChildByName('name');
        if(nametext){
                var str = userinfo.szNickName;
                nametext.setString(userinfo.szNickName+'');
                if(nametext.getContentSize().width>150){
                    var newstr = str;
                    var newstr2 = str+"...";
                    nametext.setString(newstr2);
                    while(nametext.getContentSize().width>150){
                        newstr = newstr.substring(0,newstr.length-1);
                        var newstr2 = newstr+"...";
                        nametext.setString(newstr2);
                    }
                    nametext.setString(newstr2);
                }
        }
        this._ratelabel && this._ratelabel.setString(this._rate+'');

        if (this._labgold){
            this._labgold.setString(''+userinfo.lGold);
            if(userinfo.lGold >= 1000000000){

                this._labgold.setAnchorPoint(cc.p(1,0.5));
                if(appglobal._switch6==0){
                    this._labgold.setPosition(cc.p(this.width,47));
                }else{
                    this._labgold.setPosition(cc.p(this.width,83));
                }
            }else{

                this._labgold.setAnchorPoint(cc.p(0,0.5));
                if(appglobal._switch6==0){
                    this._labgold.setPosition(cc.p(31,47));
                }else{
                    this._labgold.setPosition(cc.p(31,83));
                }
            }
        }


        if (this._labcoupon){
            this._labcoupon.setString(''+userinfo.lCoupon);
            if(userinfo.lCoupon >= 1000000000){
                this._labcoupon.setAnchorPoint(cc.p(1,0.5));
                this._labcoupon.setPosition(cc.p(this.width,47));
            }else{
                this._labcoupon.setAnchorPoint(cc.p(0,0.5));
                this._labcoupon.setPosition(cc.p(31,47));
            }
        }

    },

    createBullet  : function(lbulletId, alivetime){
        var self = this;
        var curRotate = self._cannon.getRotation();
        if (self._cannonRotate != curRotate)
        {
            self._cannonRotate = curRotate;
            self._radianx = Math.sin(FYMath.AngletoRadian(self._cannonRotate));
            self._radiany = Math.cos(FYMath.AngletoRadian(self._cannonRotate));
            self._bulletPos = self.getBulletPos(self._cannonRotate);
            self._bulleteft.setRotation(self._cannonRotate);
            self._bulleteft.setPosition(self.getBulletEftPos(self._cannonRotate));
        }

        self._bulleteft.setVisible(true);
        self._bulleteft.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.9), new cc.FadeIn(0.05)),
            new cc.Spawn(new cc.ScaleTo(0.05, 1), new cc.FadeOut(0.05))));

        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.shoot_eft);

        ///添加子弹
        var layer = self._scene._bulletlayer;
        var bullet = Bullet.create(lbulletId, self._type, self._bulletPos,
            self._cannonRotate, FishGlobal.bulletSpeed, self._rate, self._bSelf,
            self._radianx, self._radiany, alivetime, self._userId);
        var tagname = "name"+lbulletId;
        layer.addChild(bullet, 11, tagname);

        self._scene._bulletArr.push(bullet);
        self._handler.changeUserGold(self._chairId, -self._rate);
        self._scene.changeUserGold();
        layer.reSetCount(1);
        self.pushBulletEvent(lbulletId, self._rate);

    },

    autoBtnClickCallBack : function(sender){
        if(this._handler._fishData._userData[this._chairId].lGold< this._rate){
            this.checkNeedSubBatteryLevel();
            return;
        }
        var layer = this._scene._bulletlayer;
        layer.setAutoPlay(!layer.isAutoPlay());
        var btn = this.getChildByName('autobtn');
        if(layer.isAutoPlay()){
            btn.loadTexture(FishSceneRes.Png.AutoPlayOpenBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = btn.getChildByName('autoeft');
            if(!autoeft){
                var autoeft = new cc.Sprite(FishSceneRes.Png.AutoEft);
                if(autoeft){
                    btn.addChild(autoeft,0,'autoeft');
                    autoeft.setPosition(cc.p(btn.width/2,btn.height/2));
                    var rotate = new cc.RotateBy(1.2,360);
                    autoeft.runAction(new cc.RepeatForever(rotate));
                }
            }
        }else{
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = btn.getChildByName('autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },

    shootBullet : function(){
        if (this._actiondone){
            return;
        }

        this._actiondone = true;
        var self = this;
        var xdelta = FYMath.getSinx(8, self._cannon.getRotation());
        var ydelta = FYMath.getCosx(8, self._cannon.getRotation());

        var id = FishGlobal.getAddBulletId(this._chairId);
        self.createBullet(id, 0);
        this._cannon.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.98, 0.9), new cc.MoveBy(0.05,cc.p(-xdelta,-ydelta))), new cc.Spawn(new cc.ScaleTo(0.05, 1),new cc.MoveBy(0.05,cc.p(xdelta,ydelta))), new cc.CallFunc(function(){
            self._actiondone = false;
        })));
    },


    adjustBattery : function(angle){
        this._cannon.setRotation(angle);
        this._bulleteft.setRotation(angle);
        this._bulleteft.setPosition(this.getBulletEftPos(angle));
    },

    shootServerBullet : function(id, rotate, type, rate, alivetime, userid){
        cc.log("shootServerBullet"+id);
        var self = this;
        FishGlobal.bulletId = id;
        self.createServerBullet(id, alivetime);
    },

    createServerBullet  : function(lbulletId, alivetime){
        var self = this;
        var curRotate = self._cannon.getRotation();
        if (self._cannonRotate != curRotate)
        {
            self._cannonRotate = curRotate;
            self._radianx = Math.sin(FYMath.AngletoRadian(self._cannonRotate));
            self._radiany = Math.cos(FYMath.AngletoRadian(self._cannonRotate));
            self._bulletPos = self.getBulletPos(self._cannonRotate);
            self._bulleteft.setRotation(self._cannonRotate);
            self._bulleteft.setPosition(self.getBulletEftPos(self._cannonRotate));
        }


        ///添加子弹
        var layer = self._scene._bulletlayer;
        var bullet = Bullet.create(lbulletId, self._type, self._bulletPos,
            self._cannonRotate, FishGlobal.bulletSpeed, self._rate, self._bSelf,
            self._radianx, self._radiany, alivetime, self._userId);
        var tagname = "name"+lbulletId;
        layer.addChild(bullet, 11, tagname);

        self._scene._bulletArr.push(bullet);
        self._handler.changeUserGold(self._chairId, -self._rate);
        self._scene.changeUserGold();
        layer.reSetCount(1);
    },

    getBulletPos : function(rotation){
        var pos = this.getPosition();
        if (this._bDown){
            pos.y += 60;
        }
        else{
            pos.y -= 60;
        }

        var r = 50;
        var rotate = this._bDown ? rotation : rotation-180;
        if (this._bDown && rotate >= 270){
            rotate -= 360;
        }

        var offx = r*Math.sin(Math.abs(FYMath.AngletoRadian(rotate)));
        var offy = r*Math.cos(Math.abs(FYMath.AngletoRadian(rotate)));
        if (rotate == 0){
            pos.y -= r;
        }
        else if (rotate > 0){
            if(this._bDown){
                pos.x += Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x -= Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        else{
            if(this._bDown){
                pos.x -= Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x += Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        return pos;
    },

    getBulletEftPos : function(rotation){
        var pos = this._cannon.getPosition();

        var r = 65;
        var rotate = this._bDown ? rotation : rotation-180;
        if (this._bDown && rotate >= 270){
            rotate -= 360;
        }

        var offx = r*Math.sin(Math.abs(FYMath.AngletoRadian(rotate)));
        var offy = r*Math.cos(Math.abs(FYMath.AngletoRadian(rotate)));
        if (rotate == 0){
            pos.y -= r;
        }
        else if (rotate > 0){
            if(this._bDown){
                pos.x += Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x -= Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        else{
            if(this._bDown){
                pos.x -= Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x += Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        return pos;
    },

    pushBulletEvent : function(lbulletId, iRate){
        var iRotate =this._cannon.getRotation();
        var iChairId = this._chairId;
        var iType = this._type;
        this._handler.sendFireBulletReq(iChairId,lbulletId,iRate,iRotate,iType)
    },


    getRate : function(){
        return this._rate;
    },

    changeUserGold : function(lGold){
        cc.log("1changeUserGold"+lGold);
        if (this._labgold){
            this._labgold.setString(''+lGold);
            if(lGold>=1000000000){
                if(this._labgold.getAnchorPoint().x ==1){
                    return;
                }else{
                    this._labgold.setAnchorPoint(cc.p(1,0.5));

                    if(appglobal._switch6==0){
                        this._labgold.setPosition(cc.p(this.width,47));
                    }else{
                        this._labgold.setPosition(cc.p(this.width,83));
                    }
                }
            }else{
                if(this._labgold.getAnchorPoint().x == 0){
                    return;
                }else{
                    this._labgold.setAnchorPoint(cc.p(0,0.5));

                    if(appglobal._switch6==0){
                        this._labgold.setPosition(cc.p(31,47));
                    }else{
                        this._labgold.setPosition(cc.p(31,83));
                    }
                }
            }
        }
    },

    changeUserCoupon : function(lCoupon){
        if (this._labcoupon){
            this._labcoupon.setString(''+lCoupon);
        }
    },

    checkNeedSubBatteryLevel : function(){
        var userinfo = this._handler._fishData._userData[this._chairId];
        if(userinfo.lGold<this._rate){
            // if(FishGlobal.relivelimit != 0){
            //     var mlayer = this._scene.getChildByName('jiuji');
            //     if(!mlayer){
            //         mlayer = new ReliveLayer();
            //         this._scene.addChild(mlayer, FishZorder.poplayer, 'jiuji');
            //         FYEngine.popupLayerAnimate(mlayer.layerbg);
            //     }
            // }else{
                var mlayer = this._scene.getChildByName(FishCopyLobbyLayer.CopyTimeOutLayer);
                if(!mlayer){
                    mlayer = new CopyTimeOutLayer(0);
                    this._scene.addChild(mlayer, FishZorder.poplayer+9, FishCopyLobbyLayer.CopyTimeOutLayer);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            // }
        }
    },


    getPosition : function(){
        var pos = cc.p(535,0);
        return pos;
    },

    resetBattery : function(){
        this._type = 0;
        this._rate = 0;
        this._cannon.setRotation(0);
        this._bulleteft.setSpriteFrame(BatteryRes.BatteryName.BulletEftSelf.format(0));
        this.resetCannon();
    },


});

var FishCopyBulletLayer = cc.Layer.extend({
    _bTouched : false,
    _bulletCount : 0,
    _isAutoPlay : false,
    _shoottime : 0,
    _touchtime : -1,
    _scene : null,
    _timeCount : 0,
    _time : 0,
    _posarr : [],
    _endtimemark:0,
    _arrlength :0,
    _startcount : 0,
    _lastposid:0,
    _handler : null,
    _canOpenFire : true,
    _noverrange:true,//没有超过数量
    _hastoomore:false,

    ctor : function(){
        this._super();
        this._scene = FYEngine.getRunningLayer(0);
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this.createBulletPool();
        this.createFishNetPool();
        this._posarr = [];
        this._endtimemark = 0;
        this._arrlength=0;
        this._startcount =0;
        this._lastposid=0;
        this._noverrange =true;
        this._hastoomore =false;

        ///触摸监听
        this.addTouchListener();
        this.schedule(this.updateFire,0.033);
        //this.schedule(this.openFire,FishGlobal.bulletTimes);
        //this.schedule(this.update, 1/30);
    },

    openFire : function(){
        if ((this._isAutoPlay || this._bTouched)&&this._handler._fishData._fishTideControl && this._canOpenFire){
            //cc.log('发射子弹---------------------'+this._bTouched);
            var handlerMsg = this._handler._fishData;
            this._scene.shootBullet(handlerMsg._selfId);
            this._timeCount = 0;
            var mlayer = this._scene.getChildByName('timeoutlayer');
            if(mlayer){
                mlayer.removeFromParent(true);
            }
        }
    },

    createBulletPool : function(){

    },

    createFishNetPool : function(){

    },

    updateFire : function(dt){
        var self = this;
        if(this._handler._canSendNormalMsg == false){
//            cc.log('-------断线了');
            return;
        }
        if(this._startcount ==1){
            this._endtimemark += dt;
            if(this._endtimemark > 1){
                this._startcount = 0;
                this._endtimemark = 0;
                this._posarr.splice(this._lastposid);
                //this._arrlength = this._arrlength - 1;
                if(this._posarr.length ==!0){
                    var angle =this.caculateFinalAngleByArry(this._handler.getSelfId(),this,this._posarr);
                    this._scene.adjustBattery(this._handler.getSelfId(), angle);
                }

            }
        }

        if(this._bulletCount <=15){

            this._noverrange = true;
            if(this._hastoomore){
                var layer = this._scene.getChildByName("toomore");
                if (layer) {
                    layer.removeFromParent(true);
                }
                this._hastoomore = false;
            }

        }

        if (this._bulletCount == 30){

            if(this._noverrange ==true){
                if(this._isAutoPlay||this._bTouched){
                    //this._canOpenFire = false;
                    var layer = this._scene.getChildByName("toomore");
                    if (!layer) {
                        this._hastoomore =true;
                        // this._bTouched = false;
                        layer = new DialogLayer();
                        this._scene.addChild(layer, FishZorder.poplayer, "toomore");
                        var bg = layer.addLayerBg(cc.size(612, 303));
                        var toast = new cc.Sprite(FishSceneRes.Png.tooMoreToast);
                        toast.setPosition(cc.p(bg.width / 2, 207));
                        bg.addChild(toast);
                        var self =this;
                        var confirmCallBack = function (sender) {
                            self._hastoomore =false;
                            sender.getParent().getParent().removeFromParent(true);
                            //self._canOpenFire = true;
                        };
                        layer.addConfirmBtn(confirmCallBack, cc.p(bg.width / 2, 74),"#iknow.png");
                    }
                }
                this._noverrange = false;
            }

            return;
        }
        if ((this._isAutoPlay || this._bTouched)&&this._noverrange){
            //cc.log('发射子弹---------------------'+this._bTouched);
            if (this._shoottime == 0){
                var handlerMsg = this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._shoottime += dt;
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
                return;
            }

            this._shoottime += dt;
            if (this._shoottime >= FishGlobal.bulletTimes){
                this._shoottime = 0.0001;
                var handlerMsg =this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
            }
        }
    },


    reSetCount : function(addnum){
        this._bulletCount += addnum;
        if (this._bulletCount > 30){
            this._bulletCount = 30;
        }
        else if (this._bulletCount < 0){
            this._bulletCount = 0;
        }
    },

    getTouched : function(){
        return this._bTouched;
    },

    addTouchListener : function(){
        var self = this;
        var selfId = self._handler.getSelfId();
        var listener = cc.EventListener.create({
            event : cc.EventListener.TOUCH_ALL_AT_ONCE,
            swallowTouches: true,
            onTouchesBegan: function (touches, event) {
                var target = event.getCurrentTarget();
                //cc.log('--------'+touches[0].getId());
                target._startcount = 0;
                target._endtimemark = 0;
                //FYEngine.logObject(touches[0].getID(),'------------START ID :');
                target._posarr.push(touches[0].getLocation());
                target._arrlength = target._arrlength+1;
                var angle =target.caculateFinalAngleByArry(selfId,target,target._posarr);

                self._scene.adjustBattery(selfId, angle);
                self._noverrange = true;
                if(self._isAutoPlay){

                    self._scene.setTouchEffect(touches[0].getLocation());
                }
                else{
                    target._bTouched = true;
                    target._shoottime = 0;
                    self._scene.setTouchEffect(touches[0].getLocation());
                }
                return true;
            },

            onTouchesMoved : function(touches, event){
                var target = event.getCurrentTarget();
                target._startcount = 0;
                target._endtimemark = 0;
                target._arrlength = touches.length;
                var angle =target.caculateFinalAngle(selfId,target,touches);
                self._scene.adjustBattery(selfId, angle);
                //FYEngine.logObject(touches,'------------moved Final angel :');
                //self._scene.adjustBattery(selfId, pos);
            },

            onTouchesCancelled : function(touches, event){
                var target = event.getCurrentTarget();
                //cc.log('cancel----------------------');
                target._bTouched = false;
            },

            onTouchesEnded: function (touches, event) {
                //cc.log('ended----------------------');
                //FYEngine.logObject(touches[0].getID(),'--------------END ID');

                var target = event.getCurrentTarget();
                if(target._arrlength ==1 && target._posarr.length ==1){
//                    cc.log('test1');
                    target._startcount = 0;
                    target._endtimemark = 0;
                    target._posarr=[];
                    target._arrlength = 0;
                    target._bTouched = false;
                }else{
                    if(target._arrlength == target._posarr.length){
//                        cc.log('test2');
                        target._endtimemark = 0;
                        //FYEngine.logObject(touches[0].getID(), '---------------77777777777777777777------------');
                        target._lastposid =touches[0].getID();
                        target._startcount = 1;
                        target._arrlength =target._arrlength-1;
                    }else{
//                        cc.log('test3');
                        //FYEngine.logObject(touches[0].getID(), '---------------8888888888888888888------------');
                        target._startcount = 0;
                        target._endtimemark = 0;
                        target._arrlength =target._arrlength-1;
                        target._posarr.splice(touches[0].getID());
                        target._posarr.splice(target._lastposid);
                        if(target._posarr.length !=0){
                            var angle =target.caculateFinalAngleByArry(selfId,target,target._posarr);
                            self._scene.adjustBattery(selfId, angle);
                        }else{
                            target._bTouched = false;
                        }
                    }
                }
            },
        });
        cc.eventManager.addListener(listener, this);
    },

    isAutoPlay : function(){
        return this._isAutoPlay;
    },

    setAutoPlay : function(status){
        this._isAutoPlay = status;
        this._shoottime = 0;
        this._noverrange = true;
    },

    caculateFinalAngleByArry : function(selfId,target,arry){
        var sum = 0;
        for(var i =0;i<arry.length;i++){
            var angle =target.caculateAngle(selfId,arry[i]);
            sum+=angle;
        }
        return sum/arry.length;
    },

    caculateFinalAngle : function(selfId,target,touches){
        var sum = 0;
        for(var i = 0;i < touches.length; i++){
            var angle = target.caculateAngle(selfId, touches[i].getLocation());
            this._posarr[i] = touches[i].getLocation();
            sum += angle;
        }
        return sum/touches.length;
    },

    caculateAngle : function(selfId,endpos){

        var battery = this._scene.getBattery(selfId);
        var pos = battery.getPosition();
        if (battery._bDown){
            pos.y += 60;
        }
        else{
            pos.y -= 60;
        }

        var rotate = FYMath.getAngle(pos.x, pos.y, endpos.x, endpos.y);
        if(battery._bDown){
            if(-180 <= rotate && rotate< (-90)){
                rotate = -90;
            }else if(180 > rotate && rotate >90){
                rotate = 90;
            }else if(180 <= rotate && rotate< 270){
                rotate = -90;
            }
        }else{
            if(rotate >=0 && rotate <90){
                rotate = 90;
            }else if( 270<rotate && rotate<360){
                rotate = 270;
            }else if(-90<rotate && rotate<0){
                rotate = 270;
            }
        }
        return rotate;
    }

});

var copyTool = cc.Sprite.extend({
    _type : 0,

    ctor : function(type){
        this._super();
        this._type = type;
        var framename = "";
        if(type == FishGlobal.WealthType.beike){
            framename = "fish_copy_22.png";
        }else if(type == FishGlobal.WealthType.shuijing){
            framename = "fish_copy_21.png";
        }else if(type == FishGlobal.WealthType.shanhu){
            framename = "fish_copy_19.png";
        }else if(type == FishGlobal.WealthType.haixing){
            framename = "fish_copy_20.png";
        }else if(type == FishGlobal.WealthType.zhenzhu){
            framename = "fish_copy_23.png";
        }
        this.setSpriteFrame(framename);
        this.setScale(0.1);

        var numberbg = new ccui.ImageView("fish_copy_100.png",ccui.Widget.PLIST_TEXTURE);
        if(numberbg){
            this.addChild(numberbg,0,"numberbg");
            numberbg.setPosition(cc.p(this.width/2,0));

            var number = FYEngine.createAlts('res/updatepackmail/fish_copy_num.png', 11, '0', '/');
            if(number){
                numberbg.addChild(number,0,"number");
                number.setPosition(cc.p(numberbg.width/2,numberbg.height/2));
            }
        }
    },

    setNumber : function(num){
        var number = this.getChildByName("numberbg").getChildByName("number");
        if(number){
            number.setString(""+num);
        }
    },

    startTomove : function(beginpos, endpos){
        var self = this;
        var action1 = new cc.ScaleTo(0.2,1);
        var action2 = new cc.MoveBy(0.4,cc.p(0,15));
        var action3 = new cc.MoveBy(0.4,cc.p(0,-15));
        var action4 = new cc.MoveBy(0.5,cc.p(0,20));
        var action5 = new cc.MoveBy(0.5,cc.p(0,-20));
        var distance = FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y);
        var action6 = new cc.MoveTo(distance*0.001, endpos);
        var action7 = new cc.ScaleTo(distance*0.001,0.1);
        this.runAction(new cc.Sequence(action1,action2,action3,action4,action5,
            new cc.Spawn(action6,action7),new cc.CallFunc(function(){
                FYEngine.pool.putInPoolbyTag(self, self._type);
            })));
    },

    unuse : function(){
        this.setScale(0.1);
        this.setVisible(false);
        this.stopAllActions();
        this.removeFromParent(true);
    },

    reuse : function(){
        this.setScale(0.1);
        this.setVisible(true);
    },

});

copyTool.create = function(type,num){
    var gold = null;
    if (FYEngine.pool.hasObjectbyTag(copyTool, type)){
        gold = FYEngine.pool.getFromPoolbyTag(copyTool, type);
    }
    else{
        cc.log('------------copyTool缓存不足'+type);
        gold = new copyTool(type);
    }
    gold.setNumber(num);
    return gold;
};
