/**
 * Created by PhoneU on 2018/3/29.
 */

var FishCopyLayer = cc.Layer.extend({
    _handler : null,
    _lobbyhandler : null,
    _heartBeatCount : 0,
    eupdateflag : false,
    _fishArr:[],
    _bulletArr:[],
    _selfBulletArr : [], //自己的子弹数组
    _playerNode:null,
    mainscene : null,
    eventTime : 0,
    _SyncTable : 0,
    m_tideIn : false,//鱼潮来了
    _tideCount : 0,//鱼潮计数 >1必出海浪特效
    _isVibrationSwitch : 1,
    _bulletlayer : null,
    _broadSp : null,
    _tideArr : [],
    ejoinflag : false,
    eleaveflag : false,
    ekillflag : false,
    eshootflag : false,
    ehitflag : false,
    echangeflag : false,
    _birtharr : [],
    _vibrationend : false,
    _inittime :false,
    _Nlock:false,
    _needProtect : true,
    _gameLeftTime :0,

    ctor : function(){
        this._super();
        this.setName('fishcopyscene');
        FishGlobal.bInFishScene = true;
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._handler.setScene(this);
    },

    onEnter : function(){
        this._super();
        this.init();
    },

    init : function(){
        this.initData();
        this.initBGLayer();
        this.initGameLayer();
        this.initEffectLayer();
        this.initUILayer();
        this.initPhoneBtnCallBack();
        this.initBackGroundMusic();
        this.scheduleUpdate();
        if(appglobal._switch7==1){
            this.createBroadCast();
        }

        if(appglobal._switch21 == 0){
            var player = appglobal.getPlayer();
            if(player.realIDnumber == "" ||!player.isAdult){
                this.schedule(this.writeLawRecord,60);
            }
        }

    },

    createBroadCast : function(){
        var size = FYEngine.winSize;
        var _broadSp = new LobbyBroadCast('fishbroadbg2.png', cc.size(825, 37), null,
            cc.size(790, 39), cc.p(1.5, 0), 3, ccui.Widget.PLIST_TEXTURE, false);
        _broadSp.setVisible(false);
        _broadSp.setPosition(cc.p(size.width/2, size.height/2));
        this.addChild(_broadSp, FishZorder.BroadLayer);
        //this.addLobbyWarnBroad();
    },

    addLobbyWarnBroad : function(){
        var tempbr = {};
        tempbr.lUserId =1000000;
        tempbr.iArea = 100;
        tempbr.iShowType = 100;
        tempbr.iLevel = 1;
        tempbr.iGameId = 1;
        tempbr.iMsgLen = 255;
        tempbr.szMsg = "[phoneu]倡导绿色游戏，享受健康生活，游戏内禁止一切违法行为[/phoneu]";
        CoreServiceProxy.getInstance().getLobbyHandler()._lobbyData.putLobbyBroad(tempbr);
    },

    writeLawRecord : function(){

        var player = appglobal.getPlayer();
        if(player.realIDnumber != "" && player.isAdult){
            this.unschedule(this.writeLawRecord);
            return;
        }
        var date = new Date();
        var currentRecordTime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(currentRecordTime){
            var totaltime = Number(currentRecordTime)+1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                totaltime+"");
            cc.log('-----------------1分钟计时一次已经游戏时间'+totaltime);
            if(totaltime<FishGlobal.lostTime.controllevel1){
                if((totaltime%FishGlobal.lostTime.duration1) == 0){//3小时内每小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }else if(totaltime==FishGlobal.lostTime.controllevel1){
                this.showAvoidLayer(totaltime);
            }else if(totaltime>FishGlobal.lostTime.controllevel1 && totaltime<FishGlobal.lostTime.controllevel2){
                if((totaltime%FishGlobal.lostTime.duration2) == 0){//3~5小时内每半小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }else if(totaltime==FishGlobal.lostTime.controllevel2){
                this.showAvoidLayer(totaltime);
            }else{
                if((totaltime%FishGlobal.lostTime.duration3) == 0){//5小时后每15分钟弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }
        }else{
            var totaltime = 1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                totaltime+"");
        }

    },

    showAvoidLayer : function(totaltime){
        var layer = this.getChildByName(LobbySceneName.AvoidGameLostTip);
        if(!layer){
            layer = new AvoidGameLostTip(totaltime);
            this.addChild(layer, FishZorder.poplayer,LobbySceneName.AvoidGameLostTip)
        }else{
            layer.refreshUI(totaltime);
        }
    },

    writeLocalIDverifyRecord : function(){
        cc.log('-----------------2分钟计时一次');
        if(FishGlobal.playGameTime<0){
            FishGlobal.playGameTime =0;
        }

        var date = new Date();
        var playergametime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(playergametime){
            var record = Math.floor(FishGlobal.playGameTime);
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate(), record+"");
        }else{
            var player = appglobal.getPlayer();
            if(player.realIDnumber == ""){
                FishGlobal.playGameTime = FishGlobal.idControl.noid.totalgametime;
            }else{
                if(player.isAdult){
                    FishGlobal.playGameTime = FishGlobal.idControl.adult.totalgametime;
                }else{
                    FishGlobal.playGameTime = FishGlobal.idControl.child.totalgametime;
                }
            }
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate(), FishGlobal.playGameTime+"");
        }

    },

    createUpdate : function (dt) {
        this._handler._gametime += dt;
        if (this.eupdateflag){
            return;
        }

        this.eupdateflag = true;
        var i = 0;
        var info = null;
        for (; i < this._handler._unbirthFishArr.length; ++ i){
            info = this._handler._unbirthFishArr[i];
            if (this._handler._gametime < info.iBirthTime){
                break;
            }
        }

        if (i == 0){
            this.eupdateflag = false;
            return;
        }

        this._birtharr = this._handler._unbirthFishArr.splice(0, i);
        var fish = null;
//        cc.log("-----创建鱼数量 this._birtharr.length : "+this._birtharr.length);
        for(var j = 0; j < this._birtharr.length; ++ j){
            var protype = FishGlobal.getFishPropsType(this._birtharr[j].iFishType);
            if (protype == FishPropsType.Plate){
                fish = PlateFish.create(this._birtharr[j]);
            }
            else {
                fish = CommFish.create(this._birtharr[j]);
            }

            fish._bTideFish = false;
            if(this._birtharr[j].tidefish == 0){
                fish._bTideFish = true;
            }

            var zorder = this.getFishZorder(fish._clientType, fish._serverType);
            this.addChild(fish, zorder, this._birtharr[j].iFishId);
            this._fishArr.push(fish);
        }

        this.eupdateflag = false;
    },

    getFishZorder : function(clienttype, servertype){
        var zorder = servertype;
        if (servertype == FishServerType.Fish21){
            zorder = FishZorder.fishMax;
        }
        else if (clienttype >= FishClientType.Fish24 &&
            clienttype <= FishClientType.Fish30){
            zorder = FishZorder.fishMid;
        }
        return zorder;
    },

    updateschedule : function(callback, interval){
        var then = Date.now();
        interval = interval*1000;
        this.schedule(function(){
            var now = Date.now();
            var delta = now-then;
            if (delta > interval){
                then = now - (delta%interval);
                callback.call(this);
            }
        }.bind(this), 0);
    },

    update : function(dt){
        if(this._handler && this._handler._canSendNormalMsg){
            this.checkObbCollision();
        }

        this.createUpdate(dt);
        this.checkShootEvents();
        this.checkHitEvents();
        this.checkKillEvents();
    },

    checkIDcount : function(dt){
        FishGlobal.playGameTime-=dt;
    },

    initData : function(){
        FishGlobal.bInFishScene = true;
        this._bulletArr =[];
        this._fishArr = [];
        FishGlobal.needCharge = 0;
        FishGlobal.InterNumber = 0;
        this._inittime =false;
        this._Nlock = false;
        FishGlobal.isLobbyRecord = false;
        this._needProtect = true;
        this._gameLeftTime = FishGlobal.copyTimeControl.copyGameLeftTime;
        // this._gameLeftTime = 10;
        cc.log("------剩余时间："+this._gameLeftTime);
    },

    freeModeSchedule : function(){
        this._gameLeftTime--;
        if(this._gameLeftTime <= 0){
            //this.unschedule(this.freeModeSchedule);
            this._gameLeftTime =0;
            this.popTimeOutLayer();
        }
        var timesp = FYMath.formatRecountDateShort(this._gameLeftTime);
        cc.log(this._gameLeftTime+"----------------剩余时间"+timesp);
        this._timesp.setString(""+timesp);

    },

    popTimeOutLayer : function(){
        cc.log("popTimeOutLayer");
        var mlayer = this.getChildByName(FishCopyLobbyLayer.CopyTimeOutLayer);
        if(!mlayer){
            mlayer = new CopyTimeOutLayer(1);
            this.addChild(mlayer, FishZorder.poplayer+9, FishCopyLobbyLayer.CopyTimeOutLayer);
            FYEngine.popupLayerAnimate(mlayer.layerbg);
        }

        if(this._bulletlayer.isAutoPlay()){
            this._bulletlayer.setAutoPlay(false);
            var btn = FYEngine.getChild(this._playerNode,'autobtn');
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = FYEngine.getChild(btn, 'autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },

    initPhoneBtnCallBack : function(){
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this,'game_on_show',this.gameOnShowEvent);
        FYEngine.AddCustomLister(this,'game_on_hide',this.testGameOnHide);
    },

    testGameOnHide : function(){
        cc.log("---testgameonhide");
        cc.audioEngine.stopMusic();
        if(FishGlobal.bInFishScene == true){
            // FishGlobal.tipout = 1;
            this.exitGame();

        }
    },

    initBroadCast : function(){
        var size = FYEngine.winSize;
        this._broadSp = new FishBroadCast(FishSceneRes.Png.FishBroadBg, cc.size(825, 44), null,
            cc.size(815, 39), cc.p(1.5, 2.5), 3.5, ccui.Widget.PLIST_TEXTURE, false);
        this._broadSp.setVisible(false);
        this._broadSp.setPosition(cc.p(size.width/2, size.height/2));
        this.addChild(this._broadSp, FishZorder.BroadLayer);
    },

    onGameEvent : function(event_id, event_param){
        switch (event_id){
            case FishGameEventID.unConnect:{
                this.onUnconnect(event_param);
                if(event_param == 1 && this._needProtect){
                    this._needProtect = false;
                    this.protectUser();
                }else{
                    this._needProtect = true;
                }
            }break;
            case lobbyGameEvent.refreshSelfRank :{

            }break;
            case lobbyGameEvent.GetFreeRankOuter:{

            }break;
            case FishGameEventID.firespecial:{

            }break;
            case FishGameEventID.hitspecial:{

            }break;
            case lobbyGameEvent.refreshWealth : {
                this.changeWealth();
            }break;
            default : break;
        }
    },

    protectUser : function(){
        cc.log("protectUser");
        for(var i =0; i<this._bulletArr.length;++i){
            this._bulletlayer.reSetCount(-1);
            this._bulletArr[i].openFishNet();
        }
        if(this._bulletlayer.isAutoPlay()){
            this._bulletlayer.setAutoPlay(false);
            var btn = FYEngine.getChild(this._playerNode,'autobtn');
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = FYEngine.getChild(btn, 'autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },



    checkUpdateFishEvents : function(){
        if (this.eupdateflag){
            return;
        }

        var data = this._handler._fishData;
        if (data._eFishArry.length == 0){
            return;
        }

        this.eupdateflag = true;
        this.onUpdateFishEvents(data._eFishArry);
        data._eFishArry = [];
        this.eupdateflag = false;
    },

    onUpdateFishEvents : function(eFishArray){
        for(var i = 0; i < eFishArray.length; ++ i){
            for(var j = 0; j< eFishArray[i].iCount;++j){
                var fish = this.getFishbyIdFormArr(eFishArray[i].fishArry[j].iFishId);
                if (!fish){
                    var protype = FishGlobal.getFishPropsType(eFishArray[i].fishArry[j].iFishType);
                    if (protype == FishPropsType.Plate){
                        fish = PlateFish.create(eFishArray[i].fishArry[j]);
                    }
                    else {
                        fish = CommFish.create(eFishArray[i].fishArry[j]);
                    }
                    fish._bTideFish = false;
                    if(eFishArray[i].fishArry[j].tidefish == 0){
                        fish._bTideFish = true;
                    }
                    var zorder = fish._serverType;
                    if (fish._serverType == FishServerType.Fish21){
                        zorder = FishZorder.fishMax;
                    }
                    else if (fish._clientType >= FishClientType.Fish24 &&
                        fish._clientType <= FishClientType.Fish30){
                        zorder = FishZorder.fishMid;
                    }
                    this.addChild(fish, zorder, eFishArray[i].fishArry[j].iFishId);
                    this._fishArr.push(fish);
                }
                else{
                    if(eFishArray[i].fishArry[j].iAlieveTime> fish._fishAliveTime){
                        fish._delaytime = eFishArray[i].fishArry[j].iAlieveTime;
                        fish._elaspetime = eFishArray[i].fishArry[j].iAlieveTime > 0 ? 0 : Math.abs(eFishArray[i].fishArry[j].iAlieveTime);
                    }else{
//                        cc.log('---------------鱼-鱼已经存在 ,需要倒退');
                    }
//

                }
            }
        }
        eFishArray = [];
    },


    initBGLayer : function(){
        var index = FishGlobal.roomId -1;
        var ground = new cc.Sprite(FishSceneRes.BackGround.format(index));
        ground.setAnchorPoint(cc.p(0, 0));
        ground.setPosition(cc.p(0, 0));
        this.addChild(ground, FishZorder.BGLayer, FYTagName.BGLayer);
    },

    initGameLayer : function(){
        this._bulletlayer = new FishCopyBulletLayer();
        this.addChild(this._bulletlayer, FishZorder.bulletLayer, FishSceneName.BulletLayer);
    },

    initEffectLayer : function(){

        var water = cc.AnimationCache.getInstance().getAnimation('water');
        for (var j = 0; j < 2; ++ j){
            for(var i = 0; i < 4; ++ i){
                var stemp = new cc.Sprite();
                stemp.setAnchorPoint(cc.p(0,0));
                stemp.setPosition(cc.p(i*323, 320*j));
                this.addChild(stemp, FishZorder.eftlayer);
                stemp.runAction(new cc.RepeatForever(new cc.Animate(water)));
            }
        }
        this.createMoneyCache();
    },

    initUILayer : function(){
        var uilayer = new ccui.Layout();
        if(uilayer){
            this.addChild(uilayer, FishZorder.UILayer, FYTagName.UILayer);
            uilayer.setContentSize(cc.size(1136, 640));
            uilayer.setAnchorPoint(cc.p(0, 0));
            uilayer.setPosition(cc.p(0, 0));
            this._uilayer = uilayer;
        }

        this.initFunctionMenu();

        var battery = new CopyBattery();
        this._uilayer.addChild(battery,0,'playerbattery');
        this._playerNode = battery;
        battery.showUserInfo();
        this.initUpLayer();
        this.addRecountModel();

    },

    addRecountModel : function(){
        var recountnode = new ccui.ImageView("fish_copy_31.png",ccui.Widget.PLIST_TEXTURE);
        if(recountnode){
            this._uilayer.addChild(recountnode, 1, "recountnode");
            recountnode.setAnchorPoint(cc.p(0.5,0.5));
            recountnode.setPosition(cc.p(this._uilayer.width/2-50, 540));
        }

        var timesp = this._timesp =FYEngine.createAlts('res/updatepackmail/fish_copy_num.png', 11, '0', '/');
        timesp.setAnchorPoint(cc.p(0,0.5));
        timesp.setPosition(cc.p(recountnode.width+5,recountnode.height/2));
        recountnode.addChild(timesp, 0, 'timesp');

        this.schedule(this.freeModeSchedule,1);
    },

    initUpLayer : function(){
        var upbg = new ccui.ImageView("fish_copy_3.png",ccui.Widget.PLIST_TEXTURE);
        if(upbg){
            this._uilayer.addChild(upbg, 1, "upbg");
            upbg.setAnchorPoint(cc.p(0.5,1));
            upbg.setScale9Enabled(true);
            upbg.setPosition(cc.p(this._uilayer.width/2, this._uilayer.height));
            upbg.setCapInsets(cc.rect(93,0, 10,0));
            upbg.setContentSize(cc.size(965,75));
        }

        var tipname = ["fish_copy_27.png","fish_copy_24.png","fish_copy_28.png","fish_copy_26.png","fish_copy_25.png"];
        for(var i = 0; i< 5;++i){
            var wealthbg = new ccui.ImageView("hall35.png",ccui.Widget.PLIST_TEXTURE);
            if(wealthbg){
                upbg.addChild(wealthbg, 0, "wealthbg"+i);
                wealthbg.setScale9Enabled(true);
                wealthbg.setPosition(cc.p(120+i*170,35));
                wealthbg.setCapInsets(cc.rect(30,0, 10,0));
                wealthbg.setContentSize(cc.size(140,41));

                var tip = new ccui.ImageView(tipname[i],ccui.Widget.PLIST_TEXTURE);
                if(tip){
                    tip.setScale(0.6);
                    wealthbg.addChild(tip,0,"wealthtip");
                    tip.setPosition(cc.p(5,wealthbg.height/2));
                }

                var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
                labgold.setPosition(cc.p(wealthbg.width/2+5, wealthbg.height/2));
                labgold.setAnchorPoint(cc.p(0.5, 0.5));
                wealthbg.addChild(labgold, 1, 'labgold');
            }
        }

        var helpbtn = new ccui.ImageView("fish_copy_2.png",ccui.Widget.PLIST_TEXTURE);
        if(helpbtn){
            upbg.addChild(helpbtn,1,"btnHelp");
            helpbtn.setTouchEnabled(true);
            helpbtn.setPosition(cc.p(900,35));
            helpbtn.addTouchEventListener(this.btnTouchEft,this);
            helpbtn.addClickEventListener(this.uiBtnCallBack);
        }

        this.changeWealth();
    },

    changeBeike : function(){
        var num =  this._uilayer.getChildByName("upbg").getChildByName("wealthbg0").getChildByName("labgold");
        var player = appglobal.getPlayer();
        if(num){
            num.setString(""+player.beike);
        }
    },

    changeHaixing : function(){
        var num =  this._uilayer.getChildByName("upbg").getChildByName("wealthbg1").getChildByName("labgold");
        var player = appglobal.getPlayer();
        if(num){
            num.setString(""+player.haixing);
        }
    },
    changeShanhu : function(){
        var num =  this._uilayer.getChildByName("upbg").getChildByName("wealthbg2").getChildByName("labgold");
        var player = appglobal.getPlayer();
        if(num){
            num.setString(""+player.shanhu);
        }
    },
    changeShuijing : function(){
        var num =  this._uilayer.getChildByName("upbg").getChildByName("wealthbg3").getChildByName("labgold");
        var player = appglobal.getPlayer();
        if(num){
            num.setString(""+player.shuijing);
        }
    },
    changeZhenzhu : function(){
        var num =  this._uilayer.getChildByName("upbg").getChildByName("wealthbg4").getChildByName("labgold");
        var player = appglobal.getPlayer();
        if(num){
            num.setString(""+player.zhenzhu);
        }
    },


    changeWealth : function(){
        this.changeBeike();
        this.changeHaixing();
        this.changeShanhu();
        this.changeShuijing();
        this.changeZhenzhu();
    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },


    refreshSelfRank : function(rsp){
        if(rsp.iResult ==0){
            if(this._inittime ==false){
                this._ranksp.setString("排名："+rsp.iAllRank+"/"+rsp.iAllRank);
            }else{
                this._ranksp.setString("排名："+rsp.iRank+"/"+rsp.iAllRank);
            }

            //this._ranksp.setString("排名："+88888+"/"+88888);
        }
    },


    initFunctionMenu : function(){
        var automenu = new ccui.ImageView(FishSceneRes.Png.AutoMenuBg,ccui.Widget.PLIST_TEXTURE);
        if(automenu){
            this._uilayer.addChild(automenu,1,'automenu');
            automenu.setScale9Enabled(true);
            automenu.setCapInsets(cc.rect(22,20,53,277));
            automenu.setContentSize(cc.size(97,317));
            automenu.setAnchorPoint(cc.p(0,0));
            automenu.setPosition(cc.p(this._uilayer.width,this._uilayer.height*0.26));

            var btnArrow = new ccui.ImageView(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
            if(btnArrow){
                automenu.addChild(btnArrow,1,'btnArrow');
                btnArrow.setTouchEnabled(true);
                btnArrow.setAnchorPoint(cc.p(0.5,0.5));
                btnArrow.setPosition(cc.p(automenu.width*(-0.1753),automenu.height*0.5));
                btnArrow.addClickEventListener(this.uiBtnCallBack);
            }

            var btnBack = new ccui.Button(FishSceneRes.Png.btnBackNormal,FishSceneRes.Png.btnBackPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnBack){
                automenu.addChild(btnBack, 1, 'btnBack');
                btnBack.setAnchorPoint(cc.p(0.5,0.5));
                btnBack.setPosition(cc.p(automenu.width*0.5,automenu.height*0.81));
                btnBack.addClickEventListener(this.uiBtnCallBack);
            }

            var btnSetting = new ccui.Button(FishSceneRes.Png.btnSettingNormal,FishSceneRes.Png.btnSettingPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnSetting){
                automenu.addChild(btnSetting, 1, 'btnSetting');
                btnSetting.setAnchorPoint(cc.p(0.5,0.5));
                btnSetting.setPosition(cc.p(automenu.width*0.5,automenu.height*0.5));
                btnSetting.addClickEventListener(this.uiBtnCallBack);
            }

            var btnHelp = new ccui.Button(FishSceneRes.Png.btnHelpNormal,FishSceneRes.Png.btnHelpPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnHelp){
                automenu.addChild(btnHelp, 1, 'btnHelp');
                btnHelp.setAnchorPoint(cc.p(0.5,0.5));
                btnHelp.setPosition(cc.p(automenu.width*0.5,automenu.height*0.2));
                btnHelp.addClickEventListener(this.uiBtnCallBack);
            }


        }
    },


    uiBtnCallBack : function(sender){
        var name = sender.getName();
        cc.log("name="+name);
        var layer = FYEngine.getRunningLayer(0);
        var uilayer = layer.getChildByName(FYTagName.UILayer);
        switch(name){
            case 'btnArrow' : {
                var automenu = uilayer.getChildByName('automenu');
                var moveout =new cc.MoveTo(0.2, cc.p(1136, 167));
                var movein =new cc.MoveTo(0.2, cc.p(1045, 167));

                if(FYMath.fixedNum(automenu.getPositionX(),0) == 1045 ){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(moveout, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }else if(FYMath.fixedNum(automenu.getPositionX(),0) == 1136){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(movein, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }

            }break;
            case 'btnBack' : {
                var mlayer = layer.getChildByName('warmtiplayer');
                if(!mlayer){
                    mlayer = new BackToLobby(1);
                    //mlayer = new KickByServer();
                    layer.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
            case 'btnSetting' : {
                var mlayer = layer.getChildByName('gamesettinglayer');
                if(!mlayer){
                    mlayer = new GameSettingLayer();
                    layer.addChild(mlayer, FishZorder.poplayer ,'gamesettinglayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }

            }break;
            case 'btnHelp' : {
                var mlayer = layer.getChildByName('helpinfolayer');
                if(!mlayer){
                    //var mlayer = new TokenFailLayer();
                    mlayer = new CopyGameGuideLayer();
                    layer.addChild(mlayer, FishZorder.poplayer , FishCopyLobbyLayer.CopyGameGuideLayer);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
            default:break;
        }
    },

    onExit : function(){
        this._super();
        for(var i = 0; i < this._fishArr.length;++i){
//            cc.log('--还鱼');
            cc.pool.putInPool(this._fishArr[i]);
        }

        for(var j = 0; j< this._bulletArr.length;++j){
            cc.log('--还子弹');
            cc.pool.putInPool(this._bulletArr[j]);
        }
        this._fishArr = [];
        this._bulletArr = [];
    },

    exitGame : function(){
        this.stopAllActions();
        this.unscheduleAllCallbacks();
        FishGlobal.bInFishScene = false;
        if(appglobal.idVerifySwitch){
            this.writeLocalIDverifyRecord();
        }
        FYEngine.runScene(FishCopyLobby.createScene());
    },

    setTouchEffect : function(pos){
        var touchEft = new cc.Sprite(FishSceneRes.Png.touchEft);
        touchEft.setPosition(pos);
        touchEft.setScale(0.1);
        touchEft.setOpacity(50);
        this.addChild(touchEft,FishZorder.eftlayer);
        touchEft.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.6, 0.6), new cc.FadeTo(0.6, 255)),
            new cc.Spawn(new cc.ScaleTo(0.4, 1), new cc.FadeTo(0.4, 50)),
            new cc.RemoveSelf()));
    },

    changeUserInfo : function(){
        cc.log("changeUserInfo");
        var handlerMsg = this._handler._fishData;
        this._playerNode.changeUserGold(handlerMsg._userData[0].lGold);
        this._playerNode.changeUserCoupon(handlerMsg._userData[0].lCoupon);

    },

    changeUserGold : function(){

        var handlerMsg = this._handler._fishData;
        var userinfo = handlerMsg._userData[0];
        cc.log("----更新玩家的钱"+userinfo.lGold);
        this._playerNode.changeUserGold(userinfo.lGold);
        appglobal.getPlayer().gold = userinfo.lGold;

    },

    changeUserCoup : function(){
        var handlerMsg = this._handler._fishData;
        var userinfo = handlerMsg._userData[0];
        this._playerNode.changeUserCoupon(userinfo.lCoupon);
        appglobal._player.coupon = userinfo.lCoupon;
    },

    shootBullet : function(){
        var battery = this.getBattery();
        if (!battery){
            return;
        }


//        if(GameCostManager.costMoney(Math.abs(this._playerNode._rate)) == false){
//            return;
//        }
        //先检查金钱是否足够,不够则关掉自动射击,并且调整炮台倍率,金钱足够则battery射击
        var handlerMsg = this._handler._fishData;
        if(handlerMsg._userData[0].lGold < Math.abs(this._playerNode._rate))
        {
            this._bulletlayer.setAutoPlay(false);
            var btn = FYEngine.getChild(this._playerNode,'autobtn');
            if(this._bulletlayer.isAutoPlay()){
                btn.loadTexture(FishSceneRes.Png.AutoPlayOpenBtn,ccui.Widget.PLIST_TEXTURE);
                var autoeft = FYEngine.getChild(btn, 'autoeft');
                if(!autoeft){
                    autoeft = new cc.Sprite(FishSceneRes.Png.AutoEft);
                    if(autoeft){
                        btn.addChild(autoeft,0,'autoeft');
                        autoeft.setPosition(cc.p(btn.width/2,btn.height/2));
                        var rotate = new cc.RotateBy(1.2,360);
                        autoeft.runAction(new cc.RepeatForever(rotate));
                    }
                }
            }else{
                btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
                var autoeft = FYEngine.getChild(btn, 'autoeft');
                if(autoeft){
                    autoeft.removeFromParent(true);
                }
            }
            this._playerNode.checkNeedSubBatteryLevel();
        }else{
            battery.shootBullet();
        }

    },


    adjustBattery : function(id, angle){
        cc.log("adjustBattery"+angle);
        var battery = this.getBattery();
        if (!battery){
            return;
        }

        battery.adjustBattery(angle);
    },

    getBattery : function(){
        return this._playerNode;
    },

    getKillFishUserInfo : function(info){
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < 4; ++ i){
            if (handlerMsg._userData[i].lRoleId == info.lRoleId){
                return handlerMsg._userData[i];
            }
        }
        return null;
    },

    createMoneyCache : function(){
// //        cc.log('---------------------初始化转盘动画------');
//         this._goldPlate = [];
//         var posArr = [cc.p(345,440), cc.p(790,440), cc.p(790,200), cc.p(345,200)];
//         for (var i = 0; i < 4; ++ i){
//             var rotatePlate = new cc.Sprite(FishSceneRes.Png.RewardPlate);
//             rotatePlate.setScale(0.1);
//             rotatePlate.setVisible(false);
//             rotatePlate.setPosition(posArr[i]);
//             this.addChild(rotatePlate, FishZorder.eftlayer, 'plate'+i);
//             this._goldPlate.push(rotatePlate);
//         }

        var self = this;
        var movedown = new cc.MoveBy(0.3, cc.p(0, -60));
        this._goldAni = new cc.Sequence(new cc.MoveBy(0.2, cc.p(0, 20)), movedown.easing(cc.easeIn(3)),
            new cc.MoveBy(0.2, cc.p(0, 50)),
            new cc.Spawn(new cc.FadeTo(0.3, 50), new cc.MoveBy(0.3, cc.p(0, 60))), new cc.RemoveSelf());
        this._goldAni.retain();
    },

    /**
     *
     * @param iCoinType 奖励类型
     * @param iCoinCount 奖励数量
     * @param iRewardNum 鱼的倍率
     * @param startpos 鱼的死亡位置
     */
    addMoneyToUserNew : function(iCoinType,iCoinCount, iRewardNum, startpos){
        cc.log("addMoneyToUserNew");
        var player = appglobal.getPlayer();
        switch(iCoinType){
            case FishGlobal.WealthType.gold :{
                this.winGold(iCoinCount, iRewardNum, startpos);
                // GameCostManager.addMoney(iCoinCount);
            }break;
            case FishGlobal.WealthType.coup :{

            }break;
            case FishGlobal.WealthType.beike :{
                player.beike += iCoinCount;
                this.createTool(iCoinType,startpos,cc.p(200,610),iCoinCount);
                this.changeBeike();
                // GameCostManager.addMoney(iCoinCount*FishGlobal.getCoinValue(iCoinType));
            }break;
            case FishGlobal.WealthType.shuijing :{
                player.shuijing += iCoinCount;
                this.createTool(iCoinType,startpos,cc.p(710,610),iCoinCount);
                this.changeShuijing();
                // GameCostManager.addMoney(iCoinCount*FishGlobal.getCoinValue(iCoinType));
            }break;
            case FishGlobal.WealthType.shanhu :{
                player.shanhu += iCoinCount;
                this.createTool(iCoinType,startpos,cc.p(540,610),iCoinCount);
                this.changeShanhu();
                // GameCostManager.addMoney(iCoinCount*FishGlobal.getCoinValue(iCoinType));
            }break;
            case FishGlobal.WealthType.haixing :{
                player.haixing += iCoinCount;
                this.createTool(iCoinType,startpos,cc.p(370,610),iCoinCount);
                this.changeHaixing();
                // GameCostManager.addMoney(iCoinCount*FishGlobal.getCoinValue(iCoinType));
            }break;
            case FishGlobal.WealthType.zhenzhu :{
                player.zhenzhu += iCoinCount;
                this.createTool(iCoinType,startpos,cc.p(880,610),iCoinCount);
                this.changeZhenzhu();
                // GameCostManager.addMoney(iCoinCount*FishGlobal.getCoinValue(iCoinType));
            }break;
            default:break;
        }
    },

    winGold : function(iCoinCount, iRewardNum, startpos){
        var fishrate = iRewardNum;
        if (fishrate == 0){
            return;
        }
        var endpos = this._playerNode.getPosition();

        if(fishrate <= 3){
            this.createCoins(1, 1, startpos, endpos);
        }else if(fishrate<=6){
            this.createCoins(1, 2, startpos, endpos);
        }else if(fishrate<=9){
            this.createCoins(1, 3, startpos, endpos);
        }else if(fishrate<=14){
            this.createCoins(1, 4, startpos, endpos);
        }else if(fishrate<=19){
            this.createCoins(1, 6, startpos, endpos);
        }else if(fishrate<=29){
            this.createCoins(1, 8, startpos, endpos);
        }else if(fishrate<=100){
            this.createCoins(1, 10, startpos, endpos);
        }else if(fishrate<=299){
            this.createCoins(1, 20, startpos, endpos);
        }else{
            this.createCoins(1, 30, startpos, endpos);
        }

        var sp_gold = FYEngine.createNumSprite(iCoinCount
            , FishSceneRes.Png.killgold);
        sp_gold.setPosition(cc.pAdd(startpos, cc.p(0, -30)));
        sp_gold.setVisible(true);
        this.addChild(sp_gold, FishZorder.eftlayer);
        sp_gold.runAction(this._goldAni.clone());

        var handlerMsg = this._handler._fishData;
        handlerMsg._userData[0].lGold += iCoinCount;
        this.changeUserGold();

    },

    addMoneyToUser : function(tReward, iRate, chairid, startpos){
        //cc.log('---addMoneyToUser------------------test:'+chairid);
        if (!tReward){
//            cc.log('---------保护------');
            return;
        }

        var fishrate = tReward.iRewardNum;
        if (fishrate == 0){
            return;
        }

        var goldReward = fishrate*iRate;//
        var self = this;
        var endpos = this._playerNode.getPosition();


        if(chairid == this._handler.getSelfId()){
            if(fishrate <= 3){
                this.createCoins(1, 1, startpos, endpos);
            }else if(fishrate<=6){
                this.createCoins(1, 2, startpos, endpos);
            }else if(fishrate<=9){
                this.createCoins(1, 3, startpos, endpos);
            }else if(fishrate<=14){
                this.createCoins(1, 4, startpos, endpos);
            }else if(fishrate<=19){
                this.createCoins(1, 6, startpos, endpos);
            }else if(fishrate<=29){
                this.createCoins(1, 8, startpos, endpos);
            }else if(fishrate<=100){
                this.createCoins(1, 10, startpos, endpos);
            }else if(fishrate<=299){
                this.createCoins(1, 20, startpos, endpos);
            }else{
                this.createCoins(1, 30, startpos, endpos);
            }
        }else{
            if(fishrate <= 3){
                this.createCoins(0, 1, startpos, endpos);
            }else if(fishrate<=6){
                this.createCoins(0, 2, startpos, endpos);
            }else if(fishrate<=9){
                this.createCoins(0, 3, startpos, endpos);
            }else if(fishrate<=14){
                this.createCoins(0, 4, startpos, endpos);
            }else if(fishrate<=19){
                this.createCoins(0, 6, startpos, endpos);
            }else if(fishrate<=29){
                this.createCoins(0, 8, startpos, endpos);
            }else if(fishrate<=100){
                this.createCoins(0, 10, startpos, endpos);
            }else if(fishrate<=299){
                this.createCoins(0, 20, startpos, endpos);
            }else{
                this.createCoins(0, 30, startpos, endpos);
            }

        }

        ////
        if(fishrate < 40 || this._goldPlate[chairid].isVisible()){
            var sp_gold = FYEngine.createNumSprite(goldReward
                , chairid == this._handler.getSelfId()?FishSceneRes.Png.killgold:FishSceneRes.Png.skillgold);
            sp_gold.setPosition(cc.pAdd(startpos, cc.p(0, -30)));
            sp_gold.setVisible(true);
            this.addChild(sp_gold, FishZorder.eftlayer);
            sp_gold.runAction(this._goldAni.clone());
        }
        else
        {
            if(this._isVibrationSwitch == 0){
                this.vibrationCallBack();
            }

            FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.bingo_eft);

            var rotatePlate = this._goldPlate[chairid];
            rotatePlate.setScale(0.1);
            rotatePlate.setOpacity(255);
            rotatePlate.setVisible(true);
            var ani = new cc.Sequence(new cc.ScaleTo(0.2,1.2),new cc.ScaleTo(0.1,1),new cc.DelayTime(2), new cc.FadeTo(0.2,50),
                new cc.CallFunc(function(){
                    rotatePlate.setVisible(false);
                }));
            var ani2 = new cc.RepeatForever(new cc.RotateBy(1,360));
            rotatePlate.runAction(ani);
            rotatePlate.runAction(ani2);


            var sp_gold2 = FYEngine.createNumSprite(goldReward, FishSceneRes.Png.killgold);
            sp_gold2.setAnchorPoint(cc.p(0.5,0.5));
            sp_gold2.setPosition(rotatePlate.getPosition());
            this.addChild(sp_gold2, FishZorder.eftlayer);

            var spani1 = new cc.RepeatForever(new cc.Sequence(new cc.RotateBy(0.3,15),new cc.RotateBy(0.6,-30),
                new cc.RotateBy(0.3,15)));
            var spani2 = new cc.Sequence(new cc.ScaleTo(0.2,1.4),new cc.ScaleTo(0.1,1),new cc.Spawn(new cc.DelayTime(2), new cc.CallFunc(function(){
                self.changeUserCoup(chairid);
                self.changeUserGold(chairid);
            })),new cc.FadeTo(0.2,50),new cc.RemoveSelf());
            sp_gold2.runAction(spani1);
            sp_gold2.runAction(spani2);
        }


    },

    createCoins : function(type, count, bpos, epos){

        if(count<=4){
            for (var i = 0; i < count; ++ i){
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%10), -20*parseInt((i/10)))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }else if(count<=20){
            for (var i = 0; i < count; ++ i){
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%(count*0.5)), -20*parseInt((i/(count*0.5))))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }else{
            for (var i = 0; i < count; ++ i){
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%10), -20*parseInt((i/10)))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }
    },

    createTool : function(type,bpos, epos,iCoinCount){
        cc.log("createTool");
        var sp_tool = copyTool.create(type,iCoinCount);
        sp_tool.setPosition(bpos);
        sp_tool.startTomove(bpos, epos);
        this.addChild(sp_tool, FishZorder.eftlayer);
    },

    checkObbCollision : function(){
        if (this._bulletArr.length <= 0 || this._fishArr.length <= 0){
            return;
        }

//       cc.log('------this._bulletArr.length : '+this._bulletArr.length);
        for (var i = 0; i < this._bulletArr.length; ++ i){
            var bullet = this._bulletArr[i];

            for (var j = 0; j < this._fishArr.length; ++ j) {
                var fish = this._fishArr[j];
                if (!this._fishArr[j] || !this._fishArr[j].isCanCollision()) {
                    continue;
                }

                var distance = FYMath.getDistance(bullet.x, bullet.y, fish.x, fish.y);
                if (distance < 10) {
                    this.bullethitFish(fish, bullet);
                    break;
                }
                else if (distance > fish.getFishLength()){
                    continue;
                }


                if (fish._fishQueneType == FishPropsType.Plate){
                    var ishit = false;
                    for (var k = 0; k < fish._plate.length; ++ k){
                        var bulletpos = fish._plate[k].convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish._plate[k].getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            ishit = true;
                            break;
                        }
                    }

                    if (ishit){
                        break;
                    }
                }
                else{
                    if (fish._bSurperise){
                        var bulletpos = fish._platesp.convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish._platesp.getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            break;
                        }
                    }
                    else{
                        var bulletpos = fish.convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish.getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            break;
                        }
                    }

                }
            }
        }

    },

    bullethitFish : function(fish, bullet){
        this.pushHitEvent(fish, bullet);
        this._bulletlayer.reSetCount(-1);
        bullet.openFishNet();
    },

    checkJoinEvents : function(){
        if (this.ejoinflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eJoinArray.length == 0){
            return;
        }

        this.ejoinflag = true;
        for (var i = 0; i < handlerMsg._eJoinArray.length; ++ i){
            this.changeUserInfo(handlerMsg._eJoinArray[i].iChairId);
        }
        handlerMsg._eJoinArray = [];
        this.ejoinflag = false;
    },

    checkLeaveEvents : function(){
        if (this.eleaveflag){
            return;
        }
        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eLeaveArray.length == 0){
            return;
        }

        this.eleaveflag = true;
        for (var i = 0; i < handlerMsg._eLeaveArray.length; ++ i){
            this.changeUserInfo(handlerMsg._eLeaveArray[i].iChairId);
            this.removeBulletsByUserId(handlerMsg._eLeaveArray[i].lRoleId);
        }
        handlerMsg._eLeaveArray = [];
        this.eleaveflag = false;
    },


    checkFishTideEvents : function(){

        if(this._handler._fishData._fishTideCome == false){
            return;
        }
        this._handler._fishData._fishTideCome = false;
        var self = this;
        for (var i = 0; i < this._fishArr.length; ++ i){
            if (!this._fishArr[i]._bTideFish){
                this._fishArr[i]._swimSpeed = 8;
            }
        }

        if(this._handler._fishData._fishTideTagTime<1){
            this.onFishTideAnimation();
//            cc.log('-----------------播放鱼潮动画------'+this._handler._fishData._fishTideControl);
        }

        if(this._handler._fishData._fishTideTagTime<4){
            this._handler._fishData._fishTideControl = false;
            var delaytime = 4-this._handler._fishData._fishTideTagTime;
            this.runAction(new cc.Sequence(new cc.DelayTime(delaytime),new cc.CallFunc(function(){
                self._handler._fishData._fishTideControl = true;
//                cc.log('-------------可以开炮了....');
            })));
        }

    },

    onFishTideAnimation : function(){
        var self = this;
        if (!this._weavAni){
            this._weavAni = new cc.RepeatForever(FYEngine.createAnimate('wave'));
            this._weavAni.retain();

            var moveby = new cc.MoveBy(3.5, cc.p(-1500,0));
            this._weavMove = new cc.Sequence( new cc.CallFunc(function(){
                FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.effect.wave_eft, false);
            }), moveby, new cc.CallFunc(function(){
                self.removeChildByName('wavetemp');
                var t = FishGlobal.roomId;
                switch(t){
                    case 1 : {
                        FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                    }break;
                    case 2 : {
                        FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                    }break;
                    case 3 : {
                        FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                    }break;
                }
            }));
            this._weavMove.retain();
        }

        var wavetemp = new cc.Sprite();
        this.addChild(wavetemp, FishZorder.eftlayer, 'wavetemp');
        wavetemp.setAnchorPoint(cc.p(0,0.5));
        wavetemp.setPosition(cc.p(1136,320));
        wavetemp.runAction(this._weavAni);
        wavetemp.runAction(this._weavMove);
    },

    onKillFishEvents : function(eKillInfo){
        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.gold_eft);

        var fish = this.getFishbyIdFormArr(eKillInfo.iFishId);
        if (fish && fish._status != FishStatus.Dead){
            if (fish._clientType < FishClientType.Fish24 ||fish._clientType > FishClientType.Fish30 ){
                if(fish._clientType != FishClientType.Fish21){
                    if (1 > (FYMath.getRandom(0,FishGlobal.getMusicRate(fish._serverType)-1))){
                        var temp = FishGlobal.getMusicName(fish._serverType);
                        FYEngine.Audio.playEffect(temp, false);
                    }
                }

                fish.setFishDead();
                this.addMoneyToUserNew(eKillInfo.iCoinType,eKillInfo.iCoinCount,eKillInfo.iRewardNum,fish.getPosition());
            }
        }
    },

    checkKillEvents : function(){
        if (this.ekillflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eKillArray.length == 0){
            return;
        }

        this.ekillflag = true;
        for (var i = 0; i < handlerMsg._eKillArray.length; ++ i){
            this.onKillFishEvents(handlerMsg._eKillArray[i]);
        }
        handlerMsg._eKillArray = [];
        this.ekillflag = false;
    },

    onShootBulletEvents : function(eShootArray){
        // cc.log('-------发射子弹 onShootBulletEvents : '+eShootArray.length);
        for (var i = 0; i < eShootArray.length; ++ i){
            if(eShootArray[i].bisValid == 1){
                if(eShootArray[i].iChairId == this._handler._fishData._selfId){
                    cc.log("无效子弹退钱");
                    this._handler.changeUserGold(eShootArray[i].iChairId, eShootArray[i].iRate);
                    this.changeUserGold();
                }
                continue;
            }
            if(eShootArray[i].iFireTime<0){
                var battery = this.getBattery();
                if (battery){
                    battery.shootServerBullet(eShootArray[i].lBulletId, eShootArray[i].iRotate, eShootArray[i].iType,
                        eShootArray[i].iRate, eShootArray[i].iFireTime, eShootArray[i].lRoleId, eShootArray[i].bisValid);
                }
            }
        }
        eShootArray = [];
    },

    checkShootEvents : function(){
        if (this.eshootflag){
            return;
        }

        if (this._handler._fishData._eShootArray.length == 0){
            return;
        }

        this.eshootflag = true;
        this.onShootBulletEvents(this._handler._fishData._eShootArray);
        this._handler._fishData._eShootArray = [];
        this.eshootflag = false;
    },


    onChangeCannonEvents : function(eCannonArray){
        //cc.log('-------切换炮台 onChangeCannonEvents: '+eCannonArray.length);
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < eCannonArray.length; ++ i){
            if (handlerMsg._selfId == eCannonArray[i].iChairId){
                //cc.log('--------自己的切换炮台事件');
                continue;
            }
            var battery = this.getBattery(eCannonArray[i].iChairId);
            if (battery){
//                cc.log("席位:"+eCannonArray[i].iChairId+"+ 倍率:"+eCannonArray[i].iRate);
                battery.changeOtherCannon(eCannonArray[i].iRate,eCannonArray[i].iType);

            }

        }
        eCannonArray = [];
    },

    checkCannonEvents : function(){
        if (this.echangeflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eCannonArray.length == 0){
            return;
        }

        this.echangeflag = true;
        this.onChangeCannonEvents(handlerMsg._eCannonArray);
        handlerMsg._eCannonArray = [];
        this.echangeflag = false;
    },
    //
    // removeLocalBUllet : function(lBulletId){
    //     var handlerMsg = this._handler._fishData;
    //     var playernode = this._playerNode[handlerMsg._selfId];
    //     playernode._localBulletArry.remove(lBulletId);
    // },

    onHitFishEvents : function(eHitArray){
        // FYEngine.logObject(eHitArray,'---------碰撞事件');
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < eHitArray.length; ++ i){
            if (eHitArray[i].bisValid == 0){
                cc.log('------------自己碰撞无效子弹加钱');
                this._handler.changeUserGold(handlerMsg._selfId, eHitArray[i].iRate);
                this.changeUserGold();

            }
        }
        eHitArray = [];
    },

    checkHitEvents : function(){
        if (this.ehitflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eHitArray.length == 0){
            return;
        }

        this.ehitflag = true;
        this.onHitFishEvents(handlerMsg._eHitArray);
        handlerMsg._eHitArray = [];
        this.ehitflag = false;
    },


    getFishbyIdFormArr : function(id){
        for (var i = 0; i < this._fishArr.length; ++ i){
            if (this._fishArr[i] && this._fishArr[i].getId() == id){
                return this._fishArr[i];
            }
        }

        return null;
    },

    getBulletFromArr : function(id){
        for (var i = 0; i < this._bulletArr.length; ++ i){
            if (this._bulletArr[i] && this._bulletArr[i].getId() == id){
                return this._bulletArr[i];
            }
        }

        return null;
    },

    removeBulletsByUserId : function(id){
        var removearr = [];
        for (var i = 0; i < this._bulletArr.length; ++ i){
            if (this._bulletArr[i] && this._bulletArr[i].getUserId() == id){
                removearr.push(this._bulletArr[i].getId());
//                cc.log('----------删除的子弹:'+this._bulletArr[i].getId());
            }
        }

        for (var i = 0; i < removearr.length; ++ i){
            var bullet = this._bulletlayer.getChildByName('name'+removearr[i]);
            if (bullet){
                bullet.removeSelf();
            }
        }

    },

    pushHitEvent : function(fish, bullet){
//        cc.log('----------发送子弹碰撞消息');
        var lBulletId = bullet.getId();
        var iHitFishId = fish.getId();
        var iRate = bullet.getRate();
        var bHitFishType = fish.getServerType();
        if(this._handler && this._handler._canSendNormalMsg){
            this._handler.sendCopyHitFishReq(lBulletId,iHitFishId,iRate,bHitFishType);
        }
    },

    onUnconnect : function(type){
//        cc.log('----------------FishScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
//        cc.log("unconnecttype====="+type);
        switch (type){
            case 1:{

                if (!layer){
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer+100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
//                cc.log("code===="+layer._reConnectCode);
                if(layer && layer._reConnectCode&&layer._reConnectCode==1){
                    if(layer._type&&layer._type==3){
                        return;
                    }
                    layer.refreshUI(3);
                }

                if(layer && layer._reConnectCode==0 && layer.code==0){
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF,10.0);
                    //this.scheduleOnce(f,30.0);
                    layer.code=1;
                }
            }
                break;
            case 2:
            case 3:{
                if (layer){
                    if(layer._type&&layer._type==3){
                        return;
                    }
                    if(layer &&layer.layerF){
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code=0;
                    }
                    //this.unschedule(f);

                }
            }
                break;
            case 0:{
                if (layer){
                    layer.removeFromParent();
                }
            }
                break;
        }
    },

    vibrationCallBack : function(){
        if(this._vibrationend){
            return;
        }
        this._vibrationend = true;
        var self = this;
        var bg = this.getChildByName(FYTagName.BGLayer);
        if(bg){
            bg.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(10,18)), new cc.MoveTo(0.05,cc.p(-10,-20)),
                new cc.MoveTo(0.05,cc.p(10,50)), new cc.MoveTo(0.05,cc.p(-10,-50)),new cc.MoveTo(0.1,cc.p(10,30)), new cc.MoveTo(0.1,cc.p(-10,-30)), new cc.MoveTo(0.1,cc.p(10,20)),new cc.MoveTo(0.1,cc.p(-8,-10)),new cc.MoveTo(0.1,cc.p(5,5)),new cc.MoveTo(0.1,cc.p(0,0))));
        }
        this._uilayer.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(-5,-10)), new cc.MoveTo(0.05,cc.p(10,20)),
            new cc.MoveTo(0.05,cc.p(-10,-30)), new cc.MoveTo(0.05,cc.p(10,30)),new cc.MoveTo(0.1,cc.p(-10,-20)), new cc.MoveTo(0.1,cc.p(10,20)), new cc.MoveTo(0.1,cc.p(-10,-10)),new cc.MoveTo(0.1,cc.p(8,10)),new cc.MoveTo(0.1,cc.p(-5,-5)),new cc.MoveTo(0.1,cc.p(0,0)),new cc.CallFunc(function(){
                self._vibrationend = false;
            })));


    },

    gameOnShowEvent : function(){
       cc.log('----------------游戏退到后台啦-');
        // if(FishGlobal.bInFishScene == true){
        //     FishGlobal.tipout = 1;
        //     var coreserviceproxy = CoreServiceProxy.getInstance();
        //     coreserviceproxy.unlinkGameClient();
        //
        //     var layer = FYEngine.getRunningLayer(0);
        //
        //
        //     if(cc.sys.os != 'iOS'){
        //         var coreserviceproxy = CoreServiceProxy.getInstance();
        //         var lobbyHandler = coreserviceproxy.getLobbyHandler();
        //         if(lobbyHandler){
        //             lobbyHandler.setCanSendHeart(false);
        //         }
        //     }
        //
        //     layer.exitGame();
        //
        //
        //
        // }
    },

    phoneKeyCallBack : function(keycode,target){
        switch(keycode){
            case cc.KEY.back : {
//                cc.log('---------物理返回键--------');

                if(FYEngine.getRunningLayer(0).getChildByName('kickedbyserver')){
                    return;
                }

                var layer = target.getChildByName(FishSceneName.UnConnectDialog)
                    || target.getChildByName(FishCopyLobbyLayer.CopyTimeOutLayer);
                if(layer){
                    return;
                }

                var namelist = [FishCopyLobbyLayer.CopyGameGuideLayer,'warmtiplayer','gocharge','helpinfolayer','gamesettinglayer',LobbySceneName.FreeRoomRule,LobbySceneName.DetailLayer];

                for(var i = 0; i < namelist.length ; ++i){
                    var layer =target.getChildByName(namelist[i]);
                    if(layer){
                        FYEngine.popoutLayerAnimate(layer.layerbg);
                        return;
                    }
                }

                var mlayer = new BackToLobby(1);
                if(mlayer){
                    target.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
        }

    },

    initBackGroundMusic : function(type){
        cc.log('---------------------初始化音乐------');
        var vibtn = cc.sys.localStorage.getItem('isVibration');
        if(vibtn == null || vibtn == '0'){
            this._isVibrationSwitch = 0;
        }else{
            this._isVibrationSwitch = 1;
        }


        var bgmusic = cc.sys.localStorage.getItem('bgVolum');
        cc.log("-----fish---bgmusic===="+bgmusic);
        if(bgmusic == null){
            FYEngine.Audio.setMusicVolume(1);
        }else{
            // FYEngine.Audio.setMusicVolume(Number(bgmusic));
            // cc.audioEngine.setMusicVolume(Number(bgmusic));
            FYEngine.Audio.setOpenMusic(Number(bgmusic))
        }

        var eftmusic = cc.sys.localStorage.getItem('eftVolum');
//        cc.log("fish---eftmusic===="+eftmusic);
        if(eftmusic == null){
            FYEngine.Audio.setEffectVolume(1);
        }else{
            FYEngine.Audio.setEffectVolume(Number(eftmusic));
        }
        var t = FishGlobal.roomId;
        if(!type){
            switch(t){
                case 1 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                }break;
                case 2 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                }break;
                case 3 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                }break;
            }
        }
    },

});


FishCopyLayer.createScene = function(){
    var scene = new cc.Scene();
    var layer = new FishCopyLayer();
    scene.addChild(layer, 0, 0);
    return scene;
};


