
var GAME_NEW_INT_DATA = {
    _SYLZ_CFG_OK : false,
    _JZSJ_CFG_OK : false,
    GAME_TYPE : -1,                         //进入的游戏场
    TOTAL_ATTACK_TIMES : [0,0,0],        //总的攻击次数
    LEFT_ATTACK_TIMES :[0,0,0],          //当前剩下的攻击次数
    TOTAL_EX_ATTACK_TIME:[0,0,0],        //总的可以兑换的次数
    LEFT_EX_ATTACK_TIMES:[0,0,0],        //剩下可以兑换的次数
    EX_ATTACK_NEED_SCORE:[0,0,0],//兑换所需积分
    ATTACK_PRICE :[0,0,0],   //不同攻击类型的倍率
    ATTACK_TOTAL_TYPE : 3,
    CURRENT_ATTACK_TYPE:0,                  //当前类型
    ARROW_SPEED:1,                          //箭头转动的速度
    ARROW_SPEED_RATE :1,                    //箭头转动速度倍率
    ARROW_START_ANGLE : -90,                //箭头的初始角度
    GAME1_REWARD_TYPE_RATE : 60,            //第一个游戏奖励类型的概率
    REW_POS_RAND : 80,      //打中鱼后的奖励的随机位置上线
    CANNON_SPRITEFRAME :["N_G_G_0.png","N_G_G_1.png","N_G_G_2.png"],
    BULLET_SPEED :700,
    BULLET_SPEED_2 : 1100,
    BULLET_SHOOT_RANGE :1,
    SWITCH_SHOOT : false,
    GAME1_SHOOOT_DISTANCE : 10,
    player : {
        gold : 0,
        fishcoin :0,
        score:0,
    },

    GAME2_CANNON_RATE :[0,0,0],              //游戏2的倍率
    GAME2_TOTAL_PLAY_TIME :[0,0,0],
    GAME2_ENTER_NEED_MONEY :[0,0,0],
    GAME2_TOTAL_ENTER_TIMES :[0,0,0],           //精准射击总进入场次
    GAME2_ENTER_TIMES :[0,0,0],                 //精准射击剩余入场次数
    GAME2_NEED_INT :[0,0,0],
    GAME2_ROOM_INDEX :-1,
    GAME2_FISH_RAND_NUM_MAX : 3,
    GAME2_FISH_RAND_NUM_MIN : 2,
    GAME2_FISH_RAND_DIRECTION: 0,    //1，左边，0：右边
    GAME2_FISH_YELLOW_RATE :[0,0,0],    //鱼类型的概率
    GAME2_G : 400,                //重力加速度
    GAME2_FISH_SPEED_X : 300,
    GAME2_FISH_SPEED_Y :700,
    GAME2_F_S_Y_R : [500,700],
    GAME2_F_S_X_R : [300,700],
    GAME2_SHOOOT_DISTANCE : 40,   //子弹碰到鱼的距离判断
    roominfo : {
        gamestart : false,
        gamelefttime : 0,
    },


    GAME1_GUIDE_SHOW : true,
    GAME1_GUIDE_LAST_TIME : 0,
    GAME2_GUIDE_SHOW : true,
    GAME2_GUIDE_LAST_TIME :0,
};

var GAME_NEW_EVENT = {
    CHANGE_CANNON_TYPE : "CHANGE_CANNON_TYPE",
    SHOW_CANNOT_SHOOT : "SHOW_CANNOT_SHOOT",
    END_SHOOT_EVENT : "END_SHOOT_EVENT",
    SHOOT_BULLET : "SHOOT_BULLET",
    ON_HITBOSS_REWARD : "ON_HITBOSS_REWARD",//打中boss后服务器返回的奖励
    UPDATE_PLAYER_INFO : "UPDATE_PLAYER_INFO",
    ADJUST_CANNON : "ADJUST_CANNON",
    QUERRY_GAME_ACC : "QUERRY_GAME_ACC",
    GAME_NEW_LOGIN_OK :"GAME_NEW_LOGIN_OK",
    GAME_NEW_INFO_OK : "GAME_NEW_INFO_OK",
    GAME_NEW_BUY_BOOM : "GAME_NEW_BUY_BOOM",
    GAME_NEW_SYLZ_LOTTERY : "GAME_NEW_SYLZ_LOTTERY",
    CLICK_GAME2 : "CLICK_GAME2",
    JZSJ_CREATE_ROOM: "JZSJ_CREATE_ROOM",
    JZSJ_GAME_START : "JZSJ_GAME_START",
    JZSJ_GAME_LOTTERY :"JZSJ_GAME_LOTTERY",
    GAME1_SHOW_EX_TIME :"GAME1_SHOW_EX_TIME",
    GAME1_SHOW_EX_CANNON:"GAME1_SHOW_EX_CANNON",
    FUBEN2_OPENBOX_CFG: "FUBEN2_OPENBOX_CFG",
    FUBEN2_BUY_BOX_CFG: "sendFUBEN2_BUY_BOX_CFG",
    FUBEN2_OPEN_BOX :"FUBEN2_OPEN_BOX",
    UPDATE_SYLZ_CFG : "UPDATE_SYLZ_CFG",
    UPDATE_JZSJ_CFG : "UPDATE_JZSJ_CFG",
    JZSJ_GAME_STATUS : "JZSJ_GAME_STATUS",
    GAME_RELOGIN_OK:"GAME_RELOGIN_OK",
    GAME_RELOGIN_FAIL : "GAME_RELOGIN_FAIL",
    GAME_REMOVE_GUIDE : "GAME_REMOVE_GUIDE",
};

/**
 * 弹出层
 * @type {{Game1ExchangeTimes: string}}
 */
var GAME_NEW_WINDOWS = {
    Game1ExchangeTimes : "Game1ExchangeTimes",
    GameNewChoosGame : "GameNewChoosGame",
    Game1ExchangeOrBuy :"Game1ExchangeOrBuy",
    Game1OnlyBuy :"Game1OnlyBuy",
    GameNewFishBox :"GameNewFishBox",
    GameNewEnterExnNumber : "GameNewEnterExnNumber",
    GameNewOpenBox :"GameNewOpenBox",
    Game2TimeOff : "Game2TimeOff",
    GAME1_HELP_LAYER :"GAME1_HELP_LAYER",
    GAME2_HELP_LAYER :"GAME2_HELP_LAYER",
    Game2EnterTip1 : "Game2EnterTip1",
    GAME1_GUIDE_LAYER : "GAME1_GUIDE_LAYER",
    GAME2_GUIDE_LAYER : "GAME2_GUIDE_LAYER",
    GAME_NEW_OPEN_BOX_RESULT :"GAME_NEW_OPEN_BOX_RESULT",




};

var GAME_NEW_BULLET_STATUS ={
    STAY:0,
    MOVE:1,
};

var GAME_NEW_FISH_STATUS ={
    STAY:0,
    MOVE:1,
};