/**
 * Created by daichunfeng on 2016/11/17.
 */

var FishClientType = {
    Fish0   : 0, //小鱼
    Fish1   : 1,
    Fish2   : 2,
    Fish3   : 3,
    Fish4   : 4,
    Fish5   : 5,
    Fish6   : 6,
    Fish7   : 7,
    Fish8   : 8, //中等鱼
    Fish9   : 9,
    Fish10  : 10,
    Fish11  : 11,
    Fish12  : 12,
    Fish13  : 13,
    Fish14  : 14,
    Fish15  : 15,
    Fish16  : 16,
    Fish17  : 17, //银龙 大鱼
    Fish18  : 18,
    Fish19  : 19,
    Fish20  : 20,
    Fish21  : 21, //炸弹
    Fish22  : 22,
    Fish23  : 23,
    Fish24 :  24,//奖券1
    Fish25 :  25,//奖券2
    Fish26 :  26,//奖券5
    Fish27 :  27,//奖券10
    Fish28 :  28,//奖券20
    Fish29 :  29,//奖券50
    Fish30 :  30,//奖券100


};

////服务器类型

var FishServerType = {
    Fish0   : 10,
    Fish1   : 11,
    Fish2   : 12,
    Fish3   : 13,
    Fish4   : 14,//
    Fish5   : 15,//
    Fish6   : 16,//
    Fish7   : 17,//
    Fish8   : 20,//
    Fish9   : 22,//
    Fish10  : 21,//
    Fish11  : 23,//
    Fish12  : 24,
    Fish13  : 25,
    Fish14  : 26,
    Fish15  : 30,
    Fish16  : 31,
    Fish17  : 50,//银龙
    Fish18  : 51,//金龙
    Fish19  : 32,//银蛤蟆
    Fish21  : 40,//炸弹

    Fish23  : 33,//金蛤蟆
    Fish22  : 34,//金蛤蟆
    Fish20  : 35,//金蛤蟆
    Fish50  : 36,//金蛤蟆

    Fish24 :  60,//奖券1
    Fish25 :  61,//奖券1
    Fish26 :  62,//奖券1
    Fish27 :  63,//奖券1
    Fish28 :  64,//奖券1
    Fish29 :  65,//奖券1
    Fish30 :  66,//奖券1

    ///鱼盘
    Fish32  : 70,
    Fish33  : 71,
    Fish34  : 72,
    Fish35  : 73,
    Fish36  : 74,
    Fish37  : 75,
    Fish38  : 76,
    Fish39  : 77,
    Fish40  : 78,
    Fish41  : 79,
    ///
    Fish74 :  80,//奖券1
    Fish75 :  81,//奖券1
    Fish76 :  82,//奖券1
    Fish77 :  83,//奖券1
    Fish78 :  84,//奖券1
    Fish79 :  85,//奖券1
    Fish80 :  86,//奖券1

    Fish84 :  90,//奖券1
    Fish85 :  91,//奖券1
    Fish86 :  92,//奖券1
    Fish87 :  93,//奖券1
    Fish88 :  94,//奖券1
    Fish89 :  95,//奖券1
    Fish90 :  96,//奖券1


};

/***
 * 鱼道具功能类型
 * @type {{}}
 */
var FishPropsType = {
    Common : 0, //普通鱼
    Bomb : 1, //炸弹鱼
    Plate : 2, //鱼盘
    Surprise : 3, //出奇制胜
};

/****
 *
 * @type {Fish0: string}
 */
var FishJson = {
    Fish  : 'res/fish{0}.json',
    count : 24,
};

var FishPng = {
    Fish : 'res/fish/fish{0}.png',
    Count : 24,
};

var FishPlist = {
    Fish : 'res/fish/fish{0}.plist',
    Count : 24,
};

/***
 * 贝塞尔曲线路径
 * @type {{start: *, end: *, point1: *, point2: *}}
 */
var FishBezierCfg = {
    point1  : cc.POINT_ZERO,
    point2  : cc.POINT_ZERO,
    end     : cc.POINT_ZERO,
};


var FishStatus = {
    Stay : 0,
    Swim : 1,
    Dead : 2,
};

var FishAniName = {
    Swim : 'swim',
    Dead : 'dead',
};

var Fish = cc.Sprite.extend({
    _fishId : 0,
    _serverType : 0,
    _clientType : 0,
    _fishQueneType : 0,
    _pathId : 0,
    _offset : cc.p(0,0),
    _delaytime : 0,
    _elaspetime : 0,
    _speed : 0,
    _pathPosArr : [],
    m_bOutScreen : false,
    _status : 0,
    _collisionRect : null,
    _swimSpeed : 1, //游动几倍速
    _bTideFish : false, //是否是鱼潮鱼
    _offX : 0,
    _offY : 0,
    _fishLen : 0,
    //_fishAliveTime : 0,
    _point1 : cc.p(0,0),
    _point2 : cc.p(0,0),
    _fpoint : cc.p(0,0),

    ctor : function(servertype){
        this._super();

        this._status = FishStatus.Stay;
        this._serverType = servertype;
        this._clientType = FishGlobal.getFishClientType(servertype);
        this._fishQueneType = FishGlobal.getFishPropsType(servertype);
        this.m_bOutScreen = false;
        return true;
    },

    isOutOfScreen : function(){
        if((this.x+this.width) > 0 && (this.x-this.width) < 1136
            && (this.y+this.height) > 0 && (this.y-this.height) < 640){
            return false;
        }

        return true;
    },

    getClientType : function(){
        return this._clientType;
    },

    getStatus : function(){
        return this._status;
    },

    getId : function(){
        return this._fishId;
    },

    getServerType : function(){
        return this._serverType;
    },

    setPathArr : function(){
        this._pathPosArr = [];
        var pathInfo = FishGlobal.getFishPathPosArr(this._pathId);
        if (pathInfo){
            this._pathPosArr = pathInfo.posArr;
        }
    },

    isCanCollision : function(){
        return (this._status == FishStatus.Swim) && this.isVisible() && !this.isOutOfScreen(this.getPosition())
    },


    OnUpdate : function(dt){
        this._elaspetime += dt*this._swimSpeed;

        // if(this._delaytime >= 0) {
        //     if(this._elaspetime < this._delaytime){
        //         if (this.isVisible()){
        //             this.setVisible(false);
        //         }
        //         return;
        //     }
        //
        //     if (this._delaytime > 0){
        //         this._elaspetime = 0;
        //     }
        //     this._delaytime = -1;
        // }

        if (!this.isVisible()){
            this.setVisible(true);
        }

        var fIndex = (this._elaspetime*this._speed)*0.1;
        var index = parseInt(fIndex);
        if (index < 0){
            index = 0;
        }
        else if (index >= this._pathPosArr.length){
            index = this._pathPosArr.length-1;
        }

        ////
        var diff = fIndex-index;
        if (index < this._pathPosArr.length-1){
            this._point1 = this._pathPosArr[index].pos;
            this._point2 = this._pathPosArr[index+1].pos;
            this._fpoint.x = this._point1.x*(1-diff)+this._point2.x*diff+this._offset.x;
            this._fpoint.y = this._point1.y*(1-diff)+this._point2.y*diff+this._offset.y;
        }
        else{
            this._fpoint.x = this._pathPosArr[index].pos.x+this._offset.x;
            this._fpoint.y = this._pathPosArr[index].pos.y+this._offset.y;
            this.m_bOutScreen = true;
        }

        this.setRotation(this._pathPosArr[index].angle);
        this.setPosition(this._fpoint);
        // this.attr({x:this._fpoint.x, y:this._fpoint.y, rotation: this._pathPosArr[index].angle});
    },

    setObb : function(){
        var rect = FishGlobal.getFishCollisionInfo(this._serverType);
        if (rect == null){
            rect = cc.rect(0, 0, this.width, this.height);
        }
        var abrect = new cc.math.AABB(cc.math.vec3(rect.x, rect.y, 0), cc.math.vec3(rect.width+rect.x, rect.height+rect.y, 0));
        this._obb = new cc.math.OBB(abrect);
    },

    getObb : function(){
        return this._obb;
    },

    setCollisionRect : function(){
        var rect = FishGlobal.getFishCollisionInfo(this._serverType);
        if (rect == null){
            rect = cc.rect(this.x, this.y, this.width, this.height);
        }
        this._collisionRect = rect;
    },

    getCollisionRect : function(){
        this._collisionRect.x += (this.x+this._collisionRect.width/2+this._offX);
        this._collisionRect.y += (this.y+this._collisionRect.height/2+this._offY);
        return this._collisionRect;
    },

    setFishLength : function(){
        this._fishLen = Math.sqrt(this.width*this.width + this.height*this.height) * 0.5;
    },

    getFishLength : function(){
        return this._fishLen;
    },

});

/***
 * 普通鱼对象
 */
var CommFish = Fish.extend({
    _status : FishStatus.Stay,
    _bSurperise : 0,
    _bezier : null,
    _anisp : null,
    _platesp : null,
    _swimAni : null,
    _deadAni : null,

    ctor : function(servertype){
        this._super(servertype);

        this._status = FishStatus.Stay;
        this._serverType = servertype;
        this._clientType = FishGlobal.getFishClientType(servertype);
        this._fishQueneType = FishGlobal.getFishPropsType(servertype);
        this._bSurperise = false;
        this.m_bOutScreen = false;
        this.setObb();
        this.setFishLength();
        this.setAnchorPoint(cc.p(0.5, 0.5));
    },

    createSurperise : function(){
        this._bSurperise = true;
        this._status = FishStatus.Swim;

        this.initWithSpriteFrameName(FishSceneRes.FishPlateRes.Plate5);

        this._platesp = Plate.create(5);
        this.addChild(this._platesp, 0, 'plate');
        this.setContentSize(this._platesp.getContentSize());
        this._platesp.setPosition(cc.p(this.width/2,this.height/2));

        this._anisp = new cc.Sprite();
        this._anisp.setPosition(cc.p(this.width/2,this.height/2));
        this.addChild(this._anisp, 1);
        var name = 'Swim'+this._clientType;
        this._anisp.runAction(new cc.RepeatForever(FYEngine.createAnimate(name)));

        this.setObb();
        this.setFishLength();
    },

    createCouponFish : function(clienttype){
        this.setSpriteFrame(FishSceneRes.Png.FishCoupon);
        this._status = FishStatus.Swim;
        var count = ['1', '2', '5', '10', '20', '50', '100'];
        var index = clienttype-FishClientType.Fish24;
        var labelcou = FYEngine.createAlts(FishSceneRes.Png.Num3, 10, count[index], '0');
        labelcou.setPosition(cc.p(35, 35));
        this.addChild(labelcou, 1, 'couponcount');
        this.setObb();
        this.setFishLength();
    },


    playSwim : function(){
        this._status = FishStatus.Swim;
        var name = 'Swim'+this._clientType;
        var fishname = 'fish'+this._clientType+'_0.png';
        this.initWithSpriteFrameName(fishname);
        this.setFishLength();
        this.runAction(new cc.RepeatForever(FYEngine.createAnimate(name)));
    },

    playDead : function(target){
        if (this._status == FishStatus.Dead){
            return;
        }
        this._status = FishStatus.Dead;
        target.stopAllActions();
        target.unscheduleAllCallbacks();

        var name = 'Dead'+this._clientType;
        var self = this;
        target.runAction(new cc.Sequence(FYEngine.createAnimate(name), new cc.CallFunc(function(){
            self.removeFromBezier();
        })));
    },

    playCouponDead : function(chairid, endpos){
        this.unscheduleUpdate();
        this._status = FishStatus.Dead;
        this.runAction(new cc.RepeatForever(new cc.RotateBy(1, 720)));

        var distance = FYMath.getDistance(this.x, this.y, endpos.x, endpos.y);
        var moveto = new cc.MoveTo(distance*0.002, endpos);
        var scaleto = new cc.ScaleTo(distance*0.002, 0);
        var self = this;
        this.runAction(new cc.Sequence(new cc.Spawn(moveto, scaleto), new cc.CallFunc(function(){
            self.removeFromBezier();
            var scene = FYEngine.getRunningLayer(0);
            scene.changeUserCoup(chairid);
        })));
    },

    playBezier : function(info){
        this._pathId = info.iPathId;
        this._speed = info.iSpeed;//
        this._delaytime = info.iAlieveTime;
        this._elaspetime = info.iAlieveTime > 0 ? 0 : Math.abs(info.iAlieveTime);
        this._offset = cc.p(info.iOffsetX, info.iOffsetY);
        this._fishId = info.iFishId;

        this.setPathArr();
        this.setPosition(cc.p(-500, -500));
        this.setFishFlipped(this._pathPosArr[0].pos.x, this._pathPosArr[this._pathPosArr.length-1].pos.x);

        this.scheduleUpdate();
    },

    isNeedFlipped : function(){
        switch (this._clientType){
            case FishClientType.Fish1:
            case FishClientType.Fish2:
            case FishClientType.Fish4:
            case FishClientType.Fish5:
            case FishClientType.Fish7:
            case FishClientType.Fish9:
            case FishClientType.Fish13:
                return true;
                break;
            default:
                return false;
                break;
        }
    },

    setFishFlipped : function(bx, ex){
        if (!this.isNeedFlipped()){
            return;
        }

        if (!this._anisp){
            if (bx > ex){
                this.setFlippedX(true);
            }
            else {
                this.setFlippedX(false);
            }
        }
        else{
            if (bx > ex){
                this._anisp.setFlippedX(true);
            }
            else {
                this._anisp.setFlippedX(false);
            }
        }
    },

    update : function(dt){
        if (this.m_bOutScreen){
            this.setPosition(-500, -500);
            this.removeFromBezier();
            return;
        }

        this.OnUpdate(dt);
    },

    removeFromBezier : function(){
        var scene = FYEngine.getRunningLayer(0);
        scene._fishArr.remove(this);

        cc.pool.putInPool(this);
    },

    blinkBlink : function(){
        if(this._bSurperise == true){
            this.runAction(new cc.Sequence(new cc.TintTo(0.2,150,100,100),new cc.TintTo(0.2,255,255,255)));
            this._platesp.runAction(new cc.Sequence(new cc.TintTo(0.2,150,100,100),new cc.TintTo(0.2,255,255,255)));
            this._anisp.runAction(new cc.Sequence(new cc.TintTo(0.2,150,100,100),new cc.TintTo(0.2,255,255,255)));
        }else{
            this.runAction(new cc.Sequence(new cc.TintTo(0.2,150,100,100),new cc.TintTo(0.2,255,255,255)));
        }
    },

    setFishDead : function(){
        this.unscheduleAllCallbacks();
        if (this._anisp){
            this.playDead(this._anisp);
        }
        else{
            this.playDead(this);
        }
    },

    unuse : function(){
        this._status = FishStatus.Stay;
        this._offX = this._offY = 0;
        this._bSurperise = false;
        this.m_bOutScreen = false;
        this._elaspetime = 0;
        this._swimSpeed = 1;
        this._bTideFish = false;
        this.stopAllActions();
        this.unscheduleAllCallbacks();
        if (this._platesp){
            this._platesp.removeSelf();
            this._platesp = null;
        }
        if (this._anisp){
            this._anisp.stopAllActions();
            this._anisp.removeFromParent();
            this._anisp = null;
        }

        this.removeAllChildren(true);
        this.removeFromParent(true);
    },

    reuse : function(servertype){
        this._status = FishStatus.Stay;
        this._serverType = servertype;
        this._clientType = FishGlobal.getFishClientType(servertype);
        this._fishQueneType = FishGlobal.getFishPropsType(servertype);
        this._bSurperise = false;
        this.m_bOutScreen = false;
        this._elaspetime = 0;
        this._swimSpeed = 1;
        this._offset = cc.p(0,0);
        this.setAnchorPoint(cc.p(0.5, 0.5));
        this.setContentSize(cc.size(0,0));
        this.setFlippedX(false);
        this.setScale(1);//针对奖券鱼
        this.setOpacity(255);
        this.setObb();
        this.setFishLength();

    },

});

CommFish.create = function(info){
    // cc.log('------创建fish 普通鱼');
    var fish = null;
    if (cc.pool.hasObject(CommFish)){
        fish = cc.pool.getFromPool(CommFish, info.iFishType);
    }
    else {
        fish = new CommFish(info.iFishType);
    }
    if (info.bSurprise >= 1 && info.bSurprise <= 20){
        fish.createSurperise();
    }
    else{
        if (fish._clientType < FishClientType.Fish24) {
            fish.playSwim();
        }
        else {
            fish.createCouponFish(fish._clientType);
        }
    }
    fish.setVisible(false);
    fish.playBezier(info);
    return fish;
};

CommFish.createPlateFish = function(info, plateinfo){

    var fish = null;
    var servertype = parseInt(plateinfo.fishTypex);
    if (cc.pool.hasObject(CommFish)){
        fish = cc.pool.getFromPool(CommFish, servertype);
    }
    else{
//        cc.log('-------鱼盘鱼不够, type : ' + servertype);
        fish = new CommFish(servertype);
    }
    fish.setVisible(true);
    fish.setRotation(0);
    fish.playSwim();
    return fish;
};




/***
 * 鱼盘
 */
var Plate = cc.Sprite.extend({
    _type : 0,
    _repet : null,

    ctor : function (type) {
        this._super();
        this._type = type;
        this.initWithSpriteFrameName(this.getPlateResName(type));
        this._repet = new cc.RepeatForever(new cc.RotateBy(5, 720));
        this._repet.retain();
        this.setObb();
    },

    playAction : function(){
        this.runAction(this._repet);
    },

    getPlateResName : function(type){
        var name = '';
        switch (type){
            case 1:
                name = FishSceneRes.FishPlateRes.Plate1;
                break;
            case 2:
                name = FishSceneRes.FishPlateRes.Plate2;
                break;
            case 3:
                name = FishSceneRes.FishPlateRes.Plate3;
                break;
            case 4:
                name = FishSceneRes.FishPlateRes.Plate4;
                break;
            case 5: //出奇制胜
                name = FishSceneRes.FishPlateRes.Plate5;
                break;
            default:
                name = FishSceneRes.FishPlateRes.Plate1;
                break;
        }
        return name;
    },

    removeSelf : function(){
        cc.pool.putInPool(this);
    },

    removeSurperise : function(){
        cc.pool.putInPool(this);
    },

    unuse : function(){
        this.unscheduleAllCallbacks();
        this.stopAllActions();
        this.setVisible(false);
        this.removeFromParent(true);
    },

    reuse : function(type){
        this.setScale(1);
        this.setOpacity(255);
        this.setVisible(true);
        this._type = type;
        this.setSpriteFrame(this.getPlateResName(type));
        this.setObb();
    },

    setObb : function(){
        var px = 0,py = 0,pw = this.width,ph = this.height;
        switch (this._type){
            case 1:{
                px = py = 3;
                pw = ph = 103;
            }
                break;
            case 2:{
                px = py = 13;
                pw = ph = 134;
            }
                break;
            case 3:{
                px = py = 13;
                pw = ph = 165;
            }
                break;
            case 4:{
                px = py = 5;
                pw = ph = 191;
            }
                break;
            case 5:{
                px = py = 17;
                pw = ph = 171;
            }
                break;
            default:
                break;
        }
        var abrect = new cc.math.AABB(cc.math.vec3(px, py, 0), cc.math.vec3(px+pw, py+ph, 0));
        this._obb = new cc.math.OBB(abrect);
    },

    getObb : function(){
        return this._obb;
    }

});

Plate.create = function(type){
    var plate = null;
    if (cc.pool.hasObject(Plate)){
        plate = cc.pool.getFromPool(Plate, type);
    }
    else{
//        cc.log('-------Plate pool is not enouth : ' + type);
        plate = new Plate(type);
    }
    plate.playAction();
    return plate;
};


/***
 * 鱼盘整体
 */
var PlateFish = Fish.extend({
    _commfish : [],
    _plate : [],
    _status : FishStatus.Stay,

    ctor : function(info){
        this._super(info.iFishType);
        this._status = FishStatus.Stay;
        this._commfish = [];
        this._plate = [];
        this._offset = cc.p(0,0);
        this._clientType = FishGlobal.getFishClientType(info.iFishType);
        this._fishQueneType = FishGlobal.getFishPropsType(info.iFishType);

        var plateInfo = FishGlobal.getFishPlateInfo(info.iFishType);
        for (var i = 0; i < plateInfo.array.length; ++ i){
            var offx = Number(plateInfo.array[i].fx);
            var offy = Number(plateInfo.array[i].fy);
            var fish = CommFish.createPlateFish(info, plateInfo.array[i]);
            fish.setPosition(cc.p(offx, offy));
            fish._offX = offx;
            fish._offY = offy;
            this.addChild(fish, 1);
            this._commfish.push(fish);

            var plate = Plate.create(parseInt(plateInfo.array[i].faType));
            plate.setPosition(cc.p(offx, offy));
            this.addChild(plate, 0);
            this._plate.push(plate);
        }
        this.setContentSize(cc.size(plateInfo.px, plateInfo.py));
        this.setAnchorPoint(cc.p(0.5, 0.5));
        this.setFishLength();
    },

    setFishFlipped : function(bx, ex){
        for (var i = 0; i < this._commfish.length; ++ i){
            this._commfish[i].setFishFlipped(bx, ex);
        }
    },


    removeFromBezier : function(){
        var scene = FYEngine.getRunningLayer(0);
        scene._fishArr.remove(this);

        this.stopAllActions();
        for (var i = 0; i < this._commfish.length; ++ i){
            this._commfish[i].removeFromBezier();
        }
        for (var i = 0; i < this._plate.length; ++ i){
            this._plate[i].removeSelf();
        }
        this.removeFromParent();
    },

    setFishDead : function(){
        this._status = FishStatus.Dead;
        this.unscheduleAllCallbacks();
        var scene = FYEngine.getRunningLayer(0);
        scene._fishArr.remove(this);
        var self = this;


        this.runAction(new cc.Sequence(new cc.CallFunc(function(){
            for (var i = 0; i < self._commfish.length; ++ i){
                self._commfish[i].setFishDead();
                self._plate[i].stopAllActions();
            }
            self._commfish = [];
        }), new cc.DelayTime(0.8), new cc.CallFunc(function(){
            for (var i = 0; i < self._plate.length; ++ i){
                self._plate[i].removeSelf();
            }
            self._plate = [];
        }), new cc.DelayTime(0.05), new cc.CallFunc(function(){
            self.removeAllChildren();
            self.removeFromParent();
        })));
    },

    blinkBlink : function(){
        var self = this;
        for (var i = 0; i < self._plate.length; ++ i){
            self._plate[i].runAction(new cc.Sequence(new cc.TintTo(0.2,150,100,100),new cc.TintTo(0.2,255,255,255)));
        }
        for (var j = 0; j < self._commfish.length; ++ j){
            self._commfish[j].runAction(new cc.Sequence(new cc.TintTo(0.2,150,100,100),new cc.TintTo(0.2,255,255,255)));
        }
    },

    setFishSwim : function(){
        this._status = FishStatus.Swim;
        for (var i = 0; i < this._commfish.length; ++ i){
            this._commfish[i]._status = FishStatus.Swim;
        }
    },



    playBezier : function(info){
        this.setFishSwim();

        this._pathId = info.iPathId;
        this._speed = info.iSpeed;
        this._delaytime = info.iAlieveTime;
        this._elaspetime = info.iAlieveTime > 0 ? 0 : Math.abs(info.iAlieveTime);
        this._offset = cc.p(info.iOffsetX, info.iOffsetY);
        this._fishId = info.iFishId;

        this.setPathArr();
        this.setPosition(cc.p(-500, -500));
        // if(this._pathPosArr[0] == undefined){
        //     FYEngine.logObject(info,'-----------------------------pathid == undefined:');
        //     cc.log('---------pathid+'+this._pathId);
        // }
        this.setFishFlipped(this._pathPosArr[0].pos.x, this._pathPosArr[this._pathPosArr.length-1].pos.x);

        this.scheduleUpdate();
    },

    update : function(dt){
        if (this.m_bOutScreen){
            this.setPosition(-500, -500);
            this.removeFromBezier();
            return;
        }

        this.OnUpdate(dt);
    },


});


PlateFish.create = function(info){
    // cc.log('------创建fish 鱼盘鱼');
    var fish = new PlateFish(info);
    fish.setVisible(false);
    fish.playBezier(info);
    return fish;
};


