/**
 * Created by mintao on 16/8/30.
 */


/***
 * 捕鱼广播
 * 大厅\捕鱼场
 */
var FishBroadCast = FYEngine.RichBroadCast.extend({
    _handler : null,
    _gamebroadLen : 0,

    ctor : function(filename, size, rect, masksize, maskpos, move, textureType, isshow){
        this._super(filename, size, rect, masksize, maskpos, move, textureType, isshow);

        this._handler = CoreServiceProxy.getInstance().getGameHandler();

        this._gamebroadLen = 0;
        this.scheduleUpdate();

        return true;
    },

    update : function(dt){
        if(this._handler){
            if (this._handler._fishData._fishSceneBroadArry.length == 0 && this._broadlab == null){
                return;
            }

            if (this._broadlab == null){
                if (!this._isAwlaysShow){
                    this.setVisible(true);
                }
                var broadInfo = this._handler._fishData._fishSceneBroadArry.shift();
//            cc.log('----broadInfo----------'+broadInfo.szMsg);
                this.setLabelText(broadInfo.szMsg, cc.color.WHITE, cc.color(254, 245, 6), 30); //
                this._gamebroadLen = -(this._broadlab.getVirtualRendererSize().width-this._broadlength*this.count+10);
                return;
            }

            this.OnUpdategame(dt);
        }

    },

    OnUpdategame : function(dt){
        if (!this._broadlab){
            return;
        }

        this._broadlab.x -= this._move;
        if (this._broadlab.x < this._gamebroadLen){
            this._broadlab.removeFromParent();
            this._broadlab = null;
            if (this._handler._fishData._fishSceneBroadArry.length==0){
                this.setVisible(false);
            }
        }
    },
});

