/**
 * Created by mintao on 16/6/6.
 */

var FishProtocol = {
    GameBaseProto   : 100, //游戏基础主协议
    PlayerLogin     : 0,
    PlayerLogout    : 1,
    ReLogin         : 2, //断线重连
    Gameing         : 3, //未完成游戏
    GoldApply       : 4, //申请财富
    GoldBack        : 5, //归还财富
    GoldQuery       : 6, //财富查询
    GameKicked      : 7, //被游戏服务器踢出

    FishProto       : 107, //捕鱼游戏主消息
    JoinTable       : 0, //加入桌子
    JoinEvent       : 1, //加入桌子事件（广播给其他玩家）
    LeaveTable      : 2, //离开桌子 & 离开桌子事件
    SyncTable       : 3, //同步(恢复)牌桌
    TideStart       : 4, //鱼潮开始
    UpdateFish      : 5, //刷新鱼 & 恢复牌桌&断线重连推送
    UpdateBullet    : 6, //刷新子弹（恢复牌桌&断线重连推送）
    Collision       : 7, //碰撞
    FireBullet      : 8, //发射子弹
    ChangeCannon    : 9, //切换炮台
    KillFish        :10, //打死鱼奖励
    OnReliveInfo    :18, //玩家领取救济金后财富刷新;
    IntergralNumber : 20, //
    FreeRommKick    :22,//踢出玩家
    FireSpecial     :23,//发射特殊子弹
    KillSpecialFish :24,//特殊子弹杀死鱼
    copyCollision   : 36, //副本碰撞
    copyKillFish    : 37, //副本打死鱼奖励
    copyGetTime     : 38, //副本场景时间获取
    copyGetWealth   : 39, //副本财富
    copyCombine     : 40, //副本合成
    copyGetConf     : 41, //副本房间获取配置
    copyCombList    : 42, //副本合成列表
    getBulletType   : 43, //获取特殊弹头的配置
    createTable     : 44, // 创建房间
    canCreateTable  : 45, // 查询能否创建
    queryTableInfo  : 46, // 查询桌子信息
    dissoveTable    : 47, // 解散桌子
    queryScore      : 48, // 分数查询
    fightResult     : 49, // 结算信息
    gameStart       : 50, // 游戏开始
    linkOff          : 51, //玩家掉线
    copyResult      :52, //副本的奖励结果
    GET_P_INFO      :54, //
    SYLZ_BUY_BOOM   :55,
    SYLZ_LOTTERY    :56,
    JZSJ_CREATE_ROOM:57,
    JZSJ_GAME_START :58,
    JZSJ_LOTTERY    :59,
    JZSJ_STATUS     :60,


    FishBroad       : 15, //渔场内广播主协议
    FishBroadMsg    : 0, //渔场内广播

    FishSceneRelive      : 12, //渔场内救济金主协议
    FishSceneReliveGet   : 12,  // 渔场内救济金领取
};


/****
 * GameBaseProto
 * 游戏基础消息
 */
FishProtocol.PlayerLoginReq = {
    lRoleId : 0,
    iSourceId : 0,
    szGameToken : ''
};

FishProtocol.PlayerLoginRsp = {
    iResult : 0,
    lRoleId : 0,
    szGameToken : '',
    iGender : 0,
    szNickName : '',
    szFaceId : '',
    iFaceStatus : 0,
    szSigned : '', //128
    iTradeMoney : 0
};

FishProtocol.PlayerLogoutReq = {
    lRoleId : 0
};

FishProtocol.PlayerReLoginReq = {
    lRoleId : 0
};

FishProtocol.PlayerLogoutRsp = {
    iResult : 0
};

FishProtocol.PlayerReLoginReq = {
    lRoleId : 0,
    szGameToken : ''
};

FishProtocol.PlayerReLoginRsp = {
    iResult : 0,
    lGold : 0,
    lCoupon : 0,
    lScore : 0,
    lExp : 0
};

FishProtocol.JoinTableReq = {
    lRoleId : 0,
    iRate : 0,
    iRoomId : 0,
};

FishProtocol.FishUserInfo = {
    lRoleId : 0,      //玩家用户ID(-1为该椅子为空)
    iRate : 0,        //炮台倍率
    szNickName : '',  //昵称
    szFaceId : '',    //头像ID
    lGold : 0,        //玩家金豆
    lCoupon : 0,      //玩家奖券
    iChairId : 0,     //only client
};

FishProtocol.FishInfo = {
    iFishId : 0,
    iPathId:0,
    iSpeed:0,
    iOffsetX:0,
    iOffsetY:0,
    iBirthTime:0,
    iSpecialType:0,
};

FishProtocol.encode_PlayerLogin = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iSourceId);
    bb.setFixedString(req.szGameToken, FYEngine.TokenLen);
};

FishProtocol.decode_PlayerLogin = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.szGameToken = byteBuf.getFixedString(FYEngine.TokenLen);
    rsp.iGender = byteBuf.getInt32();
    rsp.szNickName = byteBuf.getFixedString(FYEngine.NickNameLen);
    rsp.szFaceId = byteBuf.getFixedString(FYEngine.FaceIdLen);
    rsp.iFaceStatus = byteBuf.getInt32();
    rsp.szSigned = byteBuf.getFixedString(FYEngine.SignLen);
    rsp.iTradeMoney = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_PlayerLogout =function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};


FishProtocol.decode_PlayerLogout = function(byteBuf){
    var rsp = createObj(FishProtocol.PlayerLogoutRsp);
    rsp.iResult = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_PlayerReLogon =function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szGameToken, FYEngine.TokenLen);
};

FishProtocol.decode_PlayerReLogon = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lExp = byteBuf.getUint64();
    return rsp;
};

FishProtocol.encode_JoinTable = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iRate);
    bb.setInt32(req.iRoomId);
};

FishProtocol.encode_JoinTableNew = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iRate);
    bb.setInt32(req.iRoomId);
    bb.setInt32(req.iTableId);
};

FishProtocol.encode_ChangeCannon = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iChairId);
    bb.setInt32(req.iRate);
    bb.setInt32(req.iType);

};

FishProtocol.encode_FireBullet = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iChairId);
    bb.setInt64(req.lBulletId);
    bb.setInt32(req.iRate);
    bb.setFloat32(req.fRotate);
    bb.setInt16(req.iType);
    bb.setInt16(0);
    bb.setInt32(req.iFireTime);
    bb.setInt32(req.bisValid);
};

FishProtocol.encode_FireSpecialBullet = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt32(req.iSpecialType);
    bb.setInt32(req.ix);
    bb.setInt32(req.iy);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iChairId);
    bb.setInt64(req.lBulletId);
    bb.setInt32(req.iRate);
    bb.setFloat32(req.fRotate);
    bb.setInt16(req.iTfirype);
    bb.setInt16(0);
    bb.setInt32(req.iFireTime);
    bb.setInt32(req.bisValid);

};

FishProtocol.encode_HitFish = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lBulletId);
    bb.setInt32(req.iHitFishId);
    bb.setInt32(req.iRate);
    bb.setInt8(req.iHitFishType);
    bb.setInt8(req.bisValid);
    bb.setInt16(req.iFishNum);
    for(var i =0;i < req.iFishNum;++i){
        bb.setInt32(req.iFishId[i]);
    }


};

FishProtocol.encode_CopyHitFish = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lBulletId);
    bb.setInt32(req.iHitFishId);
    bb.setInt32(req.iRate);
    bb.setInt8(req.iHitFishType);
    bb.setInt8(req.bisValid);
};

FishProtocol.encode_SpecialHitFish = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lGold);
    bb.setInt64(req.lCoupon);
    bb.setInt32(req.iBoomType);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lBulletId);
    bb.setInt32(req.iHitFishId);
    bb.setInt32(req.iRate);
    bb.setInt8(req.iHitFishType);
    bb.setInt8(req.bisValid);
    bb.setInt16(req.iFishNum);
    for(var i =0;i < req.iFishNum;++i){
        bb.setInt32(req.iFishId[i]);
    }


};


FishProtocol.encode_LeaveTable = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);

};

FishProtocol.encode_SyncTable = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);

};

FishProtocol.encode_FishSceneReliveGet = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


FishProtocol.encode_GetUserActiveReq = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};


FishProtocol.decode_JoinTable = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iRoomId = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();
    rsp.iChairId = byteBuf.getInt32();
    rsp.tUserInfo = [];
    for (var i = 0; i < 4; ++ i){
        var info = {};//createObj(FishProtocol.FishUserInfo);
        info.lRoleId = byteBuf.getInt64();
        info.iRate = byteBuf.getInt32();
        info.iType = byteBuf.getInt32();
        var tempname = byteBuf.getFixedString(FYEngine.NickNameLen);
        info.szNickName = SoftReplaceWords(tempname);
        info.szFaceId = byteBuf.getFixedString(FYEngine.FaceIdLen);
        info.lGold = byteBuf.getUint64();
        info.lCoupon = byteBuf.getUint64();
        info.iChairId = i;
        rsp.tUserInfo.push(info);
    }

    return rsp;
};

FishProtocol.decode_JoinTableNew = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iRoomId = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();
    rsp.iChairId = byteBuf.getInt32();
    rsp.tUserInfo = [];
    for (var i = 0; i < 4; ++ i){
        var info = {};//createObj(FishProtocol.FishUserInfo);
        info.lRoleId = byteBuf.getInt64();
        info.iRate = byteBuf.getInt32();
        info.iType = byteBuf.getInt32();
        var tempname = byteBuf.getFixedString(FYEngine.NickNameLen);
        info.szNickName = SoftReplaceWords(tempname);
        info.szFaceId = byteBuf.getFixedString(FYEngine.FaceIdLen);
        info.lGold = byteBuf.getUint64();
        info.lCoupon = byteBuf.getUint64();
        info.iChairId = i;
        rsp.tUserInfo.push(info);
    }
    rsp.iTableStatus = byteBuf.getInt32();//0游戏未开始，1游戏开始

    return rsp;
};



FishProtocol.decode_JoinEvent = function(byteBuf){
    var rsp = {};
    rsp.iChairId = byteBuf.getInt32();
    rsp.tUserInfo = {};
    rsp.tUserInfo.lRoleId = byteBuf.getInt64();
    rsp.tUserInfo.iRate = byteBuf.getInt32();
    rsp.tUserInfo.iType = byteBuf.getInt32();
    var tempname = byteBuf.getFixedString(FYEngine.NickNameLen);
    rsp.tUserInfo.szNickName = SoftReplaceWords(tempname);
    rsp.tUserInfo.szFaceId = byteBuf.getFixedString(FYEngine.FaceIdLen);
    rsp.tUserInfo.lGold = byteBuf.getUint64();
    rsp.tUserInfo.lCoupon = byteBuf.getUint64();
    rsp.tUserInfo.iChairId = rsp.iChairId;

    return rsp;

};

FishProtocol.decode_LeaveTable = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iChairId = byteBuf.getInt32();
    return rsp;
};

FishProtocol.decode_SyncTable = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iSceneTime = byteBuf.getInt32();
    rsp.iRoomId = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();
    rsp.iChairId = byteBuf.getInt32();
    rsp.tUserInfo = [];
    for (var i = 0; i < 4; ++ i){
        var info = {};//createObj(FishProtocol.FishUserInfo);
        info.lRoleId = byteBuf.getInt64();
        info.iRate = byteBuf.getInt32();
        info.iType = byteBuf.getInt32();
        info.szNickName = byteBuf.getFixedString(FYEngine.NickNameLen);
        info.szFaceId = byteBuf.getFixedString(FYEngine.FaceIdLen);
        info.lGold = byteBuf.getUint64();
        info.lCoupon = byteBuf.getUint64();
        info.iChairId = i;
        rsp.tUserInfo.push(info);
    }

    return rsp;

};

FishProtocol.decode_TideStart = function(byteBuf){
    var rsp = {};
    rsp.iTideId = byteBuf.getInt32();
    rsp.iTideTime = byteBuf.getInt32();
    rsp.iSceneTime = byteBuf.getInt32();
    return rsp;
};

FishProtocol.decode_UpdateFish = function(byteBuf){
    var rsp ={};
    rsp.iSceneTime = byteBuf.getInt32();
    rsp.iCount = byteBuf.getInt32();
    rsp.fishArry = [];
    for(var i = 0; i < rsp.iCount; ++i){
        var info = {};
        info.iFishId = byteBuf.getInt32();
        info.iPathId = byteBuf.getInt16();
        info.iSpeed = byteBuf.getInt16();
        info.iOffsetX = byteBuf.getInt16();
        info.iOffsetY = byteBuf.getInt16();
        info.iBirthTime = byteBuf.getInt32();
        info.bSurprise = byteBuf.getUint8();
        info.tidefish = byteBuf.getInt8();
        byteBuf.getInt16();
        info.iAlieveTime = (info.iBirthTime-rsp.iSceneTime)*0.001;
        info.iFishType = info.iFishId >> 24;
        info.iBirthTime = info.iBirthTime*0.001;
        rsp.fishArry.push(info);
    }

    return rsp;
};

FishProtocol.decode_UpdateBullet = function(byteBuf){
    var rsp ={};
    rsp.iSceneTime = byteBuf.getInt32()*0.001;
    rsp.icount = byteBuf.getInt32();
    rsp.bulletArry =[];
    for(var i = 0 ;i < rsp.icount ; ++i){
        var info = {};
        info.lRoleId = byteBuf.getUint64();
        info.iChairId = byteBuf.getInt32();
        info.lBulletId = byteBuf.getUint64();
        info.iRate = byteBuf.getInt32();
        info.iRotate = byteBuf.getFloat32();
        info.iType = byteBuf.getInt16();
        byteBuf.getInt16();
        var birthtime = byteBuf.getInt32()*0.001;
        info.iFireTime = birthtime - rsp.iSceneTime;
        info.bisValid = byteBuf.getInt32();
        if(info.iType ==101){
            continue;
        }
        rsp.bulletArry.push(info);
    }
    return rsp;
};

FishProtocol.decode_Collision = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.lBulletId = byteBuf.getUint64();
    rsp.iHitFishId = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iHitFishType = byteBuf.getInt8();
    rsp.bisValid = byteBuf.getInt8();
    rsp.iFishNum = byteBuf.getInt16();
    rsp.iFishId = [];
    for(var i =0 ; i< rsp.iFishNum ; ++i){
        var id = byteBuf.getInt32();
        rsp.iFishId.push(id);
    }
    return rsp;
};

FishProtocol.decode_CopyCollision = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.lBulletId = byteBuf.getUint64();
    rsp.iHitFishId = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iHitFishType = byteBuf.getInt8();
    rsp.bisValid = byteBuf.getInt8();
    rsp.iFishNum = byteBuf.getInt16();
    return rsp;
};

FishProtocol.decode_SpecialCollision = function(byteBuf){
    var rsp ={};
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.iBoomType =byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.lBulletId = byteBuf.getUint64();
    rsp.iHitFishId = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iHitFishType = byteBuf.getInt8();
    rsp.bisValid = byteBuf.getInt8();
    rsp.iFishNum = byteBuf.getInt16();
    rsp.iFishId = [];
    rsp.iFishType =[];
    rsp.tReward =[];
    for(var i =0 ; i< rsp.iFishNum ; ++i){
        var id = byteBuf.getInt32();
        rsp.iFishId.push(id);

        var fishtype = id >>24;
        rsp.iFishType.push(fishtype);
        var reward = FishGlobal.getFishReward(fishtype);
        if (reward){
            var temp = {};
            temp.iRewardType = reward.type;
            temp.iRewardNum = reward.count;
            rsp.tReward.push(temp);
        }
    }

    return rsp;
};

FishProtocol.decode_FireBullet = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iChairId = byteBuf.getInt32();
    rsp.lBulletId = byteBuf.getUint64();
    rsp.iRate = byteBuf.getInt32();
    rsp.iRotate = byteBuf.getFloat32();
    rsp.iType = byteBuf.getInt16();
    byteBuf.getInt16();
    rsp.iFireTime = byteBuf.getInt32();
    rsp.bisValid = byteBuf.getInt32();
    return rsp;
};

FishProtocol.decode_FireSpecialBullet = function(byteBuf){
    var rsp ={};
    rsp.iSpecialType = byteBuf.getInt32();
    rsp.ix = byteBuf.getInt32();
    rsp.iy = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iChairId = byteBuf.getInt32();
    rsp.lBulletId = byteBuf.getUint64();
    rsp.iRate = byteBuf.getInt32();
    rsp.iRotate = byteBuf.getFloat32();
    rsp.iType = byteBuf.getInt16();
    byteBuf.getInt16();
    rsp.iFireTime = byteBuf.getInt32();
    rsp.bisValid = byteBuf.getInt32();
    return rsp;
};

FishProtocol.decode_ChangeCannon = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iChairId = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iType = byteBuf.getInt32();
    return rsp;
};

FishProtocol.decode_KillFish = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iChairId = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iFishCount = byteBuf.getInt32();
    rsp.iFishId = [];
    rsp.iFishType = [];
    rsp.tReward = [];
    rsp.lRewardGold = 0;
    rsp.lRewardCoupon = 0;
    for(var i =0 ;i <rsp.iFishCount ;++i){
        var fishid = byteBuf.getInt32();
        rsp.iFishId.push(fishid);
        var fishtype = fishid >>24;
        if (fishtype == 0){
//            cc.log('-------------死亡鱼的type:');
        }
        rsp.iFishType.push(fishtype);
        var reward = FishGlobal.getFishReward(fishtype);
        if (reward){
            var temp = {};
            temp.iRewardType = reward.type;
            temp.iRewardNum = reward.count;
            rsp.tReward.push(temp);
            if (temp.iRewardType == 0){
                rsp.lRewardGold += temp.iRewardNum*rsp.iRate;
            }
            else{
                rsp.lRewardCoupon += temp.iRewardNum*rsp.iRate*0.01;
            }
        }
        else{
//            cc.log('---------rewaed is null !!!!, fishtype : '+fishtype);
        }
    }
    return rsp;
};

FishProtocol.decode_CopyKillFish = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iChairId = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    var fishid = byteBuf.getInt32();
    rsp.iFishId =fishid;
    rsp.iFishType = fishid >>24;
    rsp.iCoinType = byteBuf.getInt32();
    rsp.iCoinCount =  byteBuf.getUint64();
    var reward = FishGlobal.getFishReward(rsp.iFishType);
    if (reward){
        rsp.iRewardNum = reward.count;
    }else{
        rsp.iRewardNum =0;
    }

    return rsp;
};

FishProtocol.decode_FishSceneBroadMsg = function (byteBuf) {
    var rsp ={};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iArea = byteBuf.getInt32();
    rsp.iShowType = byteBuf.getInt32();
    rsp.iLevel = byteBuf.getInt32();
    rsp.iGameId = byteBuf.getInt32();
    rsp.iMsgLen = byteBuf.getInt32();
    rsp.szMsg = byteBuf.getFixedString(rsp.iMsgLen);
    return rsp;
};

FishProtocol.decode_FishSceneReliveGet = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.iTimes = byteBuf.getInt32();
    rsp.iAddGold = byteBuf.getInt32();
    rsp.lTotalGold = byteBuf.getUint64();
    return rsp;
};

FishProtocol.decode_ReliveInfo = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    byteBuf.getUint64();
    byteBuf.getUint64();
    return rsp;
};

FishProtocol.decode_IntergralResultRsp = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lExp = byteBuf.getUint64();
    return rsp;
};

FishProtocol.decode_GetUserActiveRsp = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iLevel = byteBuf.getInt32();
    rsp.lActive = byteBuf.getInt64();
    return rsp;
};

FishProtocol.decode_FreeGameKickNoticeRsp = function(byteBuf){
    var rsp ={};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iReason = byteBuf.getInt32();// 1时间到、2银币打完
    rsp.iRoomId = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();
    rsp.iChairId = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_UpdateWealth = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};
FishProtocol.decode_UpdateWealth = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lExp = byteBuf.getUint64();


    //cc.log('--------decode_UpdateWealth rsp.lGold: '+rsp.lGold+'---rsp.lCoupon:'+rsp.lCoupon);
    return rsp;
};

FishProtocol.encode_getSceneTime = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_getSceneTime = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iRoomId = byteBuf.getInt32();
    rsp.iAllGameTime = byteBuf.getUint32();
    rsp.iSceneTime = byteBuf.getUint32();

    return rsp;
};

FishProtocol.encode_copyGetWealth = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_copyGetWealth = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iCount = byteBuf.getInt32();
    rsp.coinArry = [];
    for(var i=0;i<rsp.iCount;++i){
        var coininfo = {};
        coininfo.iCoinType = byteBuf.getInt32();
        coininfo.iCoinCount = byteBuf.getUint64();
        rsp.coinArry.push(coininfo);
    }

    return rsp;
};

FishProtocol.encode_copyHecheng = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iCount);
    bb.setInt32(req.iHechengId);
    bb.setInt32(req.iReserved);
};

FishProtocol.decode_copyhHecheng = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iCount = byteBuf.getInt32();
    rsp.iHechengId = byteBuf.getInt32();
    rsp.iReserved = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_copyHechengList = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_copyhHechengList = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iCount = byteBuf.getUint32();
    rsp.iList =[];
    for(var i =0; i<rsp.iCount;++i){
        var mlist = {};
        mlist.iHechengId = byteBuf.getInt32();
        mlist.iCount = byteBuf.getInt32();
        mlist.content =[];
        for(var j=0;j<mlist.iCount;++j){
            var coininfo = {};
            coininfo.iCoinType = byteBuf.getInt32();
            coininfo.iCoinCount = byteBuf.getUint64();
            mlist.content.push(coininfo);
        }
        rsp.iList.push(mlist);
    }
    return rsp;
};

FishProtocol.encode_getCopyRoomCfg = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_getCopyRoomCfg = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iList =[];
    for(var i =0; i<3;++i){
        var info ={};
        info.iRoomId = byteBuf.getInt32();//房间id
        info.iSceneTime = byteBuf.getInt32();//房间最大游戏时长
        info.lMinGold = byteBuf.getUint64(); //最小金豆限制
        info.lMaxGold = byteBuf.getUint64(); //最大金豆限制
        info.iRate = byteBuf.getInt32();  //炮台倍率
        info.iExpendScore = byteBuf.getInt32();  //消耗积分
        rsp.iList.push(info);
    }
    return rsp;
};


FishProtocol.encode_getBulletType = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_getBulletType = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iMaxGold = byteBuf.getInt32();//一个弹头最多获取金豆数量
    rsp.iCount = byteBuf.getInt32();//弹头信息配置信息
    rsp.iList =[];
    for(var i =0; i<rsp.iCount;++i){
        var info ={};
        info.iBulletType = byteBuf.getInt32();//弹头类型
        info.iHedanCount = byteBuf.getInt32();//消耗核弹数量
        rsp.iList.push(info);
    }
    return rsp;
};

FishProtocol.encode_createFightTable = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iCoinType);
    bb.setInt32(req.iMaxPlayer);
    bb.setInt32(req.iDesScore);
    bb.setInt32(req.iTimeMs);
    for(var i =0;i<4;++i){
        bb.setInt32(req.iPrize[i]);
    }
};

FishProtocol.decode_createFightTable = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iTableId = byteBuf.getInt32();//牌桌号
    rsp.lMainRole = appglobal.getPlayer().userid;//房主id
    rsp.iCoinType = byteBuf.getInt32();
    rsp.iMaxPlayer = byteBuf.getInt32();
    rsp.iDesScore = byteBuf.getInt32();
    rsp.iTimeMs = byteBuf.getInt32();
    rsp.iPrize =[];
    for(var i =0;i<4;++i){
        rsp.iPrize.push(byteBuf.getInt32());
    }
    return rsp;
};

FishProtocol.encode_canCreateTable = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_canCreateTabel = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iTotalPay = byteBuf.getInt32();//需要充值总额
    rsp.iMoney = byteBuf.getInt32();//还需要充值数
    rsp.iPay = byteBuf.getInt32();//已充值数
    return rsp;
};

FishProtocol.encode_dissolveTabel = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iTableId);
};

FishProtocol.decode_dissolveTabel = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_queryUnfinishTable = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.gameid);
};

FishProtocol.decode_queryUnfinishTable = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.iRoomId = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();
    rsp.iChairId = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_sendQueryTableInfo = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iTableId);
    bb.setInt32(req.iReserved);
};

FishProtocol.decode_sendQueryTableInfo = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.lMainRole = byteBuf.getInt64();
    rsp.iTableId = byteBuf.getInt32();//牌桌号
    rsp.iCoinType = byteBuf.getInt32();
    rsp.iMaxPlayer = byteBuf.getInt32();
    rsp.iDesScore = byteBuf.getInt32();
    rsp.iTimeMs = byteBuf.getInt32();
    rsp.iPrize =[];
    for(var i =0;i<4;++i){
        rsp.iPrize.push(byteBuf.getInt32());
    }
    rsp.iReserved = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_sendGameStart = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

FishProtocol.decode_sendGameStart = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();//牌桌号
    return rsp;
};

FishProtocol.decode_gameResultInfo = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.iTableId = byteBuf.getInt32();//牌桌号
    rsp.iCoinType = byteBuf.getInt32();
    rsp.iMaxPlayer = byteBuf.getInt32();
    rsp.tScore =[];
    for(var i =0 ;i<4;++i){
        var temp ={};
        temp.szNickName = "";
        temp.szFaceId = "";
        temp.lRoleId = byteBuf.getInt64();
        temp.lUserId = byteBuf.getInt64();
        temp.iChairId =byteBuf.getInt32();
        temp.iScore = byteBuf.getInt32();
        temp.iPrize = byteBuf.getInt32();
        rsp.tScore.push(temp);
    }

    return rsp;
};

FishProtocol.encode_sendQueryPlayerScore = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iTableId);
};

FishProtocol.decode_sendQueryPlayerScore = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iTableId = byteBuf.getInt32();//牌桌号
    rsp.iMaxPlayer = byteBuf.getInt32();
    rsp.iFinChair = [];
    for(var i =0 ;i<4;++i){
        var temp1 ={};
        temp1.fchair = byteBuf.getInt32();
        rsp.iFinChair.push(temp1);
    }
    rsp.tScore =[];
    for(var j =0 ;j<4;++j){
        var temp2 ={};
        temp2.szNickName ="";
        temp2.iChairId =j;
        temp2.iScore = byteBuf.getInt32();
        rsp.tScore.push(temp2);
    }
    return rsp;
};

FishProtocol.decode_playerLinkOff = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt32();
    rsp.iChairId = byteBuf.getInt32();//牌桌号
    return rsp;
};

FishProtocol.decode_CopyResult = function(byteBuf){
    var rsp = {};
    rsp.iCount = byteBuf.getInt32();
    rsp.chip =[];
    for(var i =0;i<rsp.iCount;++i){
        var temp ={};
        temp.iCoinType = byteBuf.getInt32();
        temp.iCoinCount = byteBuf.getInt32();
        rsp.chip.push(temp);
    }
    return rsp;
};

FishProtocol.encode_GameNewInfoReq = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

FishProtocol.decode_GameNewInfoRsp = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iBombTimes =[];
    for(var i=0;i<3;++i){
        rsp.iBombTimes.push(byteBuf.getInt32())
    }
    rsp.iBuyTimes=[];
    for(var j=0;j<3;++j){
        rsp.iBuyTimes.push(byteBuf.getInt32())
    }

    rsp.iGameTimes=[];
    for(var k=0;k<3;++k){
        rsp.iGameTimes.push(byteBuf.getInt32());
    }

    rsp.lYuBi = byteBuf.getUint64();
    rsp.lGold = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    return rsp;
};

FishProtocol.encode_GameNewBuyBoom = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iBuyCount);
    bb.setInt32(req.iRate);
};

FishProtocol.decode_GameNewBuyBoom = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iBuyCount = byteBuf.getInt32();//当天已经购买个数
    rsp.iRate = byteBuf.getInt32();
    rsp.iLeftCount = byteBuf.getInt32();//玩家剩余的弹头个数
    rsp.iScore = byteBuf.getUint64();
    return rsp;
};

FishProtocol.encode_GameNewSYLZLottery = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iRate);
    bb.setInt32(req.iLotteryType);
};

FishProtocol.decode_GameNewSYLZLottery = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.lAddGold = byteBuf.getUint64();
    rsp.lAddYubi = byteBuf.getUint64();
    rsp.lAllGold = byteBuf.getUint64();
    rsp.lAllYubi = byteBuf.getUint64();
    return rsp;
};

FishProtocol.encode_GameNewJZSJCreate = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iRate);
};

FishProtocol.decode_GameNewJZSJCreate = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iGameTime = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_GameNewJZSJStart = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

FishProtocol.decode_GameNewJZSJStart = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iGameTime = byteBuf.getInt32();
    return rsp;
};

FishProtocol.encode_GameNewJZSJLottery = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iLotteryType);
    bb.setFloat32(req.fx);
    bb.setFloat32(req.fy);
};

FishProtocol.decode_GameNewJZSJLottery = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.lAddGold = byteBuf.getUint64();
    rsp.lAddYubi = byteBuf.getUint64();
    rsp.lAllGold = byteBuf.getUint64();
    rsp.lAllYubi = byteBuf.getUint64();
    rsp.fx = byteBuf.getFloat32();
    rsp.fy = byteBuf.getFloat32();

    return rsp;
};

FishProtocol.encode_GameNewJZSJSTATUS = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

FishProtocol.decode_GameNewJZSJSTATUS = function(byteBuf){
    var rsp = {};
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iRate = byteBuf.getInt32();
    rsp.iGameStatus = byteBuf.getInt32(); //游戏状态 0：空闲 1：准备 2：游戏中
    rsp.iLeftGameTime = byteBuf.getInt32();
    return rsp;
};