/**
 * Created by mintao on 2016/10/17.
 * 应用配置
 */

///游戏type
var GameType = {
    Lobby: 0,///大厅==none
    MahJong_XZ: 1,//血战
    Fruit: 2,//水果
    Treasure: 3,//寻宝
    GoBang: 4,//五子棋
    Fish: 5,//捕鱼
};

///渠道
var GameChannel = {
    Andriod: 201, //安卓
    Apple: 202, //苹果
    Fish: 301, //捕鱼
};

/***
 * 货币类型
 * @type {{}}
 */
var FYCoinType = {
    Gold: 1, //金豆
    Diamond: 2, //钻石
    Ticket: 3, //奖券
};

/**
 * 功能列表 Id
 * @type {{}}
 */
var MenuModule = {
    None: -1, //空
    LuckyMedal: 1, //幸运勋章
    MyBank: 2, //我的银行
    VIP: 3, //Vip
    Relieve: 4, //救济金
    RichRank: 5, //财富排行
    TurnTable: 6, //新手转盘
};

/***
 * 注册事件
 * @type {{}}
 */
var FYCustomEventName = {
    AppBaseInfo : "AppBaseInfo", //基础配置
    SystemNet : "SystemNet", //网络状态
    AppDialog : "AppDialog",
    ExitApp : "ExitApp", //退出应用

    RunLogin : "RunLogin", //切换到登录
    RunLobby : "RunLobby", //切换到大厅
    RunFish  : "RunFish", //
    RunPlayerLogin : "RunPlayerLogin",

    SDKLogin : "SDKLogin", //SDK登录注册
    SDKBinding : "SDKBinding", //SDK绑定
    SDKPassword : "SDKPassword", //SDK密码修改
    SDKExit : "SDKExit", //SDK账号退出
    ConnEvent : "onConnectionEvent",
};

/***
 * 链接服务器事件ID
 */
var NetworkEventId = {
    onNetConnected : 'onNetConnected',
    onNetDisclosed : "onNetDisclosed",
    onNetReconn : "onNetReconn",
};

/***
 * 登录服务器事件ID
 */
var ClientServerEventId = {
    onLobbyLoginSeccessed : "onLobbyLoginSeccessed",
    onLobbyLoginFailed : "onLobbyLoginFailed",
    onSocialLoginSeccessed : "onSocialLoginSeccessed",
    onSocialLoginFailed : "onSocialLoginFailed",
    onGameLoginSeccessed : "onGameLoginSeccessed",
    onGameLoginFailed : "onGameLoginFailed",
};

var LobbyEventId = {
    onHallLogin : 'onHallLogin',
    onPlayerWealth : 'onPlayerWealth',
    onRelieve : 'onRelieve',
};

var GameCommonEventId = {
    onPlayerLogin : 'onPlayerLogin',
    onPlayerLogout : 'onPlayerLogout',
    onPlayerGold : 'onPlayerGold',
    onBroadcastCommonMsg : 'onBroadcastCommonMsg',
};

var eLoginType = {
    LOGINTYPE_REGISTER  : 1,
    LOGINTYPE_QUICKLOG  : 2,
    LOGINTYPE_USERLOG   : 3,
    LOGINTYPE_USERLOGOUT : 4,
};

var AppSceneName = {
    Login : "loginscene",
    Lobby : "lobbyscene",
    Fourth : "forthscene",
};

/***
 * 本地化文本提示
 * @type {{}}
 */

var LocalStringfilePath = "res/localString.xml";
var LocalStringName = {
    Chat12 : "Word12",
};

///内外网开关
var FYNetWorkType = {
    Inner: 0, //内网
    Outer: 1, //外网
};
FYEngine.NetType = FYNetWorkType.Outer;

