/**
 * Created by mintao on 16/5/26.
 */


/***
 *
 * @param args
 * @returns {String}
 */
String.prototype.format = function(args) {
    var result = this;
    if (arguments.length > 0) {
        if (arguments.length == 1 && typeof (args) == "object") {
            for (var key in args) {
                if(args[key]!=undefined){
                    var reg = new RegExp("({" + key + "})", "g");
                    result = result.replace(reg, args[key]);
                }
            }
        }
        else {
            for (var i = 0; i < arguments.length; i++) {
                if (arguments[i] != undefined) {
                    var reg = new RegExp("({[" + i + "]})", "g");
                    result = result.replace(reg, arguments[i]);
                }
            }
        }
    }
    return result;
};

/***
 * 数组  插入元素
 * @param index
 * @param item
 */
Array.prototype.insert = function (index, item) {
    this.splice(index, 0, item);
};

Array.prototype.remove = function(val) {
    var index = this.indexOf(val);
    if (index > -1) {
        this.splice(index, 1);
    }
};



function Map(){
    this.container = new Object();
};

Map.prototype.clear = function(){
    this.container = {};
};

Map.prototype.Obj = function(){
    return this.container;
};

Map.prototype.put = function(key, value){
    if (!isString(key)){
        key += '';
    }
    this.container[key] = value;
};


Map.prototype.get = function(key){
    if (!isString(key)){
        key += '';
    }
    return this.container[key];
};


Map.prototype.keySet = function() {
    var keyset = new Array();
    var count = 0;
    for (var key in this.container) {
    // 跳过object的extend函数
        if (key == 'extend') {
            continue;
        }
        keyset[count] = key;
        count++;
    }
    return keyset;
};


Map.prototype.size = function() {
    var count = 0;
    for (var key in this.container) {
        if (key == 'extend'){
            continue;
        }
        count++;
    }
    return count;
};


Map.prototype.remove = function(key) {
    delete this.container[key];
};


Map.prototype.toString = function(){
    var str = "";
    for (var i = 0, keys = this.keySet(), len = keys.length; i < len; i++) {
        str = str + keys[i] + "=" + this.container[keys[i]] + ";\n";
    }
    return str;
};