/**
 * Created by mintao on 16/8/15.
 */

FYEngine.Audio = FYEngine.Audio || {
    isOpenMusic : true,
    isOpenEffect : true,
    musicVolume : 1,
    effectVolume : 1,


    playMusic : function(filePath, isLoop){
        if(!this.isOpenMusic) return;
        jsb.AudioEngine.play2d(filePath, isLoop, this.musicVolume, jsb.AudioEngine.getDefaultProfile());
    },

    stopMusic : function(filePath){
        jsb.AudioEngine.uncache(filePath);
    },

    playEffect : function(filePath){
        if(!this.isOpenEffect) return;
        jsb.AudioEngine.play2d(filePath, false, this.effectVolume, jsb.AudioEngine.getDefaultProfile());
//        cc.log('-------- 播放音效 playEffect : -----'+filePath);
    },

    stopEffect : function(filePath){
        jsb.AudioEngine.uncache(filePath);
    },

    stopAll : function(){
        cc.audioEngine.stopMusic();
        cc.audioEngine.stopAllEffects();
        jsb.AudioEngine.stopAll();
    },

    end : function(){
        cc.audioEngine.stopMusic();
        cc.audioEngine.stopAllEffects();
        cc.audioEngine.end();
        jsb.AudioEngine.stopAll();
        jsb.AudioEngine.uncacheAll();
        jsb.AudioEngine.end();
    },

    getAudioEngine : function(){
        return cc.audioEngine;
    },

    preloadSound : function(res_sound){
        for (var i = 0; i < res_sound.length; ++ i){
            jsb.AudioEngine.preload(res_sound[i], function(bok){
                // cc.log('----预加载res_sound[i]：'+res_sound[i]+' 成功: '+bok+'----i： '+i);
            });
        }
    },

     preloadMusic : function(res_music){
        for (var i = 0; i < res_music.length; ++ i){
            cc.audioEngine.preload(res_music[i]);
        }
     },

    setMusicVolume : function(volume){
        this.musicVolume = volume;
        //this.musicVolume = cc.sys.localStorage.getItem('musicVolume');
    },

    getMusicVolume : function(){
        this.musicVolume = 1;
    },

    setEffectVolume : function(volume){
        this.effectVolume = volume;
    },

    getEffectVolume : function(){
        this.effectVolume = 1;
    },

    setOpenMusic:function(openMusic){
        this.isOpenMusic = openMusic;
    },

    getOpenMusic:function(){
        return this.isOpenMusic;
    },

    setOpenEffect:function(openEffect){
        this.isOpenEffect = openEffect;
    },

    getOpenEffect:function(){
        return this.isOpenEffect;
    },

    playMusicSingle:function(filePath, isLoop){
        if(!this.isOpenMusic)return;
        cc.audioEngine.setMusicVolume(1.0);
        cc.audioEngine.playMusic(filePath,isLoop);
    },

    playEffectSingle:function(filePath, isLoop){
        if(!this.isOpenEffect)return;
        cc.audioEngine.playEffect(filePath,isLoop);
    }




};
