//国际化本地语言key-value获取
var LanguageStringType = {
    NormalText : "NormalText",//纯文本格式
    RichText : "RichText",//富文本格式
}
var LanguageString =  function() {
    var _stringMap = null;
    return {
        init:function () {
            //初始化 用来加载不同的国际化文件
            var prefix = "";

            switch (cc.sys.language){
                case cc.sys.LANGUAGE_CHINESE:
                    //中文
                    prefix = cc.sys.LANGUAGE_CHINESE;
                    break;
                case cc.sys.LANGUAGE_ENGLISH:
                    //英文
                    prefix = cc.sys.LANGUAGE_ENGLISH;
                    break;
                default:
                    //默认中文
                    prefix = cc.sys.LANGUAGE_CHINESE;
                    break;
            }
            var loadCallback = function (err,result) {
                if (!err){
                    _stringMap = result;
                }else{
                    _stringMap = null;
                    cc.log("---LanguageString loadJson failed---");
                }
            };
            //如果某个包对语言文件有特殊要求，直接在这边修改成对应的文件路径
            var path = "res/languageString/languageString_"+prefix+".json";
            cc.loader.loadJson(path,loadCallback);
        },

        getValue:function (key) {
            //根据key值来获取相应的value值
            if (!_stringMap){
                cc.log("---LanguageString Module need init---");
                return "";
            }
            if (key){

                if(_stringMap[key]){
                    //var resultData =_stringMap[key];
                    //var result = {};
                    //    if (resultData.search("<font")>=0||resultData.search("</br>")>=0){
                    //        result[LanguageStringType.RichText]=resultData;
                    //    }else{
                    //        result[LanguageStringType.NormalText]=resultData;
                    //    }
                    return _stringMap[key];
                }
                else {
                    cc.log("---LanguageString key is undefined in the file---");
                    return "";
                }
            }else{
                cc.log("---LanguageString key is null---");
                return "";
            }

        },


    }
}

FYEngine.LanguageString = LanguageString();
FYEngine.LanguageString.init();
