var SmallLayerRes = {
    Backbtn: {
        Up: 'dialog_20.png',
        Down: 'dialog_19.png',
    },
    Outerbg: 'smallwines7.png',
    Innerbg: 'smallwines3.png',
    Innerbg2: 'smallwines19.png',
    Smallbg: 'smallwines1.png',
    Titlebg: '#smallwines0.png',
    Confirmbtn: '#smallwines22.png',
    Confirmtitle: '#smallwines4.png',
    Confirmtitle2: '#smallwines9.png',
    Cancelbtn: '#smallwines21.png',
    Canceltitle: '#smallwines20.png',
    TitleWrite: '#smallwines2.png',
   
    Helper: '#smallwines10.png',
    Helperbtnname: '#smallwines17.png',
    settingPassNow: "#setting_now_pass.png",
    exchangebtn: '#smallwines23.png',
    exchangetittle: '#smallwines24.png',
    lay3other: 'smallwines25.png',
    recordtittle: '#smallwines29.png',

    changeName: "#changename.png",
    timeout: "#gameui35.png",
    jiujitip: '#jiujitip.png',
    jiujinumberbg: '#jiujinumberbg.png',
    jiujinumber: '#jiuji{0}.png',
    Goldbig1: '#gold_big.png',

};
var SmallMsgKey={
    reliveTimesToday1:"reliveTimesToday1",
    reliveTimesToday2:"reliveTimesToday2",
    reliveTimesToday3:"reliveTimesToday3"
};
var SmallLayer = cc.LayerColor.extend({
    ctor: function () {
        this._super();
        this.init(cc.color(0, 0, 0, 190));
        this.bindTouch();
    }, bindTouch: function () {
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {

                }

            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },
    addLayerBg: function (bgSize) {
        var layerbg = this.layerbg = FYEngine.createImageView(SmallLayerRes.Outerbg, cc.p(cc.winSize.width / 2, cc.winSize.height / 2), null, bgSize);
        layerbg.setCapInsets(cc.rect(110,26,layerbg.width-145,layerbg.height-67));
        this.addChild(layerbg, 0, 1);
        return this.layerbg;
    },

    addInnerBg: function (imageName, bgSize) {
        var innerbg = FYEngine.createImageView(imageName, cc.p(this.layerbg.width / 2, this.layerbg.height * 0.55), null, bgSize)
        this.layerbg.addChild(innerbg, 0, 2);
        return innerbg;
    },

    addTitleBg: function (titleImage,titlePos) {

        var titleBg = FYEngine.createSprite(SmallLayerRes.Titlebg, cc.p(this.layerbg.width / 2, this.layerbg.height));
        this.layerbg.addChild(titleBg, 0, 3);
        titlePos = titlePos||cc.p(titleBg.width / 2, titleBg.height / 2);
        var titleName = FYEngine.createSprite(titleImage,titlePos);
        titleBg.addChild(titleName, 0, 1);
    },

    addCloseBtn: function (func) {
        var that = this;
        var btnback = new ccui.Button(SmallLayerRes.Backbtn.Up, SmallLayerRes.Backbtn.Down, '', ccui.Widget.PLIST_TEXTURE);
        if (btnback) {
            btnback.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.97);
            this.layerbg.addChild(btnback, 0, 3);
            if (func) {
                btnback.addClickEventListener(func);
            } else {
                btnback.addClickEventListener(function () {
                    FYEngine.popoutLayerAnimate(that.layerbg)
                });
            }
        }
    },

    addConfirmBtn: function (func, texture, position) {
        var that = this;
        texture = texture || SmallLayerRes.Confirmtitle;
        position = position || cc.p(this.layerbg.width * 0.72, this.layerbg.height * 0.12);
        func = func || function () {
                FYEngine.popoutLayerAnimate(that.layerbg);
            };

        var confirmbtn = FYEngine.createSprite(SmallLayerRes.Confirmbtn, position);
        this.layerbg.addChild(confirmbtn, 0, 4);
        FYEngine.AddNodeTouchListener(confirmbtn, func, FYEngine.ActionType.Fade);
        var confirmtitle = FYEngine.createSprite(texture, cc.p(confirmbtn.width / 2, confirmbtn.height * 0.6));
        confirmbtn.addChild(confirmtitle, 0);
    },

    addCancelBtn: function (func,position) {
        var that = this;
        position = position||cc.p(this.layerbg.width * 0.31, this.layerbg.height * 0.12);
        func = func || function () {
                FYEngine.popoutLayerAnimate(that.layerbg);
            };
        var cancelbtn = FYEngine.createSprite(SmallLayerRes.Cancelbtn, position);
        this.layerbg.addChild(cancelbtn, 0, 4);
        FYEngine.AddNodeTouchListener(cancelbtn, func, FYEngine.ActionType.Fade);
        var canceltitle = FYEngine.createSprite(SmallLayerRes.Canceltitle, cc.p(cancelbtn.width / 2, cancelbtn.height * 0.6));
        cancelbtn.addChild(canceltitle, 0);

    },
});


/**
 * 救济金领取界面
 */
var ReliveLayer = SmallLayer.extend({
    //_bg:null,
    ctor: function () {
        this._super();
        this.initUI();
    },


    initUI: function () {
        var bg = this.addLayerBg(cc.size(479, 344));
        this.addInnerBg(SmallLayerRes.Innerbg2, cc.size(414, 205));
        this.addTitleBg(SmallLayerRes.Helper);
        this.addConfirmBtn(this.confirmCallBack, SmallLayerRes.Helperbtnname, cc.p(bg.width / 2, -bg.height * 0.15));

        var pic = new cc.Sprite(SmallLayerRes.Goldbig1);
        if (pic) {
            pic.setPosition(cc.p(bg.width / 2, bg.height / 2));
            bg.addChild(pic);
        }

        var pic2 = new cc.Sprite(SmallLayerRes.jiujitip);
        if(pic2){
            pic2.setPosition(cc.p(bg.width /2+80, bg.height / 2+30));
            bg.addChild(pic2);
        }

        var pic3 = new cc.Sprite(SmallLayerRes.jiujinumberbg);
        if(pic3){
            pic3.setPosition(cc.p(bg.width /2-105, bg.height / 2+55));
            bg.addChild(pic3);
        }

        var i =  FishGlobal.reliveinfor.iDayCount;
        var j =  FishGlobal.reliveinfor.iLimit;
        var addgold = FishGlobal.reliveinfor.iAddGold;

        var number = FYEngine.createNumSprite(addgold,SmallLayerRes.jiujinumber);
        if(number){
            number.setAnchorPoint(cc.p(0.5,0.5));
            number.setPosition(cc.p(50,40));
            pic3.addChild(number);
        }

        var tex1 = new cc.LabelTTF(FYEngine.LanguageString.getValue(SmallMsgKey.reliveTimesToday1), 22);
        if(tex1){
            tex1.setAnchorPoint(cc.p(0,0.5));
            tex1.setPosition(cc.p(bg.width *0.15, bg.height * 0.12));
            bg.addChild(tex1);
        }

        var tex2 = new cc.LabelTTF(i+'',FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if(tex2){
            tex2.setColor(cc.color(255,0,0));
            tex2.setAnchorPoint(cc.p(0,0.5));
            tex2.setPosition(cc.p(tex1.width+5, tex1.height/2));
            tex1.addChild(tex2);
        }

        var tex3 = new cc.LabelTTF(FYEngine.LanguageString.getValue(SmallMsgKey.reliveTimesToday2),FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if(tex3){
            tex3.setAnchorPoint(cc.p(0,0.5));
            tex3.setPosition(cc.p(tex1.width+tex2.width+10, tex1.height/2));
            tex1.addChild(tex3);
        }

        var tex4 = new cc.LabelTTF(j+'',FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if(tex4){
            tex4.setColor(cc.color(255,0,0));
            tex4.setAnchorPoint(cc.p(0,0.5));
            tex4.setPosition(cc.p(tex1.width+tex2.width+tex3.width+15, tex1.height/2));
            tex1.addChild(tex4);
        }

        var tex5 = new cc.LabelTTF(FYEngine.LanguageString.getValue(SmallMsgKey.reliveTimesToday3),FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
        if(tex5){
            tex5.setAnchorPoint(cc.p(0,0.5));
            tex5.setPosition(cc.p(tex1.width+tex2.width+tex3.width+tex4.width+20, tex1.height/2));
            tex1.addChild(tex5);
        }

    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        if(scene.getName() == 'fishscene' || scene.getName() == "fishcopyscene"){
            scene._handler.sendFishSceneReliveGetReq();
        }else{
            var handler = CoreServiceProxy.getInstance().getLobbyHandler();
            if(handler && handler._canSendNormalMsg){
                handler.sendGetReliveGoldReq();
            }
        }
    },
});


var ChooseBoomLayer = cc.LayerColor.extend({
    _scene:null,
    ctor:function(){
        this._super();
        this.init(cc.color(0, 0, 0, 150), 1136, 640);
        this.bindTouch();
        this.initUI();
    },

    bindTouch : function(){
        var self = this;
        this._size=cc.winSize;
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    cc.log("----消除ChooseBoomLayer");
                    FYEngine.popoutLayerAnimate(self.layerbg);
                }
            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },

    initUI:function(){
        this._scene = FYEngine.getRunningLayer(0);
        var self = this;

        var bg = this.layerbg = new ccui.Layout();
        if(bg){
            bg.setContentSize(cc.size(1136,640));
            this.addChild(bg,0,"bg");
            bg.setBackGroundColorType(ccui.Layout.BG_COLOR_NONE);
            // bg.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
            // bg.setBackGroundColor(cc.color(255,0,0));
            bg.setAnchorPoint(cc.p(0.5,0.5));
            bg.setPosition(cc.p(this.width/2,this.height/2));
        }

        var player = appglobal.getPlayer();
        var Recommend = 9999;
        for(var i = 0;i<FishGlobal.BoomConf.iCount;++i){
            if(player.crystal>= FishGlobal.BoomConf.iList[i].iHedanCount){
                Recommend = i;
            }
            var boomCard = new ccui.ImageView("fish_boom43.png",ccui.Widget.PLIST_TEXTURE);
            if(boomCard){
                bg.addChild(boomCard,1,i);
                boomCard.setTouchEnabled(true);
                boomCard.setPosition(cc.p(this.getStartPosition()+i*210,270));
                boomCard.addClickEventListener(function (sender) {
                    self.playerUseBoom(sender);
                });

                var mtag = 48-i;
                var boompic = new ccui.ImageView("fish_boom"+mtag+".png",ccui.Widget.PLIST_TEXTURE);
                if(boompic){
                    boomCard.addChild(boompic,1,"boompic");
                    boompic.setPosition(cc.p(boomCard.width/2,205));
                }

                var costnum = new ccui.Text(""+FishGlobal.BoomConf.iList[i].iHedanCount,"微软雅黑",24);
                if(costnum){
                    boomCard.addChild(costnum,1,"costnum");
                    costnum.setPosition(cc.p(124,118));
                    costnum.setTextColor(cc.color("fdff54"));
                }

                var totalnum = FishGlobal.BoomConf.iList[i].iHedanCount * FishGlobal.BoomConf.iMaxGold;
                var totalwin = new FYEngine.createAlts('res/num/fish_number.png', 12, ""+totalnum, '.');
                if(totalwin){
                    boomCard.addChild(totalwin,1,"totalwin");
                    totalwin.setAnchorPoint(cc.p(0,0.5));
                    totalwin.setPosition(cc.p(60,55));
                }
            }
        }

        if(Recommend!=9999){
            var recomandCard = bg.getChildByTag(Recommend);
            if(recomandCard){
                var recopic = new ccui.ImageView("fish_boom34.png",ccui.Widget.PLIST_TEXTURE);
                if(recopic){
                    recomandCard.addChild(recopic,1,"recopic");
                    recopic.setPosition(cc.p(140,285));
                }
            }
        }

        var title = new ccui.ImageView("fish_boom37.png",ccui.Widget.PLIST_TEXTURE);
        if(title){
            bg.addChild(title,2,"title");
            title.setPosition(cc.p(this.width/2,470));
        }
    },

    playerUseBoom : function(sender){
        var tag = sender.getTag();
        cc.log("点击了第{0}个按钮".format(tag));

        var needCount = FishGlobal.BoomConf.iList[tag].iHedanCount;
        if(appglobal.getPlayer().crystal<needCount){
            FYEngine.AddCommToast("道具数量不足");
            return;
        }

        if(this._scene._Nlock){
            FYEngine.AddCommToast("技能冷却中");
            return;
        }

        if(this._scene._handler._fishData._fishTideControl == false){
            FYEngine.AddCommToast("鱼潮期间无法发射核弹，请稍等");
            return;
        }

        this._scene.playerUseBoom(tag);
        this.removeFromParent(true);
    },

    getStartPosition : function(){
        var startpos = 0;
        if(FishGlobal.BoomConf.iCount == 1){
            startpos = 568;
        }else if(FishGlobal.BoomConf.iCount == 2){
            startpos = 463;
        }else if(FishGlobal.BoomConf.iCount == 3){
            startpos = 358;
        }else if(FishGlobal.BoomConf.iCount == 4){
            startpos = 253;
        }else if(FishGlobal.BoomConf.iCount == 5){
            startpos = 148;
        }
        return startpos;
    },
});

