var LobbyBroadCast = FYEngine.RichBroadCast.extend({
    _handler : null,
    _hallbroadLen : 0,

    ctor : function(filename, size, rect, masksize, maskpos, move, textureType, isshow){
        this._super(filename, size, rect, masksize, maskpos, move, textureType, isshow);

        this._handler = CoreServiceProxy.getInstance().getLobbyHandler();

        this._hallbroadLen = 0;
        this.scheduleUpdate();

        return true;
    },

    update : function(dt){
        if(!this._handler){
            return;
        }
        if (this._handler && this._handler._lobbyData.getLobbyBroad().length == 0 && this._broadlab == null){
            return;
        }

        if (this._broadlab == null){
            if (!this._isAwlaysShow){
                this.setVisible(true);
            }

            var broadInfo = this._handler._lobbyData.getLobbyBroad().shift();
            this.setLabelText(broadInfo.szMsg, cc.color.WHITE, cc.color(254, 245, 6), 24); //

            this._hallbroadLen = -(this._broadlab.getVirtualRendererSize().width-this._broadlength*this.count+10);

            return;
        }

        this.OnUpdatehall(dt);
    },

    OnUpdatehall : function(dt){
        if (!this._broadlab){
            return;
        }
//        cc.log('-----------#######################------发送广播');
        this._broadlab.x -= this._move;
        if (this._broadlab.x < this._hallbroadLen){
            this._broadlab.removeFromParent();
            this._broadlab = null;
            if (this._handler._lobbyData.getLobbyBroad().length==0){
                this.setVisible(false);
            }
        }
    },

});
