

var TurnTableDialog = cc.LayerColor.extend({
    _isTurning:false,
    _isClose : false,
    ctor: function (type) {
        this._super();
        this.init(cc.color(0, 0, 0, 190));
        this.loadResource();
        this.bindTouch();
        this._type = type;
        this._isClose = false;
        this.initLayer();
    },
    bindTouch: function () {
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {

                }

            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },

    /***
     *
     * @param event_id
     * @param event_param
     */
    onGameEventTurnTable: function (obj) {
        var that = this;
        //this._type=1;
        if (obj.lResult == -16) {
            this.removeFromParent(true);
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(TurnTableDialog.ImgName.turnTimesOut));
            return;
        }
        if (obj.lResult != 0) {
            this.removeFromParent(true);
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(TurnTableDialog.ImgName.turnRewardFailed));
            // FYEngine.AddCommToast('开奖失败');
            return;
        }

        if(obj.lResult ==0 && obj.iNum ==0 && obj.iType ==0 && obj.lAddValue ==0 && obj.lTotal ==0){
            this.removeFromParent(true);
            return;
        }
        this.layerbg.getChildByName("closebtn").setVisible(false);
        var index = obj.iNum - 1;

        var addnum = obj.lAddValue;
        var layerbg = this.layerbg.getChildByTag(0);
        var startbtn = this.layerbg.getChildByName("startbtn");
        if (addnum == 0) {
            startbtn.setTouchEnabled(true);
            return;
        }
        FishGlobal.reliveinfor.iStatus = 0;
        layerbg.setRotation(0);
        var rotateArr = [];
        for(var i=0;i<5;i++){
            rotateArr.push(cc.rotateBy(0.2,14.4+i*28.8));
        }
        rotateArr.push(cc.rotateBy(2,1440));
        var s =1080-index*30-Math.ceil(Math.random(1)*24)-3;
        //s =1080;
        var t= 5,t2;
        var a = 2*s/(t*t);
        var s1 = (a*0.5*0.04).toFixed(3)-0;
        for(var i=24;i>=2;i--){
            rotateArr.push(cc.rotateBy(0.2,s1+i*2*s1));
        }
        t2=1;
        rotateArr.push(cc.rotateBy(t2,4*s1));
        rotateArr.push(new cc.DelayTime(1));
        rotateArr.push(cc.callFunc(function () {
                FYEngine.getRunningLayer(0).getChildByName("luckPan").addSpecificReward(obj.iNum, obj.lAddValue);
                that._isTurning = false;
            }
        ));

        layerbg.runAction(cc.sequence(rotateArr));


    },

    initLayer: function () {
        this._isTurning = false;
        var size = cc.winSize;
        var layerbig = new cc.LayerColor();
        layerbig.init(cc.color(0, 0, 0, 0));
        layerbig.ignoreAnchorPointForPosition(false);
        layerbig.setAnchorPoint(cc.p(0.5, 0.5));
        layerbig.setPosition(size.width / 2, size.height / 2);
        cc.log("bg position====" + JSON.stringify(layerbig.getPosition()));

        this.addChild(layerbig, 0, 0);
        this.layerbg = layerbig;
        var layerbg = FYEngine.createSprite(TurnTableDialog.ImgName.BG, cc.p(size.width / 2, size.height / 2 + 20), cc.p(0.5, 0.5));
        this.layerbg.addChild(layerbg, 0, 0);
        var pos = cc.p(layerbg.width / 2, layerbg.height / 2);

        var yellow = new cc.Sprite(TurnTableDialog.ImgName.yellow);
        var green = new cc.Sprite(TurnTableDialog.ImgName.green);

        yellow.setPosition(pos);
        green.setPosition(pos);
        layerbg.addChild(yellow, 0, "yellow");
        layerbg.addChild(green, 0, "green");

        var closebtn = FYEngine.createButton(TurnTableDialog.ImgName.CloseNormal, TurnTableDialog.ImgName.ClosePress,
           cc.p(size.width - 260, size.height - 60), this.closeCallBack);

        this.layerbg.addChild(closebtn, 0, "closebtn");
        var sp_arrow = new cc.Sprite(TurnTableDialog.ImgName.Arrow);
        sp_arrow.setPosition(cc.p(layerbg.getPositionX(), layerbg.getPositionY() + 105));

        this.layerbg.addChild(sp_arrow, 1);

        var sp_show = FYEngine.createSprite(TurnTableDialog.ImgName.Show, cc.p((size.width / 2) + 1, 23));
        this.layerbg.addChild(sp_show, 100);
        var startbtn = FYEngine.createButton(TurnTableDialog.ImgName.StartNormal, TurnTableDialog.ImgName.StartPress,
            layerbg.getPosition(), this.startCallBack);
        this.layerbg.addChild(startbtn, 2, "startbtn");
        this.addPopBtn();

    },

    addPopBtn : function(){
        var self = this;
        var btn_family = new ccui.ImageView("hall07.png",ccui.Widget.PLIST_TEXTURE);//开奖公示
        if(btn_family){
            this.addChild(btn_family,100,"btn_family");
            btn_family.setTouchEnabled(true);
            btn_family.setPosition(cc.p(150,45));
            btn_family.addTouchEventListener(this.btnTouchEft,this);
            btn_family.addClickEventListener(function(sender){
                cc.log("addPopBtn:"+self._isTurning);
                if(self._isTurning == true){
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(TurnTableDialog.ImgName.getReward));
                }else{
                    cc.sys.openURL(appglobal._URLrewardinfo);
                }

            });
        }
    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },


    /***
     * @param info
     */
    getRewardImg: function (name) {
        var imgname = ["bean", "ticket", "50card", "100card", "iphone", "ipad"];
        switch (name) {
            case imgname[0]:
                return TurnTableDialog.ImgName.Reward1;
                break;
            case imgname[1]:
                return TurnTableDialog.ImgName.Reward2;
                break;
            case imgname[2]:
                return TurnTableDialog.ImgName.Reward3;
                break;
            case imgname[3]:
                return TurnTableDialog.ImgName.Reward4;
                break;
            case imgname[4]:
                return TurnTableDialog.ImgName.Reward5;
                break;
            case imgname[5]:
                return TurnTableDialog.ImgName.Reward6;
                break;
            default:
                return TurnTableDialog.ImgName.Reward1;
                break;
        }
    },

    /****
     * 获取reward的坐标
     * @param baseangle 基准角度
     * @param targetangle 目标角度
     * @param circelR  半径
     * 12格,美格30°
     */
    getRewardPos: function (baseangle, targetangle, circelR) {
        var layerbg = this.layerbg.getChildByTag(0);
        var circelX = layerbg.getContentSize().width / 2, circelY = layerbg.getContentSize().height / 2;
        var hudu = (2 * Math.PI / 360 * baseangle) * (targetangle / baseangle);//弧度
        var rewardX = circelX + Math.sin(hudu) * circelR;
        var rewardY = circelY + Math.cos(hudu) * circelR;

        return cc.p(rewardX, rewardY);
    },

    /***
     *
     * @param sender
     */
    closeCallBack: function (sender) {
        var layer = sender.getParent();
        FYEngine.popoutLayerAnimate(layer);
        //layer.removeFromParent();
    },
    /**
     * 点击回调
     * @param sender
     */
    startCallBack: function (sender) {

        var that = sender.getParent().getParent();
        if (that._turnStatus == 1 ) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(TurnTableDialog.ImgName.getReward));
        } else if(that._type!=1){
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(TurnTableDialog.ImgName.turnTimesOut));
        }
        else {
            that._isTurning = true;
            that._turnStatus = 1;
            that.luckPanGet();
        }
    },
    /**
     * 是否可以抽奖
     */
    luckPanGet: function () {

        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendTurnTableReq();
        }

    },
    loadResource: function () {

        for (var i = 0; i < TurnTableDialog.Res.plist.length; i++) {
            cc.director.getTextureCache().addImage(TurnTableDialog.Res.png[i]);
            cc.spriteFrameCache.addSpriteFramesWithFile(TurnTableDialog.Res.plist[i]);
        }


    },
    /**
     * 奖励的弹出动画
     * @param rewardIndex
     */
    addSpecificReward: function (rewardIndex, rewardCount) {
        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }

            },

        });

        var size = cc.winSize;
        var size1 = cc.size(512, 512);
        var pos = cc.p(size.width / 2, size.height / 2 + 20);
        var layerBig = new cc.LayerColor();
        layerBig.init(cc.color(0, 0, 0, 190));
        layerBig.ignoreAnchorPointForPosition(true);
        this.addChild(layerBig, 99);
        cc.eventManager.addListener(touchListener, layerBig);
        var layerSmall = new cc.Sprite();
        layerSmall.setContentSize(size1);
        layerSmall.setScale(0);
        layerSmall.setPosition(pos);
        layerBig.addChild(layerSmall);
            var rewardImg ;
        if(rewardIndex==1||rewardIndex==4||rewardIndex==7||rewardIndex==10){
            rewardImg = "bean";
        }else{
            rewardImg = "ticket";
        }
        var rewardName = this.getRewardImg(rewardImg);

        var spriteBg = new cc.Sprite(TurnTableDialog.ImgName.reward);
        spriteBg.setPosition(size1.width / 2, size1.height / 2);
        layerSmall.addChild(spriteBg);

        var spriteTitle = new cc.Sprite(TurnTableDialog.ImgName.rewardTitle);
        var spriteMsg = new cc.Sprite(TurnTableDialog.ImgName.rewardTitleMsg);
        spriteMsg.setPosition(cc.p(spriteTitle.width / 2, 75));
        spriteTitle.addChild(spriteMsg);
        spriteTitle.attr({x: size1.width / 2, y: size.height - 150, anchorX: 0.5, anchorY: 1});
        var spriteReward = new cc.Sprite(rewardName);

        spriteReward.setPosition(size1.width / 2, size1.height / 2 - 18.5);

        layerSmall.addChild(spriteReward);
        var spriteCount = new ccui.TextAtlas("/" + rewardCount, TurnTableDialog.ImgName.turnTableNum, 32, 42, "/");

        spriteCount.attr({x: size1.width / 2, y: size1.height / 2 - spriteReward.height / 2 - 46});
        layerSmall.addChild(spriteCount);
        layerSmall.addChild(spriteTitle);

        var sureBtn = new ccui.Button(TurnTableDialog.ImgName.sureBtn, TurnTableDialog.ImgName.sureBtn, TurnTableDialog.ImgName.sureBtn, ccui.Widget.PLIST_TEXTURE);
        var btnMsg = new cc.Sprite(SccomRes.SmallWinRes.Helperbtnname);
        btnMsg.setPosition(sureBtn.width / 2, sureBtn.height / 2 + 5);
        sureBtn.addChild(btnMsg);
        sureBtn.setPosition(size1.width / 2, 40);
        layerSmall.addChild(sureBtn);

        sureBtn.addClickEventListener(function () {
            FYEngine.popoutLayerAnimate(layerSmall, 1);
            FYEngine.popoutLayerAnimate(FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.LuckPan).layerbg);

            //cc.director.getRunningScene().luckPanCheck();
            var handler = CoreServiceProxy.getInstance().getLobbyHandler();
            if (handler) {
                handler.sendUpdateWealthReq();
            }
        });

        layerSmall.runAction(cc.sequence(cc.TargetedAction(layerSmall, cc.sequence(cc.scaleTo(0.3, 1.5), cc.scaleTo(0.15, 1)))));

        spriteBg.runAction(cc.sequence(cc.rotateBy(1, 45)).repeatForever());

    },

    onExit : function(){
        this._super();
        this._isClose = true;
        if(FishGlobal.stoptip == 1){//自动的查询
            var scene =  FYEngine.getRunningLayer(0);
            if(scene.getName() == "lobbyscene" && appglobal._switch25 == 0){
                if(scene._handler && scene._handler._canSendNormalMsg){
                    scene._handler.sendGetCheckinStatus();
                }else{
                    FishGlobal.stoptip = 0;
                    if(scene && scene.onGameEvent){
                        scene.onGameEvent(lobbyGameEvent.refreshWealth);
                    }
                }
            }else{
                FishGlobal.stoptip = 0;
                if(scene && scene.onGameEvent){
                    scene.onGameEvent(lobbyGameEvent.refreshWealth);
                }
            }
        }
    },
});

TurnTableDialog.ImgName = {
    kuang: "res/turnTable/turn_base_kuang.png",
    green: "res/turnTable/turn_base_green.png",
    yellow: "res/turnTable/turn_base_yellow.png",
    reward: "res/turnTable/turn_reward_bg.png",
    BG: "res/turnTable/turn_base_bg.png",
    CloseNormal: "dialog_20.png",
    ClosePress: "dialog_19.png",
    Arrow: "#turn_arrow.png",
    Show: "#turn_tip.png",
    StartNormal: "turn_start.png",
    StartPress: "turn_start_press.png",
    //金豆,奖券,50,100,iphone,ipad
    Reward1: "#turn_gold.png",
    Reward2: "#turn_coupon.png",
    Reward3: "#turn_50.png",
    Reward4: "#turn_100.png",
    Reward5: "#turn_iphone.png",
    Reward6: "#turn_ipad.png",
    rewardTitle: "#turn_reward_title.png",
    rewardTitleMsg: "#turn_reward_title_msg.png",
    sureBtn: "smallwines22.png",
    sureBtnMsg: "#smallwines4.png",
    turnTableNum: "res/turnTable/turnTable_num.png",
    turnTimesOut:"turnTimesOut",
    getReward:"getReward",
    turnRewardFailed:"turnRewardFailed"

};
TurnTableDialog.Res = {
    plist: ["res/turnTable/turn_table.plist"],
    png: ["res/turnTable/turn_table.png", "res/turnTable/turn_base_bg.png", "res/turnTable/turn_base_green.png", "res/turnTable/turn_base_kuang.png"
        , "res/turnTable/turn_base_yellow.png", "res/turnTable/turn_reward_bg.png"]
};