/**
 * Created by mintao on 2016/10/14.
 * 游戏公告场景
 * 强更公告
 * 热更公告
 * 普通公告
 */

var NoticeRes = {
    noticeTitle: "#notice_title.png",
    titleColor: "#41cf09",
    contentColor: "#eedd59"

};

var NoticeComm = NoticeComm || {
        btnFlag: 0,
        loadFlag:0,
        loadGameNotice: function () {
            cc.log("conf3===="+Date.now());
            Http.getMessage(NoticeComm.getGameNoticeUrl(), null, NoticeComm.loadDataComplete);
        },
        getGameNoticeUrl: function () {
            var service = formservice("gameNoticeList");
            var time = Date.now();
            var sign = formsign("gameNoticeList", time);
            // var type = {name: "type", value: 0};
            time = formTime(time);
            var source = formsource(appglobal.getSource());
            var checksum = formchecksum(source.value, sign.value, FYEngine.PrivateKey);
            // cc.log("--notice:"+formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, source));
            return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, sign, checksum, source);
        },

        loadDataComplete: function (str) {
            var scene =  FYEngine.getRunningLayer(0);
            if(scene.getName() == "lobbyscene"){
                NoticeComm.loadFlag = 1;
                var obj = JSON.parse(str);
                if (obj.code == 0 && obj.data.length > 0 && appglobal._switch1 == 1) {
                    NoticeComm._data = [];
                    NoticeComm.recheckData(obj.data);
                    var noticeLayer = new NoticeLayerNew();
                    scene.addChild(noticeLayer, FishZorder.poplayer, LobbySceneName.NoticeLayer);
                    FYEngine.popupLayerAnimate(noticeLayer.layerbg);
                }
                else if ((appglobal._switch5 == 1) && FishGlobal.reliveinfor && FishGlobal.reliveinfor.iStatus == 1) {
                    cc.log('---------大装盘创建4');
                    FishGlobal.stoptip = 0;
                    var turnLayer = new TurnTableDialog(FishGlobal.reliveinfor.iStatus);
                    scene.addChild(turnLayer, FishZorder.poplayer, LobbySceneName.LuckPan);
                    FYEngine.popupLayerAnimate(turnLayer.layerbg);
                }else if(appglobal._switch25 == 0){
                    if(scene._handler && scene._handler._canSendNormalMsg){
                        scene._handler.sendGetCheckinStatus();
                    }
                } else {
                    FishGlobal.stoptip = 0;
                }
            }
        },

        recheckData :function(data){
            cc.log("--整理数据");
            for(var i=0;i<data.length;++i){
                if(data[i].title1 == ""){
                    continue;
                }else{
                    if(NoticeComm._data.length<6){
                        NoticeComm._data.push(data[i])
                    }
                }
            }
        },

        resetNoticeComm:function(){
            this._data=undefined;
            this.btnFlag=0;
            this.loadFlag=0;
            FishGlobal.reliveinfor = {};
        }
    };

var NoticeLayerNew = DialogLayer.extend({
    _data:null,
    _currentbtn:0,
    _btnArr:[],
    _layArr : [],
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        this.setName("noticeLayer");
        this.initData();

//        FYEngine.logObject(this._data, '-------data:');

        this.addLayerBg(cc.size(1040, 575));

        this.addTitleBg(NoticeRes.noticeTitle, 1045);
        var innerBg = this.addInnerBg(cc.size(730, 485));
        innerBg.setPosition(cc.p(650,270));

        var BTNBG = new ccui.Layout();
        if(BTNBG){
            BTNBG.setContentSize(cc.size(265,475));
            // BTNBG.setBackGroundImage(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
            BTNBG.setBackGroundImageScale9Enabled(true);
            BTNBG.setAnchorPoint(cc.p(0,0));
            BTNBG.setPosition(cc.p(28,30));
            // BTNBG.setBackGroundColor(cc.color.RED);
            // BTNBG.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
            this.layerbg.addChild(BTNBG);
            this._btnbg = BTNBG;
        }
        this.initBtn();
        this.initLayout();

        var btnBack = new ccui.Button(FishSceneRes.DialogPng.BackBtnUp, FishSceneRes.DialogPng.BackBtnDowm, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(this.layerbg.width * 0.98, this.layerbg.height * 0.96);
            this.layerbg.addChild(btnBack, 0, "myclosebtn");
            btnBack.addClickEventListener(function (sender) {
                cc.log("-----addCloseBtn4");
                self.closeCallBack(sender);
            })

        }
    },

    initData : function(){
        this._currentbtn = 0;
        this._btnArr =[];
        this._layArr =[];
        this._data = NoticeComm._data;
    },

    initBtn : function(){
        var self = this;
        var btncall = function(sender){
            self.btnCallBack(sender);
        };
        for(var i =0;i<this._data.length;++i)
        {
            var btnname = i==0?"fish_acbind_28.png":"fish_acbind_29.png";
            var nbtn = new ccui.ImageView(btnname,ccui.Widget.PLIST_TEXTURE);
            if(nbtn){
                nbtn.setPosition(cc.p(140,475-40-80*i));
                nbtn.setTouchEnabled(true);
                this._btnbg.addChild(nbtn,1,i);
                this._btnArr.push(nbtn);
                nbtn.addClickEventListener(btncall);

                var tip1 = new ccui.Text(""+this._data[i].title,"",26);
                if(tip1){
                    tip1.setVisible(i ==0?false:true);
                    nbtn.addChild(tip1,1,1);
                    tip1.setPosition(cc.p(nbtn.width*0.45,nbtn.height*0.55));
                    tip1.setColor(cc.color("175a03"));
                    tip1.enableShadow(cc.color("9ae8a3"),cc.size(1,0),0.5);
                }

                var tip2 = new ccui.Text(""+""+this._data[i].title,"",28);
                if(tip2){
                    tip2.setVisible(i ==0?true:false);
                    nbtn.addChild(tip2,1,2);
                    tip2.setPosition(cc.p(nbtn.width*0.46,nbtn.height*0.55));
                    tip2.enableOutline(cc.color("b13c00"),3);
                    tip2.enableShadow(cc.color("b13c00"),cc.size(0,-2),0.5);
                }
            }
        }
    },

    btnCallBack:function(sender){
        var tag = sender.getTag();
        cc.log("-----------"+tag);
        if(tag ==this._currentbtn){
            return;
        }
        this.setCurrentBtn(tag);
    },

    setCurrentBtn : function(i){
        this._btnArr[this._currentbtn].loadTexture("fish_acbind_29.png",ccui.Widget.PLIST_TEXTURE);
        this._layArr[this._currentbtn].setVisible(false);
        this._btnArr[this._currentbtn].getChildByTag(1).setVisible(true);
        this._btnArr[this._currentbtn].getChildByTag(2).setVisible(false);
        this._btnArr[i].loadTexture("fish_acbind_28.png",ccui.Widget.PLIST_TEXTURE);
        this._btnArr[i].getChildByTag(1).setVisible(false);
        this._btnArr[i].getChildByTag(2).setVisible(true);
        this._layArr[i].setVisible(true);
        this._currentbtn = i;

    },

    initLayout : function(){
        for(var i=0;i<this._data.length;++i){
            var contentLayout = new ccui.Layout();
            if(contentLayout){
                contentLayout.setVisible(i==0?true:false);
                contentLayout.setContentSize(cc.size(700,460));
                // BTNBG.setBackGroundImage(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
                contentLayout.setBackGroundImageScale9Enabled(true);
                contentLayout.setAnchorPoint(cc.p(0.5,0.5));
                contentLayout.setPosition(cc.p(this.innerBg.width/2,this.innerBg.height/2));
                this.innerBg.addChild(contentLayout,1,i);
                this._layArr.push(contentLayout);

                var titlebg = new ccui.ImageView("fish_acbind_30.png",ccui.Widget.PLIST_TEXTURE);
                if(titlebg){
                    contentLayout.addChild(titlebg);
                    titlebg.setScale9Enabled(true);
                    titlebg.setContentSize(cc.size(690,48));
                    titlebg.setPosition(cc.p(contentLayout.width/2,430));

                    var innertitle = new ccui.Text(""+this._data[i].title1,"微软雅黑",26);
                    if(innertitle){
                        titlebg.addChild(innertitle,0,1);
                        innertitle.setVisible(true);
                        innertitle.setColor(cc.color("900f0f"));
                        innertitle.setAnchorPoint(cc.p(0,0.5));
                        innertitle.setPosition(cc.p(30,24));
                    }

                    var innertime = new ccui.Text(""+this.getNoticeDate(this._data[i].time),"微软雅黑",26);
                    if(innertime){
                        titlebg.addChild(innertime);
                        innertime.setVisible(true);
                        innertime.setColor(cc.color("900f0f"));
                        innertime.setAnchorPoint(cc.p(1,0.5));
                        innertime.setPosition(cc.p(640,24));
                    }

                }

                var scrollView = new ccui.ScrollView();
                scrollView.setScrollBarEnabled(false);
                scrollView.setContentSize(690, 400);
                scrollView.setAnchorPoint(cc.p(0, 0));
                scrollView.setPosition(cc.p(15,0));
                contentLayout.addChild(scrollView);
                var container = scrollView.getInnerContainer();
                var content = new cc.LabelTTF("","微软雅黑",26);
                content.setString(""+this._data[i].content);
                content.setDimensions(690 , 0);
                scrollView.setInnerContainerSize(content.getContentSize());
                content.setAnchorPoint(cc.p(0 , 1));
                content.setPosition(cc.p(0 , scrollView.getInnerContainerSize().height));
                container.addChild(content);
                scrollView.jumpToTop();
            }
        }
    },

    closeCallBack : function(sender){
        FYEngine.popoutLayerAnimate(this.layerbg);
    },

    getNoticeDate: function (date) {
        var date = new Date(date * 1000);
        var month = date.getMonth() + 1;
        var day = date.getDate();
        return date.getFullYear() + "." + month + "." + day;
    },
    onExit: function () {
        this._super();
        var scene = FYEngine.getRunningLayer(0);
        if(scene.getName() == "lobbyscene"){
            if (NoticeComm.btnFlag == 0) {//如果是自动弹出公告而不是手动弹出的
                if ((appglobal._switch5 == 1) && FishGlobal.reliveinfor && FishGlobal.reliveinfor.iStatus == 1) {//如果有转盘
                    var layer = scene.getChildByName(LobbySceneName.LuckPan);
                    if(!layer){
                        layer = new TurnTableDialog(FishGlobal.reliveinfor.iStatus);
                        scene.addChild(layer, 100, LobbySceneName.LuckPan);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                } else if(appglobal._switch25 == 0){
                    if(scene._handler && scene._handler._canSendNormalMsg){
                        scene._handler.sendGetCheckinStatus();
                    }
                }else {
                    FishGlobal.stoptip = 0;//可以打开救济金弹出的开关
                    if (scene && scene.onGameEvent) {
                        scene.onGameEvent(lobbyGameEvent.refreshWealth);
                    }
                }
            }
            NoticeComm.btnFlag = 0;
        }

    },
});
