/**
 * Created by mintao on 16/2/22.
 */
//npc精灵类
//添加触摸响应:显示对话框
//添加npc动画

var NpcRec = {
    Npc1_login_png:"npc1_login.png",
    Npc1_png : "npc1.png",
    Npc1Eyebg_png : "#npc1_eyebg.png",
    Npc1Eye_png : "#npc_eye00.png",
};

///
var NpcSprite = cc.Sprite.extend({
    touchListener : null,
    ctor:function (filename, playAni) {
        this._super();

        ///初始化
        var npcframe = cc.spriteFrameCache.getSpriteFrame(filename);
        if(npcframe){
            this.initWithSpriteFrame(npcframe);
        }

        ///显示动画--换了npc,木有动画了
        playAni = false;
        if(playAni){
            ///星星
            var sp_star = new cc.Sprite();
            sp_star.setPosition(cc.p(96, 370));
            this.addChild(sp_star);
            var animate = AppGlobal.getInstance().puAni.PuEftAni("npc_star", 13, 1, 0);
            sp_star.runAction(new cc.RepeatForever(new cc.Sequence(new cc.DelayTime(0.5), animate)));

            ///眼睛
            var sp_eyebg = new cc.Sprite(NpcRec.Npc1Eyebg_png);
            sp_eyebg.setPosition(cc.p(120, 529));
            this.addChild(sp_eyebg);

            var sp_eye = new cc.Sprite(NpcRec.Npc1Eye_png);//
            sp_eye.setPosition(cc.p(24, 17));
            sp_eyebg.addChild(sp_eye);
            var eyeani = AppGlobal.getInstance().puAni.PuEftAni("npc_eye", 27, 1.5, 0);
            sp_eye.runAction(new cc.RepeatForever(new cc.Sequence(eyeani, new cc.DelayTime(1))));
        }

        ///添加触摸机制
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (!target.isVisible()){
                    return false;
                }

                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    cc.log("I say HaYiYa~");
                }
            },
        });
        cc.eventManager.addListener(this.touchListener, this);

        return true;
    },

});