/**
 * Created by PhoneU on 2018/5/29.
 */

var FishFightBattery = ccui.Layout.extend({
    _chairId : 0,
    _bSelf : false,
    _bDown : false,
    _radianx : Math.sin(FYMath.AngletoRadian(0)),
    _radiany : Math.cos(FYMath.AngletoRadian(0)),
    _handler : null,
    _index : 0,
    _type : 0,
    _rate : 0,
    _count : 0,
    _cannon : null,
    _ratelabel : null,
    _bulleteft : null,
    _localBulletArry : [],
    _bRevise : false,
    _cannonRotate : 80,
    _bulletPos : cc.p(0,0),
    _scene : null,
    _actiondone : false,
    _userId : 0,


    ctor : function(chairId){
        this._super();
        this._scene = FYEngine.getRunningLayer(0);
        this._chairId = chairId;
        if(this._chairId >1){
            this._bDown = true;
            this._radianx = Math.sin(FYMath.AngletoRadian(180));
            this._radiany = Math.cos(FYMath.AngletoRadian(180));
        }

        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        cc.log("------seld:"+this._handler.getSelfId());
        if(this._handler.getSelfId() == this._chairId){
            this._bSelf = true;
        }
        cc.log(""+chairId);
        FYEngine.logObject(this._handler._fishData._userData,"---INFO:");
        this._userId = this._handler._fishData._userData[chairId].lRoleId;

        this._rate = 1;

        this._index = 0;
        this._type = 1;

        if(this._chairId == 1 || this._chairId == 2){
            this._bRevise = true;
        }
        this._count = 1;

        this.setContentSize(cc.size(181,101));
        this.setAnchorPoint(cc.p(0,0));

        this.initBattery();
        this.createUserInfo(chairId);
        this.setVisible(false);
    },

    initBattery : function(){
        var namebg = new cc.Sprite('#fish_fight_res2.png');
        this.addChild(namebg, 1, 'namebg');
        if(this._chairId>1){
            namebg.setFlippedY(true);
            namebg.setAnchorPoint(cc.p(0,0));
            namebg.setPosition(cc.p(0,0));
        }else{
            namebg.setAnchorPoint(cc.p(0,1));
            namebg.setPosition(cc.p(0,101));
        }
        var mfentip = new cc.Sprite("#fish_fight_res41.png");
        mfentip.setAnchorPoint(cc.p(0,0.5));
        mfentip.setPosition(this._chairId > 1 ? cc.p(5, 47) : cc.p(5, 52));
        this.addChild(mfentip, 1, 'mfentip');

        //var name = new cc.LabelTTF('玩家姓名','微软雅黑',18,cc.size(150,23),cc.TEXT_ALIGNMENT_CENTER,cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        var name = FYEngine.createLengthText('玩家姓名',18,150);
        name.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        name.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.addChild(name,1,'name');
        name.setAnchorPoint(cc.p(0.5,0.5));
        name.setPosition(this._chairId > 1 ? cc.p(this.width*0.5,this.height*0.17):cc.p(this.width*0.5,this.height*0.83));

        var batterysprite = this._batterysprite = new cc.Sprite(FishSceneRes.Png.TipsBatteryBg);
        this.addChild(batterysprite,1,'batterybg');
        batterysprite.setAnchorPoint(cc.p(0.5,this._chairId > 1 ? 0 : 1));
        batterysprite.setFlippedY(this._chairId <2);




        if(batterysprite){
            var frame = new cc.Sprite("#fish_fight_res38.png");
            batterysprite.addChild(frame, 0, 'cannonframe');
            frame.setAnchorPoint(cc.p(0.5,this._chairId > 1 ? 0 : 1));
            frame.setFlippedY(this._chairId <2);
            frame.setPosition(cc.p(batterysprite.width/2,this._chairId > 1?0:batterysprite.height+10));

            var bulleteft = new cc.Sprite();
            batterysprite.addChild(bulleteft, 1, 'bulleteft');
            bulleteft.setAnchorPoint(cc.p(0.5,0.5));
            bulleteft.setVisible(false);
            bulleteft.setSpriteFrame(this._bSelf?BatteryRes.BatteryName.BulletEftSelf.format(this._type):BatteryRes.BatteryName.BulletEftOther.format(this._type));
            bulleteft.setRotation(this._chairId > 1?0:180);
            bulleteft.setPosition(this._chairId > 1?cc.p(batterysprite.width*0.5,125):cc.p(batterysprite.width*0.5,-50));
            this._bulleteft = bulleteft;

            var cannon = new cc.Sprite();
            batterysprite.addChild(cannon, 1, 'cannon');
            cannon.setAnchorPoint(cc.p(0.5,0.4));
            cannon.setSpriteFrame(this._bSelf?BatteryRes.BatteryName.BatterySelf.format(this._type):BatteryRes.BatteryName.BatteryOther.format(this._type));
            cannon.setRotation(this._chairId > 1?0:180);
            cannon.setPosition(this._chairId > 1?cc.p(batterysprite.width*0.5,60):cc.p(batterysprite.width*0.5,15));
            this._cannon = cannon;


            if(this._bSelf){
                var autobtn = new ccui.ImageView(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
                autobtn.setTouchEnabled(true);
                autobtn.setSwallowTouches(true);
                autobtn.loadTexture(FishSceneRes.Png.AutoPlayBtn, ccui.Widget.PLIST_TEXTURE);
                if(this._chairId ==0){
                    autobtn.setPosition(cc.p(230,10));
                }else if(this._chairId ==1){
                    autobtn.setPosition(cc.p(-50,10));
                }else if(this._chairId ==2){
                    autobtn.setPosition(cc.p(-50,80));
                }else{
                    autobtn.setPosition(cc.p(230,80));
                }
                this.addChild(autobtn, 1, 'autobtn');
                autobtn.addClickEventListener(this.autoBtnClickCallBack);
            }

            switch(this._chairId){
                case 0 :{
                    this.setPosition(cc.p(0,539));
                    batterysprite.setPosition(cc.p(345,101));

                }break;
                case 1: {
                    this.setPosition(cc.p(955,539));
                    batterysprite.setPosition(cc.p(-165,101));

                }break;
                case 2:{
                    this.setPosition(cc.p(955,0));
                    batterysprite.setPosition(cc.p(-165,0));

                }break;
                case 3 : {
                    this.setPosition(cc.p(0,0));
                    batterysprite.setPosition(cc.p(345,0));

                }break;
                default:break;
            }
        }

    },

    backCannon : function(type,bool){
        this._goldbg.setVisible(false);
        this._cannon.setVisible(false);
        this._ratelabel.setVisible(false);
        if(this._bSelf){
            this._btnadd.setVisible(false);
            this._btnsub.setVisible(false);
        }

        if(bool){
            this._handler.sendChangeCannonReq(this._chairId,0, FishGlobal.BoomConf.iList[type].iBulletType);
        }

    },

    resetCannon : function(bool){
        this._goldbg.setVisible(true);
        this._cannon.setVisible(true);
        this._ratelabel.setVisible(true);
        if(this._bSelf){
            this._btnadd.setVisible(true);
            this._btnsub.setVisible(true);
        }
    },

    createUserInfo : function(chairId){
        var labgold = FYEngine.createAlts(FishFightNum.NUM3, 10, "0", '0');
        labgold.setPosition(this._chairId > 1 ? cc.p(55, 45) : cc.p(55, 50));
        labgold.setAnchorPoint(cc.p(0, 0.5));
        this.addChild(labgold, 1, 'labgold');
        this._labgold = labgold;
    },

    showUserInfo : function(chairId){

        var userinfo = this._handler._fishData._userData[chairId];
        if (userinfo.lRoleId == -1){
            this.setVisible(false);
        }else{
            this.setVisible(true);
            var nametext = this.getChildByName('name');
            if(nametext){
                if(!this._bSelf && cc.sys.os == 'iOS' && appglobal._switch1 == 0){
                    var str = "玩家"+userinfo.lRoleId;
                    nametext.setString("玩家"+userinfo.lRoleId);
                    if(nametext.getContentSize().width>150){
                        var newstr = str;
                        var newstr2 = str+"...";
                        nametext.setString(newstr2);
                        while(nametext.getContentSize().width>150){
                            newstr = newstr.substring(0,newstr.length-1);
                            var newstr2 = newstr+"...";
                            nametext.setString(newstr2);
                        }
                        nametext.setString(newstr2);
                    }
                }else{
                    var str = userinfo.szNickName;
                    nametext.setString(userinfo.szNickName+'');
                    if(nametext.getContentSize().width>150){
                        var newstr = str;
                        var newstr2 = str+"...";
                        nametext.setString(newstr2);
                        while(nametext.getContentSize().width>150){
                            newstr = newstr.substring(0,newstr.length-1);
                            var newstr2 = newstr+"...";
                            nametext.setString(newstr2);
                        }
                        nametext.setString(newstr2);
                    }
                }


            }

            if (this._labgold){
                this._labgold.setString(''+0);
            }

        }
    },

    createBullet  : function(lbulletId, alivetime){
        var self = this;
        var curRotate = self._cannon.getRotation();
        if (self._cannonRotate != curRotate)
        {
            self._cannonRotate = curRotate;
            self._radianx = Math.sin(FYMath.AngletoRadian(self._cannonRotate));
            self._radiany = Math.cos(FYMath.AngletoRadian(self._cannonRotate));
            self._bulletPos = self.getBulletPos(self._cannonRotate);
            self._bulleteft.setRotation(self._cannonRotate);
            self._bulleteft.setPosition(self.getBulletEftPos(self._cannonRotate));
        }

        self._bulleteft.setVisible(true);
        self._bulleteft.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.9), new cc.FadeIn(0.05)),
            new cc.Spawn(new cc.ScaleTo(0.05, 1), new cc.FadeOut(0.05))));

        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.shoot_eft);

        ///添加子弹
        var layer = self._scene._bulletlayer;
        var bullet = Bullet.create(lbulletId, self._type, self._bulletPos,
            self._cannonRotate, FishGlobal.bulletSpeed, self._rate, self._bSelf,
            self._radianx, self._radiany, alivetime, self._userId);
        var tagname = "name"+lbulletId;
        layer.addChild(bullet, 11, tagname);

        self._scene._bulletArr.push(bullet);

        ///子弹事件
        if (self._bSelf){
            layer.reSetCount(1);
            self.pushBulletEvent(lbulletId, self._rate);
        }
    },

    autoBtnClickCallBack : function(sender){
//        cc.log('---------按键响应-------');
        var scene = FYEngine.getRunningLayer(0);
        var battery = scene._playerNode[scene._handler.getSelfId()];

        var layer = scene._bulletlayer;
        layer.setAutoPlay(!layer.isAutoPlay());
        var btn = battery.getChildByName('autobtn');
        if(layer.isAutoPlay()){
            btn.loadTexture(FishSceneRes.Png.AutoPlayOpenBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = btn.getChildByName('autoeft');
            if(!autoeft){
                var autoeft = new cc.Sprite(FishSceneRes.Png.AutoEft);
                if(autoeft){
                    btn.addChild(autoeft,0,'autoeft');
                    autoeft.setPosition(cc.p(btn.width/2,btn.height/2));
                    var rotate = new cc.RotateBy(1.2,360);
                    autoeft.runAction(new cc.RepeatForever(rotate));
                }
            }
        }else{
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = btn.getChildByName('autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },


    shootBullet : function(){
        if (this._actiondone){
            return;
        }

        this._actiondone = true;
        var self = this;
        var xdelta = FYMath.getSinx(8, self._cannon.getRotation());
        var ydelta = FYMath.getCosx(8, self._cannon.getRotation());

        var id = FishGlobal.getAddBulletId(this._handler.getSelfId());
        self.createBullet(id, 0);
        this._cannon.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.98, 0.9), new cc.MoveBy(0.05,cc.p(-xdelta,-ydelta))), new cc.Spawn(new cc.ScaleTo(0.05, 1),new cc.MoveBy(0.05,cc.p(xdelta,ydelta))), new cc.CallFunc(function(){
            self._actiondone = false;
        })));
    },


    adjustBattery : function(angle){
        this._cannon.setRotation(angle);
        this._bulleteft.setRotation(angle);
        this._bulleteft.setPosition(this.getBulletEftPos(angle));
    },

    shootServerBullet : function(id, rotate, type, rate, alivetime, userid){
        // cc.log("-------发射服务器子弹的id"+id+"userid:"+userid+"type:"+type+"rate:"+rate);
        var self = this;
        if(self._bSelf){
            return;
        }
        self._cannon.setRotation(rotate);
        self._userId = userid;

        var xdelta = FYMath.getSinx(8, rotate);
        var ydelta = FYMath.getCosx(8, rotate);

        self.createBullet(id, alivetime);
        self._cannon.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.98, 0.9), new cc.MoveBy(0.05,cc.p(-xdelta,-ydelta))),
            new cc.Spawn(new cc.ScaleTo(0.05, 1), new cc.MoveBy(0.05,cc.p(xdelta,ydelta)))));
    },

    getBulletPos : function(rotation){
        var pos = this.getPosition();
        if (this._bDown){
            pos.y += 60;
        }
        else{
            pos.y -= 60;
        }

        var r = 50;
        var rotate = this._bDown ? rotation : rotation-180;
        if (this._bDown && rotate >= 270){
            rotate -= 360;
        }

        var offx = r*Math.sin(Math.abs(FYMath.AngletoRadian(rotate)));
        var offy = r*Math.cos(Math.abs(FYMath.AngletoRadian(rotate)));
        if (rotate == 0){
            pos.y -= r;
        }
        else if (rotate > 0){
            if(this._bDown){
                pos.x += Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x -= Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        else{
            if(this._bDown){
                pos.x -= Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x += Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        return pos;
    },

    getBulletEftPos : function(rotation){
        var pos = this._cannon.getPosition();

        var r = 65;
        var rotate = this._bDown ? rotation : rotation-180;
        if (this._bDown && rotate >= 270){
            rotate -= 360;
        }

        var offx = r*Math.sin(Math.abs(FYMath.AngletoRadian(rotate)));
        var offy = r*Math.cos(Math.abs(FYMath.AngletoRadian(rotate)));
        if (rotate == 0){
            pos.y -= r;
        }
        else if (rotate > 0){
            if(this._bDown){
                pos.x += Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x -= Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        else{
            if(this._bDown){
                pos.x -= Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x += Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        return pos;
    },


    pushBulletEvent : function(lbulletId, iRate){
        var iRotate =this._cannon.getRotation();
        var iChairId = this._chairId;
        var iType = this._type;
        this._handler.sendFireBulletReq(iChairId,lbulletId,iRate,iRotate,iType)
    },


    getRate : function(){
        return this._rate;
    },

    changeUserGold : function(lGold){
        cc.log("changeUserGold"+lGold);
        if (this._labgold){
            this._labgold.setString(''+lGold);

        }
    },


    getPosition : function(){
        var pos = cc.p(0,0);
        switch (this._chairId){
            case 0:{
                pos = cc.p(345, 640);
            }
                break;
            case 1:{
                pos = cc.p(790, 640);
            }
                break;
            case 2:{
                pos = cc.p(790, 0);
            }
                break;
            case 3:{
                pos = cc.p(345, 0);
            }
                break;
            default:
                pos = cc.p(345, 640);
                cc.log('--------initBattery error');
                break;
        }
        return pos;
    },

    resetBattery : function(){
        if (this._bDown){
            this._cannon.setRotation(0);
        }
        else{
            this._cannon.setRotation(180);
        }

        this._bulleteft.setSpriteFrame(BatteryRes.BatteryName.BulletEftSelf.format(0));
        this.resetCannon();

    },


});

var FishFightBulletLayer = cc.Layer.extend({
    _bTouched : false,
    _bulletCount : 0,
    _isAutoPlay : false,
    _shoottime : 0,
    _touchtime : -1,
    _scene : null,
    _timeCount : 0,
    _time : 0,
    _posarr : [],
    _endtimemark:0,
    _arrlength :0,
    _startcount : 0,
    _lastposid:0,
    _handler : null,
    _canOpenFire : true,
    _noverrange:true,//没有超过数量
    _hastoomore:false,
    _isReachGoal : false,

    ctor : function(){
        this._super();
        this._isReachGoal = false;
        this._scene = FYEngine.getRunningLayer(0);
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this.createBulletPool();
        this.createFishNetPool();
        this._posarr = [];
        this._endtimemark = 0;
        this._arrlength=0;
        this._startcount =0;
        this._lastposid=0;
        this._noverrange =true;
        this._hastoomore =false;

        ///触摸监听
        this.addTouchListener();
        this.schedule(this.updateFire,0.033);
    },

    openFire : function(){
        if ((this._isAutoPlay || this._bTouched)&&this._handler._fishData._fishTideControl && this._canOpenFire){
            //cc.log('发射子弹---------------------'+this._bTouched);
            var handlerMsg = this._handler._fishData;
            this._scene.shootBullet(handlerMsg._selfId);
            this._timeCount = 0;
            var mlayer = this._scene.getChildByName('timeoutlayer');
            if(mlayer){
                mlayer.removeFromParent(true);
            }
        }
    },

    createBulletPool : function(){

    },

    createFishNetPool : function(){

    },

    updateFire : function(dt){
        var self = this;
        if(this._handler._canSendNormalMsg == false || this._isReachGoal){
//            cc.log('-------断线了');
            return;
        }
        if(this._startcount ==1){
            this._endtimemark += dt;
            if(this._endtimemark > 1){
                this._startcount = 0;
                this._endtimemark = 0;
                this._posarr.splice(this._lastposid);
                //this._arrlength = this._arrlength - 1;
                if(this._posarr.length ==!0){
                    var angle =this.caculateFinalAngleByArry(this._handler.getSelfId(),this,this._posarr);
                    this._scene.adjustBattery(this._handler.getSelfId(), angle);
                }

            }
        }

        if(this._bulletCount <=15){

            this._noverrange = true;
            if(this._hastoomore){
                var layer = this._scene.getChildByName("toomore");
                if (layer) {
                    layer.removeFromParent(true);
                }
                this._hastoomore = false;
            }

        }

        if (this._bulletCount == 30){

            if(this._noverrange ==true){
                if(this._isAutoPlay||this._bTouched){
                    //this._canOpenFire = false;
                    var layer = this._scene.getChildByName("toomore");
                    if (!layer) {
                        this._hastoomore =true;
                        // this._bTouched = false;
                        layer = new DialogLayer();
                        this._scene.addChild(layer, FishZorder.poplayer, "toomore");
                        var bg = layer.addLayerBg(cc.size(612, 303));
                        var toast = new cc.Sprite(FishSceneRes.Png.tooMoreToast);
                        toast.setPosition(cc.p(bg.width / 2, 207));
                        bg.addChild(toast);
                        var self =this;
                        var confirmCallBack = function (sender) {
                            self._hastoomore =false;
                            sender.getParent().getParent().removeFromParent(true);
                            //self._canOpenFire = true;
                        };
                        layer.addConfirmBtn(confirmCallBack, cc.p(bg.width / 2, 74),"#iknow.png");
                    }
                }
                this._noverrange = false;
            }

            return;
        }
        if ((this._isAutoPlay || this._bTouched)&&this._noverrange){
            //cc.log('发射子弹---------------------'+this._bTouched);
            if (this._shoottime == 0){
                var handlerMsg = this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._shoottime += dt;
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
                return;
            }

            this._shoottime += dt;
            if (this._shoottime >= FishGlobal.bulletTimes){
                this._shoottime = 0.0001;
                var handlerMsg =this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
            }
        }
    },


    reSetCount : function(addnum){
        this._bulletCount += addnum;
        if (this._bulletCount > 30){
            this._bulletCount = 30;
        }
        else if (this._bulletCount < 0){
            this._bulletCount = 0;
        }
    },

    getTouched : function(){
        return this._bTouched;
    },

    addTouchListener : function(){
        var self = this;
        var selfId = self._handler.getSelfId();
        var listener = cc.EventListener.create({
            event : cc.EventListener.TOUCH_ALL_AT_ONCE,
            swallowTouches: true,
            onTouchesBegan: function (touches, event) {
                var target = event.getCurrentTarget();
                //cc.log('--------'+touches[0].getId());
                target._startcount = 0;
                target._endtimemark = 0;
                //FYEngine.logObject(touches[0].getID(),'------------START ID :');
                target._posarr.push(touches[0].getLocation());
                target._arrlength = target._arrlength+1;
                var angle =target.caculateFinalAngleByArry(selfId,target,target._posarr);

                self._scene.adjustBattery(selfId, angle);
                self._noverrange = true;
                if(self._isAutoPlay){

                    self._scene.setTouchEffect(touches[0].getLocation());
                }
                else{
                    target._bTouched = true;
                    target._shoottime = 0;
                    self._scene.setTouchEffect(touches[0].getLocation());
                }
                return true;
            },

            onTouchesMoved : function(touches, event){
                var target = event.getCurrentTarget();
                target._startcount = 0;
                target._endtimemark = 0;
                target._arrlength = touches.length;
                var angle =target.caculateFinalAngle(selfId,target,touches);
                self._scene.adjustBattery(selfId, angle);
                //FYEngine.logObject(touches,'------------moved Final angel :');
                //self._scene.adjustBattery(selfId, pos);
            },

            onTouchesCancelled : function(touches, event){
                var target = event.getCurrentTarget();
                //cc.log('cancel----------------------');
                target._bTouched = false;
            },

            onTouchesEnded: function (touches, event) {
                //cc.log('ended----------------------');
                //FYEngine.logObject(touches[0].getID(),'--------------END ID');

                var target = event.getCurrentTarget();
                if(target._arrlength ==1 && target._posarr.length ==1){
//                    cc.log('test1');
                    target._startcount = 0;
                    target._endtimemark = 0;
                    target._posarr=[];
                    target._arrlength = 0;
                    target._bTouched = false;
                }else{
                    if(target._arrlength == target._posarr.length){
//                        cc.log('test2');
                        target._endtimemark = 0;
                        //FYEngine.logObject(touches[0].getID(), '---------------77777777777777777777------------');
                        target._lastposid =touches[0].getID();
                        target._startcount = 1;
                        target._arrlength =target._arrlength-1;
                    }else{
//                        cc.log('test3');
                        //FYEngine.logObject(touches[0].getID(), '---------------8888888888888888888------------');
                        target._startcount = 0;
                        target._endtimemark = 0;
                        target._arrlength =target._arrlength-1;
                        target._posarr.splice(touches[0].getID());
                        target._posarr.splice(target._lastposid);
                        if(target._posarr.length !=0){
                            var angle =target.caculateFinalAngleByArry(selfId,target,target._posarr);
                            self._scene.adjustBattery(selfId, angle);
                        }else{
                            target._bTouched = false;
                        }
                    }
                }
            },
        });
        cc.eventManager.addListener(listener, this);
    },

    isAutoPlay : function(){
        return this._isAutoPlay;
    },

    setAutoPlay : function(status){
        this._isAutoPlay = status;
        this._shoottime = 0;
        this._noverrange = true;
    },

    caculateFinalAngleByArry : function(selfId,target,arry){
        var sum = 0;
        for(var i =0;i<arry.length;i++){
            var angle =target.caculateAngle(selfId,arry[i]);
            sum+=angle;
        }
        return sum/arry.length;
    },

    caculateFinalAngle : function(selfId,target,touches){
        var sum = 0;
        for(var i = 0;i < touches.length; i++){
            var angle = target.caculateAngle(selfId, touches[i].getLocation());
            this._posarr[i] = touches[i].getLocation();
            sum += angle;
        }
        return sum/touches.length;
    },

    caculateAngle : function(selfId,endpos){

        var battery = this._scene.getBattery(selfId);
        var pos = battery.getPosition();
        if (battery._bDown){
            pos.y += 60;
        }
        else{
            pos.y -= 60;
        }

        var rotate = FYMath.getAngle(pos.x, pos.y, endpos.x, endpos.y);
        if(battery._bDown){
            if(-180 <= rotate && rotate< (-90)){
                rotate = -90;
            }else if(180 > rotate && rotate >90){
                rotate = 90;
            }else if(180 <= rotate && rotate< 270){
                rotate = -90;
            }
        }else{
            if(rotate >=0 && rotate <90){
                rotate = 90;
            }else if( 270<rotate && rotate<360){
                rotate = 270;
            }else if(-90<rotate && rotate<0){
                rotate = 270;
            }
        }
        return rotate;
    }

});
