/**
 * Created by PhoneU on 2018/5/29.
 */
/**
 * Created by PhoneU on 2018/3/29.
 */

var FishFightGameLayer = cc.Layer.extend({
    _handler : null,
    _lobbyhandler : null,
    _heartBeatCount : 0,
    eupdateflag : false,
    _fishArr:[],
    _bulletArr:[],
    _selfBulletArr : [], //自己的子弹数组
    _playerNode:null,
    mainscene : null,
    eventTime : 0,
    _SyncTable : 0,
    m_tideIn : false,//鱼潮来了
    _tideCount : 0,//鱼潮计数 >1必出海浪特效
    _isVibrationSwitch : 1,
    _bulletlayer : null,
    _broadSp : null,
    _tideArr : [],
    ejoinflag : false,
    eleaveflag : false,
    ekillflag : false,
    eshootflag : false,
    ehitflag : false,
    echangeflag : false,
    _birtharr : [],
    _vibrationend : false,
    _inittime :false,
    _Nlock:false,
    _needProtect : true,
    _gameLeftTime :0,
    _tableInfo : null,
    _selfid : -1,
    _gameend :false,

    ctor : function(){
        this._super();
        this.setName('fishfightgamescene');
        FishGlobal.bInFishScene = true;
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._handler.setScene(this);
    },

    onEnter : function(){
        this._super();
        this.init();
    },

    init : function(){
        this.initData();
        this.initBGLayer();
        this.initGameLayer();
        this.initEffectLayer();
        this.initUILayer();
        this.initPhoneBtnCallBack();
        this.initBackGroundMusic();
        this.scheduleUpdate();
        this.schedule(this.queryPlayerScore,1);
        // if(appglobal._switch21 == 0){
        //     var player = appglobal.getPlayer();
        //     if(player.realIDnumber == "" ||!player.isAdult){
        //         this.schedule(this.writeLawRecord,60);
        //     }
        // }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendGetSceneTimeReq();
        }

    },

    writeLawRecord : function(){

        var player = appglobal.getPlayer();
        if(player.realIDnumber != "" && player.isAdult){
            this.unschedule(this.writeLawRecord);
            return;
        }
        var date = new Date();
        var currentRecordTime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(currentRecordTime){
            var totaltime = Number(currentRecordTime)+1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                totaltime+"");
            cc.log('-----------------1分钟计时一次已经游戏时间'+totaltime);
            if(totaltime<FishGlobal.lostTime.controllevel1){
                if((totaltime%FishGlobal.lostTime.duration1) == 0){//3小时内每小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }else if(totaltime==FishGlobal.lostTime.controllevel1){
                this.showAvoidLayer(totaltime);
            }else if(totaltime>FishGlobal.lostTime.controllevel1 && totaltime<FishGlobal.lostTime.controllevel2){
                if((totaltime%FishGlobal.lostTime.duration2) == 0){//3~5小时内每半小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }else if(totaltime==FishGlobal.lostTime.controllevel2){
                this.showAvoidLayer(totaltime);
            }else{
                if((totaltime%FishGlobal.lostTime.duration3) == 0){//5小时后每15分钟弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }
        }else{
            var totaltime = 1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                totaltime+"");
        }

    },

    showAvoidLayer : function(totaltime){
        var layer = this.getChildByName(LobbySceneName.AvoidGameLostTip);
        if(!layer){
            layer = new AvoidGameLostTip(totaltime);
            this.addChild(layer, FishZorder.poplayer,LobbySceneName.AvoidGameLostTip)
        }else{
            layer.refreshUI(totaltime);
        }
    },

    writeLocalIDverifyRecord : function(){
        cc.log('-----------------2分钟计时一次');
        if(FishGlobal.playGameTime<0){
            FishGlobal.playGameTime =0;
        }

        var date = new Date();
        var playergametime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(playergametime){
            var record = Math.floor(FishGlobal.playGameTime);
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate(), record+"");
        }else{
            var player = appglobal.getPlayer();
            if(player.realIDnumber == ""){
                FishGlobal.playGameTime = FishGlobal.idControl.noid.totalgametime;
            }else{
                if(player.isAdult){
                    FishGlobal.playGameTime = FishGlobal.idControl.adult.totalgametime;
                }else{
                    FishGlobal.playGameTime = FishGlobal.idControl.child.totalgametime;
                }
            }
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate(), FishGlobal.playGameTime+"");
        }

    },

    createUpdate : function (dt) {
        this._handler._gametime += dt;
        if (this.eupdateflag){
            return;
        }

        this.eupdateflag = true;
        var i = 0;
        var info = null;
        for (; i < this._handler._unbirthFishArr.length; ++ i){
            info = this._handler._unbirthFishArr[i];
            if (this._handler._gametime < info.iBirthTime){
                break;
            }
        }

        if (i == 0){
            this.eupdateflag = false;
            return;
        }

        this._birtharr = this._handler._unbirthFishArr.splice(0, i);
        var fish = null;
//        cc.log("-----创建鱼数量 this._birtharr.length : "+this._birtharr.length);
        for(var j = 0; j < this._birtharr.length; ++ j){
            var protype = FishGlobal.getFishPropsType(this._birtharr[j].iFishType);
            if (protype == FishPropsType.Plate){
                fish = PlateFish.create(this._birtharr[j]);
            }
            else {
                fish = CommFish.create(this._birtharr[j]);
            }

            fish._bTideFish = false;
            if(this._birtharr[j].tidefish == 0){
                fish._bTideFish = true;
            }

            var zorder = this.getFishZorder(fish._clientType, fish._serverType);
            this.addChild(fish, zorder, this._birtharr[j].iFishId);
            this._fishArr.push(fish);
        }

        this.eupdateflag = false;
    },

    getFishZorder : function(clienttype, servertype){
        var zorder = servertype;
        if (servertype == FishServerType.Fish21){
            zorder = FishZorder.fishMax;
        }
        else if (clienttype >= FishClientType.Fish24 &&
            clienttype <= FishClientType.Fish30){
            zorder = FishZorder.fishMid;
        }
        return zorder;
    },

    updateschedule : function(callback, interval){
        var then = Date.now();
        interval = interval*1000;
        this.schedule(function(){
            var now = Date.now();
            var delta = now-then;
            if (delta > interval){
                then = now - (delta%interval);
                callback.call(this);
            }
        }.bind(this), 0);
    },

    update : function(dt){
        if(this._handler && this._handler._canSendNormalMsg){
            this.checkObbCollision();
        }

        this.createUpdate(dt);
        this.checkShootEvents();
        this.checkHitEvents();
        this.checkKillEvents();
    },

    queryPlayerScore : function(){
        if(this._gameend){
            return;
        }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg && handler._bHeart) {
            handler.sendQueryPlayerScore(this._tableInfo.iTableId);
        }
    },

    checkIDcount : function(dt){
        FishGlobal.playGameTime-=dt;
    },

    initData : function(){
        FishGlobal.bInFishScene = true;
        this._playerNode =[];
        this._bulletArr =[];
        this._fishArr = [];
        FishGlobal.needCharge = 0;
        FishGlobal.InterNumber = 0;
        this._inittime =false;
        this._Nlock = false;
        FishGlobal.isLobbyRecord = false;
        this._needProtect = true;
        this._tableInfo = FishGlobal._TableConfig;
        this._gameLeftTime = Math.floor(this._tableInfo.iTimeMs/10000);
        // this._gameLeftTime = 10;
        cc.log("------剩余时间："+this._gameLeftTime);

        this._selfid = this._handler.getSelfId();
        this._gameend = false;
    },

    freeModeSchedule : function(){
        this._gameLeftTime--;
        if(this._gameLeftTime <= 0){
            this._gameLeftTime =0;
            // this.popTimeOutLayer();//todo
            this._gameend = true;
        }
        var timesp = FYMath.formatRecountDateShort(this._gameLeftTime);
        cc.log(this._gameLeftTime+"----------------剩余时间"+timesp);
        this._timesp.setString(""+timesp);

    },

    popTimeOutLayer : function(){
        cc.log("popTimeOutLayer");
        var mlayer = this.getChildByName(FishCopyLobbyLayer.CopyTimeOutLayer);
        if(!mlayer){
            mlayer = new CopyTimeOutLayer(1);
            this.addChild(mlayer, FishZorder.poplayer+9, FishCopyLobbyLayer.CopyTimeOutLayer);
            FYEngine.popupLayerAnimate(mlayer.layerbg);
        }

        if(this._bulletlayer.isAutoPlay()){
            this._bulletlayer.setAutoPlay(false);
            var btn = FYEngine.getChild(this._playerNode[this._handler.getSelfId()],'autobtn');
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = FYEngine.getChild(btn, 'autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },

    initPhoneBtnCallBack : function(){
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this,'game_on_show',this.gameOnShowEvent);
        FYEngine.AddCustomLister(this,'game_on_hide',this.testGameOnHide);
    },

    testGameOnHide : function(){
        cc.log("---testgameonhide");
        cc.audioEngine.stopMusic();
        if(FishGlobal.bInFishScene == true){
            // FishGlobal.tipout = 1;
            //this.exitGame();

        }
    },

    initBroadCast : function(){
        var size = FYEngine.winSize;
        this._broadSp = new FishBroadCast(FishSceneRes.Png.FishBroadBg, cc.size(825, 44), null,
            cc.size(815, 39), cc.p(1.5, 2.5), 3.5, ccui.Widget.PLIST_TEXTURE, false);
        this._broadSp.setVisible(false);
        this._broadSp.setPosition(cc.p(size.width/2, size.height/2));
        this.addChild(this._broadSp, FishZorder.BroadLayer);
    },

    sendMsg: function () {
        cc.log("sendMsg");
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendHasUnfinishedGameReq();
        }
    },

    addRank : function(){
        var self = this;
        var left = false;
        if(this._selfid == 0 || this._selfid == 3){
            left = true;
        }
        var automenu = new ccui.ImageView("fish_fight_res74.png",ccui.Widget.PLIST_TEXTURE);
        if(automenu){
            this._uilayer.addChild(automenu,1,'automenu');
            automenu.setScale9Enabled(true);
            automenu.setCapInsets(cc.rect(66, 50, 84, 10));
            automenu.setContentSize(cc.size(210,450-80*(4-this._tableInfo.iMaxPlayer)));
            automenu.setAnchorPoint(cc.p(left?1:0,0.5));
            automenu.setPosition(cc.p(left?cc.winSize.width:0,cc.winSize.height/2));

            var autotitle = new ccui.Text("目标分数","",22);
            if(autotitle){
                automenu.addChild(autotitle,0,"autotitle");
                autotitle.setAnchorPoint(cc.p(0,0.5));

                var gamegoal = FYEngine.createAlts(FishFightNum.NUM3, 10, ""+this._tableInfo.iDesScore, '0');
                if(gamegoal){
                    autotitle.addChild(gamegoal, 2, "gamegoal");
                    gamegoal.setAnchorPoint(cc.p(0,0.5));
                    gamegoal.setPosition(cc.p(autotitle.width+5,autotitle.height/2));
                }
                autotitle.setPosition(cc.p(automenu.width/2-(autotitle.width+gamegoal.width)/2,425-80*(4-this._tableInfo.iMaxPlayer)));
            }

            var btnArrow = new ccui.ImageView(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
            if(btnArrow){
                btnArrow.setFlippedX(!left);
                automenu.addChild(btnArrow,1,'btnArrow');
                btnArrow.setTouchEnabled(true);
                btnArrow.setAnchorPoint(cc.p(left?1:1,0.5));
                btnArrow.setPosition(cc.p(left?-2:automenu.width-2,automenu.height*0.5));
                btnArrow.addClickEventListener(function(sender){
                    self.uiBtnCallBack(sender);
                })
            }

            var btnname = ["btnSetting","btnHelp"];
            var btnpic = [FishSceneRes.Png.btnSettingNormal,"fish_fight_res55.png"];
            for(var i =0;i<2;++i){
                var btn = new ccui.ImageView(btnpic[i],ccui.Widget.PLIST_TEXTURE);
                if(btn){
                    automenu.addChild(btn,1,btnname[i]);
                    btn.setPosition(cc.p(65+80*i,50));
                    btn.setTouchEnabled(true);
                    btn.addTouchEventListener(this.btnTouchEft,this);
                    btn.addClickEventListener(function(sender){
                        self.uiBtnCallBack(sender);
                    });
                }
            }

            for(var j =0 ;j< this._tableInfo.iMaxPlayer;++j){
                var line = new ccui.ImageView("fish_fight_res60.png",ccui.Widget.PLIST_TEXTURE);
                if(line){
                    automenu.addChild(line,1,"line"+j);
                    line.setPosition(cc.p(automenu.width/2,100+j*75));
                    line.setScale9Enabled(true);
                    line.setContentSize(cc.size(190,2));
                }

                var playername = new ccui.Text("","",18);
                if(playername){
                    automenu.addChild(playername,1,"playername"+(this._tableInfo.iMaxPlayer-j-1));
                    playername.setAnchorPoint(cc.p(0,0.5));
                    playername.ignoreContentAdaptWithSize(true);
                    playername.setPosition(cc.p(40,150+j*75));
                    // playername.setTextAreaSize(cc.size(165,25));
                }

                var shownum = FYEngine.createAlts(FishFightNum.NUM3, 10, "0", '0');
                if(shownum){
                    automenu.addChild(shownum, 2, "playerscore"+(this._tableInfo.iMaxPlayer-j-1));
                    shownum.setAnchorPoint(cc.p(0,0.5));
                    shownum.setPosition(cc.p(40,120+j*75));

                    var fentip = new cc.Sprite("#fish_fight_res45.png");
                    if(fentip){
                        shownum.addChild(fentip,0,"fentip");
                        fentip.setAnchorPoint(cc.p(0,0.5));
                        fentip.setPosition(cc.p(shownum.width+5,shownum.height/2));
                    }
                }

                var rankbg = new cc.Sprite("#fish_fight_res57.png");
                if(rankbg){
                    automenu.addChild(rankbg,2,"rankbg"+j);
                    rankbg.setPosition(cc.p(20,150+j*75));

                    var number = new ccui.Text(""+(this._tableInfo.iMaxPlayer-j),"",16);
                    if(number){
                        rankbg.addChild(number);
                        number.setPosition(cc.p(rankbg.width/2,rankbg.height/2));
                    }
                }
            }
        }
    },

    changeRank : function(temparr){
        FYEngine.logObject(temparr,"---changeRank");
        cc.log(this._tableInfo.iMaxPlayer+"");
        var automenu = this._uilayer.getChildByName("automenu");
        for(var i =0;i<this._tableInfo.iMaxPlayer;++i){
            var playername = automenu.getChildByName("playername"+i);
            var playerscore = automenu.getChildByName("playerscore"+i);
            if(playername){
                playername.setString(temparr[i].tempname);
            }
            if(playerscore){

                var displayscore = (temparr[i].iScore >this._tableInfo.iDesScore?this._tableInfo.iDesScore:temparr[i].iScore);
                playerscore.setString(displayscore);
                var tip = playerscore.getChildByName("fentip");
                if(tip){
                    tip.setPositionX(playerscore.width+5);
                }
            }
        }
    },

    selfReachGoal : function(i){
        cc.log("selfReachGoal"+i);
        if(this._bulletlayer._isReachGoal ==true){
            return;
        }
        this._bulletlayer._isReachGoal = true;
        var mtext ="";
        if(i ==0){
            mtext = "第一";
        }else if(i ==1){
            mtext = "第二";
        } else if(i ==2){
            mtext = "第三";
        }else {
            mtext = "第四";
        }

        var sbg = new ccui.ImageView(FishSceneRes.Png.FishBroadBg,ccui.Widget.PLIST_TEXTURE);
        if(sbg){
            this._uilayer.addChild(sbg,10,"winbg");
            sbg.setScale9Enabled(true);
            sbg.setContentSize(cc.size(555,125));
            sbg.setPosition(cc.p(this._uilayer.width/2,this._uilayer.height/2));

            var rich1 = new ccui.RichText();
            if (rich1) {
                sbg.addChild(rich1, 0, "rich1");
                rich1.setPosition(cc.p(sbg.width / 2, 85));

                var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "您已完成比赛，排名", "", 30);
                rich1.pushBackElement(mtxt1);

                var mtxt2 = new ccui.RichElementText(2, cc.color("fef506"), 255, mtext, "", 30);
                rich1.pushBackElement(mtxt2);
            }

            var text2 = new ccui.Text("请耐心等候其他玩家完成比赛","",30);
            if(text2){
                sbg.addChild(text2);
                text2.setPosition(cc.p(sbg.width / 2,35));
            }
        }



    },

    onGameEvent : function(event_id, event_param){
         cc.log("onGameEvent--"+event_id);
        switch (event_id){
            case FishFightEvent.refreshPlayer :{
                this.removeBulletsByUserId(event_param.lRoleId);
            }break;
            case FishFightEvent.playerScore :{
                if(event_param.iResult ==0){
                    var temparr = event_param.tScore;
                    for(var i =0 ;i<event_param.iMaxPlayer;++i ){
                        var displayersocre = (event_param.tScore[i].iScore >this._tableInfo.iDesScore?this._tableInfo.iDesScore:event_param.tScore[i].iScore);
                        this._playerNode[i].changeUserGold(displayersocre);
                        if(event_param.iFinChair[i].fchair == this._selfid){//第几名是自己
                            this.selfReachGoal(i);
                        }

                        var name =  this._playerNode[i].getChildByName("name");
                        if(name){
                            temparr[i].tempname = name.getString();
                        }
                    }
                    var inrank = [];
                    var notinrank = [];
                    var testArry = temparr;
                    for(var m =0;m<event_param.iMaxPlayer;++m){
                        if(event_param.iFinChair[m].fchair>=0){
                            inrank.push(testArry[event_param.iFinChair[m].fchair]);
                            testArry[event_param.iFinChair[m].fchair] = 0;
                        }
                    }

                    for(var t = 0;t<event_param.iMaxPlayer;++t){
                        if(testArry[t]){
                            notinrank.push(testArry[t]);
                        }
                    }

                    for(var j =0 ;j<notinrank.length;++j){
                        for(var k =0;k<notinrank.length-j-1;++k){
                            if(notinrank[k].iScore<notinrank[k+1].iScore){
                                var sp = notinrank[k];
                                notinrank[k] = notinrank[k+1];
                                notinrank[k+1] = sp;
                            }
                        }
                    }
                    this.changeRank(inrank.concat(notinrank));
                }

            }break;
            case FishFightEvent.gameResult :{
                cc.log("该退出了");
                this._gameend = true;
                for(var i =0 ;i<event_param.iMaxPlayer;++i ){
                    var displayersocre = (event_param.tScore[i].iScore >this._tableInfo.iDesScore?this._tableInfo.iDesScore:event_param.tScore[i].iScore);
                    this._playerNode[event_param.tScore[i].iChairId].changeUserGold(displayersocre);
                    var name = this._playerNode[event_param.tScore[i].iChairId].getChildByName("name");
                    if(name){
                        event_param.tScore[i].tempname = name.getString();
                    }
                }
                this.changeRank(event_param.tScore);
                this._bulletlayer._isReachGoal = true;
                if(this._bulletlayer.isAutoPlay()){
                    this._bulletlayer.setAutoPlay(false);
                    var btn = FYEngine.getChild(this._playerNode[this._selfid],'autobtn');
                    btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
                    var autoeft = FYEngine.getChild(btn, 'autoeft');
                    if(autoeft){
                        autoeft.removeFromParent(true);
                    }
                }
                var layer = new FishFightResultLayer(event_param);
                if(layer){
                    this.addChild(layer,FishZorder.poplayer,FishFightLayer.FishFightResultLayer);
                }
            }break;
            case FishFightEvent.queryUnfinish : {//如果有未完成的，直接join
                if (event_param.iResult == 0 && event_param.iTableId > 0) {
                    var handler = CoreServiceProxy.getInstance().getGameHandler();
                    if (handler && handler._canSendNormalMsg) {
                        handler.sendJoinTabelReq(event_param.iTableId);
                    }
                }else{
                    FishGlobal._TableConfig = null;
                    FYEngine.runScene(FishFightLobby.createScene());
                }
            }
                break;
            case FishFightEvent.joinTableFail : {
                FishGlobal._TableConfig = null;
                FYEngine.runScene(FishFightLobby.createScene());
            }
                break;
            case FishFightEvent.joinTableOK : {
                if (event_param.iTableStatus == 0) {//游戏未开始
                    FishGlobal._TableConfig = null;
                    FYEngine.runScene(FishFightLobby.createScene());
                }else{
                    var handler = CoreServiceProxy.getInstance().getGameHandler();
                    if (handler && handler._canSendNormalMsg) {
                        handler.sendGetSceneTimeReq();
                    }
                }
            }break;
            case FishCopyEvent.getGameTime :{
                if(event_param.iResult == 0){
                    if(event_param.iSceneTime>0){
                        this._gameLeftTime = Math.floor((event_param.iAllGameTime - event_param.iSceneTime)/1000);
                    }else{
                        FYEngine.runScene(FishFightLobby.createScene());
                    }
                }else{
                    FYEngine.runScene(FishFightLobby.createScene());
                }

            }break;
            case FishGameEventID.unConnect:{
                this.onUnconnect(event_param);
                if(event_param == 1 && this._needProtect){
                    this._needProtect = false;
                    this.protectUser();
                }else{
                    this._needProtect = true;
                }
                if(event_param ==2){
                    this._handler = CoreServiceProxy.getInstance().getGameHandler();
                    var batterrynode = this._playerNode[this._selfid];
                    batterrynode._handler = CoreServiceProxy.getInstance().getGameHandler();
                    this._bulletlayer._handler = CoreServiceProxy.getInstance().getGameHandler();
                    this.sendMsg();
                }
            }break;
            case lobbyGameEvent.refreshWealth : {
                this.changeWealth();
            }break;
            case FishCopyEvent.reloginfail : {
                cc.log("FishCopyEvent.reloginfail");
                this.testLinkFunction();
                // if (event_param.iResult == 1101 || event_param.iResult == 1204) {
                //     FishGlobal.copyReloginTag = true;
                //     var coreserviceproxy = CoreServiceProxy.getInstance();
                //     coreserviceproxy.unlinkGameClient();
                //     appglobal.runFishFightScene();
                // }
            }break;
            default : break;
        }
    },

    testLinkFunction : function(){
        FishGlobal.copyReloginTag = true;
        var coreserviceproxy = CoreServiceProxy.getInstance();
        coreserviceproxy.unlinkGameClient();
        appglobal.runFishFightScene();
    },

    protectUser : function(){
        this.testLinkFunction();
        cc.log("protectUser"+this._selfid);
        for(var i =0; i<this._bulletArr.length;++i){
            this._bulletlayer.reSetCount(-1);
            this._bulletArr[i].openFishNet();
        }
        if(this._bulletlayer.isAutoPlay()){
            this._bulletlayer.setAutoPlay(false);
            var btn = FYEngine.getChild(this._playerNode[this._selfid],'autobtn');
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = FYEngine.getChild(btn, 'autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },


    onUpdateFishEvents : function(eFishArray){
        for(var i = 0; i < eFishArray.length; ++ i){
            for(var j = 0; j< eFishArray[i].iCount;++j){
                var fish = this.getFishbyIdFormArr(eFishArray[i].fishArry[j].iFishId);
                if (!fish){
                    var protype = FishGlobal.getFishPropsType(eFishArray[i].fishArry[j].iFishType);
                    if (protype == FishPropsType.Plate){
                        fish = PlateFish.create(eFishArray[i].fishArry[j]);
                    }
                    else {
                        fish = CommFish.create(eFishArray[i].fishArry[j]);
                    }
                    fish._bTideFish = false;
                    if(eFishArray[i].fishArry[j].tidefish == 0){
                        fish._bTideFish = true;
                    }
                    var zorder = fish._serverType;
                    if (fish._serverType == FishServerType.Fish21){
                        zorder = FishZorder.fishMax;
                    }
                    else if (fish._clientType >= FishClientType.Fish24 &&
                        fish._clientType <= FishClientType.Fish30){
                        zorder = FishZorder.fishMid;
                    }
                    this.addChild(fish, zorder, eFishArray[i].fishArry[j].iFishId);
                    this._fishArr.push(fish);
                }
                else{
                    if(eFishArray[i].fishArry[j].iAlieveTime> fish._fishAliveTime){
                        fish._delaytime = eFishArray[i].fishArry[j].iAlieveTime;
                        fish._elaspetime = eFishArray[i].fishArry[j].iAlieveTime > 0 ? 0 : Math.abs(eFishArray[i].fishArry[j].iAlieveTime);
                    }else{
//                        cc.log('---------------鱼-鱼已经存在 ,需要倒退');
                    }
//

                }
            }
        }
        eFishArray = [];
    },


    initBGLayer : function(){
        var index = FYMath.getRandom(0,2);
        var ground = new cc.Sprite(FishSceneRes.BackGround.format(index));
        ground.setAnchorPoint(cc.p(0, 0));
        ground.setPosition(cc.p(0, 0));
        this.addChild(ground, FishZorder.BGLayer, FYTagName.BGLayer);
    },

    initGameLayer : function(){
        this._bulletlayer = new FishFightBulletLayer();
        this.addChild(this._bulletlayer, FishZorder.bulletLayer, FishSceneName.BulletLayer);
    },

    initEffectLayer : function(){

        var water = cc.AnimationCache.getInstance().getAnimation('water');
        for (var j = 0; j < 2; ++ j){
            for(var i = 0; i < 4; ++ i){
                var stemp = new cc.Sprite();
                stemp.setAnchorPoint(cc.p(0,0));
                stemp.setPosition(cc.p(i*323, 320*j));
                this.addChild(stemp, FishZorder.eftlayer);
                stemp.runAction(new cc.RepeatForever(new cc.Animate(water)));
            }
        }
        this.createMoneyCache();
    },

    initUILayer : function(){
        var uilayer = new ccui.Layout();
        if(uilayer){
            this.addChild(uilayer, FishZorder.UILayer, FYTagName.UILayer);
            uilayer.setContentSize(cc.size(1136, 640));
            uilayer.setAnchorPoint(cc.p(0, 0));
            uilayer.setPosition(cc.p(0, 0));
            this._uilayer = uilayer;
        }

        this.addRank();

        this._playerNode =[];
        for(var i = 0; i < this._tableInfo.iMaxPlayer; ++ i){
            var battery = new FishFightBattery(i);
            this._uilayer.addChild(battery,0,'player'+i);
            this._playerNode.push(battery);
            battery.showUserInfo(i);
        }
        this.addRecountModel();

    },

    addRecountModel : function(){

        var recountbg = new ccui.ImageView("fish_fight_res48.png",ccui.Widget.PLIST_TEXTURE);
        if(recountbg){
            this._uilayer.addChild(recountbg, 1, "recountbg");
            recountbg.setScale9Enabled(true);
            recountbg.setContentSize(cc.size(260,52));
            recountbg.setAnchorPoint(cc.p(0.5,1));
            recountbg.setPosition(cc.p(this._uilayer.width/2, this._uilayer.height));
        }

        var recountnode = new ccui.ImageView("fish_fight_res44.png",ccui.Widget.PLIST_TEXTURE);
        if(recountnode){
            this._uilayer.addChild(recountnode, 1, "recountnode");
            recountnode.setAnchorPoint(cc.p(0.5,0.5));
            recountnode.setPosition(cc.p(this._uilayer.width/2-30, 615));
        }

        var timesp = this._timesp =FYEngine.createAlts('res/updatepackmail/fish_copy_num.png', 11, '0', '/');
        timesp.setAnchorPoint(cc.p(0,0.5));
        timesp.setPosition(cc.p(recountnode.width+5,recountnode.height/2));
        recountnode.addChild(timesp, 0, 'timesp');

        this.schedule(this.freeModeSchedule,1);
    },

    initUpLayer : function(){
        var upbg = new ccui.ImageView("fish_copy_3.png",ccui.Widget.PLIST_TEXTURE);
        if(upbg){
            this._uilayer.addChild(upbg, 1, "upbg");
            upbg.setAnchorPoint(cc.p(0.5,1));
            upbg.setScale9Enabled(true);
            upbg.setPosition(cc.p(this._uilayer.width/2, this._uilayer.height));
            upbg.setCapInsets(cc.rect(93,0, 10,0));
            upbg.setContentSize(cc.size(965,75));
        }

        var tipname = ["fish_copy_27.png","fish_copy_24.png","fish_copy_28.png","fish_copy_26.png","fish_copy_25.png"];
        for(var i = 0; i< 5;++i){
            var wealthbg = new ccui.ImageView("hall35.png",ccui.Widget.PLIST_TEXTURE);
            if(wealthbg){
                upbg.addChild(wealthbg, 0, "wealthbg"+i);
                wealthbg.setScale9Enabled(true);
                wealthbg.setPosition(cc.p(120+i*170,35));
                wealthbg.setCapInsets(cc.rect(30,0, 10,0));
                wealthbg.setContentSize(cc.size(140,41));

                var tip = new ccui.ImageView(tipname[i],ccui.Widget.PLIST_TEXTURE);
                if(tip){
                    tip.setScale(0.6);
                    wealthbg.addChild(tip,0,"wealthtip");
                    tip.setPosition(cc.p(5,wealthbg.height/2));
                }

                var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
                labgold.setPosition(cc.p(wealthbg.width/2+5, wealthbg.height/2));
                labgold.setAnchorPoint(cc.p(0.5, 0.5));
                wealthbg.addChild(labgold, 1, 'labgold');
            }
        }

        var helpbtn = new ccui.ImageView("fish_copy_2.png",ccui.Widget.PLIST_TEXTURE);
        if(helpbtn){
            upbg.addChild(helpbtn,1,"btnHelp");
            helpbtn.setTouchEnabled(true);
            helpbtn.setPosition(cc.p(900,35));
            helpbtn.addTouchEventListener(this.btnTouchEft,this);
            helpbtn.addClickEventListener(this.uiBtnCallBack);
        }

        this.changeWealth();
    },


    changeWealth : function(){

    },

    btnTouchEft : function(sender,type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setScale(1);
            }
                break;
            default:break;
        }
    },


    refreshSelfRank : function(rsp){
        if(rsp.iResult ==0){
            if(this._inittime ==false){
                this._ranksp.setString("排名："+rsp.iAllRank+"/"+rsp.iAllRank);
            }else{
                this._ranksp.setString("排名："+rsp.iRank+"/"+rsp.iAllRank);
            }

            //this._ranksp.setString("排名："+88888+"/"+88888);
        }
    },


    initFunctionMenu : function(){
        var automenu = new ccui.ImageView(FishSceneRes.Png.AutoMenuBg,ccui.Widget.PLIST_TEXTURE);
        if(automenu){
            this._uilayer.addChild(automenu,1,'automenu');
            automenu.setScale9Enabled(true);
            automenu.setCapInsets(cc.rect(22,20,53,277));
            automenu.setContentSize(cc.size(97,317));
            automenu.setAnchorPoint(cc.p(0,0));
            automenu.setPosition(cc.p(this._uilayer.width,this._uilayer.height*0.26));

            var btnArrow = new ccui.ImageView(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
            if(btnArrow){
                automenu.addChild(btnArrow,1,'btnArrow');
                btnArrow.setTouchEnabled(true);
                btnArrow.setAnchorPoint(cc.p(0.5,0.5));
                btnArrow.setPosition(cc.p(automenu.width*(-0.1753),automenu.height*0.5));
                btnArrow.addClickEventListener(this.uiBtnCallBack);
            }

            var btnBack = new ccui.Button(FishSceneRes.Png.btnBackNormal,FishSceneRes.Png.btnBackPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnBack){
                automenu.addChild(btnBack, 1, 'btnBack');
                btnBack.setAnchorPoint(cc.p(0.5,0.5));
                btnBack.setPosition(cc.p(automenu.width*0.5,automenu.height*0.81));
                btnBack.addClickEventListener(this.uiBtnCallBack);
            }

            var btnSetting = new ccui.Button(FishSceneRes.Png.btnSettingNormal,FishSceneRes.Png.btnSettingPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnSetting){
                automenu.addChild(btnSetting, 1, 'btnSetting');
                btnSetting.setAnchorPoint(cc.p(0.5,0.5));
                btnSetting.setPosition(cc.p(automenu.width*0.5,automenu.height*0.5));
                btnSetting.addClickEventListener(this.uiBtnCallBack);
            }

            var btnHelp = new ccui.Button(FishSceneRes.Png.btnHelpNormal,FishSceneRes.Png.btnHelpPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnHelp){
                automenu.addChild(btnHelp, 1, 'btnHelp');
                btnHelp.setAnchorPoint(cc.p(0.5,0.5));
                btnHelp.setPosition(cc.p(automenu.width*0.5,automenu.height*0.2));
                btnHelp.addClickEventListener(this.uiBtnCallBack);
            }


        }
    },


    uiBtnCallBack : function(sender){
        var name = sender.getName();
        cc.log("name="+name);
        var layer = FYEngine.getRunningLayer(0);
        var uilayer = layer.getChildByName(FYTagName.UILayer);
        switch(name){
            case 'btnArrow' : {
                if(this._selfid == 0 || this._selfid == 3){//人在左边列表在右边
                    var automenu = uilayer.getChildByName('automenu');
                    var moveout =new cc.MoveTo(0.2, cc.p(cc.winSize.width+automenu.width, cc.winSize.height/2));
                    var movein =new cc.MoveTo(0.2, cc.p(cc.winSize.width, cc.winSize.height/2));

                    if(FYMath.fixedNum(automenu.getPositionX(),0) == cc.winSize.width ){
                        automenu.setEnabled(false);
                        var actionplay = new cc.Sequence(moveout, new cc.CallFunc(function(){
                            automenu.setEnabled(true);
                            sender.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
                        }));
                        automenu.runAction(actionplay);
                    }else if(FYMath.fixedNum(automenu.getPositionX(),0) == (cc.winSize.width+automenu.width)){
                        automenu.setEnabled(false);
                        var actionplay = new cc.Sequence(movein, new cc.CallFunc(function(){
                            automenu.setEnabled(true);
                            sender.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
                        }));
                        automenu.runAction(actionplay);
                    }

                }else{//人在右边，列表在左边
                    var automenu = uilayer.getChildByName('automenu');
                    var moveout =new cc.MoveTo(0.2, cc.p(-automenu.width, cc.winSize.height/2));
                    var movein =new cc.MoveTo(0.2, cc.p(0, cc.winSize.height/2));

                    if(FYMath.fixedNum(automenu.getPositionX(),0) == 0 ){
                        automenu.setEnabled(false);
                        var actionplay = new cc.Sequence(moveout, new cc.CallFunc(function(){
                            automenu.setEnabled(true);
                            sender.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
                        }));
                        automenu.runAction(actionplay);
                    }else if(FYMath.fixedNum(automenu.getPositionX(),0) == (-automenu.width)){
                        automenu.setEnabled(false);
                        var actionplay = new cc.Sequence(movein, new cc.CallFunc(function(){
                            automenu.setEnabled(true);
                            sender.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
                        }));
                        automenu.runAction(actionplay);
                    }
                }

            }break;
            case 'btnBack' : {
                var mlayer = layer.getChildByName('warmtiplayer');
                if(!mlayer){
                    mlayer = new BackToLobby(1);
                    //mlayer = new KickByServer();
                    layer.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
            case 'btnSetting' : {
                var mlayer = layer.getChildByName('gamesettinglayer');
                if(!mlayer){
                    mlayer = new GameSettingLayer();
                    layer.addChild(mlayer, FishZorder.poplayer ,'gamesettinglayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }

            }break;
            case 'btnHelp' : {
                var mlayer = layer.getChildByName(FishFightLayer.FishFightRuleLayer);
                if(!mlayer){
                    mlayer = new FishFightRuleLayer();
                    layer.addChild(mlayer, FishZorder.poplayer , FishFightLayer.FishFightRuleLayer);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
            default:break;
        }
    },

    onExit : function(){
        this._super();
        for(var i = 0; i < this._fishArr.length;++i){
//            cc.log('--还鱼');
            cc.pool.putInPool(this._fishArr[i]);
        }

        for(var j = 0; j< this._bulletArr.length;++j){
            cc.log('--还子弹');
            cc.pool.putInPool(this._bulletArr[j]);
        }
        this._fishArr = [];
        this._bulletArr = [];
    },

    exitGame : function(){
        this.stopAllActions();
        this.unscheduleAllCallbacks();
        FishGlobal.bInFishScene = false;
        if(appglobal.idVerifySwitch){
            this.writeLocalIDverifyRecord();
        }
        FYEngine.runScene(FishCopyLobby.createScene());
    },

    setTouchEffect : function(pos){
        var touchEft = new cc.Sprite(FishSceneRes.Png.touchEft);
        touchEft.setPosition(pos);
        touchEft.setScale(0.1);
        touchEft.setOpacity(50);
        this.addChild(touchEft,FishZorder.eftlayer);
        touchEft.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.6, 0.6), new cc.FadeTo(0.6, 255)),
            new cc.Spawn(new cc.ScaleTo(0.4, 1), new cc.FadeTo(0.4, 50)),
            new cc.RemoveSelf()));
    },

    changeUserInfo : function(){
        cc.log("changeUserInfo");
        // var handlerMsg = this._handler._fishData;
        // this._playerNode.changeUserGold(handlerMsg._userData[0].lGold);
        // this._playerNode.changeUserCoupon(handlerMsg._userData[0].lCoupon);

    },

    changeUserGold : function(){

        // var handlerMsg = this._handler._fishData;
        // var userinfo = handlerMsg._userData[0];
        // cc.log("----更新玩家的钱"+userinfo.lGold);
        // this._playerNode.changeUserGold(userinfo.lGold);
        // appglobal.getPlayer().gold = userinfo.lGold;

    },

    changeUserCoup : function(){
        // var handlerMsg = this._handler._fishData;
        // var userinfo = handlerMsg._userData[0];
        // this._playerNode.changeUserCoupon(userinfo.lCoupon);
        // appglobal._player.coupon = userinfo.lCoupon;
    },

    shootBullet : function(id){
        var battery = this.getBattery(id);
        if (battery){
            battery.shootBullet();
        }

    },


    adjustBattery : function(id, angle){
        cc.log("adjustBattery"+angle);
        var battery = this.getBattery(id);
        if (battery){
            battery.adjustBattery(angle);
        }
    },

    getBattery : function(id){
        return this._playerNode[id];
    },

    getKillFishUserInfo : function(info){
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < 4; ++ i){
            if (handlerMsg._userData[i].lRoleId == info.lRoleId){
                return handlerMsg._userData[i];
            }
        }
        return null;
    },

    createMoneyCache : function(){
        var self = this;
        var movedown = new cc.MoveBy(0.3, cc.p(0, -60));
        this._goldAni = new cc.Sequence(new cc.MoveBy(0.2, cc.p(0, 20)), movedown.easing(cc.easeIn(3)),
            new cc.MoveBy(0.2, cc.p(0, 50)),
            new cc.Spawn(new cc.FadeTo(0.3, 50), new cc.MoveBy(0.3, cc.p(0, 60))), new cc.RemoveSelf());
        this._goldAni.retain();
    },

    /**
     *
     * @param chairid 座位
     * @param iCoinCount 奖励数量
     * @param iRewardNum 鱼的倍率
     * @param startpos 鱼的死亡位置
     */
    addMoneyToUserNew : function(chairid,iCoinCount, iRewardNum, startpos){
        cc.log("addMoneyToUserNew");
        var player = appglobal.getPlayer();

        var sp_gold = FYEngine.createNumSprite(iCoinCount
            , chairid == this._selfid?FishSceneRes.Png.killgold:FishSceneRes.Png.skillgold);
        sp_gold.setPosition(cc.pAdd(startpos, cc.p(0, -30)));
        sp_gold.setVisible(true);
        this.addChild(sp_gold, FishZorder.eftlayer);
        sp_gold.runAction(this._goldAni.clone());
    },


    checkObbCollision : function(){
        if (this._bulletArr.length <= 0 || this._fishArr.length <= 0){
            return;
        }

//       cc.log('------this._bulletArr.length : '+this._bulletArr.length);
        for (var i = 0; i < this._bulletArr.length; ++ i){
            var bullet = this._bulletArr[i];

            for (var j = 0; j < this._fishArr.length; ++ j) {
                var fish = this._fishArr[j];
                if (!this._fishArr[j] || !this._fishArr[j].isCanCollision()) {
                    continue;
                }

                var distance = FYMath.getDistance(bullet.x, bullet.y, fish.x, fish.y);
                if (distance < 10) {
                    this.bullethitFish(fish, bullet);
                    break;
                }
                else if (distance > fish.getFishLength()){
                    continue;
                }


                if (fish._fishQueneType == FishPropsType.Plate){
                    var ishit = false;
                    for (var k = 0; k < fish._plate.length; ++ k){
                        var bulletpos = fish._plate[k].convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish._plate[k].getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            ishit = true;
                            break;
                        }
                    }

                    if (ishit){
                        break;
                    }
                }
                else{
                    if (fish._bSurperise){
                        var bulletpos = fish._platesp.convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish._platesp.getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            break;
                        }
                    }
                    else{
                        var bulletpos = fish.convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish.getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            break;
                        }
                    }

                }
            }
        }

    },

    bullethitFish : function(fish, bullet){
        this.pushHitEvent(fish, bullet);
        this._bulletlayer.reSetCount(-1);
        bullet.openFishNet();
    },

    checkJoinEvents : function(){
        if (this.ejoinflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eJoinArray.length == 0){
            return;
        }

        this.ejoinflag = true;
        for (var i = 0; i < handlerMsg._eJoinArray.length; ++ i){
            this.changeUserInfo(handlerMsg._eJoinArray[i].iChairId);
        }
        handlerMsg._eJoinArray = [];
        this.ejoinflag = false;
    },

    checkLeaveEvents : function(){
        if (this.eleaveflag){
            return;
        }
        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eLeaveArray.length == 0){
            return;
        }

        this.eleaveflag = true;
        for (var i = 0; i < handlerMsg._eLeaveArray.length; ++ i){
            this.changeUserInfo(handlerMsg._eLeaveArray[i].iChairId);
            this.removeBulletsByUserId(handlerMsg._eLeaveArray[i].lRoleId);
        }
        handlerMsg._eLeaveArray = [];
        this.eleaveflag = false;
    },


    onKillFishEvents : function(eKillInfo){
        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.gold_eft);

        var fish = this.getFishbyIdFormArr(eKillInfo.iFishId);
        if (fish && fish._status != FishStatus.Dead){
            if (fish._clientType < FishClientType.Fish24 ||fish._clientType > FishClientType.Fish30 ){
                if(fish._clientType != FishClientType.Fish21){
                    if (1 > (FYMath.getRandom(0,FishGlobal.getMusicRate(fish._serverType)-1))){
                        var temp = FishGlobal.getMusicName(fish._serverType);
                        FYEngine.Audio.playEffect(temp, false);
                    }
                }

                fish.setFishDead();
                this.addMoneyToUserNew(eKillInfo.iChairId,eKillInfo.iCoinCount,eKillInfo.iRewardNum,fish.getPosition());
            }
        }
    },

    checkKillEvents : function(){
        if (this.ekillflag){
            return;
        }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler) {
            var handlerMsg = handler._fishData;
            if (handlerMsg._eKillArray.length == 0){
                return;
            }

            this.ekillflag = true;
            for (var i = 0; i < handlerMsg._eKillArray.length; ++ i){
                this.onKillFishEvents(handlerMsg._eKillArray[i]);
            }
            handlerMsg._eKillArray = [];
        }
        this.ekillflag = false;
    },

    onShootBulletEvents : function(eShootArray){
        // cc.log('-------发射子弹 onShootBulletEvents : '+eShootArray.length);
        for (var i = 0; i < eShootArray.length; ++ i){
            if(eShootArray[i].bisValid == 1){
                continue;
            }

            var battery = this.getBattery(eShootArray[i].iChairId);
            if (battery){
                battery.shootServerBullet(eShootArray[i].lBulletId, eShootArray[i].iRotate, eShootArray[i].iType,
                    eShootArray[i].iRate, eShootArray[i].iFireTime, eShootArray[i].lRoleId, eShootArray[i].bisValid);
            }
            // if(eShootArray[i].iFireTime<0){
            //     var battery = this.getBattery();
            //     if (battery){
            //         battery.shootServerBullet(eShootArray[i].lBulletId, eShootArray[i].iRotate, eShootArray[i].iType,
            //             eShootArray[i].iRate, eShootArray[i].iFireTime, eShootArray[i].lRoleId, eShootArray[i].bisValid);
            //     }
            // }
        }
        eShootArray = [];
    },

    checkShootEvents : function(){
        if (this.eshootflag){
            return;
        }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler) {
            if (handler._fishData._eShootArray.length == 0){
                return;
            }

            this.eshootflag = true;
            this.onShootBulletEvents(handler._fishData._eShootArray);
            handler._fishData._eShootArray = [];
            this.eshootflag = false;

        }

    },

    onHitFishEvents : function(eHitArray){
        // FYEngine.logObject(eHitArray,'---------碰撞事件');
        for (var i = 0; i < eHitArray.length; ++ i){
                var bullet = this.getBulletFromArr(eHitArray[i].lBulletId);
                if (bullet && bullet.isVisible()){
                    bullet.openFishNet();
                }
                else{
//                    cc.log('----------子弹不存在 && bullet.isVisible()');
                    continue;
                }
        }
        eHitArray = [];
    },

    checkHitEvents : function(){

        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler) {
            if (this.ehitflag){
                return;
            }
            var handlerMsg = handler._fishData;
            if (handlerMsg._eHitArray.length == 0){
                return;
            }

            this.ehitflag = true;
            this.onHitFishEvents(handlerMsg._eHitArray);
            handlerMsg._eHitArray = [];
            this.ehitflag = false;
        }
    },


    getFishbyIdFormArr : function(id){
        for (var i = 0; i < this._fishArr.length; ++ i){
            if (this._fishArr[i] && this._fishArr[i].getId() == id){
                return this._fishArr[i];
            }
        }

        return null;
    },

    getBulletFromArr : function(id){
        for (var i = 0; i < this._bulletArr.length; ++ i){
            if (this._bulletArr[i] && this._bulletArr[i].getId() == id){
                return this._bulletArr[i];
            }
        }

        return null;
    },

    removeBulletsByUserId : function(id){
        var removearr = [];
        for (var i = 0; i < this._bulletArr.length; ++ i){
            if (this._bulletArr[i] && this._bulletArr[i].getUserId() == id){
                removearr.push(this._bulletArr[i].getId());
//                cc.log('----------删除的子弹:'+this._bulletArr[i].getId());
            }
        }

        for (var i = 0; i < removearr.length; ++ i){
            var bullet = this._bulletlayer.getChildByName('name'+removearr[i]);
            if (bullet){
                bullet.removeSelf();
            }
        }

    },

    pushHitEvent : function(fish, bullet){
//        cc.log('----------发送子弹碰撞消息');
        var lBulletId = bullet.getId();
        var iHitFishId = fish.getId();
        var iRate = bullet.getRate();
        var bHitFishType = fish.getServerType();
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendCopyHitFishReq(lBulletId,iHitFishId,iRate,bHitFishType);
        }
    },

    onUnconnect : function(type){
//        cc.log('----------------FishScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
//        cc.log("unconnecttype====="+type);
        switch (type){
            case 1:{

                if (!layer){
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer+100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
//                cc.log("code===="+layer._reConnectCode);
                if(layer && layer._reConnectCode&&layer._reConnectCode==1){
                    if(layer._type&&layer._type==3){
                        return;
                    }
                    layer.refreshUI(3);
                }

                if(layer && layer._reConnectCode==0 && layer.code==0){
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF,10.0);
                    //this.scheduleOnce(f,30.0);
                    layer.code=1;
                }
            }
                break;
            case 2:
            case 3:{
                if (layer){
                    if(layer._type&&layer._type==3){
                        return;
                    }
                    if(layer &&layer.layerF){
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code=0;
                    }
                    //this.unschedule(f);

                }
            }
                break;
            case 0:{
                if (layer){
                    layer.removeFromParent();
                }
            }
                break;
        }
    },

    vibrationCallBack : function(){
        if(this._vibrationend){
            return;
        }
        this._vibrationend = true;
        var self = this;
        var bg = this.getChildByName(FYTagName.BGLayer);
        if(bg){
            bg.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(10,18)), new cc.MoveTo(0.05,cc.p(-10,-20)),
                new cc.MoveTo(0.05,cc.p(10,50)), new cc.MoveTo(0.05,cc.p(-10,-50)),new cc.MoveTo(0.1,cc.p(10,30)), new cc.MoveTo(0.1,cc.p(-10,-30)), new cc.MoveTo(0.1,cc.p(10,20)),new cc.MoveTo(0.1,cc.p(-8,-10)),new cc.MoveTo(0.1,cc.p(5,5)),new cc.MoveTo(0.1,cc.p(0,0))));
        }
        this._uilayer.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(-5,-10)), new cc.MoveTo(0.05,cc.p(10,20)),
            new cc.MoveTo(0.05,cc.p(-10,-30)), new cc.MoveTo(0.05,cc.p(10,30)),new cc.MoveTo(0.1,cc.p(-10,-20)), new cc.MoveTo(0.1,cc.p(10,20)), new cc.MoveTo(0.1,cc.p(-10,-10)),new cc.MoveTo(0.1,cc.p(8,10)),new cc.MoveTo(0.1,cc.p(-5,-5)),new cc.MoveTo(0.1,cc.p(0,0)),new cc.CallFunc(function(){
                self._vibrationend = false;
            })));


    },

    gameOnShowEvent : function(){
        cc.log('----------------游戏退到后台啦-');
        this.initBackGroundMusic();
        this.queryRealTime();
    },

    queryRealTime: function(){
        if(this._gameend){
            return;
        }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendGetSceneTimeReq();
        }
    },

    phoneKeyCallBack : function(keycode,target){
        switch(keycode){
            case cc.KEY.back : {
//                cc.log('---------物理返回键--------');

                if(FYEngine.getRunningLayer(0).getChildByName('kickedbyserver')){
                    return;
                }

                var layer = target.getChildByName(FishSceneName.UnConnectDialog)
                    || target.getChildByName(FishCopyLobbyLayer.CopyTimeOutLayer);
                if(layer){
                    return;
                }

                var namelist = [FishFightLayer.FishFightRuleLayer,'warmtiplayer','gocharge','helpinfolayer','gamesettinglayer',LobbySceneName.FreeRoomRule,LobbySceneName.DetailLayer];

                for(var i = 0; i < namelist.length ; ++i){
                    var layer =target.getChildByName(namelist[i]);
                    if(layer){
                        FYEngine.popoutLayerAnimate(layer.layerbg);
                        return;
                    }
                }

            }break;
        }

    },

    initBackGroundMusic : function(type){
        cc.log('---------------------初始化音乐------');
        var vibtn = cc.sys.localStorage.getItem('isVibration');
        if(vibtn == null || vibtn == '0'){
            this._isVibrationSwitch = 0;
        }else{
            this._isVibrationSwitch = 1;
        }


        var bgmusic = cc.sys.localStorage.getItem('bgVolum');
        cc.log("-----fish---bgmusic===="+bgmusic);
        if(bgmusic == null){
            FYEngine.Audio.setMusicVolume(1);
        }else{
            // FYEngine.Audio.setMusicVolume(Number(bgmusic));
            // cc.audioEngine.setMusicVolume(Number(bgmusic));
            FYEngine.Audio.setOpenMusic(Number(bgmusic))
        }

        var eftmusic = cc.sys.localStorage.getItem('eftVolum');
//        cc.log("fish---eftmusic===="+eftmusic);
        if(eftmusic == null){
            FYEngine.Audio.setEffectVolume(1);
        }else{
            FYEngine.Audio.setEffectVolume(Number(eftmusic));
        }
        var t = FYMath.getRandom(1,3);
        if(!type){
            switch(t){
                case 1 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                }break;
                case 2 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                }break;
                case 3 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                }break;
            }
        }
    },

});


FishFightGameLayer.createScene = function(){
    var scene = new cc.Scene();
    var layer = new FishFightGameLayer();
    scene.addChild(layer, 0, 0);
    return scene;
};


