/**
 * Created by mintao on 2016/11/12.
 * 捕鱼场景界面
 */


var FishSceneRes = {

    BackGround : 'res/fishbg/fishground{0}.png',

    Png : {
        Num3             : 'res/num/fishnum3.png',
        Num4             : 'res/num/fishnum4.png',
        Num6             : "res/num/number6.png",
        FishBroadBg      : 'fishbroadbg2.png',
        AutoMenuBg       : 'gameui3.png',
        arrowbtn_in      : 'gameui25.png',
        arrowbtn_out     : 'gameui2.png',
        btnBackNormal    : 'gameui20.png',
        btnBackPressed   : 'gameui19.png',
        btnSettingNormal : 'gameui22.png',
        btnSettingPressed: 'gameui21.png',
        btnHelpNormal    : 'gameui12.png',
        btnHelpPressed   : 'gameui11.png',
        TipsBg           : "#position3.png",
        TipsBatteryBg    :'#gameui8.png',
        TipsSelfCannon   :'#cannonself0.png',
        TipsGoldBg       : '#gameui4.png',
        TipsSub          : '#gameui16.png',
        TipsAdd          :  '#gameui24.png',
        BatterySubNormal : 'gameui16.png',
        BatterySubPressed: 'gameui15.png',
        BatteryAddNormal :'gameui24.png',
        BatteryAddPressed:'gameui23.png',
        touchEft         : '#bullettouch.png',
        waitIn           :"#gameui27.png",
        MallTip          : "#malltip.png",
        tryConnectSuccess:"#common4.png",
        tryConnectFail   :"#common1.png",
        tryPoint         :"#common3.png",
        tryConnect       :"#common2.png",
        tooMoreToast     :"#gameui34.png",
        AutoEft          : '#fish_hallnew087.png',
        RewardPlate      : '#fishPlate3.png',
        AutoPlayOpenBtn  : 'fish_hallnew086.png',
        AutoPlayBtn      : 'fish_hallnew085.png',
        FishCoupon : 'fishcoupon.png',
        killgold : '#killnum{0}.png',
        skillgold : '#skillnum{0}.png',
        FishCoin : 'fishcoin_{0}.png',
        FishCoin1 : 'silverCoin_{0}.png',
    },

    Plist : {

    },

    csb : {
        Boom   : "res/effect/boomeft.csb",
    },


    FishPlateRes : {
        Plate1 : 'fishPlate4.png',
        Plate2 : 'fishPlate2.png',
        Plate3 : 'fishPlate1.png',
        Plate4 : 'fishPlate5.png',
        Plate5 : 'fishPlate0.png',
    },
    DialogPng : {
        OuterBg : 'dialog_0.png',
        InnerBg : 'dialog_1.png',
        NotChoose : 'dialog_4.png',
        TitleTip : '#dialog_5.png',
        TitleBigBG : 'dialog_6.png',
        TitleSmallBG : 'dialog_7.png',
        TitleSetting : '#crystal33.png',
        
        TitleHelp : '#dialog_10.png',
       
        SliderProgress : 'dialog_13.png',
        SliderBg : 'dialog_14.png',
        ConfirmTitle : '#dialog_15.png',
        CancelTitle : '#smallwines20.png',
        CancelBtn : '#dialog_17.png',
        ConfirmBtn : '#dialog_18.png',
        BackBtnDowm : 'dialog_19.png',
        BackBtnUp : 'dialog_20.png',
        couponbg:'gameui42.png',
        couponblink1:"#gameui36.png",
        couponblink2:"#gameui38.png"
    },

    preloadAudioName : {
        music :{
            Lobby_bg : 'res/sound/bgm_scene_fish.mp3',
            FishScene_bg1 : 'res/sound/bgm10.mp3',
            FishScene_bg2 : 'res/sound/bgm100.mp3',
            FishScene_bg3 : 'res/sound/bgm1000.mp3',

        },

        fisheft : {
            Fish0   : 'res/sound/fish0.mp3',
            Fish1   : 'res/sound/fish1.mp3',
            Fish2   : 'res/sound/fish4.mp3',
            Fish3   : 'res/sound/fish5.mp3',
            Fish4   : 'res/sound/fish7.mp3',
            Fish5   : 'res/sound/fish8.mp3',
            Fish12  : 'res/sound/fish3.mp3',
            Fish13  : 'res/sound/fish12.mp3',
            Fish14  : 'res/sound/fish2.mp3',
            Fish15  : 'res/sound/fish9.mp3',
            Fish16  : 'res/sound/fish15.mp3',
            Fish18  : 'res/sound/fish19.mp3',
            Fish19  : 'res/sound/fish6.mp3',//银蛤蟆
            Fish21  : 'res/sound/superarm.mp3',
            Fish22  : 'res/sound/fish14.mp3',
            Fish24 :  'res/sound/getcoupon.mp3',
            Fish32  : 'res/sound/fish10.mp3',
            Fish34  : 'res/sound/fish13.mp3',
            Fish39  : 'res/sound/fish11.mp3',
            Fish41  : 'res/sound/fish19.mp3',

        },

        effect : {
            change_gun : 'res/sound/changegun.mp3',
            shoot_eft : 'res/sound/fire.mp3',
            gold_eft  : 'res/sound/gold.mp3',
            bingo_eft : 'res/sound/bingo.mp3',
            reward_eft :'res/sound/catch.mp3',
            wave_eft : 'res/sound/wave.mp3',
            BOOM_eft :"res/updateboom/nucbomb.mp3",
        },
    },
};

/***
 * 场景tag/name
 * @type {{}}
 */
var FishSceneName = {
    UILayer : 'layer',
    FishLayer : 'fishlayer',
    BulletLayer : 'bulletlayer',
    Btnexchange : 'btnexchange',
    Btnback : 'btnback',
    Autoplay : 'autoplay',
    Btnrecharge : 'btnrecharge',
    Automenu: 'automenu',
    Btnpull : 'btn',
    MenuBtn : {
        Btnback : 'btnback',
        Btnsetting : 'btnsetting',
        Btnhelp : 'btnhelp',
    },

    Player : 'playerinfo{0}',

    UnConnectDialog : 'UnConnectDialog',

    PopLayer : {
        BackToLobby : 'warmtiplayer',
        Setting     :'gamesettinglayer',
        Help        :'helpinfolayer',

    }

};

var FishGameEventID = {
    unConnect : 'unConnect',
    firespecial:"firespecial",
    hitspecial : "hitspecial",
};

var FishZorder = {
    BGLayer     : 0,
    fishMid     : 80,
    fishMax     : 90,
    bulletLayer : 160,
    UILayer     : 180,
    eftlayer    : 190,
    BroadLayer  : 200,
    TipsLayer   : 210,
    poplayer    : 220,
};

var FishLayer = cc.Layer.extend({
    _handler : null,
    _lobbyhandler : null,
    _heartBeatCount : 0,
    eupdateflag : false,
    _fishArr:[],
    _bulletArr:[],
    _selfBulletArr : [], //自己的子弹数组
    _playerNode:[],
    mainscene : null,
    eventTime : 0,
    _SyncTable : 0,
    m_tideIn : false,//鱼潮来了
    _tideCount : 0,//鱼潮计数 >1必出海浪特效
    _isVibrationSwitch : 1,
    _bulletlayer : null,
    _broadSp : null,
    _tideArr : [],
    ejoinflag : false,
    eleaveflag : false,
    ekillflag : false,
    eshootflag : false,
    ehitflag : false,
    echangeflag : false,
    _birtharr : [],
    _vibrationend : false,
    _inittime :false,
    _Nlock:false,
    _needProtect : true,
    _selfid : -1,

    ctor : function(){
        this._super();
        this.setName('fishscene');
        FishGlobal.bInFishScene = true;
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._handler.setScene(this);

        this._lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();

    },

    onEnter : function(){
        this._super();
        this.init();
    },

    init : function(){
        this.initData();
        this.initBGLayer();
        this.initGameLayer();
        this.initEffectLayer();
        this.initUILayer();

        this.initTipsLayer();
        this.initNuclear();
        this.initPhoneBtnCallBack();
        this.initBackGroundMusic();
        this.scheduleUpdate();
        if(appglobal._switch7==1){
            this.initBroadCast();
        }

        if(appglobal._switch21 == 0){
            var player = appglobal.getPlayer();
            if(player.realIDnumber == "" ||!player.isAdult){
                this.schedule(this.writeLawRecord,60);
                // this.schedule(this.writeLawRecordtest,60);
            }
        }

        if(this._lobbyhandler && this._lobbyhandler._canSendNormalMsg){
            this._lobbyhandler.sendGetCrystalInfoReq();
        }
    },

    initNuclear : function(){
        var self = this;

        if(FishGlobal.LiveLevel>=3 && appglobal._switch1 ==1){
            var nuccallfun = function(sender){
                self.nuclrearBtnCallBack(sender);
            };
            var boombtn = new ccui.ImageView("fish_boom49.png",ccui.Widget.PLIST_TEXTURE);
            if(boombtn){
                this._uilayer.addChild(boombtn,1,'boombtn');
                boombtn.setPosition(cc.p(50,400));
                boombtn.setTouchEnabled(true);
                this._boombtn = boombtn;
                boombtn.addClickEventListener(nuccallfun);
            }

            var boonlight = cc.AnimationCache.getInstance().getAnimation('boombtneft');
            var stemp = new cc.Sprite();
            this._boomstemp = stemp;
            stemp.setVisible(false);
            stemp.setAnchorPoint(cc.p(0.5,0.5));
            stemp.setPosition(cc.p(boombtn.width/2, boombtn.height/2));
            boombtn.addChild(stemp, 0);
            stemp.runAction(new cc.RepeatForever(new cc.Animate(boonlight)));

            //炸弹数量
            var txt = ccui.Text("x"+appglobal.getPlayer().crystal ,'微软雅黑' ,18 );
            if(txt){
                txt.setAnchorPoint(cc.p(0.5,0));
                txt.setColor(cc.color("ffea00"));
                txt.enableOutline(cc.color("0d00bc"),2);
                txt.setPosition(cc.p(boombtn.width/2,6));
                boombtn.addChild(txt,0);
                this._txtboomqty = txt;
            }

            //
            var yellowlight = new cc.Sprite("#fish_boom26.png");
            if(yellowlight){
                boombtn.addChild(yellowlight,6,'yellowlight');
                yellowlight.setPosition(cc.p(boombtn.width/2,boombtn.height/2));
                yellowlight.setVisible(false);
                this._yellowlight = yellowlight;
            }

            //黑色遮罩
            var cover = new cc.Sprite("#fish_boom09.png");
            if(cover){
                boombtn.addChild(cover,7,'shad');
                cover.setPosition(cc.p(boombtn.width/2,boombtn.height/2));
                cover.setVisible(false);
                this._bcover = cover;
            }

            //倒计时转圈
            var shad = new cc.Sprite("#fish_boom25.png");
            if(shad){
                shad.setFlippedX(true);
                var process = new cc.ProgressTimer(shad);
                process.setType(cc.ProgressTimer.TYPE_RADIAL);
                process.setPosition(cc.p(boombtn.width/2,boombtn.height/2));
                boombtn.addChild(process,9);
                this._shad = process;

            }
            //倒计时文本
            // var txt1 = ccui.Text("20" ,'微软雅黑' ,40 );
            var txt1=FYEngine.createAlts('res/updateboom/fish_boomnum.png', 10,"20", '0');
            if(txt1){
                txt1.setAnchorPoint(cc.p(0.5,0.5));
                // txt1.setColor(cc.color("ffea00"));
                // txt1.enableOutline(cc.color("ffea00"),1);
                txt1.setPosition(cc.p(boombtn.width/2,boombtn.height/2));
                boombtn.addChild(txt1,10);
                txt1.setVisible(false);
                this._shadtxt = txt1;
            }

            var date = (new Date()).getTime();
            var sp  = Math.ceil((date-FishGlobal.nuclearrecount)/1000);
            if(sp<=20 && sp>0){
                this._Nlock = true;
                this.NucBtnRecount(21-sp);
            }
        }


        var nucLayer = new NuclearLayerOther();
        if(nucLayer){
            this._uilayer.addChild(nucLayer,FishZorder.eftlayer,FYTagName.NuclearLayero);
            nucLayer.setContentSize(cc.size(1136, 640));
            nucLayer.setAnchorPoint(cc.p(0, 0));
            nucLayer.setPosition(cc.p(0, 0));
            this._nuclearlayerother = nucLayer;

            for(var i=0;i<4;++i){
                var userinfo = this._handler._fishData._userData[i];
//                FYEngine.logObject(userinfo,"----------特殊");
                if(userinfo.lRoleId >0 && userinfo.iType!= 0){
                    nucLayer.initRocket(i,userinfo.iType);
                }
            }
        }



    },

    NucBtnRecount : function(totoalc){
        var self =this;
        var number = totoalc;
        this._shadtxt.setString(""+number);
        this._boomstemp.setVisible(false);
        this._bcover.setVisible(true);
        this._shad.setVisible(true);
        this._shadtxt.setVisible(true);
        var startp = totoalc*5;
        var action1 = new cc.ProgressFromTo(number,startp,0);
        this._shad.runAction(action1);
        this._yellowlight.runAction(new cc.Sequence(new cc.DelayTime(number),new cc.Show(),new cc.FadeIn(0.2),new cc.FadeOut(0.8)));

        this.schedule(function(){
            number--;
            if(number>=0){
                self._shadtxt.setString(""+number);
            }
            if(number==0){
                self._Nlock = false;
                self._bcover.setVisible(false);
                self._shad.setVisible(false);
                self._shadtxt.setVisible(false);
                self._shadtxt.setString("20");
            }
        },1,totoalc);

    },

    nuclrearBtnCallBack : function(sender){
        cc.log("--------点击了核弹头按钮"+this._Nlock);

        if(appglobal.getPlayer().crystal<=0){
            FYEngine.AddCommToast("道具数量不足");
            return;
        }

        if(this._Nlock){
            FYEngine.AddCommToast("技能冷却中");
            return;
        }

        if(this._handler._fishData._fishTideControl == false){
            FYEngine.AddCommToast("鱼潮期间无法发射核弹，请稍等");
            return;
        }
        var mlayer = this.getChildByName(LobbySceneName.ChooseBoomLayer);
        if(!mlayer){
            mlayer = new ChooseBoomLayer();
            this.addChild(mlayer, FishZorder.poplayer ,LobbySceneName.ChooseBoomLayer);
            FYEngine.popupLayerAnimate(mlayer.layerbg);
        }
    },

    playerUseBoom : function(type){
        this._Nlock = true;
        FishGlobal.isBoom = true;
        var handlerMsg = this._handler._fishData;
        var selfid = handlerMsg._selfId;
        this._boomstemp.setVisible(true);
        this._txtboomqty.setString("x"+(appglobal.getPlayer().crystal-FishGlobal.BoomConf.iList[type].iHedanCount));
        this.getBattery(selfid).backCannon(type,true);
        var nucLayer = new NuclearLayerSelf(type);
        if(nucLayer){
            this._uilayer.addChild(nucLayer,FishZorder.eftlayer,FYTagName.NuclearLayers);
            nucLayer.setContentSize(cc.size(1136, 640));
            nucLayer.setAnchorPoint(cc.p(0, 0));
            nucLayer.setPosition(cc.p(0, 0));
            this._nuclearlayerself = nucLayer;
        }
    },

    writeLawRecord : function(){

        var player = appglobal.getPlayer();
        if(player.realIDnumber != "" && player.isAdult){
            this.unschedule(this.writeLawRecord);
            return;
        }
        var date = new Date();
        var currentRecordTime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(currentRecordTime){
            var totaltime = Number(currentRecordTime)+1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                totaltime+"");
            cc.log('-----------------1分钟计时一次已经游戏时间'+totaltime);
            if(totaltime<FishGlobal.lostTime.controllevel1){
                if((totaltime%FishGlobal.lostTime.duration1) == 0){//3小时内每小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }else if(totaltime==FishGlobal.lostTime.controllevel1){
                this.showAvoidLayer(totaltime);
            }else if(totaltime>FishGlobal.lostTime.controllevel1 && totaltime<FishGlobal.lostTime.controllevel2){
                if((totaltime%FishGlobal.lostTime.duration2) == 0){//3~5小时内每半小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }else if(totaltime==FishGlobal.lostTime.controllevel2){
                this.showAvoidLayer(totaltime);
            }else{
                if((totaltime%FishGlobal.lostTime.duration3) == 0){//5小时后每15分钟弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }
        }else{
            var totaltime = 1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                totaltime+"");
        }

    },

    // writeLawRecordtest : function(){
    //
    //     var player = appglobal.getPlayer();
    //     if(player.realIDnumber != "" && player.isAdult){
    //         this.unschedule(this.writeLawRecordtest);
    //         return;
    //     }
    //     var date = new Date();
    //     var currentRecordTime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate());
    //     if(currentRecordTime){
    //         var totaltime = Number(currentRecordTime)+1;
    //         cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
    //             totaltime+"");
    //         cc.log('-----------------1分钟计时一次已经游戏时间'+totaltime);
    //         if(totaltime<FishGlobal.testlostTime.controllevel1){
    //             if((totaltime%FishGlobal.testlostTime.duration1) == 0){//3小时内每小时弹出一次
    //                 this.showAvoidLayer(totaltime*60);
    //             }
    //         }else if(totaltime==FishGlobal.testlostTime.controllevel1){
    //             this.showAvoidLayer(totaltime*60);
    //         }else if(totaltime>FishGlobal.testlostTime.controllevel1 && totaltime<FishGlobal.lostTime.controllevel2){
    //             if((totaltime%FishGlobal.testlostTime.duration2) == 0){//3~5小时内每半小时弹出一次
    //                 this.showAvoidLayer(totaltime*60);
    //             }
    //         }else if(totaltime==FishGlobal.testlostTime.controllevel2){
    //             this.showAvoidLayer(totaltime*60);
    //         }else{
    //             if((totaltime%FishGlobal.testlostTime.duration3) == 0){//5小时后每15分钟弹出一次
    //                 this.showAvoidLayer(totaltime*60);
    //             }
    //         }
    //     }else{
    //         var totaltime = 1;
    //         cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'LawRecord'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
    //             totaltime+"");
    //     }
    //
    // },

    showAvoidLayer : function(totaltime){
        var layer = this.getChildByName(LobbySceneName.AvoidGameLostTip);
        if(!layer){
            layer = new AvoidGameLostTip(totaltime);
            this.addChild(layer, FishZorder.poplayer,LobbySceneName.AvoidGameLostTip)
        }else{
            layer.refreshUI(totaltime);
        }
    },


    writeLocalIDverifyRecord : function(){
        cc.log('-----------------2分钟计时一次');
        if(FishGlobal.playGameTime<0){
            FishGlobal.playGameTime =0;
        }

        var date = new Date();


        var playergametime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(playergametime){
            var record = Math.floor(FishGlobal.playGameTime);
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate(), record+"");
        }else{
            var player = appglobal.getPlayer();
            if(player.realIDnumber == ""){
                FishGlobal.playGameTime = FishGlobal.idControl.noid.totalgametime;
            }else{
                if(player.isAdult){
                    FishGlobal.playGameTime = FishGlobal.idControl.adult.totalgametime;
                }else{
                    FishGlobal.playGameTime = FishGlobal.idControl.child.totalgametime;
                }
            }
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'gametime'+date.getFullYear()+date.getMonth()+date.getUTCDate(), FishGlobal.playGameTime+"");
        }

    },

    createUpdate : function (dt) {
        this._handler._gametime += dt;
        if (this.eupdateflag){
            return;
        }

        this.eupdateflag = true;
        var i = 0;
        var info = null;
        for (; i < this._handler._unbirthFishArr.length; ++ i){
            info = this._handler._unbirthFishArr[i];
            if (this._handler._gametime < info.iBirthTime){
                break;
            }
        }

        if (i == 0){
            this.eupdateflag = false;
            return;
        }

        this._birtharr = this._handler._unbirthFishArr.splice(0, i);
        var fish = null;
//        cc.log("-----创建鱼数量 this._birtharr.length : "+this._birtharr.length);
        for(var j = 0; j < this._birtharr.length; ++ j){
            var protype = FishGlobal.getFishPropsType(this._birtharr[j].iFishType);
            if (protype == FishPropsType.Plate){
                fish = PlateFish.create(this._birtharr[j]);
            }
            else {
                fish = CommFish.create(this._birtharr[j]);
            }

            fish._bTideFish = false;
            if(this._birtharr[j].tidefish == 0){
                fish._bTideFish = true;
            }

            var zorder = this.getFishZorder(fish._clientType, fish._serverType);
            this.addChild(fish, zorder, this._birtharr[j].iFishId);
            this._fishArr.push(fish);
        }

        this.eupdateflag = false;
    },

    getFishZorder : function(clienttype, servertype){
        var zorder = servertype;
        if (servertype == FishServerType.Fish21){
            zorder = FishZorder.fishMax;
        }
        else if (clienttype >= FishClientType.Fish24 &&
            clienttype <= FishClientType.Fish30){
            zorder = FishZorder.fishMid;
        }
        return zorder;
    },

    updateschedule : function(callback, interval){
        var then = Date.now();
        interval = interval*1000;
        this.schedule(function(){
            var now = Date.now();
            var delta = now-then;
            if (delta > interval){
                then = now - (delta%interval);
                callback.call(this);
            }
        }.bind(this), 0);
    },

    update : function(dt){
        if(this._handler && this._handler._canSendNormalMsg){
            this.checkObbCollision();
        }

        this.checkJoinEvents();
        // this.checkLeaveEvents();
        this.checkFishTideEvents();
        // this.checkUpdateFishEvents();
        this.createUpdate(dt);
        this.checkShootEvents();
        this.checkLeaveEvents();
        this.checkHitEvents();
        this.checkCannonEvents();
        this.checkKillEvents();

        // if(appglobal.idVerifySwitch){
        //     this.checkIDcount(dt);
        // }

    },

    checkIDcount : function(dt){
        FishGlobal.playGameTime-=dt;
    },

    initData : function(){
        this._bulletArr =[];
        this._fishArr = [];
        FishGlobal.needCharge = 0;
        FishGlobal.InterNumber = 0;
        this._inittime =false;
        this._Nlock = false;
        FishGlobal.isBoom = false;
        this._needProtect = true;
        this._selfid = this._handler.getSelfId();
    },

    initPhoneBtnCallBack : function(){
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this,'game_on_show',this.gameOnShowEvent);
        FYEngine.AddCustomLister(this,'game_on_hide',this.testGameOnHide);
    },

    testGameOnHide : function(){
        cc.log("---testgameonhide");
        if(cc.sys.os == 'iOS'){
            cc.audioEngine.stopMusic();
        }
    },

    initBroadCast : function(){
        cc.log("initBroadCast");
        var size = FYEngine.winSize;
        this._broadSp = new FishBroadCast(FishSceneRes.Png.FishBroadBg, cc.size(825, 44), null,
            cc.size(815, 39), cc.p(1.5, 2.5), 3.5, ccui.Widget.PLIST_TEXTURE, false);
        this._broadSp.setVisible(false);
        this._broadSp.setPosition(cc.p(size.width/2, size.height/2));
        this.addChild(this._broadSp, FishZorder.BroadLayer);
    },

    onGameEvent : function(event_id, event_param){
        switch (event_id){
            case FishGameEventID.unConnect:{
                this.onUnconnect(event_param);
                if(event_param ==2){
                    this._nuclearlayerother.init();
                    for(var i=0; i<4;++i){
                        this._playerNode[i].resetCannon();
                    }
                }
                if(event_param == 1 && this._needProtect){
                    this._needProtect = false;
                    this.protectUser();
                }else{
                    this._needProtect = true;
                }

            }break;
            case lobbyGameEvent.refreshSelfRank :{

            }break;
            case lobbyGameEvent.GetFreeRankOuter:{

            }break;
            case FishGameEventID.firespecial:{
                this.firSpecialOther(event_param);
            }break;
            case FishGameEventID.hitspecial:{
                this.hitSecial(event_param);
            }break;
            case lobbyGameEvent.refreshWealth : {
                if(this._txtboomqty){
                    this._txtboomqty.setString("x"+appglobal.getPlayer().crystal);
                }
            }break;
            default : break;
        }
    },

    protectUser : function(){
        cc.log("protectUser");
        for(var i =0; i<this._bulletArr.length;++i){
            this._bulletlayer.reSetCount(-1);
            this._bulletArr[i].openFishNet();
        }
        if(this._bulletlayer.isAutoPlay()){
            this._bulletlayer.setAutoPlay(false);
            var selfId = this._handler.getSelfId();
            var btn = FYEngine.getChild(this._playerNode[selfId],'autobtn');
            if(btn){
                btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
                var autoeft = FYEngine.getChild(btn, 'autoeft');
                if(autoeft){
                    autoeft.removeFromParent(true);
                }
            }
        }
    },

    firSpecialOther : function(rsp){
        this._nuclearlayerother.openFire(rsp.iChairId,cc.p(rsp.ix,rsp.iy),rsp.iRotate);
    },

    hitSecial : function(rsp){
        if(rsp.lRoleId ==appglobal.getPlayer().roleid){
            this.createNB(rsp.lGold,rsp.iBoomType);
            FishGlobal.isBoom = false;
            // this._handler.sendUpdateWealthReq();
            this._lobbyhandler.sendGetCrystalInfoReq();
        }
        var chairid =0;
        for(var j=0;j<4;++j){
            var userinfo = this._handler._fishData._userData[j];
            if(userinfo.lRoleId == rsp.lRoleId){
                chairid = userinfo.iChairId;
                this._handler._fishData._userData[j].lGold+=rsp.lGold;
            }
        }
        this.changeUserGold(chairid);

        for(var i =0;i<rsp.iFishId.length;++i){
            var fish = this.getFishbyIdFormArr(rsp.iFishId[i]);
            fish.setFishDead();
            var startpos = fish.getPosition();
            var tReward = rsp.tReward[i];
            var fishrate = tReward.iRewardNum;
            if (fishrate == 0){
                return;
            }
            var endpos = this._playerNode[chairid].getPosition();

            ///创建金币动画
            if(chairid == this._handler.getSelfId()){
                if(fishrate <= 3){
                    this.createCoins(1, 1, startpos, endpos);
                }else if(fishrate<=6){
                    this.createCoins(1, 2, startpos, endpos);
                }else if(fishrate<=9){
                    this.createCoins(1, 3, startpos, endpos);
                }else if(fishrate<=14){
                    this.createCoins(1, 4, startpos, endpos);
                }else if(fishrate<=19){
                    this.createCoins(1, 6, startpos, endpos);
                }else if(fishrate<=29){
                    this.createCoins(1, 8, startpos, endpos);
                }else if(fishrate<=100){
                    this.createCoins(1, 10, startpos, endpos);
                }else if(fishrate<=299){
                    this.createCoins(1, 20, startpos, endpos);
                }else{
                    this.createCoins(1, 30, startpos, endpos);
                }
            }else{
                if(fishrate <= 3){
                    this.createCoins(0, 1, startpos, endpos);
                }else if(fishrate<=6){
                    this.createCoins(0, 2, startpos, endpos);
                }else if(fishrate<=9){
                    this.createCoins(0, 3, startpos, endpos);
                }else if(fishrate<=14){
                    this.createCoins(0, 4, startpos, endpos);
                }else if(fishrate<=19){
                    this.createCoins(0, 6, startpos, endpos);
                }else if(fishrate<=29){
                    this.createCoins(0, 8, startpos, endpos);
                }else if(fishrate<=100){
                    this.createCoins(0, 10, startpos, endpos);
                }else if(fishrate<=299){
                    this.createCoins(0, 20, startpos, endpos);
                }else{
                    this.createCoins(0, 30, startpos, endpos);
                }

            }
        }
    },

    createNB: function(gold, rockid){
        var rockindex =0;
        for(var i =0 ;i<FishGlobal.BoomConf.iCount;++i){
            if(FishGlobal.BoomConf.iList[i].iBulletType == rockid){
                rockindex = i;
            }
        }

        var stemp = new cc.Sprite();
        stemp.setAnchorPoint(cc.p(0.5,0.5));
        stemp.setPosition(this.width/2,this.height/2);
        this.addChild(stemp, FishZorder.eftlayer);
        stemp.runAction(new cc.Sequence(FYEngine.createAnimate("nuclearlight"),new cc.RemoveSelf()));

        var particle = new cc.ParticleSystem("res/updateboom/test.plist");
        this.addChild(particle,FishZorder.eftlayer+1);
        particle.setPosition(cc.p(this.width/2,this.height/2));

        this.scheduleOnce(function(){
            cc.log("----删除lizi");
            particle.removeFromParent(true);
        },(particle.getLife()+1));

        var node = new cc.Node();
        if(node){
            node.setScale(0.1);
            this.addChild(node,FishZorder.eftlayer+1);
            node.setPosition(cc.p(this.width/2,this.height/2));

            var rsp = new cc.Sprite("#fishPlate3.png");
            if(rsp){
                node.addChild(rsp,0);
                rsp.setPosition(cc.p(node.width/2,node.height/2));
                rsp.runAction(new cc.RepeatForever(new cc.RotateBy(1,360)));
            }

            var boompic = new cc.Sprite("#fish_boom"+(38+rockindex)+".png");
            if(boompic){
                node.addChild(boompic,0,"boompic");
                boompic.setPosition(cc.p(node.width/2,5))
            }
            var player = new cc.Sprite("#fish_boom35.png");
            if(player){
                node.addChild(player,1);
                player.setPosition(cc.p(node.width/2,-55));

                var sp_gold2 = FYEngine.createNumSprite(gold, FishSceneRes.Png.killgold);
                sp_gold2.setScale(0.85);
                sp_gold2.setAnchorPoint(cc.p(0.5,0.5));
                sp_gold2.setPosition(cc.p(player.width/2,player.height*0.5));
                player.addChild(sp_gold2, 0,'sp_gold2');
            }
            var action1 = new cc.ScaleTo(0.2,1.5);
            var action2 = new cc.ScaleTo(0.2,1);
            node.runAction(new cc.Sequence(action1,action2,new cc.DelayTime(2.5),new cc.RemoveSelf()));

        }

    },

    checkUpdateFishEvents : function(){
        if (this.eupdateflag){
            return;
        }

        var data = this._handler._fishData;
        if (data._eFishArry.length == 0){
            return;
        }

        this.eupdateflag = true;
        this.onUpdateFishEvents(data._eFishArry);
        data._eFishArry = [];
        this.eupdateflag = false;
    },

    onUpdateFishEvents : function(eFishArray){
        for(var i = 0; i < eFishArray.length; ++ i){
            for(var j = 0; j< eFishArray[i].iCount;++j){
                var fish = this.getFishbyIdFormArr(eFishArray[i].fishArry[j].iFishId);
                if (!fish){
                    var protype = FishGlobal.getFishPropsType(eFishArray[i].fishArry[j].iFishType);
                    if (protype == FishPropsType.Plate){
                        fish = PlateFish.create(eFishArray[i].fishArry[j]);
                    }
                    else {
                        fish = CommFish.create(eFishArray[i].fishArry[j]);
                    }
                    fish._bTideFish = false;
                    if(eFishArray[i].fishArry[j].tidefish == 0){
                        fish._bTideFish = true;
                    }
                    var zorder = fish._serverType;
                    if (fish._serverType == FishServerType.Fish21){
                        zorder = FishZorder.fishMax;
                    }
                    else if (fish._clientType >= FishClientType.Fish24 &&
                        fish._clientType <= FishClientType.Fish30){
                        zorder = FishZorder.fishMid;
                    }
                    this.addChild(fish, zorder, eFishArray[i].fishArry[j].iFishId);
                    this._fishArr.push(fish);
                }
                else{
                    if(eFishArray[i].fishArry[j].iAlieveTime> fish._fishAliveTime){
                        fish._delaytime = eFishArray[i].fishArry[j].iAlieveTime;
                        fish._elaspetime = eFishArray[i].fishArry[j].iAlieveTime > 0 ? 0 : Math.abs(eFishArray[i].fishArry[j].iAlieveTime);
                    }else{
//                        cc.log('---------------鱼-鱼已经存在 ,需要倒退');
                    }
//

                }
            }
        }
        eFishArray = [];
    },


    initBGLayer : function(){
        var index = FishGlobal.roomId -1;
        var ground = new cc.Sprite(FishSceneRes.BackGround.format(index));
        ground.setAnchorPoint(cc.p(0, 0));
        ground.setPosition(cc.p(0, 0));
        this.addChild(ground, FishZorder.BGLayer, FYTagName.BGLayer);
    },

    initGameLayer : function(){
        this._bulletlayer = new BulletLayer();
        this.addChild(this._bulletlayer, FishZorder.bulletLayer, FishSceneName.BulletLayer);
    },

    initEffectLayer : function(){
        this._boom = {};
        this._boom.node = fycommonfunc.ccsLoadNode(FishSceneRes.csb.Boom);
        this._boom.action =fycommonfunc.ccsLoadAction(FishSceneRes.csb.Boom);
        this.addChild(this._boom.node, FishZorder.eftlayer+1, 'boom');
        this._boom.node.setPosition(cc.p(568, 320));
        this._boom.node.setVisible(false);
        this._boom.node.runAction(this._boom.action);
        this._boom.action.retain();

        var water = cc.AnimationCache.getInstance().getAnimation('water');
        for (var j = 0; j < 2; ++ j){
            for(var i = 0; i < 4; ++ i){
                var stemp = new cc.Sprite();
                stemp.setAnchorPoint(cc.p(0,0));
                stemp.setPosition(cc.p(i*323, 320*j));
                this.addChild(stemp, FishZorder.eftlayer);
                stemp.runAction(new cc.RepeatForever(new cc.Animate(water)));
            }
        }

        this.createCouponBroad();
        this.createMoneyCache();
    },

    initUILayer : function(){
        var uilayer = new ccui.Layout();
        if(uilayer){
            this.addChild(uilayer, FishZorder.UILayer, FYTagName.UILayer);
            uilayer.setContentSize(cc.size(1136, 640));
            uilayer.setAnchorPoint(cc.p(0, 0));
            uilayer.setPosition(cc.p(0, 0));
            this._uilayer = uilayer;
        }

        this.initFunctionMenu();
        this._playerNode =[];
        for(var i = 0; i < 4; ++ i){
            var battery = new Battery(i);
            this._uilayer.addChild(battery,0,'player'+i);
            this._playerNode.push(battery);
            battery.showUserInfo(i);
        }

        for(var i = 0; i < 4; ++ i){
            if(i != this._handler._fishData._selfId && !this._playerNode[i].isVisible()){
                var sprite = new cc.Sprite(FishSceneRes.Png.waitIn);
                switch (i){
                    case 0:sprite.setPosition(cc.p(345,600));
                        break;
                    case 1:sprite.setPosition(cc.p(790,600));
                        break;
                    case 3:sprite.setPosition(cc.p(345,40));
                        break;
                    case 2:sprite.setPosition(cc.p(790,40));
                        break;
                }

                sprite.setName("waitIn"+i);
                var spawn1 = cc.spawn(cc.fadeTo(0.85,178.5),cc.scaleTo(0.85,0.98));
                var spawn2 = cc.spawn(cc.fadeTo(0.85,255),cc.scaleTo(0.85,1));
                sprite.runAction(cc.sequence(cc.targetedAction(sprite,spawn1),cc.targetedAction(sprite,spawn2)).repeatForever());
                this._uilayer.addChild(sprite, 0);
            }
        }

    },


    refreshSelfRank : function(rsp){
        if(rsp.iResult ==0){
            if(this._inittime ==false){
                this._ranksp.setString("排名："+rsp.iAllRank+"/"+rsp.iAllRank);
            }else{
                this._ranksp.setString("排名："+rsp.iRank+"/"+rsp.iAllRank);
            }

            //this._ranksp.setString("排名："+88888+"/"+88888);
        }
    },


    initFunctionMenu : function(){
        var automenu = new ccui.ImageView(FishSceneRes.Png.AutoMenuBg,ccui.Widget.PLIST_TEXTURE);
        if(automenu){
            this._uilayer.addChild(automenu,1,'automenu');
            automenu.setScale9Enabled(true);
            automenu.setCapInsets(cc.rect(22,20,53,277));
            automenu.setContentSize(cc.size(97,317));
            automenu.setAnchorPoint(cc.p(0,0));
            automenu.setPosition(cc.p(this._uilayer.width,this._uilayer.height*0.26));

            var btnArrow = new ccui.ImageView(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
            if(btnArrow){
                automenu.addChild(btnArrow,1,'btnArrow');
                btnArrow.setTouchEnabled(true);
                btnArrow.setAnchorPoint(cc.p(0.5,0.5));
                btnArrow.setPosition(cc.p(automenu.width*(-0.1753),automenu.height*0.5));
                btnArrow.addClickEventListener(this.uiBtnCallBack);
            }

            var btnBack = new ccui.Button(FishSceneRes.Png.btnBackNormal,FishSceneRes.Png.btnBackPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnBack){
                automenu.addChild(btnBack, 1, 'btnBack');
                btnBack.setAnchorPoint(cc.p(0.5,0.5));
                btnBack.setPosition(cc.p(automenu.width*0.5,automenu.height*0.81));
                btnBack.addClickEventListener(this.uiBtnCallBack);
            }

            var btnSetting = new ccui.Button(FishSceneRes.Png.btnSettingNormal,FishSceneRes.Png.btnSettingPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnSetting){
                automenu.addChild(btnSetting, 1, 'btnSetting');
                btnSetting.setAnchorPoint(cc.p(0.5,0.5));
                btnSetting.setPosition(cc.p(automenu.width*0.5,automenu.height*0.5));
                btnSetting.addClickEventListener(this.uiBtnCallBack);
            }

            var btnHelp = new ccui.Button(FishSceneRes.Png.btnHelpNormal,FishSceneRes.Png.btnHelpPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnHelp){
                automenu.addChild(btnHelp, 1, 'btnHelp');
                btnHelp.setAnchorPoint(cc.p(0.5,0.5));
                btnHelp.setPosition(cc.p(automenu.width*0.5,automenu.height*0.2));
                btnHelp.addClickEventListener(this.uiBtnCallBack);
            }


        }
    },

    initMall : function(){
        var btnexchange = new ccui.Button('gameui18.png','gameui17.png','',ccui.Widget.PLIST_TEXTURE);
        if(btnexchange){
            this._uilayer.addChild(btnexchange,1,'btnexchange');
            btnexchange.setPosition(cc.p(42,455));
            btnexchange.addClickEventListener(this.uiBtnCallBack);
        }
    },

    createCouponBroad : function(){
//        cc.log('---------------------初始化奖券奖励特效------');
        //cc.log('测试1');
        this._couponBroad = new ccui.ImageView(FishSceneRes.DialogPng.couponbg,ccui.Widget.PLIST_TEXTURE);
        var blink1= new cc.Sprite(FishSceneRes.DialogPng.couponblink1);
        var blink2= new cc.Sprite(FishSceneRes.DialogPng.couponblink2);
        var sprite = new cc.Sprite();
        var pos = cc.p(this._couponBroad.width/2, this._couponBroad.height/2);
        blink1.setVisible(true);
        blink2.setVisible(false);
        //cc.log('测试2');

        blink1.setPosition(pos);
        blink2.setPosition(pos);
        blink1.setName("blink1");
        blink2.setName("blink2");
        this._couponBroad.addChild(blink1);
        this._couponBroad.addChild(blink2);
        //cc.log('测试3');

        sprite.setPosition(pos);
        sprite.setName("sprite");
        this._couponBroad.addChild(sprite);
        this._broadW = 0;
        this.sp_word = new cc.Sprite('#gameui39.png');
        //sp_word.setPosition(40,pos.y);
        this.sp_word.setAnchorPoint(cc.p(0,0));
        this._couponBroad.addChild(this.sp_word);
        this._broadW += this.sp_word.width;
        //cc.log('测试4');

        this._labnum = FYEngine.createAlts(FishSceneRes.Png.Num6, 11, '0', '/');
        //this._labnum.setPosition(cc.p(sp_word.width+sp_word.x, pos.y+sp_word.height/2));
        this._labnum.setAnchorPoint(cc.p(0,0.5));
        this._couponBroad.addChild(this._labnum);
        //this._broadW+=this._labnum.width;

        this._sp_word1 = new cc.Sprite('#gameui40.png');
        //this._sp_word1.setPosition(this._labnum.x+this._labnum.width, pos.y);
        this._sp_word1.setAnchorPoint(cc.p(0,0));
        this._couponBroad.addChild(this._sp_word1);
        this._broadW += this._sp_word1.width;
        //cc.log('测试5');

        this._labnum2 = FYEngine.createAlts(FishSceneRes.Png.Num6, 11, '0', '/');

        this._labnum2.setAnchorPoint(cc.p(0,0.5));
        this._couponBroad.addChild(this._labnum2);

        this._sp_word3 = new cc.Sprite('#gameui37.png');
        //this._sp_word3.setPosition(this._labnum2.x+this._labnum2.width, pos.y);
        this._sp_word3.setAnchorPoint(cc.p(0,0));
        this._couponBroad.addChild(this._sp_word3);
        this._broadW += this._sp_word3.width;

        this._sp_word2 = new cc.Sprite('#gameui41.png');
        this._sp_word2.setAnchorPoint(cc.p(0.5,1));
        this._sp_word2.setPosition(pos);
        this._couponBroad.addChild(this._sp_word2);

        var size = FYEngine.winSize;

        this._couponBroad.setVisible(false);
        this._couponBroad.setAnchorPoint(cc.p(0.5,0));
        var selfId = this._handler.getSelfId();
        if(selfId<=1){
            this._couponBroad.setPosition(size.width/2, size.height/2+30);
        }else{
            this._couponBroad.setPosition(size.width/2, size.height/2-30-107);
        }

        this.addChild(this._couponBroad, FishZorder.eftlayer);
        //this._couponBroad.runAction(cc.show());
    },

    showCouponBroad : function(rate, count){
        this._couponBroad.stopAllActions();
        var numstr = '/'+rate;
        this._labnum.setString(count);
        this._labnum2.setString(numstr);
        this.sp_word.setPosition((this._couponBroad.width-this._broadW-this._labnum.width-this._labnum2.width)/2,this._couponBroad.height/2);
        this._labnum.setPosition(this.sp_word.x+this.sp_word.width,this._couponBroad.height/2+this.sp_word.height/2);
        this._sp_word1.setPosition(this._labnum.x+this._labnum.width, this._couponBroad.height/2);
        this._labnum2.setPosition(cc.p(this._sp_word1.width+this._sp_word1.x, this._couponBroad.height/2+this.sp_word.height/2));
        this._sp_word3.setPosition(this._labnum2.x+this._labnum2.width, this._couponBroad.height/2);
        //this._couponBroad.setContentSize(cc.size(this._broadW+this._labnum.width, 100));
        //this._sp_word2.setPosition(this._couponBroad.width/2,-this._sp_word2.height);
        this._couponBroad.setScale(0.1);
        var animateArr = [],animateAllArr = [];
        var blink1 = this._couponBroad.getChildByName("blink1"),blink2 = this._couponBroad.getChildByName("blink2"),sprite = this._couponBroad.getChildByName("sprite");
        animateArr.push(cc.callFunc(function(){
            blink1.setVisible(false);
            blink2.setVisible(true);
        }));
        animateArr.push(cc.delayTime(0.5));
        animateArr.push(cc.callFunc(function(){
            blink1.setVisible(true);
            blink2.setVisible(false);
        }));
        animateArr.push(cc.delayTime(0.5));
        this._couponBroad.runAction(cc.sequence(animateArr).repeatForever());
        var star = cc.AnimationCache.getInstance().getAnimation('star');
        animateAllArr.push(cc.targetedAction(sprite,new cc.Animate(star)));
        animateAllArr.push(cc.targetedAction(this._couponBroad,cc.sequence(cc.scaleTo(0.21,1),cc.scaleTo(0.04,1.1),cc.scaleTo(0.04,1))));
        this._couponBroad.runAction(cc.sequence(cc.show(),cc.targetedAction(this._couponBroad,cc.spawn(animateAllArr)),cc.delayTime(4),cc.scaleTo(0.2,0.1),cc.hide()));
    },


    uiBtnCallBack : function(sender){
        var name = sender.getName();
        var layer = FYEngine.getRunningLayer(0);
        var uilayer = layer.getChildByName(FYTagName.UILayer);
        switch(name){
            case 'btnArrow' : {
                var automenu = uilayer.getChildByName('automenu');
                var moveout =new cc.MoveTo(0.2, cc.p(1136, 167));
                var movein =new cc.MoveTo(0.2, cc.p(1045, 167));

                if(FYMath.fixedNum(automenu.getPositionX(),0) == 1045 ){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(moveout, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }else if(FYMath.fixedNum(automenu.getPositionX(),0) == 1136){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(movein, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }

            }break;
            case 'btnBack' : {
                var mlayer = layer.getChildByName('warmtiplayer');
                if(!mlayer){
                    mlayer = new BackToLobby(2);
                    //mlayer = new KickByServer();
                    layer.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
            case 'btnSetting' : {
                var mlayer = layer.getChildByName('gamesettinglayer');
                if(!mlayer){
                    mlayer = new GameSettingLayer();
                    layer.addChild(mlayer, FishZorder.poplayer ,'gamesettinglayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }

                //layer.showCouponBroad(100, 10000);
                //layer.runBoomEft(100);
            }break;
            case 'btnHelp' : {
                var mlayer = layer.getChildByName('helpinfolayer');
                if(!mlayer){
                    // var mlayer = new ChooseBoomLayer();
                    mlayer = new HelpInfoLayerNew();
                    layer.addChild(mlayer, FishZorder.poplayer ,'helpinfolayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
            case 'btnexchange' : {
                layer._handler.sendFishSceneReliveGetReq();

            }break;
            case "rankbtn" :{
                var lobbyHandle = CoreServiceProxy.getInstance().getLobbyHandler();
                if(lobbyHandle){
                    lobbyHandle.sendSelfRankReq();
                }
                var mlayer = layer.getChildByName(LobbySceneName.DetailLayer);
                if(!mlayer){
                    mlayer = new DetailLayer2(0,FishGlobal.enterroominfo);
                    layer.addChild(mlayer,FishZorder.poplayer,LobbySceneName.DetailLayer);
                }
            }break;
            default:break;
        }
    },

    exitGame : function(){
       cc.log('----------退出游戏');
        this.stopAllActions();
        this.unscheduleAllCallbacks();
        for(var i = 0; i < this._fishArr.length;++i){
//            cc.log('--还鱼');
            cc.pool.putInPool(this._fishArr[i]);
        }

        for(var j = 0; j< this._bulletArr.length;++j){
            cc.log('--还子弹');
            cc.pool.putInPool(this._bulletArr[j]);
        }

        //for(var k =0 ; k < FishGlobal.fishNetArry.length; ++k){
        //    cc.log('------还渔网');
        //    cc.pool.putInPool(FishGlobal.fishNetArry[k]);
        //}

        //cc.pool.drainAllPools();
        //FYEngine.pool.drainAllPools();

        //FYEngine.Audio.end();

        this._fishArr = [];
        this._bulletArr = [];
        FishGlobal.bInFishScene = false;

        if(appglobal.idVerifySwitch){
            this.writeLocalIDverifyRecord();
        }
        var lobbyHandle = CoreServiceProxy.getInstance().getLobbyHandler();
        if(lobbyHandle && lobbyHandle._canSendNormalMsg){
            lobbyHandle.sendBackToLobbyRequest();
        }


        FYEngine.runScene(LobbyLayer.createScene());
    },

    setTouchEffect : function(pos){
        var touchEft = new cc.Sprite(FishSceneRes.Png.touchEft);
        touchEft.setPosition(pos);
        touchEft.setScale(0.1);
        touchEft.setOpacity(50);
        this.addChild(touchEft,FishZorder.eftlayer);
        touchEft.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.6, 0.6), new cc.FadeTo(0.6, 255)),
            new cc.Spawn(new cc.ScaleTo(0.4, 1), new cc.FadeTo(0.4, 50)),
            new cc.RemoveSelf()));
    },

    changeUserInfo : function(chairid){
        var battery = this.getBattery(chairid);
        if (!battery){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if(chairid == handlerMsg._selfId){
            battery.changeUserGold(handlerMsg._userData[chairid].lGold);
            battery.changeUserCoupon(handlerMsg._userData[chairid].lCoupon);
            return;
        }


        var waitInSprite = FYEngine.getChild(this._uilayer,"waitIn"+chairid);
        if(handlerMsg._userData[chairid].lRoleId == -1 && waitInSprite){
            return;
        }

        if(waitInSprite){
            waitInSprite.stopAllActions();
        }

        if (handlerMsg._userData[chairid].lRoleId == -1){
            var spawn1 = cc.spawn(cc.fadeTo(0.85,178.5),cc.scaleTo(0.85,0.98));
            var spawn2 = cc.spawn(cc.fadeTo(0.85,255),cc.scaleTo(0.85,1));
            battery.resetBattery();
            battery.setVisible(false);
            if(!waitInSprite){
                waitInSprite = new cc.Sprite(FishSceneRes.Png.waitIn);
                switch (chairid){
                    case 0:waitInSprite.setPosition(cc.p(345,600));
                        break;
                    case 1:waitInSprite.setPosition(cc.p(790,600));
                        break;
                    case 3:waitInSprite.setPosition(cc.p(345,40));
                        break;
                    case 2:waitInSprite.setPosition(cc.p(790,40));
                        break;
                }
                this._uilayer.addChild(waitInSprite, 0, "waitIn"+chairid);
            }
            waitInSprite.runAction(cc.sequence(cc.targetedAction(waitInSprite,spawn1),cc.targetedAction(waitInSprite,spawn2)).repeatForever());
        }
        else{
            if(waitInSprite){
                this._uilayer.removeChildByName("waitIn"+chairid);
            }

            battery.showUserInfo(chairid);
            battery.setVisible(true);
        }
    },

    changeUserGold : function(chairid){
        if (this._playerNode[chairid].isVisible() == false) {
            return;
        }

        var handlerMsg = this._handler._fishData;
        var userinfo = handlerMsg._userData[chairid];
        this._playerNode[chairid].changeUserGold(userinfo.lGold);
        if(chairid == handlerMsg._selfId ){
            appglobal._player.gold = userinfo.lGold;

        }
    },

    changeUserCoup : function(chairid){
        var playernode = this._playerNode[chairid];
        if (playernode == undefined ||
            playernode == null) {
            return;
        }

        var handlerMsg = this._handler._fishData;
        var userinfo = handlerMsg._userData[chairid];
        playernode.changeUserCoupon(userinfo.lCoupon);
        if(chairid == handlerMsg._selfId){
            appglobal._player.coupon = userinfo.lCoupon;
        }

    },

    shootBullet : function(id){
        var battery = this.getBattery(id);
        if (!battery){
            return;
        }



        var selfId = this._handler.getSelfId();
        var handlerMsg = this._handler._fishData;
        var playernode = this._playerNode[selfId];

        if(GameCostManager.costMoney(Math.abs(playernode._rate)) == false){
            return;
        }
        //先检查金钱是否足够,不够则关掉自动射击,并且调整炮台倍率,金钱足够则battery射击
        if(handlerMsg._userData[selfId].lGold < Math.abs(playernode._rate))
        {
            this._bulletlayer.setAutoPlay(false);
            var btn = FYEngine.getChild(playernode,'autobtn');
            if(this._bulletlayer.isAutoPlay()){
                btn.loadTexture(FishSceneRes.Png.AutoPlayOpenBtn,ccui.Widget.PLIST_TEXTURE);
                var autoeft = FYEngine.getChild(btn, 'autoeft');
                if(!autoeft){
                    autoeft = new cc.Sprite(FishSceneRes.Png.AutoEft);
                    if(autoeft){
                        btn.addChild(autoeft,0,'autoeft');
                        autoeft.setPosition(cc.p(btn.width/2,btn.height/2));
                        var rotate = new cc.RotateBy(1.2,360);
                        autoeft.runAction(new cc.RepeatForever(rotate));
                    }
                }
            }else{
                btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
                var autoeft = FYEngine.getChild(btn, 'autoeft');
                if(autoeft){
                    autoeft.removeFromParent(true);
                }
            }
            playernode.checkNeedSubBatteryLevel();
        }else{
            battery.shootBullet();
        }

    },


    adjustBattery : function(id, angle){
        var battery = this.getBattery(id);
        if (!battery){
            return;
        }

        battery.adjustBattery(angle);
    },

    getBattery : function(id){
        return this._playerNode[id];
    },

    getKillFishUserInfo : function(info){
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < 4; ++ i){
            if (handlerMsg._userData[i].lRoleId == info.lRoleId){
                return handlerMsg._userData[i];
            }
        }
        return null;
    },

    createMoneyCache : function(){
//        cc.log('---------------------初始化转盘动画------');
        this._goldPlate = [];
        var posArr = [cc.p(345,440), cc.p(790,440), cc.p(790,200), cc.p(345,200)];
        for (var i = 0; i < 4; ++ i){
            var rotatePlate = new cc.Sprite(FishSceneRes.Png.RewardPlate);
            rotatePlate.setScale(0.1);
            rotatePlate.setVisible(false);
            rotatePlate.setPosition(posArr[i]);
            this.addChild(rotatePlate, FishZorder.eftlayer, 'plate'+i);
            this._goldPlate.push(rotatePlate);
        }

        var self = this;
        var movedown = new cc.MoveBy(0.3, cc.p(0, -60));
        this._goldAni = new cc.Sequence(new cc.MoveBy(0.2, cc.p(0, 20)), movedown.easing(cc.easeIn(3)),
            new cc.MoveBy(0.2, cc.p(0, 50)),
            new cc.Spawn(new cc.FadeTo(0.3, 50), new cc.MoveBy(0.3, cc.p(0, 60))), new cc.RemoveSelf(),
            new cc.CallFunc(function(){
                for (var i = 0; i < 4; ++ i){
                    self.changeUserCoup(i);
                    self.changeUserGold(i);
                }
            }));
        this._goldAni.retain();
    },

    addMoneyToUser : function(tReward, iRate, chairid, startpos){
        //cc.log('---addMoneyToUser------------------test:'+chairid);
        if (!tReward){
//            cc.log('---------保护------');
            return;
        }

        var fishrate = tReward.iRewardNum;
        if (fishrate == 0){
            return;
        }

        var goldReward = fishrate*iRate;//
        var self = this;
        var endpos = this._playerNode[chairid].getPosition();

        ///创建金币动画
        // if (fishrate <= 100){
        //     if (fishrate < 10){
        //         this.createCoins(0, parseInt(fishrate/2), startpos, endpos);
        //     }
        //     else{
        //         this.createCoins(1, parseInt(fishrate/10), startpos, endpos);
        //     }
        // }
        // else if (fishrate > 100 && fishrate < 200){
        //     this.createCoins(1, 20, startpos, endpos);
        // }
        // else{
        //     this.createCoins(1, 30, startpos, endpos);
        // }
        if(chairid == this._handler.getSelfId()){
            if(fishrate <= 3){
                this.createCoins(1, 1, startpos, endpos);
            }else if(fishrate<=6){
                this.createCoins(1, 2, startpos, endpos);
            }else if(fishrate<=9){
                this.createCoins(1, 3, startpos, endpos);
            }else if(fishrate<=14){
                this.createCoins(1, 4, startpos, endpos);
            }else if(fishrate<=19){
                this.createCoins(1, 6, startpos, endpos);
            }else if(fishrate<=29){
                this.createCoins(1, 8, startpos, endpos);
            }else if(fishrate<=100){
                this.createCoins(1, 10, startpos, endpos);
            }else if(fishrate<=299){
                this.createCoins(1, 20, startpos, endpos);
            }else{
                this.createCoins(1, 30, startpos, endpos);
            }
        }else{
            if(fishrate <= 3){
                this.createCoins(0, 1, startpos, endpos);
            }else if(fishrate<=6){
                this.createCoins(0, 2, startpos, endpos);
            }else if(fishrate<=9){
                this.createCoins(0, 3, startpos, endpos);
            }else if(fishrate<=14){
                this.createCoins(0, 4, startpos, endpos);
            }else if(fishrate<=19){
                this.createCoins(0, 6, startpos, endpos);
            }else if(fishrate<=29){
                this.createCoins(0, 8, startpos, endpos);
            }else if(fishrate<=100){
                this.createCoins(0, 10, startpos, endpos);
            }else if(fishrate<=299){
                this.createCoins(0, 20, startpos, endpos);
            }else{
                this.createCoins(0, 30, startpos, endpos);
            }

        }

        ////
        if(fishrate < 40 || this._goldPlate[chairid].isVisible()){
            var sp_gold = FYEngine.createNumSprite(goldReward
                , chairid == this._handler.getSelfId()?FishSceneRes.Png.killgold:FishSceneRes.Png.skillgold);
            sp_gold.setPosition(cc.pAdd(startpos, cc.p(0, -30)));
            sp_gold.setVisible(true);
            this.addChild(sp_gold, FishZorder.eftlayer);
            sp_gold.runAction(this._goldAni.clone());
        }
        else
        {
            if(this._boom.node.isVisible()){
                return;
            }
            if(this._isVibrationSwitch == 0){
                this.vibrationCallBack();
            }

            FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.bingo_eft);

            var rotatePlate = this._goldPlate[chairid];
            rotatePlate.setScale(0.1);
            rotatePlate.setOpacity(255);
            rotatePlate.setVisible(true);
            var ani = new cc.Sequence(new cc.ScaleTo(0.2,1.2),new cc.ScaleTo(0.1,1),new cc.DelayTime(2), new cc.FadeTo(0.2,50),
                new cc.CallFunc(function(){
                    rotatePlate.setVisible(false);
                }));
            var ani2 = new cc.RepeatForever(new cc.RotateBy(1,360));
            rotatePlate.runAction(ani);
            rotatePlate.runAction(ani2);


            var sp_gold2 = FYEngine.createNumSprite(goldReward, FishSceneRes.Png.killgold);
            sp_gold2.setAnchorPoint(cc.p(0.5,0.5));
            sp_gold2.setPosition(rotatePlate.getPosition());
            this.addChild(sp_gold2, FishZorder.eftlayer);

            var spani1 = new cc.RepeatForever(new cc.Sequence(new cc.RotateBy(0.3,15),new cc.RotateBy(0.6,-30),
                new cc.RotateBy(0.3,15)));
            var spani2 = new cc.Sequence(new cc.ScaleTo(0.2,1.4),new cc.ScaleTo(0.1,1),new cc.Spawn(new cc.DelayTime(2), new cc.CallFunc(function(){
                self.changeUserCoup(chairid);
                self.changeUserGold(chairid);
            })),new cc.FadeTo(0.2,50),new cc.RemoveSelf());
            sp_gold2.runAction(spani1);
            sp_gold2.runAction(spani2);
        }


    },

    createCoins : function(type, count, bpos, epos){
        // for (var i = 0; i < count; ++ i){
        //     var sp_coin = GoldProps.create(type);
        //     sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%10), -20*parseInt((i/10)))));
        //     sp_coin.startTomove(bpos, epos, i);
        //     this.addChild(sp_coin, FishZorder.eftlayer);
        // }

        if(count<=4){
            for (var i = 0; i < count; ++ i){
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%10), -20*parseInt((i/10)))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }else if(count<=20){
            for (var i = 0; i < count; ++ i){
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%(count*0.5)), -20*parseInt((i/(count*0.5))))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }else{
            for (var i = 0; i < count; ++ i){
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20*(i%10), -20*parseInt((i/10)))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }
    },

    checkObbCollision : function(){
        if (this._bulletArr.length <= 0 || this._fishArr.length <= 0){
            return;
        }

//       cc.log('------this._bulletArr.length : '+this._bulletArr.length);
        for (var i = 0; i < this._bulletArr.length; ++ i){
            var bullet = this._bulletArr[i];
            if (bullet._bSelf == false){
                continue;
            }

            for (var j = 0; j < this._fishArr.length; ++ j) {
                var fish = this._fishArr[j];
                if (!this._fishArr[j] || !this._fishArr[j].isCanCollision()) {
                    continue;
                }

                var distance = FYMath.getDistance(bullet.x, bullet.y, fish.x, fish.y);
                if (distance < 10) {
                    this.bullethitFish(fish, bullet);
                    break;
                }
                else if (distance > fish.getFishLength()){
                    continue;
                }


                if (fish._fishQueneType == FishPropsType.Plate){
                    var ishit = false;
                    for (var k = 0; k < fish._plate.length; ++ k){
                        var bulletpos = fish._plate[k].convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish._plate[k].getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            ishit = true;
                            break;
                        }
                    }

                    if (ishit){
                        break;
                    }
                }
                else{
                    if (fish._bSurperise){
                        var bulletpos = fish._platesp.convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish._platesp.getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            break;
                        }
                    }
                    else{
                        var bulletpos = fish.convertToNodeSpace(bullet.getPosition());
                        if (cc.math.obbContainPoint(fish.getObb(), cc.math.vec3(bulletpos.x, bulletpos.y, 0))){
                            this.bullethitFish(fish, bullet);
                            break;
                        }
                    }

                }
            }
        }

    },

    bullethitFish : function(fish, bullet){
        this.pushHitEvent(fish, bullet);
        this._bulletlayer.reSetCount(-1);
        bullet.openFishNet();
    },

    checkJoinEvents : function(){
        if (this.ejoinflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eJoinArray.length == 0){
            return;
        }

        this.ejoinflag = true;
        for (var i = 0; i < handlerMsg._eJoinArray.length; ++ i){
            this.changeUserInfo(handlerMsg._eJoinArray[i].iChairId);
        }
        handlerMsg._eJoinArray = [];
        this.ejoinflag = false;
    },

    checkLeaveEvents : function(){
        if (this.eleaveflag){
            return;
        }
        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eLeaveArray.length == 0){
            return;
        }

        this.eleaveflag = true;
        for (var i = 0; i < handlerMsg._eLeaveArray.length; ++ i){
            this.changeUserInfo(handlerMsg._eLeaveArray[i].iChairId);
            this.removeBulletsByUserId(handlerMsg._eLeaveArray[i].lRoleId);
            this._nuclearlayerother.clearRocket(handlerMsg._eLeaveArray[i].iChairId);
        }
        handlerMsg._eLeaveArray = [];
        this.eleaveflag = false;
    },


    checkFishTideEvents : function(){

        if(this._handler._fishData._fishTideCome == false){
            return;
        }
        this._handler._fishData._fishTideCome = false;
        var self = this;
        for (var i = 0; i < this._fishArr.length; ++ i){
            if (!this._fishArr[i]._bTideFish){
                this._fishArr[i]._swimSpeed = 8;
            }
        }

        if(this._handler._fishData._fishTideTagTime<1){
            this.onFishTideAnimation();
//            cc.log('-----------------播放鱼潮动画------'+this._handler._fishData._fishTideControl);
        }

        if(this._handler._fishData._fishTideTagTime<4){
            this._handler._fishData._fishTideControl = false;
            var delaytime = 4-this._handler._fishData._fishTideTagTime;
            this.runAction(new cc.Sequence(new cc.DelayTime(delaytime),new cc.CallFunc(function(){
                self._handler._fishData._fishTideControl = true;
//                cc.log('-------------可以开炮了....');
            })));
        }

    },

    onFishTideAnimation : function(){
        var self = this;
        if (!this._weavAni){
            this._weavAni = new cc.RepeatForever(FYEngine.createAnimate('wave'));
            this._weavAni.retain();

            var moveby = new cc.MoveBy(3.5, cc.p(-1500,0));
            this._weavMove = new cc.Sequence( new cc.CallFunc(function(){
                FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.effect.wave_eft, false);
            }), moveby, new cc.CallFunc(function(){
                self.removeChildByName('wavetemp');
                var t = FishGlobal.roomId;
                switch(t){
                    case 1 : {
                        FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                    }break;
                    case 2 : {
                        FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                    }break;
                    case 3 : {
                        FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                    }break;
                }
            }));
            this._weavMove.retain();
        }

        var wavetemp = new cc.Sprite();
        this.addChild(wavetemp, FishZorder.eftlayer, 'wavetemp');
        wavetemp.setAnchorPoint(cc.p(0,0.5));
        wavetemp.setPosition(cc.p(1136,320));
        wavetemp.runAction(this._weavAni);
        wavetemp.runAction(this._weavMove);
    },


    onKillFishEvents : function(eKillInfo){
        var handlerMsg = this._handler._fishData;
        var userinfo = handlerMsg._userData[eKillInfo.iChairId];
        handlerMsg._userData[eKillInfo.iChairId].lGold += eKillInfo.lRewardGold;
        handlerMsg._userData[eKillInfo.iChairId].lCoupon += eKillInfo.lRewardCoupon;
//        cc.log('----------------增加金钱'+handlerMsg._userData[eKillInfo.iChairId].lGold);
        this.changeUserGold(eKillInfo.iChairId);
        if(appglobal._switch6==1){
            this.changeUserCoup(eKillInfo.iChairId);
        }
        if(eKillInfo.iChairId ==this._handler.getSelfId()){
            GameCostManager.addMoney(eKillInfo.lRewardGold+eKillInfo.lRewardCoupon*FishGlobal.getCoinValue(1));
        }


        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.gold_eft);

        for (var i = 0; i < eKillInfo.iFishId.length; ++ i){
            var fish = this.getFishbyIdFormArr(eKillInfo.iFishId[i]);
            if (fish && fish._status != FishStatus.Dead){
                if (fish._clientType < FishClientType.Fish24 ||fish._clientType > FishClientType.Fish30 ){
                    if(fish._clientType != FishClientType.Fish21){
                        if (1 > (FYMath.getRandom(0,FishGlobal.getMusicRate(fish._serverType)-1))){
                            var temp = FishGlobal.getMusicName(fish._serverType);
                            FYEngine.Audio.playEffect(temp, false);
                        }
                    }
                    else{
                        if (userinfo.iChairId == handlerMsg._selfId){
                            this.runBoomEft(eKillInfo.lRewardGold);
                        }
                        if (1 > (FYMath.getRandom(0, FishGlobal.getMusicRate(fish._serverType)-1))){
                            var temp = FishGlobal.getMusicName(fish._serverType);
                            FYEngine.Audio.playEffect(temp,false);
                        }

//                        cc.log('----------打死炸弹鱼----------');
                    }

                    //FYEngine.logObject(fish.getPosition(), '------死亡,鱼坐标: ');
                    //cc.log('--------死亡鱼 fishId: '+fish._fishId+' , [坐标 x: '+fish.x+', y: '+fish.y+' ]');

                    fish.setFishDead();
                    this.addMoneyToUser(eKillInfo.tReward[i], eKillInfo.iRate, userinfo.iChairId, fish.getPosition());
                }
                else if (fish._clientType >= FishClientType.Fish24 && fish._clientType <= FishClientType.Fish30){
                    // cc.log('###########'+fish._serverType);
                    fish.playCouponDead(userinfo.iChairId, this._playerNode[userinfo.iChairId].getPosition());
                    if (1 > (FYMath.getRandom(0,FishGlobal.getMusicRate(fish._serverType)-1))){
                        FYEngine.Audio.playEffect(FishGlobal.getMusicName(fish._serverType),false);
                    }
                    if (userinfo.iChairId == handlerMsg._selfId){
                        //cc.log('-------------------自己打中奖券');
                        for (var j = 0; j < eKillInfo.tReward.length; ++ j){
                            if (eKillInfo.tReward[j].iRewardType == 1){
                                // cc.log('进入'+eKillInfo.iRate*0.1+'进入'+eKillInfo.tReward[j].iRewardNum*0.1);
                                this.showCouponBroad(eKillInfo.iRate*0.1, eKillInfo.tReward[j].iRewardNum*0.1);

                            }
                        }
                    }
                }
            }
        }

//        cc.log('------打死一条鱼结束 killfish info end');
    },

    checkKillEvents : function(){
        if (this.ekillflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eKillArray.length == 0){
            return;
        }

        this.ekillflag = true;
        for (var i = 0; i < handlerMsg._eKillArray.length; ++ i){
            this.onKillFishEvents(handlerMsg._eKillArray[i]);
        }
        handlerMsg._eKillArray = [];
        this.ekillflag = false;
    },

    onShootBulletEvents : function(eShootArray){
        // cc.log('-------发射子弹 onShootBulletEvents : '+eShootArray.length);
        for (var i = 0; i < eShootArray.length; ++ i){
            // if (this._handler.IsUserAlieve(eShootArray[i].iChairId, eShootArray[i].lRoleId) == false){
            //     continue;
            // }

            if(eShootArray[i].bisValid == 1){
                if(eShootArray[i].iChairId == this._handler._fishData._selfId){
                    this._handler.changeUserGold(eShootArray[i].iChairId, eShootArray[i].iRate);
                    this.changeUserGold(eShootArray[i].iChairId);
                }
//                cc.log('----------无效的发射子弹,席位:'+eShootArray[i].iChairId);
                continue;
            }

            var battery = this.getBattery(eShootArray[i].iChairId);
            if (battery){
                battery.shootServerBullet(eShootArray[i].lBulletId, eShootArray[i].iRotate, eShootArray[i].iType,
                    eShootArray[i].iRate, eShootArray[i].iFireTime, eShootArray[i].lRoleId, eShootArray[i].bisValid);
            }
            this._nuclearlayerother.clearRocket(eShootArray[i].iChairId)
        }
        eShootArray = [];
    },

    checkShootEvents : function(){
        if (this.eshootflag){
            return;
        }

        if (this._handler._fishData._eShootArray.length == 0){
            return;
        }

        this.eshootflag = true;
        this.onShootBulletEvents(this._handler._fishData._eShootArray);
        this._handler._fishData._eShootArray = [];
        this.eshootflag = false;
    },


    onChangeCannonEvents : function(eCannonArray){
        //cc.log('-------切换炮台 onChangeCannonEvents: '+eCannonArray.length);
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < eCannonArray.length; ++ i){
            if (handlerMsg._selfId == eCannonArray[i].iChairId){
                //cc.log('--------自己的切换炮台事件');
                continue;
            }
            var battery = this.getBattery(eCannonArray[i].iChairId);
            if (battery){
//                cc.log("席位:"+eCannonArray[i].iChairId+"+ 倍率:"+eCannonArray[i].iRate);
                battery.changeOtherCannon(eCannonArray[i].iRate,eCannonArray[i].iType);

            }
            if(eCannonArray[i].iType!=0){
                this._nuclearlayerother.AddRocket(eCannonArray[i].iChairId,eCannonArray[i].iType);
            }
        }
        eCannonArray = [];
    },

    checkCannonEvents : function(){
        if (this.echangeflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eCannonArray.length == 0){
            return;
        }

        this.echangeflag = true;
        this.onChangeCannonEvents(handlerMsg._eCannonArray);
        handlerMsg._eCannonArray = [];
        this.echangeflag = false;
    },
    //
    // removeLocalBUllet : function(lBulletId){
    //     var handlerMsg = this._handler._fishData;
    //     var playernode = this._playerNode[handlerMsg._selfId];
    //     playernode._localBulletArry.remove(lBulletId);
    // },

    onHitFishEvents : function(eHitArray){
        // FYEngine.logObject(eHitArray,'---------碰撞事件');
        var handlerMsg = this._handler._fishData;
        for (var i = 0; i < eHitArray.length; ++ i){
            if (eHitArray[i].lRoleId == appglobal._player.roleid){
                if (eHitArray[i].bisValid == 0){
                    this._handler.changeUserGold(handlerMsg._selfId, eHitArray[i].iRate);
                    this.changeUserGold(handlerMsg._selfId);
//                    cc.log('------------自己碰撞无效子弹加钱');
                }
            }else{

                var bullet = this.getBulletFromArr(eHitArray[i].lBulletId);
                if (bullet && bullet.isVisible()){
                    bullet.openFishNet();
                }
                else{
//                    cc.log('----------子弹不存在 && bullet.isVisible()');
                    continue;
                }

                if (eHitArray[i].bisValid == 0){
                    for(var j =0 ; j< handlerMsg._userData.length;++j){
                        if(handlerMsg._userData[j].lRoleId == eHitArray[i].lRoleId){
                            this._handler.changeUserGold(handlerMsg._userData[j].iChairId, eHitArray[i].iRate);
                            this.changeUserGold(handlerMsg._userData[j].iChairId);
//                            cc.log('------------别人碰撞无效子弹加钱'+handlerMsg._userData[j].iChairId+'----id'+eHitArray[i].lBulletId);
                        }
                    }
                }


            }
        }
        eHitArray = [];
    },

    checkHitEvents : function(){
        if (this.ehitflag){
            return;
        }

        var handlerMsg = this._handler._fishData;
        if (handlerMsg._eHitArray.length == 0){
            return;
        }

        this.ehitflag = true;
        this.onHitFishEvents(handlerMsg._eHitArray);
        handlerMsg._eHitArray = [];
        this.ehitflag = false;
    },


    getFishbyIdFormArr : function(id){
        for (var i = 0; i < this._fishArr.length; ++ i){
            if (this._fishArr[i] && this._fishArr[i].getId() == id){
                return this._fishArr[i];
            }
        }

        return null;
    },

    getBulletFromArr : function(id){
        for (var i = 0; i < this._bulletArr.length; ++ i){
            if (this._bulletArr[i] && this._bulletArr[i].getId() == id){
                return this._bulletArr[i];
            }
        }

        return null;
    },

    removeBulletsByUserId : function(id){
        var removearr = [];
        for (var i = 0; i < this._bulletArr.length; ++ i){
            if (this._bulletArr[i] && this._bulletArr[i].getUserId() == id){
                removearr.push(this._bulletArr[i].getId());
//                cc.log('----------删除的子弹:'+this._bulletArr[i].getId());
            }
        }

        for (var i = 0; i < removearr.length; ++ i){
            var bullet = this._bulletlayer.getChildByName('name'+removearr[i]);
            if (bullet){
                bullet.removeSelf();
            }
        }

    },

    pushHitEvent : function(fish, bullet){
//        cc.log('----------发送子弹碰撞消息');
        var lBulletId = bullet.getId();
        var iHitFishId = fish.getId();
        var iRate = bullet.getRate();
        var bHitFishType = fish.getServerType();
        var sFishNum = 0;
        var iFishId = [];

        if (fish._bSurperise){
            for (var i = 0; i < this._fishArr.length; ++ i){//
                if ( !this._fishArr || !this._fishArr[i].isCanCollision() ){
                    continue;
                }

                if (this._fishArr[i]._fishQueneType == FishPropsType.Plate
                    || this._fishArr[i].getId() == fish.getId()
                    || this._fishArr[i].getServerType() != fish.getServerType()) {
                    continue;
                }

                ++ sFishNum;
                iFishId.push(this._fishArr[i].getId());
            }
        }
        else {
            if (bHitFishType == FishServerType.Fish21){
                for (var i = 0; i < this._fishArr.length; ++ i){
                    if (this._fishArr[i].getId() == fish.getId()
                        || this._fishArr[i].getServerType() == FishServerType.Fish21) {
                        continue;
                    }

                    if ( !this._fishArr || !this._fishArr[i].isCanCollision() ){
                        continue;
                    }

                    ++ sFishNum;
                    iFishId.push(this._fishArr[i].getId());
                }
            }
        }

        if(this._handler && this._handler._canSendNormalMsg){
            this._handler.sendHitFishReq(lBulletId,iHitFishId,iRate,bHitFishType,sFishNum,iFishId);
        }
    },

    pushNuclearHitFish : function(pos,id,type){

        this.addNuclearBoomeft(pos);
        this.addBOONLight();
        var sFishNum = 0;
        var iFishId = [];
        for (var i = 0; i < this._fishArr.length; ++ i){
            if ( !this._fishArr || !this._fishArr[i].isCanCollision()){
                continue;
            }
            if(this._fishArr[i].getServerType() == FishServerType.Fish21
                ||(this._fishArr[i].getClientType()>=24 &&this._fishArr[i].getClientType()<=30 )){
                continue;
            }
            var fish = this._fishArr[i];
            var fishpos = fish.getPosition();
            if(fishpos.x>(pos.x-200) && fishpos.x<(pos.x+200) &&fishpos.y>(pos.y-200)&&fishpos.y<(pos.y+200) && fishpos.x>0
                && fishpos.x<1136 && fishpos.y>0 && fishpos.y<640){
                ++ sFishNum;
                cc.log("-------push:"+this._fishArr[i].getId());
                iFishId.push(this._fishArr[i].getId());
            }
        }
        this._handler.sendSpecialHitReq(sFishNum,iFishId,type,id);
    },

    addBOONLight : function(){

        var sprite1 = new cc.Sprite("#fish_boom02.png");
        if(sprite1){
            this.addChild(sprite1,FishZorder.eftlayer+2);
            sprite1.setPosition(cc.p(this.width/2,this.height/2));

            sprite1.runAction(new cc.Sequence(new cc.ScaleTo(0.5,1),new cc.ScaleTo(0.5,1.2),new cc.ScaleTo(0.5,1),new cc.ScaleTo(0.5,1.2),new cc.ScaleTo(0.5,1),new cc.FadeOut(0.2)
                ,new cc.RemoveSelf()));

        }

        var sprite = new cc.Sprite("#fish_boom08.png");
        if(sprite){
            this.addChild(sprite,FishZorder.eftlayer+2);
            sprite.setPosition(cc.p(this.width/2,this.height/2));

            sprite.runAction(new cc.Sequence(new cc.ScaleTo(0.5,1.5),new cc.ScaleTo(0.5,1.2),new cc.ScaleTo(0.5,1.5),new cc.ScaleTo(0.5,1.2),new cc.ScaleTo(0.5,1.5),new cc.FadeOut(0.2),
                new cc.RemoveSelf()));

        }


    },

    addNuclearBoomeft : function(pos){
        // var boonlight = cc.AnimationCache.getInstance().getAnimation('nuclear');
        var stemp = new cc.Sprite();
        stemp.setAnchorPoint(cc.p(0.5,0.5));
        stemp.setPosition(pos);
        this.addChild(stemp, FishZorder.eftlayer);
        stemp.runAction(new cc.Sequence(FYEngine.createAnimate("nuclear"), new cc.CallFunc(function(){
            stemp.removeFromParent(true);
        })));
    },

    runBoomEft : function(lGold){
        if(!this._boom.node.isVisible()){
            var self = this;
            this._boom.node.setVisible(true);
            this._boom.action.play('beft', false);

            var goldbg = this._boom.node.getChildByName('goldbg');
            var sp = goldbg.getChildByName('sp_gold2');
            if(sp){
                sp.removeFromParent(true);
            }
            var sp_gold2 = FYEngine.createNumSprite(lGold, FishSceneRes.Png.killgold);
            sp_gold2.setScale(0.85);
            sp_gold2.setAnchorPoint(cc.p(0.5,0.5));
            sp_gold2.setPosition(cc.p(goldbg.width/2,goldbg.height/2));
            goldbg.addChild(sp_gold2, 0,'sp_gold2');


            this._boom.action.setAnimationEndCallFunc('beft',function(){
                self._boom.node.setVisible(false);
            });
        }
    },

    onUnconnect : function(type){
//        cc.log('----------------FishScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
//        cc.log("unconnecttype====="+type);
        switch (type){
            case 1:{

                if (!layer){
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer+1, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
//                cc.log("code===="+layer._reConnectCode);
                if(layer && layer._reConnectCode&&layer._reConnectCode==1){
                    if(layer._type&&layer._type==3){
                        return;
                    }
                    layer.refreshUI(3);
                }

                if(layer && layer._reConnectCode==0 && layer.code==0){
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF,4.0);
                    //this.scheduleOnce(f,30.0);
                    layer.code=1;
                }
            }
                break;
            case 2:
            case 3:{
                if (layer){
                    if(layer._type&&layer._type==3){
                        return;
                    }
                    if(layer &&layer.layerF){
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code=0;
                    }
                    //this.unschedule(f);

                }
            }
                break;
            case 0:{
                if (layer){
                    layer.removeFromParent();
                }
            }
                break;
        }
    },

    initTipsLayer : function(){
//        cc.log('---------------------初始化进场提示------');
        var selfId = this._handler.getSelfId();
        var tipslay = new TipsLayer();
        this.addChild(tipslay, FishZorder.TipsLayer, 'tipslayer');
        var thistype = this._playerNode[selfId]._type;
        var lighteft = new cc.Sprite(FishSceneRes.Png.TipsBg);
        if(lighteft){
            lighteft.setAnchorPoint(cc.p(0.5,0));
            tipslay.addChild(lighteft, 0, 'lighteft');
        }

        var battery = new cc.Sprite(FishSceneRes.Png.TipsBatteryBg);
        if(battery){
            battery.setAnchorPoint(cc.p(0.5,0));
            tipslay.addChild(battery);
            var cannon = new cc.Sprite();
            if(cannon){
                cannon.setSpriteFrame(BatteryRes.BatteryName.BatterySelf.format(thistype));
                battery.addChild(cannon);
                cannon.setAnchorPoint(cc.p(0.5,0.4));

            }
            var goldbg = new cc.Sprite(FishSceneRes.Png.TipsGoldBg);
            if(goldbg){
                battery.addChild(goldbg);

            }
            var sub = new cc.Sprite(FishSceneRes.Png.TipsSub);
            if(sub){
                battery.addChild(sub);
            }
            var add = new cc.Sprite(FishSceneRes.Png.TipsAdd);
            if(add){
                battery.addChild(add);
            }

            var goldtext = FYEngine.createAlts('res/num/fishnum5.png', 10, '10', '0');
            if(goldtext){
                battery.addChild(goldtext);
                goldtext.setString(''+this._handler._fishData._userData[selfId].iRate);
                switch(selfId){
                    case 0 :
                    case 1 :{
                        goldtext.setPosition(cc.p(battery.width/2,56));
                    }break;
                    case 2 :
                    case 3 :{
                        goldtext.setPosition(cc.p(battery.width/2,16));
                    }break;
                }
            }
        }

        var tip1 = new cc.Sprite("#position1.png");
        if(tip1){
            tip1.setAnchorPoint(cc.p(0.5,0));
            tipslay.addChild(tip1);
            tip1.runAction(new cc.RepeatForever(new cc.Sequence(new cc.MoveBy(1,cc.p(0,10)), new cc.MoveBy(1,cc.p(0,-10)))));
        }

        var tip2 = new cc.Sprite("#position2.png");
        if(tip2){
            tip2.setAnchorPoint(cc.p(0.5,0));
            tipslay.addChild(tip2);
        }

        switch(selfId){
            case 0 : {
                add.setPosition(cc.p(151,50));
                sub.setPosition(cc.p(20,50));
                goldbg.setFlippedY(true);
                goldbg.setPosition(cc.p(battery.width/2,55));
                cannon.setRotation(180);
                cannon.setPosition(cc.p(battery.width/2,15));
                battery.setAnchorPoint(cc.p(0.5,1));
                battery.setFlippedY(true);
                battery.setPosition(cc.p(345,640));
                lighteft.setRotation(180);
                tip1.setRotation(180);
                tip2.setPosition(cc.p(345,460));
                tip1.setPosition(cc.p(345,460));
                lighteft.setPosition(cc.p(345,640));
            }break;
            case 1 : {
                add.setPosition(cc.p(151,50));
                sub.setPosition(cc.p(20,50));
                goldbg.setFlippedY(true);
                goldbg.setPosition(cc.p(battery.width/2,55));
                cannon.setRotation(180);
                cannon.setPosition(cc.p(battery.width/2,15));
                battery.setAnchorPoint(cc.p(0.5,1));
                battery.setFlippedY(true);
                battery.setPosition(cc.p(790,640));
                lighteft.setRotation(180);
                tip1.setRotation(180);
                tip2.setPosition(cc.p(790,460));
                tip1.setPosition(cc.p(790,460));
                lighteft.setPosition(cc.p(790,640));
            }break;
            case 2 : {
                add.setPosition(cc.p(151,25));
                sub.setPosition(cc.p(20,25));
                goldbg.setPosition(cc.p(battery.width/2,20));
                cannon.setPosition(cc.p(battery.width/2,60));
                battery.setPosition(cc.p(790,0));
                tip1.setPosition(cc.p(790,170));
                tip2.setPosition(cc.p(790,140));
                lighteft.setPosition(cc.p(790,0));
            }break;
            case 3 : {
                add.setPosition(cc.p(151,25));
                sub.setPosition(cc.p(20,25));
                goldbg.setPosition(cc.p(battery.width/2,20));
                cannon.setPosition(cc.p(battery.width/2,60));
                battery.setPosition(cc.p(345,0));
                tip1.setPosition(cc.p(345,170));
                tip2.setPosition(cc.p(345,140));
                lighteft.setPosition(cc.p(345,0));
            }break;
            default:break;
        }

    },

    vibrationCallBack : function(){
        if(this._vibrationend){
            return;
        }
        this._vibrationend = true;
        var self = this;
        var bg = this.getChildByName(FYTagName.BGLayer);
        if(bg){
            bg.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(10,18)), new cc.MoveTo(0.05,cc.p(-10,-20)),
                new cc.MoveTo(0.05,cc.p(10,50)), new cc.MoveTo(0.05,cc.p(-10,-50)),new cc.MoveTo(0.1,cc.p(10,30)), new cc.MoveTo(0.1,cc.p(-10,-30)), new cc.MoveTo(0.1,cc.p(10,20)),new cc.MoveTo(0.1,cc.p(-8,-10)),new cc.MoveTo(0.1,cc.p(5,5)),new cc.MoveTo(0.1,cc.p(0,0))));
        }
        this._uilayer.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(-5,-10)), new cc.MoveTo(0.05,cc.p(10,20)),
            new cc.MoveTo(0.05,cc.p(-10,-30)), new cc.MoveTo(0.05,cc.p(10,30)),new cc.MoveTo(0.1,cc.p(-10,-20)), new cc.MoveTo(0.1,cc.p(10,20)), new cc.MoveTo(0.1,cc.p(-10,-10)),new cc.MoveTo(0.1,cc.p(8,10)),new cc.MoveTo(0.1,cc.p(-5,-5)),new cc.MoveTo(0.1,cc.p(0,0)),new cc.CallFunc(function(){
                self._vibrationend = false;
            })));

        // if(this._nuclearlayerself){
        //     this._nuclearlayerself.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(-5,-10)), new cc.MoveTo(0.05,cc.p(10,20)),
        //         new cc.MoveTo(0.05,cc.p(-10,-30)), new cc.MoveTo(0.05,cc.p(10,30)),new cc.MoveTo(0.1,cc.p(-10,-20)), new cc.MoveTo(0.1,cc.p(10,20)), new cc.MoveTo(0.1,cc.p(-10,-10)),new cc.MoveTo(0.1,cc.p(8,10)),new cc.MoveTo(0.1,cc.p(-5,-5)),new cc.MoveTo(0.1,cc.p(0,0)),new cc.CallFunc(function(){
        //
        //         })));
        // }
        // if(this._nuclearlayerother){
        //     this._nuclearlayerother.runAction(new cc.Sequence(new cc.MoveTo(0.05,cc.p(-5,-10)), new cc.MoveTo(0.05,cc.p(10,20)),
        //         new cc.MoveTo(0.05,cc.p(-10,-30)), new cc.MoveTo(0.05,cc.p(10,30)),new cc.MoveTo(0.1,cc.p(-10,-20)), new cc.MoveTo(0.1,cc.p(10,20)), new cc.MoveTo(0.1,cc.p(-10,-10)),new cc.MoveTo(0.1,cc.p(8,10)),new cc.MoveTo(0.1,cc.p(-5,-5)),new cc.MoveTo(0.1,cc.p(0,0)),new cc.CallFunc(function(){
        //
        //         })));
        // }

    },

    gameOnShowEvent : function(){
        cc.log('----------------游戏退到后台啦-'+FishGlobal.bInFishScene);
        if(FishGlobal.is3rdSDKLogOut){
            return;
        }
        if(FishGlobal.bInFishScene == true){
            FishGlobal.tipout = 1;
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkGameClient();

            var layer = FYEngine.getRunningLayer(0);
            //layer._handler.sendLeaveTableReq();
            //layer._handler.sendPlayerLogoutRequest();

            if(cc.sys.os != 'iOS'){
                var coreserviceproxy = CoreServiceProxy.getInstance();
                var lobbyHandler = coreserviceproxy.getLobbyHandler();
                if(lobbyHandler){
                    lobbyHandler.setCanSendHeart(false);
                }
            }

            layer.exitGame();
            //layer.scheduleOnce(layer.exitGame,0.1);


        }
    },

    phoneKeyCallBack : function(keycode,target){
        switch(keycode){
            case cc.KEY.back : {
//                cc.log('---------物理返回键--------');
                if(FYEngine.getRunningLayer(0).getChildByName('kickedbyserver')){
                    return;
                }

                var layer = target.getChildByName(FishSceneName.UnConnectDialog);
                if(layer){
                    return;
                }

                var namelist = [LobbySceneName.ChooseBoomLayer,'warmtiplayer','gocharge','helpinfolayer','gamesettinglayer',LobbySceneName.FreeRoomRule,LobbySceneName.DetailLayer];

                for(var i = 0; i < namelist.length ; ++i){
                    var layer =target.getChildByName(namelist[i]);
                    if(layer){
                        FYEngine.popoutLayerAnimate(layer.layerbg);
                        return;
                    }
                }

                var mlayer = new BackToLobby(2);
                if(mlayer){
                    target.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }break;
        }

    },

    initBackGroundMusic : function(type){
       cc.log('---------------------初始化音乐------');
        var vibtn = cc.sys.localStorage.getItem('isVibration');
        if(vibtn == null || vibtn == '0'){
            this._isVibrationSwitch = 0;
        }else{
            this._isVibrationSwitch = 1;
        }


        var bgmusic = cc.sys.localStorage.getItem('bgVolum');
       cc.log("-----fish---bgmusic===="+bgmusic);
        if(bgmusic == null){
            FYEngine.Audio.setMusicVolume(1);
        }else{
            // FYEngine.Audio.setMusicVolume(Number(bgmusic));
            // cc.audioEngine.setMusicVolume(Number(bgmusic));
            FYEngine.Audio.setOpenMusic(Number(bgmusic))
        }

        var eftmusic = cc.sys.localStorage.getItem('eftVolum');
//        cc.log("fish---eftmusic===="+eftmusic);
        if(eftmusic == null){
            FYEngine.Audio.setEffectVolume(1);
        }else{
            FYEngine.Audio.setEffectVolume(Number(eftmusic));
        }
        var t = FishGlobal.roomId;
        if(!type){
            switch(t){
                case 1 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                }break;
                case 2 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                }break;
                case 3 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                }break;
            }
        }
    },

});


FishLayer.createScene = function(){
    var scene = new cc.Scene();
    var layer = new FishLayer();
    scene.addChild(layer, 0, 0);
    return scene;
};

var TipsLayer = cc.LayerColor.extend({
    _texture : null,
    _position : cc.p(0,0),
    _size : cc.size(0,0),
    _dt : 0,

    ctor:function(){
        this._super();
        this.init(cc.color(0, 0, 0, 150), 1136, 640);
        this.scheduleUpdate();
        this._size=cc.winSize;
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    var scene = FYEngine.getRunningLayer(0);
                    scene.removeChildByName('tipslayer');
                    target.runAutoMenu();
                }
            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },

    onExit: function(){
        this._super();
        FishGlobal._ControlBtnEx = false;
    },

    update : function(dt){
        this._dt = this._dt+dt;
        if(this._dt>5){

            this.removeFromParent(true);
            this.runAutoMenu();

        }

    },

    runAutoMenu : function(){
        var scene = FYEngine.getRunningLayer(0);
        var automenu = scene._uilayer.getChildByName('automenu');
        var pullbtn = automenu.getChildByName('btnArrow');

        automenu.runAction(new cc.Sequence(new cc.CallFunc(function(){
            automenu.setEnabled(false);
        }),new cc.MoveTo(0.2, cc.p(1045, 167)),new cc.CallFunc(function(){
            automenu.setEnabled(true);
            pullbtn.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
        }),new cc.DelayTime(2),new cc.CallFunc(function(){
            automenu.setEnabled(false);
        }),new cc.MoveTo(0.2, cc.p(1136, 167)),new cc.CallFunc(function(){
            automenu.setEnabled(true);
            pullbtn.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
        })));
    },

});

var NuclearLayerSelf = cc.Layer.extend({
    _touchthislayer:false,
    _fire:false,
    _cantouch:false,
    _rockettype :0,//对应1，2，3，4，5
    _rocketid :0,//对应101，102，103.。。。
    ctor:function(type){
        var self = this;
        this._super();
        this._touchthislayer = false;
        this._fire =false;
        this._cantouch=false;
        this._rockettype = type;
        this._rocketid = FishGlobal.BoomConf.iList[type].iBulletType;
        this._size=cc.winSize;
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._scene = FYEngine.getRunningLayer(0);
        this._selfid = this._handler.getSelfId();
        this.intUI();
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if(self._fire ||self._cantouch==false){
                    return false;
                }
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    self._touchthislayer =true;
                    cc.log("-------核弹点击"+self._touchthislayer);
                    var angle = self.getAngle(self.getCannonPosition(self._selfid),pos);
                    if(self._rocket){
                        self._rocket.setRotation(angle);
                        self.changeLocposition(pos);
                    }
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if(self._fire ||self._cantouch==false){
                    return false;
                }


                if (cc.rectContainsPoint(target.getBoundingBox(), pos) && self._touchthislayer) {
                    cc.log("-------核弹move"+self._touchthislayer);
                    var angle = self.getAngle(self.getCannonPosition(self._selfid),pos);
                    if(self._rocket){
                        self._rocket.setRotation(angle);
                        self.changeLocposition(pos);
                    }
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if(self._fire ||self._cantouch==false){
                    return false;
                }
                if(self._handler._fishData._fishTideControl == false){
                    FYEngine.AddCommToast("鱼潮期间无法发射核弹，请稍等");
                    return;
                }
                if (cc.rectContainsPoint(target.getBoundingBox(), pos) && self._touchthislayer) {
                    cc.log("-------核弹松开"+self._touchthislayer);
                    var angle = self.getAngle(self.getCannonPosition(self._selfid),pos);
                    self._rocket.setRotation(angle);
                    self._fire=true;
                    self.openFire(pos,parseFloat(angle).toFixed(2));
                }
            },

        });
        cc.eventManager.addListener(this.touchListener, this);

    },

    intUI : function(){
        var self = this;

        var title = new cc.Sprite("#fish_boom07.png");
        if(title){
            title.setPosition(cc.p(this.width/2,this.height/2));
            this.addChild(title);
            var action1 = new cc.ScaleTo(0.2,1.5);
            var action2 = new cc.ScaleTo(0.2,1);
            title.runAction(new cc.Sequence(action1,action2,new cc.DelayTime(1),new cc.RemoveSelf()));
        }

        var type = this._scene._playerNode[this._selfid]._type;
        var index = type - BatteryType.Battery0;
        var cannonstr = BatteryRes.BatteryName.BatterySelf;
        var name = cannonstr.format(index%getObjCount(BatteryType));
        var cannon = new cc.Sprite("#"+name);
        if(cannon){
            this.addChild(cannon,0,0);
            cannon.setAnchorPoint(cc.p(0.5,0.4));
            if(this._selfid<2){
                cannon.setRotation(180);
            }
            cannon.setPosition(this.getCannonPosition(this._selfid));
            this._cannon = cannon;
        }

        var rocket = new Rocket(this._selfid,this._rockettype);
        if(rocket){
            this.addChild(rocket,0,0);
            if(this._selfid<2){
                rocket.setRotation(180);
            }
            rocket.setPosition(this.getHidePosition(this._selfid));
            this._rocket = rocket;
        }
        cannon.runAction(new cc.MoveTo(1,this.getHidePosition(this._selfid)));
        rocket.runAction(new cc.MoveTo(1,this.getCannonPosition(this._selfid)));
        this.runAction(new cc.Sequence(new cc.DelayTime(1),new cc.CallFunc(function(){
            var locsp = new ccui.ImageView("fish_boom01.png",ccui.Widget.PLIST_TEXTURE);
            if(locsp){
                self.addChild(locsp);
                locsp.setPosition(cc.p(self.width/2,self.height/2));
                self._loc = locsp;
            }
            self._cantouch = true;
        })));



    },

    openFire: function(pos,angle){
        var self = this;
        var date = new Date().getTime();
        FishGlobal.nuclearrecount = date;
        cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'nuclear',""+FishGlobal.nuclearrecount);

        var id = self._rocket.getid();//子弹的身份证
        self._handler.sendSpecialBullet(this._rocketid,pos,angle,id);
        self._handler.sendChangeCannonReq(this._selfid,this._scene._playerNode[this._selfid]._rate,0);
        self._loc.removeFromParent(true);
        self._scene.NucBtnRecount(20);
        var flytime = this.getFireTime(pos);
        this._rocket.runAction(new cc.Sequence(new cc.MoveTo(flytime,pos),new cc.CallFunc(function(){
            FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.BOOM_eft);
            self._rocket.removeFromParent(true);
            self._scene.pushNuclearHitFish(pos,id,self._rocketid);
            if(flytime>1){
                self.removeFromParent(true);
            }
            FishGlobal.isBoom = false;
        })));
        this._cannon.runAction(new cc.Sequence(new cc.MoveTo(1,this.getCannonPosition(this._selfid)),new cc.CallFunc(function(){
            self._cannon.removeFromParent(true);
            self._scene._playerNode[self._selfid].resetCannon(true);
            if(flytime<=1){
                self.removeFromParent(true);
            }
            FishGlobal.isBoom = false;
        })));


        this._scene._bulletlayer._timeCount=0;
        var mlayer = this._scene.getChildByName('timeoutlayer');
        if(mlayer){
            mlayer.removeFromParent(true);
        }

    },

    getFireTime : function(endpos){
        var beginpos = this.getCannonPosition(this._selfid);
        var distance = Math.abs(FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y));
        return Math.round(distance/400);
    },

    changeLocposition : function(pos){
        if(this._loc){
            this._loc.setPosition(pos);
        }
    },

    getCannonPosition : function(pos){
        switch(pos){
            case 0 :{
                return cc.p(345,580);
            }break;
            case 1:{
                return cc.p(790,580);
            }break;
            case 2:{
                return cc.p(790,60);
            }break;
            case 3:{
                return cc.p(345,60);
            }break;
        }
    },

    getHidePosition : function(pos){
        switch(pos){
            case 0 :{
                return cc.p(345,840);
            }break;
            case 1:{
                return cc.p(790,840);
            }break;
            case 2:{
                return cc.p(790,-200);
            }break;
            case 3:{
                return cc.p(345,-200);
            }break;
        }
    },

    getAngle : function(posstart,posend){
        var rotate = FYMath.getAngle(posstart.x, posstart.y, posend.x, posend.y);
        if(this._selfid>1){
            if(-180 <= rotate && rotate< (-90)){
                rotate = -90;
            }else if(180 > rotate && rotate >90){
                rotate = 90;
            }else if(180 <= rotate && rotate< 270){
                rotate = -90;
            }
        }else{
            if(rotate >=0 && rotate <90){
                rotate = 90;
            }else if( 270<rotate && rotate<360){
                rotate = 270;
            }else if(-90<rotate && rotate<0){
                rotate = 270;
            }
        }
        cc.log("-----旋转角度"+rotate);
        return rotate;
    },



});

var NuclearLayerOther = cc.Layer.extend({
    _rockettype :0,//对应1，2，3，4，5
    _rocketid :0,//对应101，102，103.。。。
    ctor:function(){
        var self = this;
        this._super();
        this._size=cc.winSize;
        this._rockettype =0;
        this._rocketid =0;
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._scene = FYEngine.getRunningLayer(0);
    },

    initRocket : function(chaireid,rocketid){
        this._rocketid = rocketid;
        for(var i =0 ;i<FishGlobal.BoomConf.iCount;++i){
            if(FishGlobal.BoomConf.iList[i].iBulletType == this._rocketid){
                this._rockettype = i;
            }
        }
        var self = this;
        var type = this._scene._playerNode[chaireid]._type;
        var index = type - BatteryType.Battery0;
        var cannonstr = BatteryRes.BatteryName.BatteryOther;
        var name = cannonstr.format(index%getObjCount(BatteryType));
        var cannon = new cc.Sprite("#"+name);
        if(cannon){
            this.addChild(cannon,0,"cannon"+chaireid);
            cannon.setAnchorPoint(cc.p(0.5,0.4));
            if(chaireid<2){
                cannon.setRotation(180);
            }
            cannon.setPosition(this.getHidePosition(chaireid));
        }

        var rocket = new Rocket(chaireid,this._rockettype);
        if(rocket){
            this.addChild(rocket,0,"rocket"+chaireid);
            if(chaireid<2){
                rocket.setRotation(180);
            }
            rocket.setPosition(this.getCannonPosition(chaireid));
        }
        // cannon.runAction(new cc.MoveTo(1,this.getHidePosition(chaireid)));
        // rocket.runAction(new cc.MoveTo(1,this.getCannonPosition(chaireid)));

    },

    AddRocket : function(chaireid,rocketid){
        var self = this;
        this._rocketid = rocketid;
        for(var i =0 ;i<FishGlobal.BoomConf.iCount;++i){
            if(FishGlobal.BoomConf.iList[i].iBulletType == this._rocketid){
                this._rockettype = i;
            }
        }

        var type = this._scene._playerNode[chaireid]._type;
        var index = type - BatteryType.Battery0;
        var cannonstr = BatteryRes.BatteryName.BatteryOther;
        var name = cannonstr.format(index%getObjCount(BatteryType));
        var cannon = new cc.Sprite("#"+name);
        if(cannon){
            this.addChild(cannon,0,"cannon"+chaireid);
            cannon.setAnchorPoint(cc.p(0.5,0.4));
            if(chaireid<2){
                cannon.setRotation(180);
            }
            cannon.setPosition(this.getCannonPosition(chaireid));
        }

        var rocket = new Rocket(chaireid,this._rockettype);
        if(rocket){
            this.addChild(rocket,0,"rocket"+chaireid);
            if(chaireid<2){
                rocket.setRotation(180);
            }
            rocket.setPosition(this.getHidePosition(chaireid));
        }
        cannon.runAction(new cc.MoveTo(1,this.getHidePosition(chaireid)));
        var action1 = new cc.MoveTo(1,this.getCannonPosition(chaireid));
        rocket.runAction(action1);
        action1.setTag(chaireid);

    },

    openFire: function(chaireid,pos,angle){
        var self = this;
        var rocket = this.getChildByName("rocket"+chaireid);
        if(rocket){
            rocket.setFlying(true);
            angle = parseFloat(angle).toFixed(2);
            cc.log("----------旋转的角度"+angle);
            rocket.stopActionByTag(chaireid);
            rocket.setRotation(angle);
            var flytime = this.getFireTime(chaireid,pos);
            rocket.runAction(new cc.Sequence(new cc.MoveTo(flytime,pos),new cc.CallFunc(function(){
                FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.BOOM_eft);
                rocket.removeFromParent(true);
                self._scene.addNuclearBoomeft(pos);
            })));

            var cannon = this.getChildByName("cannon"+chaireid);
            if(cannon){
                cannon.runAction(new cc.Sequence(new cc.MoveTo(1,this.getCannonPosition(chaireid)),new cc.CallFunc(function(){
                    cannon.removeFromParent(true);
                    self._scene._playerNode[chaireid].resetCannon();
                })));
            }
        }
    },

    clearRocket : function(chaireid){
        var rocket = this.getChildByName("rocket"+chaireid);
        if(rocket && rocket.isFlying()==false){
            rocket.removeFromParent(true);
        }
        var cannon = this.getChildByName("cannon"+chaireid);
        if(cannon){
            cannon.removeFromParent(true);
            this._scene._playerNode[chaireid].resetCannon();
        }
    },

    init:function(){
        this.removeAllChildren(true);
    },

    getFireTime : function(chaireid,endpos){
        var beginpos = this.getCannonPosition(chaireid);
        var distance = Math.abs(FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y));
        return Math.round(distance/400);
    },



    getCannonPosition : function(pos){
        switch(pos){
            case 0 :{
                return cc.p(345,580);
            }break;
            case 1:{
                return cc.p(790,580);
            }break;
            case 2:{
                return cc.p(790,60);
            }break;
            case 3:{
                return cc.p(345,60);
            }break;
        }
    },

    getHidePosition : function(pos){
        switch(pos){
            case 0 :{
                return cc.p(345,840);
            }break;
            case 1:{
                return cc.p(790,840);
            }break;
            case 2:{
                return cc.p(790,-200);
            }break;
            case 3:{
                return cc.p(345,-200);
            }break;
        }
    },

    getAngle : function(posstart,posend){
        var rotate = FYMath.getAngle(posstart.x, posstart.y, posend.x, posend.y);
        if(this._selfid>1){
            if(-180 <= rotate && rotate< (-90)){
                rotate = -90;
            }else if(180 > rotate && rotate >90){
                rotate = 90;
            }else if(180 <= rotate && rotate< 270){
                rotate = -90;
            }
        }else{
            if(rotate >=0 && rotate <90){
                rotate = 90;
            }else if( 270<rotate && rotate<360){
                rotate = 270;
            }else if(-90<rotate && rotate<0){
                rotate = 270;
            }
        }
        cc.log("-----旋转角度"+rotate);
        return rotate;
    },



});
