/**
 * Created by mintao on 16/3/11.
 * 用户数据
 * 账号登录，大厅登录获取
 * 玩家全局信息
 */

var Player = cc.Class.extend({
    ///
    userid : 0,
    account : '',
    token : '',
    passWord : "",
    imei : '',
    nickname : '',
    ///
    roleid : 0, //
    gametoken : '',
    gender : 0,
    facestatus : 1, //0:未审核 1:审核通过
    faceid : '',
    ///
    alive : false,//在线
    age : 0,
    birthday : null,
    constellation : "",//星座
    signature : null,//签名
    ///
    gold : 0,//金豆
    coupon : 0,//奖券
    medal : 0,//勋章
    fruitscore : 0,//水果积分
    diamond : 0,//钻石
    freeticket :0,
    bankgold : 0,  //银行存款
    score : 0,
    exp : 0,
    totalpay : 0,

    ///列表
    friendlist : [],//好友列表
    photolist : [],///相册
    blacklist : [],//黑名单

    loaction:{ //用户位置信息
        dLongitude:  0,         //8字节   经度X
        dLatitude:   0          //8字节   纬度Y
    },
    userInfo : {},
    crystal : 0,
    sign:"",//签名
    phonenumber : 0,
    realName : "",
    realIDnumber :"",
    isAdult : false,
    beike : 0,
    shuijing :0,
    shanhu : 0,
    haixing : 0,
    zhenzhu : 0,
    iVIPLevel :0,
    iSend :0,//当天已弹头
    iMoney :0,//充值
    iVIPMoney : 0,//当前VIP充值
    iVIPSend : 0,//当前vip送数量
    iVIPNextMoney : 0,//下一等级VIP充值
    iNextSend : 0,//下一等级VIP送数量
    fishcoin : 0,//渔币
    fishbox : 0,//宝箱


    getSrealname : function(){
        if(this.realName !=""){
            var lastname = this.realName.substr(-1);
            var str = "";
            for(var i= 0; i< (this.realName.length-1);++i){
                str = str+"*";
            }
            return str+lastname;
        }
    },

    getSrealidnumber : function(){
        if(this.realIDnumber!=""){
            var first = this.realIDnumber.substr(0,2);
            var middle = "**************";
            var last = this.realIDnumber.substr(16,2);
            return first+middle+last;
        }
    },

    getName : function(){
        if(this.nickname){
            if(this.nickname.length == 0 )
                return this.account;
            else
                return this.nickname;
        }else{
            this.nickname="暂无昵称";
            return this.nickname;
        }
    },

    setNickName : function(nickname){
        this.nickname = nickname; //
    },

    getNickName : function(){
      return this.nickname;
    },

    setAccountName : function(account){
        this.account = account;
    },

    getAccountName : function(){
        if( this.account == this.userid )
            return '';
        return this.account;
    },

    getFreshPhoneNumber : function(){
        if(this.phonenumber != 0 && this.phonenumber != ""){
            var number = this.phonenumber+"";
            var head1 = number.substr(0,3);
            var head2 = number.substr(7,4);
            number = head1+"****"+head2;
            return number;
        }
        return "";
    },

    updateUserInfo : function(userInfo){
        this.nickname = userInfo.nickname;
        this.account = userInfo.account;
        this.token = userInfo.token;
        this.userid = userInfo.userId;
        cc.log('userInfo.nickname='+userInfo.nickname);
    },

    getMedal : function(){
        return this.medal;
    },
    getSign:function(){
        return this.sign;
    },
    setSign:function(sign){
        this.sign = sign;
    }
});
